<?php
namespace Geral\Repositories;

class Licencauso extends \Doctrine\ORM\EntityRepository
{
    public function getLicencaUso($cdfilibolrec, $nrlanbolrec){
        $sql = <<<SQL
                SELECT LU.NRLICENCAUSO, LU.IDTPIJURLUSO, LU.NRINSJURLUSO, LU.NMFANTLUSO,
                       LU.NMRAZSOCLUSO, LU.DSENDELUSO  , LU.NMBAIRLUSO  , LU.SGESTADO  ,
                       MU.NMMUNICIPIO , LU.NRCEPLUSO
                FROM LICENCAUSO LU, MUNICIPIO  MU,
                     (SELECT CR.CDFILIBOLREC, CR.NRLANBOLREC, MAX(NF.CDCLIENTE) CDCLIENTE,
                             MAX(NF.NRLICENCAUSO) NRLICENCAUSO
                      FROM NOTAFISCAL NF, CONTARECEBER CR
                      WHERE (CR.CDFILIBOLREC = :P_CDFILIBOLREC) AND
                            (CR.NRLANBOLREC  = :P_NRLANBOLREC ) AND
                            (NF.CDFILIAL     = CR.CDFILIAL    ) AND
                            (NF.NRLANCTONF   = CR.NRLANCTONF  )
                    GROUP BY CR.CDFILIBOLREC, CR.NRLANBOLREC) NC
                WHERE (LU.CDCLIENTE    = NC.CDCLIENTE   ) AND
                      (LU.NRLICENCAUSO = NC.NRLICENCAUSO) AND
                      (MU.CDPAIS       = LU.CDPAIS      ) AND
                      (MU.SGESTADO     = LU.SGESTADO    ) AND
                      (MU.CDMUNICIPIO  = LU.CDMUNICIPIO )
SQL;
        $params = array(
            ':P_CDFILIBOLREC' => $cdfilibolrec,
            ':P_NRLANBOLREC'  => $nrlanbolrec
        );

        return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);

    }

}