CREATE OR REPLACE TRIGGER TRG_NOTAFISCAL
BEFORE UPDATE ON NOTAFISCAL
FOR EACH ROW
BEGIN
   :NEW.USR_DTEXPXML := NULL;
END;
/

DROP TYPE XML_ARQ
/ 

DROP TYPE XML
/

CREATE OR REPLACE TYPE XML AS OBJECT
   (XMLRETORNO XMLTYPE,
    CDFILIAL   VARCHAR2(4),
    NRLANCTONF VARCHAR2(10),
    CONSTRUCTOR FUNCTION XML RETURN SELF AS RESULT)
/

CREATE OR REPLACE TYPE XML_ARQ AS TABLE OF XML
/

create or replace
FUNCTION ACA_EXPORTA_NF_XML RETURN XML_ARQ PIPELINED
IS
   V_CDFILIAL   VARCHAR2(4);
   V_NRLANCTONF VARCHAR2(10);
   
   -- DADOS GERAIS
   V_CIFFOB VARCHAR2(1);
   V_CODCPG VARCHAR2(2);
   V_CODEMP VARCHAR2(1);
   V_CODFIL VARCHAR2(20);
   V_CODFOR VARCHAR2(30);
   V_NUMNFC VARCHAR2(20);
   V_CODFPG VARCHAR2(1);
   V_CODMOE VARCHAR2(2);
   V_CODSEL VARCHAR2(5);
   V_CODSNF VARCHAR2(5);
   V_DATEMI VARCHAR2(10);
   V_DATENT VARCHAR2(10);
   V_DUDEFF VARCHAR2(1);
   V_OBSNFC VARCHAR2(1000);
   V_PERDS1 VARCHAR2(1);
   V_PERFRE FLOAT;
   V_PEROUT FLOAT;
   V_PESBRU VARCHAR2(30);
   V_PESLIQ VARCHAR2(30);
   V_TIPNFE VARCHAR2(1);
   V_TNSPRO VARCHAR2(5); 
   V_VERDOC VARCHAR2(1);
   V_FECNOT VARCHAR2(1);
   V_GERPAR VARCHAR2(1);
   V_TPPROC VARCHAR2(1);
   V_TNSPRONF VARCHAR2(5);
   V_NRACESSONFE VARCHAR2(44);  
   
   -- PARCELAS
   V_CODPOR VARCHAR2(4);
   V_CODREP VARCHAR2(1);
   V_CODTPT VARCHAR2(2);
   V_NUMTIT VARCHAR2(21); -- NUMERO DA NF + STATUS DO PAGAMENTO
   V_VCTPAR VARCHAR2(10);
   V_VLRDSC_N FLOAT;
   V_VLRPAR VARCHAR2(30);
   V_IDSTATPAG VARCHAR2(1); -- STATUS DO PAGAMENTO
   
   -- PRODUTOS
   V_CODCLF VARCHAR2(10);
   V_CODDEP VARCHAR2(2);
   V_CODDER VARCHAR2(2);
   V_CODPRO VARCHAR2(20);
   V_CODSTR VARCHAR2(3);
   V_CPLIPC VARCHAR2(300);
   V_PRIMNIVEL VARCHAR2(1);
   V_CTARED VARCHAR2(30);
   V_PERCSL FLOAT;
   V_PERDSC VARCHAR2(30);
   V_PERPIR VARCHAR2(30);
   V_PERCOR VARCHAR2(30);
   V_PREUNI VARCHAR2(30);
   V_QTDREC VARCHAR2(30);
   V_SEQIPC VARCHAR2(4);
   V_TNSPROPRO VARCHAR2(5);
   V_UNINFC VARCHAR2(10);
   V_VLRBPI VARCHAR2(30);
   V_VLRBCR FLOAT;
   V_CSTPIS VARCHAR2(3);
   V_CSTCOF VARCHAR2(3);
   V_VLRCOR VARCHAR2(30);
   V_VLRDSC VARCHAR2(30);
   V_VLRFRE VARCHAR2(30);
   V_VLRPIS VARCHAR2(30);
   V_CDPRODUTO VARCHAR2(10);
   v_VLRCTA FLOAT;
   
   -- XML 
   L_XMLTYPE XMLTYPE;
   L_DOMDOC DBMS_XMLDOM.DOMDOCUMENT;
   L_ROOT_NODE DBMS_XMLDOM.DOMNODE;
   
   L_NAME_ELEMENT DBMS_XMLDOM.DOMELEMENT;
   L_NAME_NODE DBMS_XMLDOM.DOMNODE;
   L_NAME_TEXT DBMS_XMLDOM.DOMTEXT;
   L_NAME_TEXTNODE DBMS_XMLDOM.DOMNODE;
   
   -- Dados Gerais
   L_NF_ELEMENT DBMS_XMLDOM.DOMELEMENT;
   L_NF_NODE DBMS_XMLDOM.DOMNODE;
   
   -- Parcelas
   L_PARCELAS_ELEMENT DBMS_XMLDOM.DOMELEMENT;
   L_PARCELAS_NODE DBMS_XMLDOM.DOMNODE;
   
   --Produtos
   L_PROD_ELEMENT DBMS_XMLDOM.DOMELEMENT;
   L_PROD_NODE DBMS_XMLDOM.DOMNODE;

   --rateio
   L_RATE_ELEMENT DBMS_XMLDOM.DOMELEMENT;
   L_RATE_NODE DBMS_XMLDOM.DOMNODE;

   OUT_XML_ARQ XML := XML(NULL, NULL, NULL);
   
   CURSOR C_NOTAFISCAL IS
      SELECT NF.CDFILIAL, NF.NRLANCTONF, 'X' cifFob, 'AV' codCpg, SUBSTR(E.CDEXPORTEMPR,2,1) AS codEmp, PF.CDEXFILIAL codFil,
             FO.CDEXFORNECED codFor, TO_CHAR(TO_NUMBER(NRNOTAFISC)) numNfc, NF.CDSERIEENTR codSel, 'UN' codSnf, TO_CHAR(DTEMISSAO, 'DD/MM/YYYY') datEmi,
             TO_CHAR(DTENTRSAID, 'DD/MM/YYYY') datEnt, 'ENTRADA DE NF PELO TECFOOD NO SAPIENS VIA WEB SERVICES' OBSNFC, TO_CHAR(VRPBRUTOVOLU) pesBru, TO_CHAR(VRPLIQUVOLU) pesLiq,
             DECODE(SUBSTR(NF.CDFISOPENTF, 1,1), '1', '19709', '29709') AS tnsPro,
             NF.NRACESSONFE
        FROM NOTAFISCAL NF, FORNECEDOR FO, PARAMFILIAL PF, SERIEENTR S, PARAMEMPRESA E,
             (SELECT CDFILIAL, NRLANCTONF, LISTAGG(DSDADOADIC, ' - ')
                                           WITHIN GROUP (ORDER BY CDFILIAL, NRLANCTONF) OBSNFC
                FROM DADOSADIC
               GROUP BY CDFILIAL, NRLANCTONF) D
       WHERE NF.CDFORNECED = FO.CDFORNECED
         AND NF.CDFILIRECE = PF.CDFILIAL
         AND NF.CDFILIAL   = D.CDFILIAL (+)
         AND NF.NRLANCTONF = D.NRLANCTONF (+)
         AND NF.IDENTRSAIDOP = 'E'
         AND S.CDSERIEENTR = NF.CDSERIEENTR
         AND NF.USR_DTEXPXML IS NULL
         AND E.CDEMPRESA = NF.CDEMPRESA;

   CURSOR C_PARCELAS(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
      SELECT TO_CHAR(DTATUAVENPAG, 'DD/MM/YYYY') vctPar, to_char(C.VRATUAPAG) vlrPar, C.IDSTATPAG
        FROM CONTAPAGAR C
       WHERE C.CDFILIAL   = C_CDFILIAL
         AND C.NRLANCTONF = C_NRLANCTONF
       ORDER BY C.NRSEQVENPAG;

   CURSOR C_PRODUTOS(C_CDFILIAL IN VARCHAR2, C_NRLANCTONF IN VARCHAR2) IS
      SELECT NULL codPro, P.CDCSTDIG1PROD||II.CDSITUTRIBIT codStr,
             NVL(P.DSCOMPLNOME, P.NMPRODUTO) cplIpc, SUBSTR(P.CDARVPROD,1,1) primNiv, 0 perDsc, to_char(PIS.VRALIQITEM) perPir,
             to_char(COFINS.VRALIQITEM) perCor, to_char(P.VRPESOBRUTPR) VRPESOBRUTPR, to_char(P.VRPESOLIQUPR) VRPESOLIQUPR, to_char(I.VRUNITITEM) preUni,
             to_char(I.QTITEMPROD) qtdRec, TO_CHAR(TO_NUMBER(I.NRSEQITPROD)) seqIpc,  DECODE(SUBSTR(I.CDFISOPEITEM, 1,1), '1', '19709', '29709') AS tnsPro, P.SGUNIDADE uniMed,
             PIS.vlrBpi, PIS.cstPis, COFINS.cstCof, COFINS.vlrCor,
             to_char(I.VRDESCITEM) vlrDsc, to_char(I.VRFRETEITEM) vlrFre, PIS.vlrPis,
             I.CDPRODUTO, (QTITEMPROD * VRUNITITEM) as vlrCta
        FROM ITEMPRODUTO I, PRODUTO P, CLASFISCAL C,
             (SELECT II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NVL(II.CDSITUTRIBITNFE, II.CDSITUTRIBIT) AS CDSITUTRIBIT
                FROM ITEMPROIMPOS II, IMPOSTO IM
               WHERE II.CDIMPOSTO  = IM.CDIMPOSTO
                 AND IM.CDIMPOSTONFE = '00'
               GROUP BY II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NVL(II.CDSITUTRIBITNFE, II.CDSITUTRIBIT)) II,
             (SELECT II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, SUM(II.VRALIQITEM) VRALIQITEM, to_char(SUM(II.VRIMPOSTOIT)) vlrPis,
                     '50' CSTPIS, to_char(SUM(II.VRBASECALCIT)) vlrBpi
                FROM ITEMPROIMPOS II, IMPOSTO IM
               WHERE II.CDIMPOSTO  = IM.CDIMPOSTO
                 AND IM.CDIMPOSTONFE = '50'
               GROUP BY II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NVL(II.CDSITUTRIBITNFE, II.CDSITUTRIBIT)) PIS,
             (SELECT II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, SUM(II.VRALIQITEM) VRALIQITEM,
                     '50' CSTCOF, to_char(SUM(II.VRIMPOSTOIT)) VLRCOR
                FROM ITEMPROIMPOS II, IMPOSTO IM
               WHERE II.CDIMPOSTO  = IM.CDIMPOSTO
                 AND IM.CDIMPOSTONFE = '60'
               GROUP BY II.CDFILIAL, II.NRLANCTONF, II.NRSEQITPROD, NVL(II.CDSITUTRIBITNFE, II.CDSITUTRIBIT)) COFINS
       WHERE I.CDPRODUTO   = P.CDPRODUTO
         AND I.CDFILIAL    = II.CDFILIAL
         AND I.NRLANCTONF  = II.NRLANCTONF
         AND I.NRSEQITPROD = II.NRSEQITPROD
         AND I.CDFILIAL    = PIS.CDFILIAL
         AND I.NRLANCTONF  = PIS.NRLANCTONF
         AND I.NRSEQITPROD = PIS.NRSEQITPROD
         AND I.CDFILIAL    = COFINS.CDFILIAL
         AND I.NRLANCTONF  = COFINS.NRLANCTONF
         AND I.NRSEQITPROD = COFINS.NRSEQITPROD
         AND I.CDFILIAL    = C_CDFILIAL
         AND I.NRLANCTONF  = C_NRLANCTONF
         AND P.CDCLASFISC  = C.CDCLASFISC (+)
       ORDER BY I.NRSEQITPROD;
BEGIN
   -- DADOS GERAIS
   V_CODFPG := '1'; -- PARCELAS TAMBÉM
   V_CODMOE := '01';
   V_DUDEFF := 'S'; --duplicarDefinicaoFornecedor
   V_PERDS1 := '0';
   V_TIPNFE := '1';
   V_VERDOC := '4';
   V_FECNOT := 'S';
   V_GERPAR := 'S';
   V_TPPROC := '1'; --tipoProcessamento
   V_PERFRE := 0;
   V_PEROUT := 0;
   
   -- PARCELAS
   V_CODPOR := '9999';
   V_CODREP := '1';
   V_CODTPT := '01';
   V_VLRDSC_N := 0;
      
   -- PRODUTOS
   V_CODDER := '@@';  -- ser desconsiderado valor e ir ser repassado espao
   V_PERCSL := 0;
   V_VLRBCR := 0;

   OPEN C_NOTAFISCAL;
   LOOP
      FETCH C_NOTAFISCAL INTO V_CDFILIAL, V_NRLANCTONF, V_CIFFOB, V_CODCPG, V_CODEMP, V_CODFIL,
                              V_CODFOR, V_NUMNFC, V_CODSEL, V_CODSNF, V_DATEMI,
                              V_DATENT, V_OBSNFC, V_PESBRU, V_PESLIQ,
                              V_TNSPRONF, V_NRACESSONFE;
      EXIT WHEN C_NOTAFISCAL%NOTFOUND;

      IF V_CODFIL = '1' THEN
         V_CODDEP := '30';
      ELSE
         IF V_CODFIL = '2' THEN
            V_CODDEP := '60';
         ELSE
            V_CODDEP := '3';
         END IF;   
      END IF;

      L_DOMDOC    := DBMS_XMLDOM.NEWDOMDOCUMENT;
      L_ROOT_NODE := DBMS_XMLDOM.MAKENODE(L_DOMDOC);
      
      L_NF_ELEMENT := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'dadosGerais');
      L_NF_NODE    := DBMS_XMLDOM.APPENDCHILD(L_ROOT_NODE, DBMS_XMLDOM.MAKENODE(L_NF_ELEMENT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'cifFob');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CIFFOB);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codCpg');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODCPG);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codEmp');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODEMP);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codFil');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODFIL);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codFor');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODFOR);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'numNfc');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_NUMNFC);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codFpg');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODFPG);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codMoe');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODMOE);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codSel');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODSEL);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codSnf');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODSNF);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'datEmi');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_DATEMI);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'datEnt');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_DATENT);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'duplicarDefinicaoFornecedor');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_DUDEFF);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'obsNfc');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_OBSNFC);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      OPEN C_PARCELAS(V_CDFILIAL, V_NRLANCTONF);
      LOOP
         FETCH C_PARCELAS INTO V_VCTPAR, V_VLRPAR, V_IDSTATPAG;
         EXIT WHEN C_PARCELAS%NOTFOUND;
         -- Parcelas
         L_PARCELAS_ELEMENT := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'parcelas');
         L_PARCELAS_NODE    := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE, DBMS_XMLDOM.MAKENODE(L_PARCELAS_ELEMENT));
      
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codFpg');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODFPG);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codPor');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODPOR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codRep');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODREP);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codTpt');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODTPT);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         V_NUMTIT        := V_NUMNFC||'.A';
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'numTit');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_NUMTIT);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vctPar');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VCTPAR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrDsc');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRDSC_N);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrPar');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PARCELAS_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRPAR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      END LOOP;
      CLOSE C_PARCELAS;
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perDs1');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PERDS1);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perFre');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PERFRE);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perOut');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PEROUT);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'pesBru');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PESBRU);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'pesLiq');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PESLIQ);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
      
      OPEN C_PRODUTOS(V_CDFILIAL, V_NRLANCTONF);
      LOOP
         FETCH C_PRODUTOS INTO V_CODPRO, V_CODSTR,
                               V_CPLIPC, V_PRIMNIVEL, V_PERDSC, V_PERPIR,
                               V_PERCOR, V_PESBRU, V_PESLIQ, V_PREUNI,
                               V_QTDREC, V_SEQIPC, V_TNSPROPRO, V_UNINFC,
                               V_VLRBPI, V_CSTPIS, V_CSTCOF, V_VLRCOR,
                               V_VLRDSC, V_VLRFRE, V_VLRPIS, V_CDPRODUTO, v_VLRCTA;
         EXIT WHEN C_PRODUTOS%NOTFOUND;

         IF V_PRIMNIVEL IN ('1','2','3') THEN
            V_CTARED := '4103';
         ELSE
            IF V_PRIMNIVEL IN ('4','5') THEN
               V_CTARED := '4105';
            END IF;
         END IF;

         BEGIN
            SELECT MAX(C.USR_CODCLF) AS CODCLF
              INTO V_CODCLF
              FROM INTG_NOTAFISCAL N, INTG_ITEMPRODUTO I, PRODFORNXML P, CLASFISCAL C
             WHERE N.NRACESSONFE = V_NRACESSONFE
               AND I.NRACESSONFE = N.NRACESSONFE
               AND P.CDFORNECED   = N.CDFORNECED
               AND P.CDPRODUTOXML = I.CDPRODUTO
               AND C.CDCLASFISC = I.CDCLASFISC
               AND P.CDPRODUTO = V_CDPRODUTO;
         EXCEPTION
            WHEN OTHERS THEN
               V_CODCLF := NULL;
         END;

         IF V_CODCLF IS NULL THEN
            BEGIN
               SELECT MIN(C.USR_CODCLF) AS CODCLF
                 INTO V_CODCLF
                 FROM INTG_NOTAFISCAL N, INTG_ITEMPRODUTO I, PRODFORNXML P, CLASFISCAL C
                WHERE N.NRACESSONFE = V_NRACESSONFE
                  AND I.NRACESSONFE = N.NRACESSONFE
                  AND P.CDFORNECED   = N.CDFORNECED
                  AND P.CDPRODUTOXML = I.CDPRODUTO
                  AND SUBSTR(C.CDCLASFISC,1,4) = SUBSTR(I.CDCLASFISC,1,4)
                  AND P.CDPRODUTO = V_CDPRODUTO
                  AND NOT C.USR_CODCLF IS NULL;
            EXCEPTION
               WHEN OTHERS THEN
                  V_CODCLF := NULL;
            END;
         END IF;

         L_PROD_ELEMENT := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'produtos');
         L_PROD_NODE    := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE, DBMS_XMLDOM.MAKENODE(L_PROD_ELEMENT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codClf');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODCLF);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codDep');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODDEP);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
--         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codDer');
--         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
--         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODDER);
--         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

--         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codPro');
--         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
--         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODPRO);
--         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codStr');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODSTR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'cplIpc');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CPLIPC);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'ctaRed');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CTARED);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perCsl');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PERCSL);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perDsc');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PERDSC);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perPir');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PERPIR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perCor');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PERCOR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'pesBru');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PESBRU);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'pesLiq');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PESLIQ);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'preUni');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_PREUNI);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'qtdRec');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_QTDREC);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'seqIpc');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_SEQIPC);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'snfNfv');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CODSNF);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'tnsPro');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_TNSPROPRO);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'uniNfc');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_UNINFC);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrBpi');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRBPI);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrBcr');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRBCR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'cstPis');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CSTPIS);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'cstCof');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CSTCOF);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrCor');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRCOR);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrDsc');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRDSC);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrFre');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRFRE);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));
         
         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrPis');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRPIS);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_RATE_ELEMENT := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'rateio');
         L_RATE_NODE    := DBMS_XMLDOM.APPENDCHILD(L_PROD_NODE, DBMS_XMLDOM.MAKENODE(L_RATE_ELEMENT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'ctaFin');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_RATE_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, '4103');
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'ctaRed');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_RATE_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_CTARED);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perCta');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_RATE_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, '100');
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrCta');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_RATE_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, v_VLRCTA);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'codCcu');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_RATE_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, '1171');
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'perRat');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_RATE_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, '100');
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

         L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrRat');
         L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_RATE_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
         L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, v_VLRCTA);
         L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

      END LOOP;
      CLOSE C_PRODUTOS;
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'tipNfe');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_TIPNFE);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'tnsPro');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_TNSPRONF);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'verDoc');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VERDOC);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

      SELECT to_char(SUM(VRITEMENCA)) vlrFre
        INTO V_VLRFRE
        FROM ITEMENCARGO I
       WHERE CDENCARGO IN (SELECT CDENCARGO
                             FROM ENCARGO
                             WHERE CDENCARGONFE = '01')
         AND I.CDFILIAL   = V_CDFILIAL
         AND I.NRLANCTONF = V_NRLANCTONF;
      
      L_NAME_ELEMENT  := DBMS_XMLDOM.CREATEELEMENT(L_DOMDOC, 'vlrFre');
      L_NAME_NODE     := DBMS_XMLDOM.APPENDCHILD(L_NF_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_ELEMENT));
      L_NAME_TEXT     := DBMS_XMLDOM.CREATETEXTNODE(L_DOMDOC, V_VLRFRE);
      L_NAME_TEXTNODE := DBMS_XMLDOM.APPENDCHILD(L_NAME_NODE,DBMS_XMLDOM.MAKENODE(L_NAME_TEXT));

      L_XMLTYPE := DBMS_XMLDOM.GETXMLTYPE(L_DOMDOC);
      DBMS_XMLDOM.FREEDOCUMENT(L_DOMDOC);
      OUT_XML_ARQ.XMLRETORNO := L_XMLTYPE;
      OUT_XML_ARQ.CDFILIAL   := V_CDFILIAL;
      OUT_XML_ARQ.NRLANCTONF := V_NRLANCTONF;
      PIPE ROW(OUT_XML_ARQ);
   END LOOP;
   CLOSE C_NOTAFISCAL;
   
   RETURN;   
EXCEPTION
   WHEN OTHERS THEN
      IF C_NOTAFISCAL%ISOPEN THEN
         CLOSE C_NOTAFISCAL;
      END IF;
      
      IF C_PARCELAS%ISOPEN THEN
         CLOSE C_PARCELAS;
      END IF;
      
      IF C_PRODUTOS%ISOPEN THEN
         CLOSE C_PRODUTOS;
      END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ACA_EXPORTA_NF_XML','6.35.021'); END;
/
