SCRIPTS_PATH=[PRODUCTION_PATH]/deploy_scripts/ci_scripts
MCSV_PRODUCT_PATH=[PRODUCTION_PATH]/../
TMP_MCSV_MODULE_SERVICE_PATH=[PKG_FIN_Service_TMP]
TMP_MCSV_MODULE_BACKEND_PATH=[PKG_FIN_Backend_TMP]
MCSV_MODULE_SERVICE_PATH=[PRODUCTION_PATH]/[PKG_FIN_Service_PATH_TO_DEPLOY]
MCSV_MODULE_BACKEND_PATH=[PRODUCTION_PATH]/[PKG_FIN_Backend_PATH_TO_DEPLOY]
BIRT_REPORT_PATH=$(echo $MCSV_MODULE_BACKEND_PATH | sed "s/_tmp//g")
REPORTS_CONFIG_PATH=$TMP_MCSV_MODULE_BACKEND_PATH/reports
MCSV_MODULE_FOLDER_NAME='fin'

echo 'Move Microservice Module Service to project folder -----------------------'
mv $TMP_MCSV_MODULE_SERVICE_PATH/modules/$MCSV_MODULE_FOLDER_NAME/* $TMP_MCSV_MODULE_SERVICE_PATH/
rm -rf $TMP_MCSV_MODULE_SERVICE_PATH/modules/

echo 'Frontend mnemonics -------------------------------------------------------'
cd $TMP_MCSV_MODULE_SERVICE_PATH/mobile/assets/json

echo 'Environment mnemonics ----------------------------------------------------'
$SCRIPTS_PATH/env_mnemonics.sh $SCRIPTS_PATH $TMP_MCSV_MODULE_SERVICE_PATH "@@TEK_STORAGE_PATH@@" "@@TEK_REPORTS_URL@@" "@@TEK_DEFAULT_LANGUAGE@@" "@@TEK_ERROR_REPORTING@@"

echo 'Backend mnemonics --------------------------------------------------------'
cd $TMP_MCSV_MODULE_SERVICE_PATH/backend/config

echo 'Update db.xml ------------------------------------------------------------'
$SCRIPTS_PATH/db_mnemonics.sh $SCRIPTS_PATH "@@DB_ORA_USER@@" "@@DB_ORA_PASSWORD@@" "@@DB_ORA_HOST@@" "@@DB_ORA_PORT@@" "@@DB_ORA_DBNAME@@" "@@DB_ORA_SERVICE_BOOL@@" "@@DB_VPD_WALLET_BOOL@@" "@@DB_VPD_BOOL@@" "@@DB_ORA_PASSWORD@@" "@@DB_ORA_ENCRYPTED_BOOL@@" "@@DB_ORA_SESSION_MODE@@" "@@DB_MONGO_HOST@@" "@@DB_MONGO_PORT@@"

echo 'Update BIRT files --------------------------------------------------------'
$SCRIPTS_PATH/report_mnemonics.sh $SCRIPTS_PATH "@@BIRT_LOGO_PATH@@" "$BIRT_REPORT_PATH/reports" "@@BIRT_CONF_PATH@@" "@@BIRT_URL@@" "@@BIRT_TYPE@@" "@@BIRT_FORMAT@@" "@@BIRT_VIEW_MODE@@"

# (Optional) -> Use it if you use Zeedhi's FileUploader component.
echo 'Update fileUploader.xml --------------------------------------------------'
$SCRIPTS_PATH/fileserver_mnemonics.sh $SCRIPTS_PATH "@@TEK_FILESERVER_BASE_URL@@" "@@TEK_FILESERVER_TOKEN@@" "@@TEK_FILESERVER_KEY@@" "@@TEK_FILESERVER_MODE@@"

# (Optional) -> Use it if you use parameters that change through different client's servers.
# echo 'Update parameters.xml --------------------------------------------------'
# $SCRIPTS_PATH/parameters_mnemonics.sh $SCRIPTS_PATH "@@TEK_ZHU_LOG_BOOL@@"

# (Optional) -> Use it if you use QR2 Reports
echo 'Update QR2 files ---------------------------------------------------------'
$SCRIPTS_PATH/qr2_mnemonics.sh $SCRIPTS_PATH "@@QRD_TYPE@@" "@@QRD_URL@@" "@@QRD_PORT@@" "@@TEK_SAAS_BOOL@@"

echo 'Move Microservice Module Backend to project folder -----------------------'
mv $TMP_MCSV_MODULE_BACKEND_PATH/modules/teknisa/$MCSV_MODULE_FOLDER_NAME/* $TMP_MCSV_MODULE_BACKEND_PATH
rm -rf $TMP_MCSV_MODULE_BACKEND_PATH/modules/

$SCRIPTS_PATH/birt_mnemonics.sh $SCRIPTS_PATH "$REPORTS_CONFIG_PATH" "@@BIRT_ORA_HOST@@" "@@BIRT_ORA_PORT@@" "@@BIRT_ORA_DBNAME@@" "@@BIRT_ORA_USER@@" "@@BIRT_ORA_PASSWORD@@" "@@BIRT_ORA_WALLET_BOOL@@" "@@TEK_SAAS_BOOL@@" "@@BIRT_ORA_WALLET_PREFIX@@" "@@DB_VPD_BOOL@@"

# (Optional) -> Use it if you have specific mnemonics for your product
# echo 'Specific Mnemonics -------------------------------------------------------'
# $SCRIPTS_PATH/specific_mnemoinics.sh "MNEMONIC_NAME" "MNEMONIC_VALUE" "FILE_1_TO_UPDATE_PATH"
# $SCRIPTS_PATH/specific_mnemoinics.sh "MNEMONIC_NAME" "MNEMONIC_VALUE" "FILE_2_TO_UPDATE_PATH"

echo 'Update Login Step --------------------------------------------------------'
$SCRIPTS_PATH/update_login_step.sh $SCRIPTS_PATH $TMP_MCSV_MODULE_SERVICE_PATH "@@TEK_LICENSE_URL@@"
