#!/bin/sh
SCRIPTS_PATH=$('pwd')
MODULE_NAME='fin'
MCSV_PATH="$('pwd')/../modules/$MODULE_NAME"
DEVOPS_VERSION="[VERSION]"
DEVOPS_REVISION="[REVISION]"
DEVOPS_BUILD="[BUILD]"
PACKAGE_VERSION="$DEVOPS_VERSION.$DEVOPS_REVISION.$DEVOPS_BUILD"

echo 'Back Steps -----------------------------------------------------'
{ # try !
	cd $MCSV_PATH/backend
	#$SCRIPTS_PATH/back_step.sh $DEVOPS_VERSION $DEVOPS_REVISION $DEVOPS_BUILD
	$SCRIPTS_PATH/back_step_new.sh $DEVOPS_VERSION $DEVOPS_REVISION $DEVOPS_BUILD
} || { # catch!
    echo 'Back Error -------------------------------------------------------'
    exit 1
}

echo 'Front Steps -----------------------------------------------------'
{ # try !
	cd $MCSV_PATH/mobile
	#$SCRIPTS_PATH/front_step.sh
	$SCRIPTS_PATH/front_step_new.sh
} || { # catch!
    echo 'Front Error -------------------------------------------------------'
    exit 1
}



echo 'Run grunt tasks for production -------------------------------------------'
# (Optional) Run grunt tasks
# grunt dist
# grunt ...
grunt buildEnvironment:production
grunt buildAclStruct

echo 'Update package version ---------------------------------------------------'
cd $MCSV_PATH/mobile/
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" $PACKAGE_VERSION "index.html"
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" $PACKAGE_VERSION "bower.json"

echo 'Remove development dependencies ------------------------------------------'
# rm -f $MCSV_PATH/backend/composer.lock
rm -f $MCSV_PATH/mobile/GruntFile.js
rm -f $MCSV_PATH/mobile/.bowerrc
rm -f $MCSV_PATH/mobile/.bower.json

rm -Rf $MCSV_PATH/mobile/assets/functional-tests
#rm -Rf $MCSV_PATH/mobile/node_modules
rm -Rf $MCSV_PATH/mobile/etc
rm -Rf $MCSV_PATH/mobile/tests
rm -Rf $MCSV_PATH/mobile/config

# (Optional) -> Use it if you want to delete some other dev files or folders 
rm -Rf $MCSV_PATH/mobile/assets/js/controllers
rm -Rf $MCSV_PATH/mobile/assets/js/services
rm -Rf $MCSV_PATH/mobile/assets/js/repositories
rm -Rf $MCSV_PATH/mobile/assets/js/utilities

rm -f $MCSV_PATH/README.md

echo 'Remove all .git folders --------------------------------------------------'
cd $MCSV_PATH/

#find . -name .git -exec rm -rf {} +
find . -name "*.template" -type f|xargs rm -f
find . -name "*.gitignore" -type f|xargs rm -f
find . -name "README.md" -exec rm -r {} +
find . -name "README" -exec rm -r {} +

rm -Rf $SCRIPTS_PATH/
