#!/bin/sh

MCSV_PRODUCT_PATH=[SRV_BASE_PATH]/[SUB_TEST_PATH]
SCRIPTS_PATH="$MCSV_PRODUCT_PATH/ci_scripts/"
MODULE_NAME='fin'  
VERSION=$(date +%s)                  
MCSV_MODULE_SERVICE_PATH="$MCSV_PRODUCT_PATH/modules/$MODULE_NAME"
MCSV_MODULE_BACKEND_PATH="$MCSV_PRODUCT_PATH/modules/teknisa/$MODULE_NAME"
REPORTS_CONFIG_PATH="$MCSV_MODULE_BACKEND_PATH/reports"                     
ZEEDHI_TEST_PRODUCTS_PATH="/var/www/equipe_teste/zeedhi/test_products/organizationManagement/modules"
LTS_TEST_MCSV_PRODUCT_PATH="/var/www/equipe_teste/pebbian/erp"
ALIAS_SUB_RELEASE_TEST_PRODUCT_PATH=[SUB_TEST_PATH]
ALIAS_LTS_TEST_PRODUCT_PATH="erp"
DEVOPS_VERSION="[VERSION]"
DEVOPS_REVISION="[REVISION]"
DEVOPS_BUILD="[BUILD]"

echo 'Copy another microservice product to current sub-release folder ----------'
cp -R $LTS_TEST_MCSV_PRODUCT_PATH/backend/ $MCSV_PRODUCT_PATH
cp -R $LTS_TEST_MCSV_PRODUCT_PATH/mobile/  $MCSV_PRODUCT_PATH

#echo 'Front and back steps -----------------------------------------------------'
#cd $MCSV_MODULE_SERVICE_PATH/backend
#$SCRIPTS_PATH/back_step.sh $DEVOPS_VERSION $DEVOPS_REVISION $DEVOPS_BUILD

cd $MCSV_MODULE_SERVICE_PATH/mobile
$SCRIPTS_PATH/front_step.sh

echo 'Run grunt tasks for test -------------------------------------------------'
grunt buildEnvironment:test
grunt buildAclStruct

echo 'Environment mnemonics ----------------------------------------------------'
$SCRIPTS_PATH/env_mnemonics.sh $SCRIPTS_PATH $MCSV_MODULE_SERVICE_PATH "@@TEK_STORAGE_PATH@@" "@@TEK_REPORTS_URL@@" "@@TEK_DEFAULT_LANGUAGE@@" "@@TEK_ERROR_REPORTING@@"

echo 'Update Version -----------------------------------------------------------'
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" "$VERSION" "bower.json"

echo 'Backend mnemonics --------------------------------------------------------'
cd $MCSV_MODULE_SERVICE_PATH/backend/config

echo 'Update db.xml ------------------------------------------------------------'
$SCRIPTS_PATH/db_mnemonics.sh $SCRIPTS_PATH "@@DB_ORA_USER@@" "@@DB_ORA_PASSWORD@@" "@@DB_ORA_HOST@@" "@@DB_ORA_PORT@@" "@@DB_ORA_DBNAME@@" "@@DB_ORA_SERVICE_BOOL@@" "@@DB_VPD_WALLET_BOOL@@" "@@DB_VPD_BOOL@@" "@@DB_ORA_PASSWORD@@" "@@DB_ORA_ENCRYPTED_BOOL@@" "@@DB_ORA_SESSION_MODE@@" "@@DB_MONGO_HOST@@" "@@DB_MONGO_PORT@@"

echo 'Update BIRT files --------------------------------------------------------'
$SCRIPTS_PATH/report_mnemonics.sh $SCRIPTS_PATH "@@BIRT_LOGO_PATH@@" "@@BIRT_REPORTS_PATH@@" "@@BIRT_CONF_PATH@@" "@@BIRT_URL@@" "@@BIRT_TYPE@@" "@@BIRT_FORMAT@@" 
$SCRIPTS_PATH/birt_mnemonics.sh $SCRIPTS_PATH $REPORTS_CONFIG_PATH "@@BIRT_ORA_HOST@@" "@@BIRT_ORA_PORT@@" "@@BIRT_ORA_DBNAME@@" "@@BIRT_ORA_USER@@" "@@BIRT_ORA_PASSWORD@@" "@@BIRT_ORA_WALLET_BOOL@@" "@@TEK_SAAS_BOOL@@" "@@BIRT_ORA_WALLET_PREFIX@@" "@@DB_VPD_BOOL@@"

# (Optional) -> Use it if you use Zeedhi's FileUploader component.
echo 'Update fileUploader.xml --------------------------------------------------'
$SCRIPTS_PATH/fileserver_mnemonics.sh $SCRIPTS_PATH "@@TEK_FILESERVER_BASE_URL@@" "@@TEK_FILESERVER_TOKEN@@" "@@TEK_FILESERVER_KEY@@" "@@TEK_FILESERVER_MODE@@"

# (Optional) -> Use it if you use parameters that change through different client's servers.
# echo 'Update parameters.xml --------------------------------------------------'
# $SCRIPTS_PATH/parameters_mnemonics.sh $SCRIPTS_PATH "@@TEK_ZHU_LOG_BOOL@@"

# (Optional) -> Use it if you use QR2 Reports
echo 'Update QR2 files ---------------------------------------------------------'
$SCRIPTS_PATH/qr2_mnemonics.sh $SCRIPTS_PATH "@@QRD_TYPE@@" "@@QRD_URL@@" "@@QRD_PORT@@" "@@TEK_SAAS_BOOL@@"

# (Optional) -> Use it if you have specific mnemonics for your product
# echo 'Specific Mnemonics -------------------------------------------------------'
# $SCRIPTS_PATH/specific_mnemoinics.sh "MNEMONIC_NAME" "MNEMONIC_VALUE" "FILE_1_TO_UPDATE_PATH"
# $SCRIPTS_PATH/specific_mnemoinics.sh "MNEMONIC_NAME" "MNEMONIC_VALUE" "FILE_2_TO_UPDATE_PATH"

# (Optional) -> Use it if you want to clone ACL module
# echo 'Clone ACL ----------------------------------------------------------------'
# cd $SCRIPTS_PATH
# $SCRIPTS_PATH/clone_acl.sh $SCRIPTS_PATH $MCSV_PRODUCT_PATH
# $SCRIPTS_PATH/init_acl.sh $SCRIPTS_PATH $MCSV_PRODUCT_PATH

# (Optional) -> Use it if you want to clone Login module
# echo 'Clone Login --------------------------------------------------------------'
# cd $SCRIPTS_PATH
# $SCRIPTS_PATH/clone_login.sh $MCSV_PRODUCT_PATH
# $SCRIPTS_PATH/init_login.sh $SCRIPTS_PATH $MCSV_PRODUCT_PATH

# (Optional) -> Copy Login
echo 'Copy Login ---------------------------------------------------------------'
cp -R $ZEEDHI_TEST_PRODUCTS_PATH/login $MCSV_PRODUCT_PATH/modules

# (Optional) -> Copy ACL
echo 'Copy ACL -----------------------------------------------------------------'
cp -R $ZEEDHI_TEST_PRODUCTS_PATH/acl $MCSV_PRODUCT_PATH/modules
cp -R $ZEEDHI_TEST_PRODUCTS_PATH/teknisa/acl $MCSV_PRODUCT_PATH/modules/teknisa

# (Optional) -> Use it to change products database
echo 'Update db.xml ------------------------------------------------------------'
rm -f  $MCSV_PRODUCT_PATH/backend/config/db.xml
cp -Rf $MCSV_MODULE_SERVICE_PATH/backend/config/db.xml $MCSV_PRODUCT_PATH/backend/config/
cp -Rf $MCSV_MODULE_SERVICE_PATH/backend/config/db.xml $ANOTHER_MCSV_PRODUCT_PATH/backend/config/

# (Optional) -> Use it if you want to copy another Microservice Module
# LTS_TEST_OTHER_MCSV_MODULE_PATH=""
# OTHER_MCSV_MODULE_NAME=""
# OTHER_MCSV_MODULE_SERVICE_PATH="$LTS_TEST_OTHER_MCSV_MODULE_PATH/modules/$MCSV_MODULE_NAME"
# OTHER_MCSV_MODULE_BACKEND_PATH="$LTS_TEST_OTHER_MCSV_MODULE_PATH/modules/teknisa/$MCSV_MODULE_NAME"
# $SCRIPTS_PATH/cp_module.sh "$OTHER_MCSV_MODULE_NAME" $OTHER_MCSV_MODULE_SERVICE_PATH $OTHER_MCSV_MODULE_BACKEND_PATH $MCSV_PRODUCT_PATH

echo 'LTS Test Step ------------------------------------------------------------'
if [ ! -d "$MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules" ]; then
     mkdir $MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules
fi
cp -Rf $MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/ 
if [ ! -d "$MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/teknisa" ]; then
     mkdir $MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/teknisa
fi
cp -Rf $MCSV_MODULE_BACKEND_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/teknisa/ 

echo "Update Project product path to it's Sub-Release's path ------------------"
$SCRIPTS_PATH/replace.sh "$ALIAS_LTS_TEST_PRODUCT_PATH"  "$ALIAS_SUB_RELEASE_TEST_PRODUCT_PATH" "$MCSV_PRODUCT_PATH/mobile/assets/js/environment.js"
$SCRIPTS_PATH/replace.sh "$ALIAS_LTS_TEST_PRODUCT_PATH"  "$ALIAS_SUB_RELEASE_TEST_PRODUCT_PATH" "$MCSV_PRODUCT_PATH/mobile/assets/json/modules.json"

echo 'Update Login Step Microservice Module ------------------------------------'
$SCRIPTS_PATH/update_login_step.sh $SCRIPTS_PATH $MCSV_MODULE_SERVICE_PATH "@@TEK_LICENSE_URL@@"

# (Optional) -> Use it if you want to clone ACL module
# echo 'Update Login Step ACL ----------------------------------------------------'
# $SCRIPTS_PATH/update_login_step.sh $SCRIPTS_PATH $MCSV_PRODUCT_PATH/modules/acl "@@TEK_LICENSE_URL@@"

# (Optional) -> Use it if you want to clone Login module
# echo 'Update Login Step Login --------------------------------------------------'
# $SCRIPTS_PATH/update_login_step.sh $SCRIPTS_PATH $MCSV_PRODUCT_PATH/modules/login "@@TEK_LICENSE_URL@@"
