function titulosAPagarPagosPage() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const self = this;
	const protractorHelper = require('protractor-helper');


	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		self.clickByPath(['Financeiro', 'Títulos a Pagar', 'Operações', 'Títulos a Pagar/Pagos']);
		geral.esperarLoading();
		geral.clickAplicarFiltro();
	};


	this.clickByPath = function (fullPath) {
		let prefix = '.zh-main-menu>.menu-group>.menu-group-items>';
		let child;
		for (const index in fullPath) {
			if (fullPath.hasOwnProperty(index)) {
				if (fullPath[index] == 'Operações') {
					child = element.all(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index])).get(1);
				} else {
					child = element(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index]));
				}
				child = child.element(by.xpath('..')).element(by.xpath('..'));
				protractorHelper.click(child);
				prefix = '.sub-menu>';
				browser.sleep(500);
			}
		}
	};


	this.adicionar = (unidadeDeOrigem, tipo, fornecedor, operacao, serie, valorDocumento, tipoDeConta) => {
		geral.searchAndClickGridField('NMFILIALRECE', unidadeDeOrigem, 'NMFILIAL');
		geral.selectNative('IDSTATUS', tipo);
		geral.searchAndClickGridFieldLadZone('NMRAZSOCFORN', 'NMRAZSOCFORN', fornecedor, 'NMRAZSOCFORN');
		geral.searchAndClickGridFieldLadZone('NMTIPOOPER', 'NMTIPOOPER', operacao, 'NMTIPOOPER');
		geral.searchAndClickGridFieldLadZone('DSSERIE', 'DSSERIE', serie, 'DSSERIEENTR');
		geral.clickAndFllField('VRNOTAFISC', valorDocumento);
		geral.searchAndClickGridFieldLadZone('DSTPCTPAGAR', 'DSTPCTPAGAR', tipoDeConta, 'DSTPCTPAGAR');
	};


	this.editar = (ajuste, valor) => {
		geral.searchAndClickGridFieldLadZone('DSAJUCTPAG', 'DSAJUCTPAG', ajuste, 'DSAJUCTPAG');
		geral.clickAndFllField('VRAJBOLPAG', valor);
	};


	this.incluir = (vencimento, motivo) => {
		geral.clickAndFllField('DTVENBOLPAG', vencimento, 'DTVENBOLPAG');
		geral.searchAndClickGridFieldLadZone('DSMOTIPROR', 'DSMOTIPROR', motivo, 'DSMOTIPROR');
	};
}

module.exports = new titulosAPagarPagosPage();
