/*
 TECNISA - TECNOLOGIA EM INFORMTICA

 NOME: IMPOSTO_ENTRADA

 DESCRIO:
  PROCEDIMENTO PARA ATUALIZAO DOS IMPOSTOS, VALOR DA NOTA FISCAL
  PARA NOTAS DE ENTRADA

 CRIAO:
 06/04/98 - ROBERTO A. LOPES MARTINS

 RAISERROR('', 16,1);

 @C:\Win_619\Sql\End_Conv\SqlServer\5201_DFESTPS_IMPOSTO_ENTRADA.sql
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'IMPOSTO_ENTRADA' AND
	        TYPE = 'P' 			        AND
	        U.UID = O.UID              AND
	        U.NAME = USER)

DROP PROCEDURE IMPOSTO_ENTRADA
GO

CREATE PROCEDURE IMPOSTO_ENTRADA @P_EMPRESA  VARCHAR(02),           --EMPRESA
                                 @P_INSCESTA VARCHAR(16),           --INSCRIO ESTADUAL
                                 @P_TIPOOPER VARCHAR(02),           --TIPO DE OPERAO
                                 @P_FORNECED VARCHAR(21),           --CDIGO FORNECEDOR
                                 @P_FILIAL   VARCHAR(04),           --FILIAL
                                 @P_LANCTONF VARCHAR(10),           --N LANCAMENTO
                                 @P_INIVALID DATETIME,              --DATA DE INICIO DE VALIDADDE
                                 @P_LANCESTQ VARCHAR(10) = NULL,    --N LANCAMENTO DE ESTOQUE. SE NULO, NO ATUALIZA ESTOQUE
                                 @P_ENTRSAID VARCHAR(01) = 'E',     --PARMETRO P/ IMPORTACAO DE NOTAS DE SADA
                                 @P_CDOPERADOR VARCHAR(12) = NULL,  --CDIGO OPERADOR
                                 @P_AUDIT     VARCHAR(01) = NULL,
                                 @P_VRNOTAFISC NUMERIC(15,6) OUTPUT --VALOR DA NF RETORNADO

AS

   DECLARE @V_PAISORIG     VARCHAR(04);
   DECLARE @V_ESTAORIG     VARCHAR(02);
   DECLARE @V_MUNIORIG     VARCHAR(04);
   DECLARE @V_PAISDEST     VARCHAR(04);
   DECLARE @V_ESTADEST     VARCHAR(02);
   DECLARE @V_MUNIDEST     VARCHAR(04);
   DECLARE @V_PAISCFOP     VARCHAR(04);
   DECLARE @V_ESTACFOP     VARCHAR(02);
   DECLARE @V_IDENDCFOP    VARCHAR(01);
   DECLARE @V_CDPAISST     VARCHAR(04);
   DECLARE @V_SGESTADOST   VARCHAR(02);
   DECLARE @V_CDMUNICIPIOST VARCHAR(04);
   DECLARE @V_CDINSCESTAST VARCHAR(16);
   DECLARE @V_ALIQTEMP     VARCHAR(14);
   DECLARE @V_INCITEMP     VARCHAR(14);
   DECLARE @V_CST1DIGT     VARCHAR(1);
   DECLARE @V_CSTTEMP      VARCHAR(14);
   DECLARE @V_CFOPTEMP     VARCHAR(14);
   DECLARE @V_FISOPEITEM   VARCHAR(10);
   DECLARE @V_SUFXCFOPPR   VARCHAR(03);
   DECLARE @V_SITUTRIBPR   VARCHAR(03);
   DECLARE @V_IDTRIMPSTII  VARCHAR(01);
   DECLARE @V_CDIMPOSTRIB  VARCHAR(100);
   DECLARE @V_NRINSJURNF   VARCHAR(20);
   DECLARE @V_SERIE        VARCHAR(05);
   DECLARE @V_TIPOMOVI     VARCHAR(01);
   DECLARE @V_CDFISCOPER   VARCHAR(10);
   DECLARE @V_CDFILIRECE   VARCHAR(04);
   DECLARE @V_CDFILIEMIT   VARCHAR(04);
   DECLARE @V_INTEGRACAO   VARCHAR(16);
   DECLARE @V_CDFISOPENTF  VARCHAR(10);
   DECLARE @V_IDVALORINFO  VARCHAR(01);
   DECLARE @V_NRNOTAFISC   VARCHAR(10);
   DECLARE @V_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_CDPRGENEREV  VARCHAR(10);
   DECLARE @V_IDDOCFINANC  VARCHAR(01);
   DECLARE @V_IDSTATUS     VARCHAR(01);
   DECLARE @V_IDORIGDESTNF VARCHAR(01);
   DECLARE @V_NMTIPOOPER   VARCHAR(30);
   DECLARE @V_NMFILIEMIT   VARCHAR(30);
   DECLARE @V_DESCLANC     VARCHAR(60);
   DECLARE @V_IDDOCREPLIC  VARCHAR(14);
   DECLARE @V_IDSISTEMA    VARCHAR(03);
   DECLARE @V_IDRETPROEXP  VARCHAR(01);
   DECLARE @V_FILIORIG     VARCHAR(04);
   DECLARE @V_DEVOLORIG    VARCHAR(14);
   DECLARE @V_IDCTRLESTQ   VARCHAR(01);
   DECLARE @V_IDORDPRIMDFENT VARCHAR(01);
   DECLARE @V_IDTPFORPGTFO VARCHAR(01);
   DECLARE @V_IDFORMAPUR   VARCHAR(01);
   DECLARE @V_IDATUEST     VARCHAR(01);
   DECLARE @V_IDVRIMPSTRIB VARCHAR(01);
   DECLARE @V_CDSITTRIBTMP VARCHAR(02);
   DECLARE @V_IDMODBCNFE   VARCHAR(01);
   DECLARE @V_IDMODBCSTNFE VARCHAR(01);
   DECLARE @V_CDTPCRPICOSTNFE  VARCHAR(03);
   DECLARE @V_CDNATUBCPCSTNFE  VARCHAR(02);

   DECLARE @V_IDINTEREST   VARCHAR(01);
   DECLARE @V_IDINTERNA    VARCHAR(01);

   DECLARE @V_CDIMPOSTO    VARCHAR(02);

   DECLARE @V_PARDEDTMP    NUMERIC(15,5);
   DECLARE @V_PREDBCTMP1   NUMERIC(15,5);
   DECLARE @V_PREDBCTMP    NUMERIC(15,5);
   DECLARE @V_ALIQUTMP     NUMERIC(15,5);
   DECLARE @V_PBCSUBTRIB   NUMERIC(15,5);
   DECLARE @V_TAXABCSUBSTR NUMERIC(15,5);
   DECLARE @V_VRIMPOSTOST  NUMERIC(15,5);
   DECLARE @V_VRPPRIIMPST  NUMERIC(15,5);
   DECLARE @V_COUNT        NUMERIC(15,5);
   DECLARE @V_MAXAVIS      NUMERIC(15,5);
   DECLARE @V_LIQUIITEM    NUMERIC(15,5);
   DECLARE @V_LIQUIDOPROD  NUMERIC(15,5);
   DECLARE @V_TOTALNOTA    NUMERIC(15,5);
   DECLARE @V_LIQUIDO      NUMERIC(15,5);
   DECLARE @V_VRPRODUTOS   NUMERIC(15,5);
   DECLARE @V_VRCOMPLEMEN  NUMERIC(15,5);
   DECLARE @V_SOMAENCA     NUMERIC(15,5);
   DECLARE @V_MENOENCA     NUMERIC(15,5);
   DECLARE @V_SOMAIMPO     NUMERIC(15,5);
   DECLARE @V_MENOIMPO     NUMERIC(15,5);
   DECLARE @V_TOTAPRODENCA NUMERIC(15,5);
   DECLARE @V_TOTAPRENIMPO NUMERIC(15,5);
   DECLARE @V_TOTAIMPBCALC NUMERIC(15,5);
   DECLARE @V_TOTAIMPBCINF NUMERIC(15,5);
   DECLARE @V_TAXABASECALC NUMERIC(15,5);
   DECLARE @V_TOTAIMPBCDES NUMERIC(15,5);
   DECLARE @V_TAXAALIQUOTA NUMERIC(15,5);
   DECLARE @V_PRODUENCARGO NUMERIC(15,5);
   DECLARE @V_SEQUIMPOSTNF NUMERIC;
   DECLARE @V_SOMAITEM     NUMERIC(15,5);
   DECLARE @V_DESCITEM     NUMERIC(15,5);
   DECLARE @V_BASECALCIT   NUMERIC(15,5);
   DECLARE @V_BASECALCIRRF NUMERIC(15,5);
   DECLARE @V_IMPOSTOIT    NUMERIC(15,5);
   DECLARE @V_IMPOSTORED1  NUMERIC(15,5);
   DECLARE @V_FATOCONV     NUMERIC(15,5);
   DECLARE @V_TOTABRUT     NUMERIC(15,5);
   DECLARE @V_QTDELANCTO   NUMERIC(15,5);
   DECLARE @V_VRUNITLANCTO NUMERIC(15,5);
   DECLARE @V_VRTOTALANCTO NUMERIC(15,5);
   DECLARE @V_TOTACONTAB   NUMERIC(15,5);
   DECLARE @V_VRBRUTO      NUMERIC(15,5);
   DECLARE @V_VRCONTAB     NUMERIC(15,5);
   DECLARE @V_IMPOCONTAB   NUMERIC(15,5);
   DECLARE @V_TOTIMPOCONT  NUMERIC(15,5);
   DECLARE @V_TOTIMPOBRUT  NUMERIC(15,5);
   DECLARE @V_CONTIMPO     NUMERIC(15,5);
   DECLARE @V_ALIQINFO     NUMERIC(15,5);
   DECLARE @V_TAXAALIQINFO NUMERIC(15,5);
   DECLARE @V_IMPOSINFO    NUMERIC(15,5);
   DECLARE @V_VRPERREDBCIT NUMERIC(15,5);
   DECLARE @V_VRBASECALCIT NUMERIC(15,5);
   DECLARE @V_CONTABCALC   NUMERIC(15,5);
   DECLARE @V_PERDBCALC    NUMERIC(15,5);
   DECLARE @V_VRCONTITG    NUMERIC(15,5);
   DECLARE @V_BCALCITG     NUMERIC(15,5);
   DECLARE @V_NOTAFISC     NUMERIC(15,5);
   DECLARE @V_TOTAPROD     NUMERIC(15,5);
   DECLARE @V_VRDIFERENCA  NUMERIC(15,5);
   DECLARE @V_VRNOTAFISC   NUMERIC(15,5);
   DECLARE @V_VRTOTIMPONF  NUMERIC(15,5);
   DECLARE @V_IMPOSRETI    NUMERIC(15,5);
   DECLARE @V_VRCONTAREC   NUMERIC(15,5);
   DECLARE @V_NRDECITOTANF NUMERIC(15,5);
   DECLARE @V_EXISTE_ROT   NUMERIC(5);
   DECLARE @V_VRCUSTENTR   NUMERIC(15,5);
   DECLARE @V_VALRDESCITEM NUMERIC(15,5);
   DECLARE @V_VRIMPOSCONT  NUMERIC(15,5);
   DECLARE @V_VRREDUCAO    NUMERIC(15,5);
   DECLARE @V_NRIMPOSTO    NUMERIC(15,5);
   DECLARE @V_MINBCPROD    NUMERIC(15,5);
   DECLARE @V_VRNOTAF      DOUBLE PRECISION;
   DECLARE @V_VRTOTAITEM   NUMERIC(16,2);
   DECLARE @V_SOMATOTAITEM NUMERIC(16,2);
   DECLARE @V_PERCENTITEM  NUMERIC(16,2);

   /*VARIVEIS PARA DIFERENCIAL DE ALQUOTA*/
   DECLARE @V_ALIQDIFE     NUMERIC;
   DECLARE @V_ALIQDEST     NUMERIC;
   DECLARE @V_IMPOSTODIFE  NUMERIC;
   DECLARE @V_BCALCDIFCOMP NUMERIC;
   DECLARE @V_IDCALCDIFENTFISC VARCHAR(01);

   DECLARE @V_CDGRUPOFISC  VARCHAR(03);
   DECLARE @V_CDGRPFISCSV  VARCHAR(03);
   DECLARE @V_UTGRUPFISCS  VARCHAR(01);

   DECLARE @V_CDORIGDESTNF VARCHAR(21);

   DECLARE @V_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ VARCHAR(06);

   DECLARE @V_DIFALIQITEM      VARCHAR(01);
   DECLARE @V_IDDIFALIQCUSPRC  VARCHAR(01);

   DECLARE @V_CDCSTDIGI    VARCHAR(03);

   DECLARE @V_IMPOSITEM    VARCHAR(14);

   DECLARE @V_IDOPERDEVONF VARCHAR(01);
   DECLARE @V_IDUTCUSORIGEST VARCHAR(01);
   DECLARE @V_IMPOSTO      VARCHAR(02);
   DECLARE @V_IDRECALCULO  VARCHAR(01);
   DECLARE @V_IDNFOUTRASNF VARCHAR(01);
   DECLARE @V_QTDEREGTRAB  NUMERIC(16,5);

   DECLARE @V_DSCDFISOPEIT VARCHAR(100);

   /* VARIVEIS DO CURSOR C_IMPOSTORETI*/
   DECLARE @V_IMPOSTORETI_CDEMPRESA   VARCHAR(02);
   DECLARE @V_IMPOSTORETI_CDIMPOSTO   VARCHAR(02);
   DECLARE @V_IMPOSTORETI_IDTPIJURNF  VARCHAR(01);
   DECLARE @V_IMPOSTORETI_NRINSJURNF  VARCHAR(20);
   DECLARE @V_IMPOSTORETI_DTENTRSAID  DATETIME;

   /*VARIVEIS DO CURSOR ICMSST*/
   DECLARE @V_ICMSST_CDIMPOSTRIB VARCHAR(20);

   /* VARIVEIS DO CURSOR C_ITEMPRODUTO*/
   DECLARE @V_ITEMPROD_VRTOTAITEM  NUMERIC(16,2);
   DECLARE @V_ITEMPROD_VRDESCITEM  NUMERIC(16,2);
   DECLARE @V_ITEMPROD_CDPRODUTO   VARCHAR(10);
   DECLARE @V_ITEMPROD_CDARVPROD   VARCHAR(10);
   DECLARE @V_ITEMPROD_NRSEQITPROD VARCHAR(04);
   DECLARE @V_ITEMPROD_QTITEMPROD  NUMERIC(10,3);
   DECLARE @V_ITEMPROD_CDFISOPEITEM VARCHAR(11);
   DECLARE @V_ITEMPROD_CDSITUTRIBPR VARCHAR(3);
   DECLARE @V_ITEMPROD_IDORIGEMPROD VARCHAR(01); 
   DECLARE @V_ITEMPPROD_CDFISCOPERSN VARCHAR(4);


   /* VARIVEIS DO CURSOR C_INCIDENCIA*/
   DECLARE @V_INCIDENC_CDIMPOTEMP   VARCHAR(02);
   DECLARE @V_INCIDENC_CDFISCTEMP   VARCHAR(01);
   DECLARE @V_INCIDENC_IDTRATIMPTMP VARCHAR(01);
   DECLARE @V_INCIDENC_IDCONSISTENT VARCHAR(01);
   DECLARE @V_INCIDENC_IDIMPORECUP  VARCHAR(01);
   DECLARE @V_INCIDENC_IDPREIMPENTR VARCHAR(01);
   DECLARE @V_INCIDENC_IDUTMUNIORIG VARCHAR(01);
   DECLARE @V_INCIDENC_IDORGARRECAD VARCHAR(01);
   DECLARE @V_INCIDENC_IDUTVLRQTDEIMPO VARCHAR(01);
   DECLARE @V_INCIDENC_IDUTVRPAUTA  VARCHAR(01);
   DECLARE @V_INCIDENC_CDDETALHEPROD VARCHAR(05);
   DECLARE @V_INCIDENC_CDENQLEGALIPI VARCHAR(03);

   /*VARIVEIS DO CURSOR  C_DIFEALIQ */
   DECLARE @V_DIFE_CDFOPDIFALIQ VARCHAR(02);

   /*VARIVEIS DO CURSOR C_ITEMENCARGO*/
   DECLARE @V_ITEMENC_CDENCARGO    VARCHAR(02);
   DECLARE @V_ITEMENC_VRITEMENCA   NUMERIC(16,2);
   DECLARE @V_ITEMENC_IDENCARGO    VARCHAR(01);
   DECLARE @V_ITEMENC_CDCTBLENTREN VARCHAR(20);
   DECLARE @V_ITEMENC_CDCTBLSAIDEN VARCHAR(20);

   /*VARIVEIS DO CURSOR C_VRLIQRATEIO*/
   DECLARE @V_VRLIQ_NRSEQITPROD VARCHAR(04);
   DECLARE @V_VRLIQ_VRLIQUIDO   NUMERIC(16,2);

   /*VARIVEIS DO CURSOR C_ATUAVRCONT*/
   DECLARE @V_ATUAVR_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_ATUAVR_VRLIQUIDO    NUMERIC(16,2);
   DECLARE @V_ATUAVR_NRITPROIMPOS VARCHAR(01);
   DECLARE @V_ATUAVR_CDIMPOSTOIT  VARCHAR(02);
   DECLARE @V_ATUAVR_VRIMPOSIT    NUMERIC(16,2);
   DECLARE @V_ATUAVR_CDFISCIMPOIT VARCHAR(01);
   DECLARE @V_ATUAVR_IDIMPORECUP  VARCHAR(01);
   DECLARE @V_ATUAVR_CDCCTBLATIV  VARCHAR(20);
   DECLARE @V_ATUAVR_CDCCTBLPASS  VARCHAR(20);
   DECLARE @V_ATUAVR_IDTRATIMPO   VARCHAR(01);

   /*VARIVEIS DO CURSOR C_ITEMPROIMPOS*/
   DECLARE @V_ITEMPROI_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_ITEMPROI_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_ITEMPROI_VRPERREDBCIT NUMERIC(10,2);
   DECLARE @V_ITEMPROI_VRALIQITEM   NUMERIC(10,2);
   DECLARE @V_ITEMPROI_VRPARDEDIT   NUMERIC(16,2);
   DECLARE @V_ITEMPROI_VRALIQIMPOIT NUMERIC(10,2);
   DECLARE @V_ITEMPROI_VRLIQUIDO    NUMERIC(16,2);
   DECLARE @V_ITEMPROI_IDVALORINFO  VARCHAR(01);
   DECLARE @V_ITEMPROI_NRITPROIMPOS VARCHAR(01);
   DECLARE @V_ITEMPROI_IDTRIMPSTII  VARCHAR(01);

   /*VARIVEIS DO CURSOR C_PRODUTO*/
   DECLARE @V_PRODUTO_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_PRODUTO_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_PRODUTO_VRPERREDBCIT NUMERIC(10,2);
   DECLARE @V_PRODUTO_VRALIQITEM   NUMERIC(10,2);
   DECLARE @V_PRODUTO_VRPARDEDIT   NUMERIC(16,2);
   DECLARE @V_PRODUTO_CDFISCALIT   VARCHAR(01);
   DECLARE @V_PRODUTO_VRIMPOSIT    NUMERIC(16,2);
   DECLARE @V_PRODUTO_IDTRATIMPO   VARCHAR(01);
   DECLARE @V_PRODUTO_IDIMPORECUP  VARCHAR(01);
   DECLARE @V_PRODUTO_CDCCTBLPASS  VARCHAR(20);
   DECLARE @V_PRODUTO_CDCCTBLATIV  VARCHAR(20);
   DECLARE @V_PRODUTO_VRALIQIMPOIT NUMERIC(10,2);
   DECLARE @V_PRODUTO_NRITPROIMPOS VARCHAR(01);
   DECLARE @V_PRODUTO_NRSEQITPRO   VARCHAR(01);
   DECLARE @V_PRODUTO_IDVALORINFO  VARCHAR(01);
   DECLARE @V_PRODUTO_IDTRIMPSTII  VARCHAR(01);
   DECLARE @V_PRODUTO_IDTIPCONTAB  VARCHAR(20);
   DECLARE @V_PRODUTO_VRBASECALCIT DOUBLE PRECISION;
   DECLARE @V_PRODUTO_IDCONTAIMPADIC VARCHAR(1);
   DECLARE @V_PRODUTO_CDIMPOSTONFE VARCHAR(02);

   DECLARE @V_PRODUTO_CDARVPROD    VARCHAR(20);
   DECLARE @V_PRODUTO_CDPRODUTO    VARCHAR(10);
   DECLARE @V_PRODUTO_VRTOTAITEM   NUMERIC(16,2);
   DECLARE @V_PRODUTO_VRDESCITEM   NUMERIC(16,2);
   DECLARE @V_PRODUTO_IDORIGEMPROD VARCHAR(01);

   /*VARIVEIS DO CURSOR C_IMPOSNFTOT*/
   DECLARE @V_IMPOSNF_CDIMPOSTO     VARCHAR(02);
   DECLARE @V_IMPOSNF_CDIMPOSTOIT   VARCHAR(02);
   DECLARE @V_IMPOSNF_VRIMPOSTOIT   NUMERIC(18,5);
   DECLARE @V_IMPOSNF_VRBASECALCIT  NUMERIC(16,2);
   DECLARE @V_IMPOSNF_VRBCALCIMPOIT NUMERIC(16,2);
   DECLARE @V_IMPOSNF_IDPREIMPENTR  VARCHAR(01);

   /*VARIVEIS DO CURSOR C_IMPOSCONTAB*/
   DECLARE @V_IMPOSCONT_VRIMPOSTOT  NUMERIC(15,2);
   DECLARE @V_IMPOSCONT_IDIMPORECUP VARCHAR(01);
   DECLARE @V_IMPOSCONT_CDCCTBLPASS VARCHAR(20);
   DECLARE @V_IMPOSCONT_CDCCTBLATIV VARCHAR(20);
   DECLARE @V_IMPOSCONT_IDTRATIMPO  VARCHAR(01);
   DECLARE @V_IMPOSCONT_CDFISCTEMP  VARCHAR(01);

   /*VARIVEIS DO CURSOR C_ITPRODUTO*/
   DECLARE @V_ITPROD_NRSEQITPROD VARCHAR(04);
   DECLARE @V_ITPROD_VRLIQUIDO   NUMERIC(16,2);

   /* VARIVEIS DO CURSOR C_IMPOSTONF*/
   DECLARE @V_IMPOSTON_CDIMPOSTOIT   VARCHAR(02);
   DECLARE @V_IMPOSTON_VRALIQIMPOIT  NUMERIC(10,2);
   DECLARE @V_IMPOSTON_VRREDBCIMPOIT NUMERIC(10,2);
   DECLARE @V_IMPOSTON_VRPDEDIMPOIT  NUMERIC(16,2);
   DECLARE @V_IMPOSTON_CDFISCIMPOIT  VARCHAR(01);
   DECLARE @V_IMPOSTON_CDSTRIBIMPOIT VARCHAR(03);
   DECLARE @V_IMPOSTON_CDFOPERIMPOIT VARCHAR(10);
   DECLARE @V_IMPOSTON_CDSCFOPIMPOIT VARCHAR(03);
   DECLARE @V_IMPOSTON_NRSEQITPRO    VARCHAR(01);
   DECLARE @V_IMPOSTON_VRCONTIMPOIT  NUMERIC(18,5);
   DECLARE @V_IMPOSTON_VRBCALCIMPOIT NUMERIC(16,2);
   DECLARE @V_IMPOSTON_VRIMPOSIT     NUMERIC(16,2);
   DECLARE @V_IMPOSTON_IDTRATIMPO    VARCHAR(01);
   DECLARE @V_IMPOSTON_VRIMPOSCONT   NUMERIC(16,2);
   DECLARE @V_IMPOSTON_IDDIFALIQCUSPTI VARCHAR(01);
   DECLARE @V_IMPOSTON_IDMOTDESOTRABIT VARCHAR(01);

   /*VARIVEIS DO CURSOR C_ITEMPROD*/
   DECLARE @V_ITEMPPROD_CDFILIAL         VARCHAR(04);
   DECLARE @V_ITEMPPROD_NRLANCTONF       VARCHAR(10);
   DECLARE @V_ITEMPPROD_NRSEQITPROD      VARCHAR(04);
   DECLARE @V_ITEMPPROD_CDPRODUTO        VARCHAR(10);
   DECLARE @V_ITEMPPROD_CDARVPROD        VARCHAR(10);
   DECLARE @V_ITEMPPROD_CDPRODEMIS       VARCHAR(20);
   DECLARE @V_ITEMPPROD_DSPRODEMIS       VARCHAR(400);
   DECLARE @V_ITEMPPROD_IDATUVRESTOQ     VARCHAR(01);
   DECLARE @V_ITEMPPROD_QTITEMPROD       NUMERIC(15,5);
   DECLARE @V_ITEMPPROD_VRUNITITEM       NUMERIC(16,5);
   DECLARE @V_ITEMPPROD_VRDESCITEM       NUMERIC(16,2);
   DECLARE @V_ITEMPPROD_VRTOTAITEM       NUMERIC(16,2);
   DECLARE @V_ITEMPPROD_VRCONTITEM       NUMERIC(16,5);
   DECLARE @V_ITEMPPROD_IDCONFORITEM     VARCHAR(01);
   DECLARE @V_ITEMPPROD_CDFISOPEITEM     VARCHAR(10);
   DECLARE @V_ITEMPPROD_CDSUFXCFOPPR     VARCHAR(03);
   DECLARE @V_ITEMPPROD_CDSITUTRIBPR     VARCHAR(03);
   DECLARE @V_ITEMPPROD_IDERROSITEM      VARCHAR(05);
   DECLARE @V_ITEMPPROD_IDAVISOSITEM     VARCHAR(05);
   DECLARE @V_ITEMPPROD_VRBRUTITEM       NUMERIC(16,5);
   DECLARE @V_ITEMPPROD_NRLOTEESTQ       VARCHAR(20);
   DECLARE @V_ITEMPPROD_NRSUBLOTE        VARCHAR(04);
   DECLARE @V_ITEMPPROD_IDORIGEMPROD     VARCHAR(01);


   /*VARIVEIS DO CURSOR C_INCIDITEM*/
   DECLARE @V_INCIDITEM_CDIMPOTEMP VARCHAR(02);
   DECLARE @V_INCIDITEM_CDFISCTEMP VARCHAR(01);
   DECLARE @V_INCIDITEM_CDENQLEGALIPI VARCHAR(03);

   /*VARIVEIS DO CURSOR C_IMPOSPROD*/
   DECLARE @V_IMPOSPROD_CDIMPOSTOIT  VARCHAR(02);
   DECLARE @V_IMPOSPROD_VRIMPOSTOIT  NUMERIC(18,5);
   DECLARE @V_IMPOSPROD_VRBASECALCIT NUMERIC(16,2);

   /*VARIVEIS DO CURSOR C_VRIMPOSTO*/
   DECLARE @V_VRIMPOSTO_CDIMPOSTOIT VARCHAR(02);
   DECLARE @V_VRIMPOSTO_VRIMPOSIT   NUMERIC(16,2);

   /*VARIVEIS DO CURSOR C_ATUALIZA*/
   DECLARE @V_ATUALIZA_NRSEQIMPOIT VARCHAR(04);

   /*VARIVEIS DO CURSOR C_ITLANCTOEST*/
   DECLARE @V_ITLANC_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_ITLANC_CDPRODUTO    VARCHAR(10);
   DECLARE @V_ITLANC_VRUNITITEM   NUMERIC(16,5);
   DECLARE @V_ITLANC_VRTOTAITEM   NUMERIC(16,2);
   DECLARE @V_ITLANC_QTITEMPROD   NUMERIC(15,5);
   DECLARE @V_ITLANC_CDPRODESTO   VARCHAR(10);
   DECLARE @V_ITLANC_VRBRUTITEM   NUMERIC(16,5);
   DECLARE @V_ITLANC_VRDESCITEM   NUMERIC(16,2);
   DECLARE @V_ITLANC_VRCONTITEM   NUMERIC(16,5);
   DECLARE @V_ITLANC_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_ITLANC_CDLOCALESTOQ VARCHAR(06);
   DECLARE @V_ITLANC_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_ITLANC_NRSUBLOTE    VARCHAR(04);
   DECLARE @V_ITLANC_CDFILIMOVI   VARCHAR(04);
   DECLARE @V_ITLANC_CDFISOPEITEM VARCHAR(10);
   DECLARE @V_ITLANC_IDORIGEMPROD VARCHAR(01);

   /*VARIVEIS DO CURSOR C_IMPOSNOTA */
   DECLARE @V_IMPOSNOTA_CDIMPOSTO VARCHAR(02);
   DECLARE @V_IMPOSNOTA_CDREGRAIT VARCHAR(10);
   /*VARIVEIS DO CURSOR C_REGRAMSG */
   DECLARE @V_REGRAMSG_CDREGRAFISC     VARCHAR(10);
   DECLARE @V_REGRAMSG_DSMENSREGRAFISC VARCHAR(150);


   DECLARE @V_VRCUSTPROD          NUMERIC(16,5);

   /*VARIVEL DO CURSOR C_QTITEM*/
   DECLARE @V_QTITEM_NRSEQITPROD  VARCHAR(04);

   /*VARIAVEIS DO CURSOR C_ITEM*/
   DECLARE @C_ITEM_VRBRUTITEM   NUMERIC(16,2);
   DECLARE @C_ITEM_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_DATA              DATETIME;


   /*VARIVEIS DO CURSOR C_PREDBCALC*/

   DECLARE @V_PREDBCALC_NRSEQIMPOIT   VARCHAR(04);
   DECLARE @V_PREDBCALC_CDIMPOSTOIT   VARCHAR(02);
   DECLARE @V_PREDBCALC_CDSTRIBIMPOIT VARCHAR(03);
   DECLARE @V_PREDBCALC_CDFOPERIMPOIT VARCHAR(11);
   DECLARE @V_PREDBCALC_CDSCFOPIMPOIT VARCHAR(03);
   DECLARE @V_PREDBCALC_VRCONTIMPOIT  NUMERIC(16,5);
   DECLARE @V_PREDBCALC_VRREDBCIMPOIT NUMERIC(16,5);
   DECLARE @V_PREDBCALC_VRBCALCIMPOIT NUMERIC(16,2);
   DECLARE @V_PREDBCALC_IDVALORINFO   VARCHAR(01);
   DECLARE @V_PREDBCALC_CDARVPROD     VARCHAR(10);
   DECLARE @V_PREDBCALC_IDORIGEMPROD  VARCHAR(01);

   /*VARIVEIS DO CURSOR C_INCBCALC*/

   DECLARE @V_INCBCALC_CDFILIAL    VARCHAR(04);
   DECLARE @V_INCBCALC_NRLANCTONF  VARCHAR(10);
   DECLARE @V_INCBCALC_CDIMPOBCALC VARCHAR(02);

   /*VARIVEIS DO CURSOR C_ENCARGO*/

   DECLARE @V_ENCARGO_IDENCARGO   VARCHAR(01);
   DECLARE @V_ENCARGO_VRITEMENCA  NUMERIC(16,5);

/*VARIVEIS PARA CALCULO DO CUSTO LOGISTICO*/
   DECLARE @V_VRPESOBRUTPR    NUMERIC(16,5);
   DECLARE @V_VRPECUSTOLOG    NUMERIC(16,5);
   DECLARE @V_VRVRCUSTOLOG    NUMERIC(16,5);
   DECLARE @V_VRPESEGURLOG    NUMERIC(16,5);
   DECLARE @V_VRCUSTOLOG      NUMERIC(16,5);
   DECLARE @V_VRCUSTOSEG      NUMERIC(16,5);

   DECLARE @V_DADOADIC        VARCHAR(03);
   DECLARE @V_CDEMPRESA       VARCHAR(02);
   DECLARE @V_CDINSCESTA      VARCHAR(16);
   /*VARIVEIS DO CURSOR C_MENSINSC*/
   DECLARE @V_MENSINSC_CDMENSAGEM VARCHAR(03);
   DECLARE @V_MENSINSC_DSMENSAGEM VARCHAR(120);

   DECLARE @V_VRIMPDIFALIQ   NUMERIC(16,5);

   DECLARE @V_CDTIPCUSTEST   DOUBLE PRECISION;
   DECLARE @V_DTSAIDNFORIG   DATETIME;
   DECLARE @V_DTATUAL        DATETIME;

   DECLARE @V_NRSEQITIMP     VARCHAR(04);
   DECLARE @V_NRIMPOSNF      VARCHAR(02);

   DECLARE @V_VRCONT_CDIMPOSTO      VARCHAR(02);
   DECLARE @V_VRCONT_VRCONTABILNF   NUMERIC(16,5);

   /*VARIVEIR DO CURSOR C_ITEMENCARGO*/
   DECLARE @V_ITEMENCARGO_CDENCARGONFE VARCHAR(02);
   DECLARE @V_ITEMENCARGO_VRITEMENCA   NUMERIC(16,2);

   /*VARIVEIS DO CURSOR C_ITEMPRODUTO*/
   DECLARE @V_ITEMPRODUTO_NRSEQITPROD VARCHAR(04);
   DECLARE @V_ITEMPRODUTO_VRTOTAITEM  NUMERIC(16,2);

   DECLARE @V_CDFISCOPERSN   VARCHAR(04);
   DECLARE @V_IMPOICMS       VARCHAR(02);

   /* VARIVEIS DO CURSOR C_IMPOSORIG */
   DECLARE @V_IMPOSORIG_VRPERREDBCIT       NUMERIC(16,5);
   DECLARE @V_IMPOSORIG_NRITPROIMPOS       VARCHAR(01);
   DECLARE @V_IMPOSORIG_CDIMPOSTO          VARCHAR(02);
   DECLARE @V_IMPOSORIG_CDFISCALIT         VARCHAR(01);
   DECLARE @V_IMPOSORIG_VRALIQITEM         NUMERIC(16,5);
   DECLARE @V_IMPOSORIG_VRPARDEDIT         NUMERIC(16,5);
   DECLARE @V_IMPOSORIG_IDVALORINFIT       VARCHAR(01);
   DECLARE @V_IMPOSORIG_QTITEMPROD         NUMERIC(16,5);
   DECLARE @V_IMPOSORIG_CDSITUTRIBITNFE    VARCHAR(02);
   DECLARE @V_IMPOSORIG_IDMODBCITNFE       VARCHAR(01);
   DECLARE @V_IMPOSORIG_IDMODBCSTITNFE     VARCHAR(01);
   DECLARE @V_IMPOSORIG_VRCONTITIMP        NUMERIC(16,5);
   DECLARE @V_IMPOSORIG_VRBASECALCIT       NUMERIC(16,5);
   DECLARE @V_IMPOSORIG_VRIMPOSTOIT        NUMERIC(16,5);
   DECLARE @V_IMPOSORIG_CDFISCOPERIT       VARCHAR(11);
   DECLARE @V_IMPOSORIG_CDSUFXCFOPIT       VARCHAR(03);
   DECLARE @V_IMPOSORIG_IDMOTDESONERAIT    VARCHAR(01);

   /*VARIVEIS DO CURSOR C_IMPFISC*/
   DECLARE @V_IMPFISC_CDFILIAL           VARCHAR(04);
   DECLARE @V_IMPFISC_NRLANCTONF         VARCHAR(10);
   DECLARE @V_IMPFISC_CDIMPOSTO          VARCHAR(02);
   DECLARE @V_IMPFISC_CDSITUTRIBNF       VARCHAR(02);
   DECLARE @V_IMPFISC_CDFISCOPERNF       VARCHAR(11);
   DECLARE @V_IMPFISC_CDFISCALNF         VARCHAR(01);

   DECLARE @V_VRFATOCONV      NUMERIC(16,5);

   DECLARE @V_IDIMPOBCALTPOP  VARCHAR(01);
   DECLARE @V_IDIMBCALTPOPDE  VARCHAR(01);
   DECLARE @V_CDIMPOBCALC     VARCHAR(02);

   DECLARE @V_IDNOTADEVO      VARCHAR(01);
   DECLARE @V_IDPERALTCSTFENF VARCHAR(01);

   DECLARE @V_CDSITUTRIBIT  VARCHAR(03);
   DECLARE @V_CDFISCOPERIT  VARCHAR(11);
   DECLARE @V_CDSUFXCFOPIT  VARCHAR(03);

   /*VARIVEIS DO CURSOR C_ITPROD*/
   DECLARE @V_ITPRODU_NRSEQITPROD  VARCHAR(04);

   DECLARE @V_CFOP1DIGT     VARCHAR(01);
   DECLARE @V_VRFRETEITEM   DOUBLE PRECISION;
   DECLARE @V_VRSEGURITEM   DOUBLE PRECISION;
   DECLARE @V_VRENCARGODESC DOUBLE PRECISION;
   DECLARE @V_DIFERENCA     DOUBLE PRECISION;
   DECLARE @V_SUMVRDESCITEM DOUBLE PRECISION;
   DECLARE @V_VROUTRASDESPITEM DOUBLE PRECISION;
   DECLARE @V_VRDESPADUANEIRA  DOUBLE PRECISION;
   DECLARE @V_IMPOSDESONERA    DOUBLE PRECISION;
   DECLARE @V_IDMOTIDESSTNFE   VARCHAR(01);

   /* VARIVEIS DO CURSOR C_TRABITPROIMPOS*/
   DECLARE @V_TRABITPROIMPOS_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_TRABITPROIMPOS_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_TRABITPROIMPOS_VRALIQITEM   DOUBLE PRECISION;

   /* VARIVEIS DO CURSOR C_TRABIMPOSNF*/
   DECLARE @V_TRABIMPOSNF_CDIMPOSTO     VARCHAR(02);
   DECLARE @V_TRABIMPOSNF_VRCONTITIMP   DOUBLE PRECISION;
   DECLARE @V_TRABIMPOSNF_VRBASECALCIT  DOUBLE PRECISION;
   DECLARE @V_TRABIMPOSNF_VRIMPOSTOIT   DOUBLE PRECISION;

   /*VARIVEIS DO CURSOR C_ITLANCTOESTO*/
   DECLARE @V_ITLANCT_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_ITLANCT_VRBRUTITEM   DOUBLE PRECISION;
   DECLARE @V_ITLANCT_VRFATOCONV   DOUBLE PRECISION;
   DECLARE @V_ITLANCT_QTITEMPROD   DOUBLE PRECISION;
   DECLARE @V_ITLANCT_VRCONTITEM   DOUBLE PRECISION;

   /* VARIVEIS DO CURSOR C_TRABITPROIMP*/
   DECLARE @V_TRABITPRO_CDIMPOSTO      VARCHAR(02);
   DECLARE @V_TRABITPRO_VRALIQITEM     NUMERIC(10,2);
   DECLARE @V_TRABITPRO_VRPERREDBCIT   NUMERIC(10,2);
   DECLARE @V_TRABITPRO_VRPARDEDIT     NUMERIC(16,2);
   DECLARE @V_TRABITPRO_CDFISCALIT     VARCHAR(01);
   DECLARE @V_TRABITPRO_CDSITUTRIBIT   VARCHAR(03);
   DECLARE @V_TRABITPRO_CDFISCOPERIT   VARCHAR(10);
   DECLARE @V_TRABITPRO_CDSUFXCFOPIT   VARCHAR(03);
   DECLARE @V_TRABITPRO_VRCONTITIMP    NUMERIC(16,2);
   DECLARE @V_TRABITPRO_VRBASECALCIT   NUMERIC(18,5);
   DECLARE @V_TRABITPRO_VRIMPOSTOIT    NUMERIC(16,2);

   DECLARE @V_CDFILIREDU    VARCHAR(04);
   DECLARE @V_VRCONTITIMP   DOUBLE PRECISION;

   DECLARE @V_IDREDUCAO       VARCHAR(01);
   DECLARE @V_CDGRUPOFISCAUX  VARCHAR(03);

   DECLARE @V_CDREGRAITALIQ   VARCHAR(10);

   DECLARE @V_IDSUGMODNF      VARCHAR(01);

   DECLARE @V_VRTOTBRUT       DOUBLE PRECISION;
   DECLARE @V_VRTOTANF        DOUBLE PRECISION;
   DECLARE @V_DIFBRUTNF       DOUBLE PRECISION;

   DECLARE @V_ICMS            VARCHAR(01);
   DECLARE @V_CDCFOPINFUSU    VARCHAR(11);
   DECLARE @V_DSCFOPINFUSU    VARCHAR(50);

   DECLARE @V_IDNFGERADAVIAXML VARCHAR(01);
   DECLARE @V_IDGERNFIGUALXML VARCHAR(01);

   --NOTA FISCAL DE IMPORTAO

   DECLARE @V_IDNFIMPORTACAO  VARCHAR(01);
   DECLARE @V_FATCONVIMP      DOUBLE PRECISION;
   DECLARE @V_PRODSEQIMP      DOUBLE PRECISION;
   DECLARE @V_PRODIMP         DOUBLE PRECISION;
   DECLARE @V_PERCENC         DOUBLE PRECISION;

   DECLARE @V_VRBASECALCII    DOUBLE PRECISION;
   DECLARE @V_VRBASECALCIPI   DOUBLE PRECISION;
   DECLARE @V_VRBASECALCPIS   DOUBLE PRECISION;
   DECLARE @V_VRBASECALCCOF   DOUBLE PRECISION;

   DECLARE @V_POSSUIFINANC    DOUBLE PRECISION;
   DECLARE @P_RESULTADO       VARCHAR(50);
   DECLARE @V_IDUTILVENC      VARCHAR(01);

   DECLARE @V_IDUTILPVRIMPBC  VARCHAR(01);

   /*
   DECLARE @V_ENCBCIMP        DOUBLE PRECISION;
   DECLARE @V_ENCADESCICMS    DOUBLE PRECISION;
   DECLARE @V_ENCACRESCEICMS  DOUBLE PRECISION;
   DECLARE @V_ENCADESC        DOUBLE PRECISION;
   DECLARE @V_ENCACRESCE      DOUBLE PRECISION;
   DECLARE @V_ENCBCIMPICMS    DOUBLE PRECISION;
   */

   DECLARE @V_ALIQPISIMP      DOUBLE PRECISION;
   DECLARE @V_CALCPISIMP      VARCHAR(01);
   DECLARE @V_CDPISIMP        VARCHAR(02);
   DECLARE @V_NRITPISIMP      VARCHAR(01);
   DECLARE @V_CDPISNFE        VARCHAR(02);
   DECLARE @V_PRODPISIMP      VARCHAR(04);
   DECLARE @V_VRPISIMP        DOUBLE PRECISION;

   DECLARE @V_ALIQCOFIMP      DOUBLE PRECISION;
   DECLARE @V_CALCCOFIMP      VARCHAR(01);
   DECLARE @V_CDCOFIMP        VARCHAR(02);
   DECLARE @V_NRITCOFIMP      VARCHAR(01);
   DECLARE @V_CDCOFNFE        VARCHAR(02);
   DECLARE @V_PRODCOFIMP      VARCHAR(04);
   DECLARE @V_VRCOFIMP        DOUBLE PRECISION;

   DECLARE @V_ALIQIMPII       DOUBLE PRECISION;
   DECLARE @V_CALCIIIMP       VARCHAR(01);
   DECLARE @V_CDIIIMP         VARCHAR(02);
   DECLARE @V_NRITIIIMP       VARCHAR(01);
   DECLARE @V_CDIINFE         VARCHAR(02);
   DECLARE @V_PRODIIIMP       VARCHAR(04);
   DECLARE @V_VRIIIMP         DOUBLE PRECISION;

   DECLARE @V_ALIQIPIIMP      DOUBLE PRECISION;
   DECLARE @V_CALCIPIIMP      VARCHAR(01);
   DECLARE @V_CDIPIIMP        VARCHAR(02);
   DECLARE @V_NRITIPIIMP      VARCHAR(01);
   DECLARE @V_CDIPINFE        VARCHAR(02);
   DECLARE @V_PRODIPIIMP      VARCHAR(04);
   DECLARE @V_VRIPIIMP        DOUBLE PRECISION;

   DECLARE @V_ALIQICMSIMP     DOUBLE PRECISION;
   DECLARE @V_CALCICMSIMP     VARCHAR(01);
   DECLARE @V_CDICMSIMP       VARCHAR(02);
   DECLARE @V_NRITICMSIMP     VARCHAR(01);
   DECLARE @V_CDICMSNFE       VARCHAR(02);
   DECLARE @V_PRODICMSIMP     VARCHAR(04);
   DECLARE @V_VRICMSIMP       DOUBLE PRECISION;

   /*VARIVEIS DO CURSOR C_IMPOSTOIMP - NOTA FISCAL DE IMPORTAO*/
   DECLARE @V_IMPOSTOIMP_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_IMPOSTOIMP_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_IMPOSTOIMP_VRPERREDBCIT NUMERIC(10,2);
   DECLARE @V_IMPOSTOIMP_VRALIQITEM   NUMERIC(10,2);
   DECLARE @V_IMPOSTOIMP_VRPARDEDIT   NUMERIC(16,2);
   DECLARE @V_IMPOSTOIMP_CDFISCALIT   VARCHAR(01);
   DECLARE @V_IMPOSTOIMP_VRIMPOSIT    NUMERIC(16,2);
   DECLARE @V_IMPOSTOIMP_IDTRATIMPO   VARCHAR(01);
   DECLARE @V_IMPOSTOIMP_IDIMPORECUP  VARCHAR(01);
   DECLARE @V_IMPOSTOIMP_CDCCTBLPASS  VARCHAR(20);
   DECLARE @V_IMPOSTOIMP_CDCCTBLATIV  VARCHAR(20);
   DECLARE @V_IMPOSTOIMP_VRALIQIMPOIT NUMERIC(10,2);
   DECLARE @V_IMPOSTOIMP_NRITPROIMPOS VARCHAR(01);
   DECLARE @V_IMPOSTOIMP_NRSEQITPRO   VARCHAR(01);
   DECLARE @V_IMPOSTOIMP_IDVALORINFO  VARCHAR(01);
   DECLARE @V_IMPOSTOIMP_IDTRIMPSTII  VARCHAR(01);
   DECLARE @V_IMPOSTOIMP_IDTIPCONTAB  VARCHAR(20);
   DECLARE @V_IMPOSTOIMP_VRBASECALCIT DOUBLE PRECISION;
   DECLARE @V_IMPOSTOIMP_IDCONTAIMPADIC VARCHAR(1);
   DECLARE @V_IMPOSTOIMP_CDIMPOSTONFE VARCHAR(02);

   DECLARE @V_IMPOSTOIMP_CDARVPROD    VARCHAR(20);
   DECLARE @V_IMPOSTOIMP_CDPRODUTO    VARCHAR(10);
   DECLARE @V_IMPOSTOIMP_VRTOTAITEM   NUMERIC(16,2);
   DECLARE @V_IMPOSTOIMP_VRDESCITEM   NUMERIC(16,2);
   DECLARE @V_INCITEMP_DSMENSINCTMP   VARCHAR(120);

   DECLARE @V_IDNFPRESTSERV           VARCHAR(01);
   DECLARE @V_IDCOMPRABONI            VARCHAR(01);
   DECLARE @V_COMPCUSTPROD            VARCHAR(01);

   /*VARIVEIS DO CURSOR C_CARGA */
   DECLARE @V_CARGA_CDIMPOSTO     VARCHAR(02);

   DECLARE @V_CARGA               FLOAT;

   DECLARE @V_IDENDEMIS               VARCHAR(01);

   DECLARE @V_CDFISCOPERREGRA     VARCHAR(10);
   DECLARE @V_DSCDFISOPEITREGRA   VARCHAR(100);
   DECLARE @V_IDDIFEALIQREGRA     VARCHAR(10);
   DECLARE @V_IDDIFALIQCUSPRREGRA VARCHAR(10);

   DECLARE @V_TESTE  VARCHAR(100);

   DECLARE @V_IDIMPORTAIMPXML     VARCHAR(01);

   --VARIVEIS PARA ATUALIZAR ESTOQUE POR CFOP
   DECLARE @V_ATUPORCFOP    VARCHAR(01);
   DECLARE @V_CFOPTPOPER    DOUBLE PRECISION;
   DECLARE @V_CFOPATUEST    DOUBLE PRECISION;
   DECLARE @V_IDNFRETIND    VARCHAR(01);

   /*VARIVEIS DO CURSOR C_MENSINSCESTAST*/
   DECLARE @C_MENSINSCESTAST_CDMENSAGEM VARCHAR(03);
   DECLARE @C_MENSINSCESTAST_DSMENSINSCESTAST VARCHAR(250);

   DECLARE @V_DSENDEDEVOEMBA VARCHAR(255);

   /* variveis para gerao de sada no estoque (filial agente de terceirao) */
   DECLARE @V_CDFILIAGENT       VARCHAR(04);
   DECLARE @V_BOLANESTSAIDAG    BIT = 1;
   DECLARE @V_NRLANESTENTRAG    VARCHAR(20);
   DECLARE @V_CDALMOXARIFEAG    VARCHAR(06);
   DECLARE @V_CDLOCALESTOQAG    VARCHAR(06);
   DECLARE @V_IDUTILLOTEAG      VARCHAR(01);
   DECLARE @V_NRLOTEESTQAG      VARCHAR(20);
   DECLARE @V_NRSUBLOTEAG       VARCHAR(04);
   DECLARE @V_NRLANCTONFAG      VARCHAR(20);
   DECLARE @V_CDEMPRESAAG       VARCHAR(02);
   DECLARE @V_CDINSCESTAAG      VARCHAR(16);
   DECLARE @V_CDINSCMUNIAG      VARCHAR(16);
   DECLARE @V_CDFORNAGETERC     VARCHAR(21);
   DECLARE @V_TPOPERREMESSA     VARCHAR(02);

   /*VARIVEIS DO CURSOR C_ITLANCTO*/
   DECLARE @V_ITLC_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_ITLC_CDPRODUTO    VARCHAR(10);
   DECLARE @V_ITLC_VRUNITITEM   NUMERIC(16,5);
   DECLARE @V_ITLC_VRTOTAITEM   NUMERIC(16,2);
   DECLARE @V_ITLC_QTITEMPROD   NUMERIC(15,5);
   DECLARE @V_ITLC_CDPRODESTO   VARCHAR(10);
   DECLARE @V_ITLC_VRBRUTITEM   NUMERIC(16,5);
   DECLARE @V_ITLC_VRDESCITEM   NUMERIC(16,2);
   DECLARE @V_ITLC_VRCONTITEM   NUMERIC(16,5);
   DECLARE @V_ITLC_CDARVPROD    VARCHAR(20);
   DECLARE @V_ITLC_NMPRODUTO    VARCHAR(50);
   DECLARE @V_ITLC_VRFATOCONV   VARCHAR(01);
   DECLARE @V_ITLC_IDORIGEMPROD VARCHAR(01);

   DECLARE @V_NOVO_CODIGO       VARCHAR(18);
   DECLARE @V_NOVO_CODIGO_NT    VARCHAR(18);
   DECLARE @V_IDTPIJURNF        VARCHAR(01);
   DECLARE @V_IDNFAJUSTE        VARCHAR(01);

   DECLARE @V_IDIMPDESONERA     VARCHAR(01);
   DECLARE @V_IDENTEMIS         VARCHAR(01);

   /*VARIVEIS DO CURSOR C_ITEM*/
   DECLARE @V_ITEM_CDFILIAL     VARCHAR(04);
   DECLARE @V_ITEM_NRLANCTONF   VARCHAR(10);
   DECLARE @V_ITEM_NRSEQITPROD  VARCHAR(04);
   DECLARE @V_ITEM_CDCLASFISC   VARCHAR(10);
BEGIN

--VARIVEIS COM A CHAVE PARA AS TABELAS TEMPORRIAS

   SET @V_ALIQTEMP = @P_FILIAL + @P_LANCTONF;
   SET @V_INCITEMP = @P_FILIAL + @P_LANCTONF;
   SET @V_CSTTEMP  = @P_FILIAL + @P_LANCTONF;
   SET @V_CFOPTEMP = @P_FILIAL + @P_LANCTONF;

---------------------------------------------------------------------------------------------------------
   SET @V_DATA = GETDATE();
---------------------------------------------------------------------------------------------------------

   SELECT @V_NRINSJURNF   = MAX(NRINSJURNF),
          @V_SERIE        = MAX(CDSERIEENTR),
          @V_CDFILIRECE   = MAX(CDFILIRECE),
          @V_INTEGRACAO   = MAX(CDINTEGRACAO),
          @V_NOTAFISC     = MAX(VRNOTAFISC),
          @V_CDFILIEMIT   = MAX(CDFILIEMIT),
          @V_NRNOTAFISC   = MAX(NRNOTAFISC),
          @V_IDDOCFINANC  = MAX(IDDOCFINANC),
          @V_IDSTATUS     = MAX(IDSTATUS),
          @V_IDORIGDESTNF = ISNULL(MAX(IDORIGDESTNF),'F'),
          @V_IDDOCREPLIC  = MAX(IDDOCREPLIC),
          @V_IDCTRLESTQ   = ISNULL(MAX(P.IDCTRLESTQ),'S'),
          @V_IDSISTEMA    = ISNULL(MAX(N.IDSISTEMA),'DFE'),
          @V_CDTIPCUSTEST = ISNULL(MAX(CONVERT(NUMERIC,P.CDTIPCUSTEST)),3),
          @V_DTATUAL      = MAX(ISNULL(P.DTPROCESSA, GETDATE())),
          @V_IDNFGERADAVIAXML = MAX(ISNULL(IDNFGERADAVIAXML, 'N')),
          @V_IDTPIJURNF   = MAX(IDTPIJURNF)
   FROM NOTAFISCAL N LEFT JOIN PARAMFILIAL P
                     ON (CDFILIRECE = P.CDFILIAL)
   WHERE N.CDFILIAL = @P_FILIAL   AND
         NRLANCTONF = @P_LANCTONF;

   SELECT @V_IDDOCREPLIC = MAX(CDFILIAL+NRLANCESTQ)
   FROM LANCTOESTOQ
   WHERE CDFILIAL   = SUBSTRING(@V_IDDOCREPLIC, 1, 4) AND
         NRLANCTONF = SUBSTRING(@V_IDDOCREPLIC, 5, 10);

   IF @V_IDDOCREPLIC IS NULL BEGIN
      SELECT @V_IDDOCREPLIC = MAX(CDFILIAL+NRLANCESTQ)
      FROM LANCTOESTOQ
      WHERE CDFILIAL   = SUBSTRING(@V_INTEGRACAO, 1, 4) AND
            NRLANCTONF = SUBSTRING(@V_INTEGRACAO, 5, 10);
   END;

   SELECT @V_CDPRGENEREV     = SUBSTRING(DSPARAMFATGE,73,10),
          @V_NRDECITOTANF    = ISNULL(NRDECITOTANF, 2),
          @V_IDNFOUTRASNF    = ISNULL(IDNFOUTRASNF, 'N'),
          @V_IDPERALTCSTFENF = ISNULL(IDPERALTCSTFENF, 'N'),
          @V_IDSUGMODNF      = ISNULL(IDSUGMODNF, 'N'),
          @V_IDGERNFIGUALXML = ISNULL(IDGERNFIGUALXML, 'N')
   FROM PARAMGERAL;

   IF @V_INTEGRACAO IS NOT NULL BEGIN
      IF @P_ENTRSAID = 'S' BEGIN
         SET @V_CDFILIRECE = @V_CDFILIEMIT;
      END;
   END;

-------------------------------------------------------------------------------------------------------
--MAIOR REGISTRO DA TABELA DE DADOS ADICIONAIS
   SELECT @V_DADOADIC = MAX(NRDADOADIC)
     FROM DADOSADIC
    WHERE (CDFILIAL   = @P_FILIAL)
      AND (NRLANCTONF = @P_LANCTONF);

   IF (@V_DADOADIC IS NULL) BEGIN
      SET @V_DADOADIC = '001';
   END
   ELSE BEGIN
      SET @V_DADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_DADOADIC) + 1)),3);
      /*GERA O PROXIMO SEQUENCIAL A SER INSERIDO*/
   END;

   DECLARE C_MENSINSC CURSOR FOR SELECT I.CDMENSAGEM, I.DSMENSINSCRESTA
                                   FROM MENSINSCRESTAD I, MENSAGEM M
                                  WHERE (I.CDEMPRESA = @P_EMPRESA)
                                    AND (I.CDINSCESTA = @P_INSCESTA)
                                    AND (I.CDMENSAGEM = M.CDMENSAGEM)
                                    AND (I.IDENTRSAIDMENS <> 'S')
                                    AND (M.IDSITUACAOMENS  = 'A')
                                    AND (I.DSMENSINSCRESTA NOT IN (SELECT DSDADOADIC
                                                                     FROM DADOSADIC
                                                                    WHERE (CDFILIAL = @P_FILIAL)
                                                                      AND (NRLANCTONF = @P_LANCTONF)));

   OPEN C_MENSINSC;
   FETCH NEXT FROM C_MENSINSC INTO @V_MENSINSC_CDMENSAGEM, @V_MENSINSC_DSMENSAGEM;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL*/
      INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                     VALUES(@P_FILIAL,@P_LANCTONF, @V_DADOADIC, @V_MENSINSC_CDMENSAGEM, @V_MENSINSC_DSMENSAGEM);

      SET @V_DADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_DADOADIC) + 1)),3);

      FETCH NEXT FROM C_MENSINSC INTO @V_MENSINSC_CDMENSAGEM, @V_MENSINSC_DSMENSAGEM;
   END;
   CLOSE C_MENSINSC;
   DEALLOCATE C_MENSINSC;

   SELECT @V_DSENDEDEVOEMBA = TEKNISA.TRANSLATE(SUBSTRING('Devolver as embalagens vazias no seguinte endereo: ' +
                             PRE.DSPOSTORECEMB +
                             ', ' + PRE.DSENDERECEMB +
                             CASE ISNULL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' + PRE.DSCOMPENDERECEMB END +
                             ', ' + B.NMBAIRRO +
                             ', CEP:' + PRE.NRCEPRECEMB +
                             ', ' + M.NMMUNICIPIO +
                             ', ' + E.SGESTADO +
                             ', ' + P.NMPAIS +
                             CASE ISNULL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' + PRE.NRTELERECEMB END +
                             CASE ISNULL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' + PRE.NRFAXRECEMB END, 1, 255), NULL, NULL)
     FROM NOTAFISCAL N JOIN ITEMPRODUTO I ON (N.CDFILIAL = I.CDFILIAL) AND
                                             (N.NRLANCTONF = I.NRLANCTONF)
                       JOIN PRODUTO PR ON (I.CDPRODUTO = PR.CDPRODUTO)
                       JOIN (SELECT P.CDPOSTORECEMB, PR.CDARVPROD
                               FROM PRODPOSTORECEMB P JOIN PRODUTO PR ON (P.CDPRODUTO = PR.CDPRODUTO)) PPRE ON (CHARINDEX(ISNULL(RTRIM(PPRE.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1)
                       JOIN CLIEPOSTORECEMB C ON (N.CDCLIENTE = C.CDCLIENTE) AND
                                                 (PPRE.CDPOSTORECEMB = C.CDPOSTORECEMB)
                       JOIN POSTORECEMB PRE ON (C.CDPOSTORECEMB = PRE.CDPOSTORECEMB)
                       JOIN PAIS P ON (PRE.CDPAIS = P.CDPAIS)
                       JOIN ESTADO E ON (PRE.CDPAIS = E.CDPAIS) AND
                                        (PRE.SGESTADO = E.SGESTADO)
                       JOIN MUNICIPIO M ON (PRE.CDPAIS = M.CDPAIS) AND
                                           (PRE.SGESTADO = M.SGESTADO) AND
                                           (PRE.CDMUNICIPIO = M.CDMUNICIPIO)
                       JOIN BAIRRO B ON (PRE.CDPAIS = B.CDPAIS) AND
                                        (PRE.SGESTADO = B.SGESTADO) AND
                                        (PRE.CDMUNICIPIO = B.CDMUNICIPIO) AND
                                        (PRE.CDBAIRRO = B.CDBAIRRO)
    WHERE N.CDFILIAL = @P_FILIAL
      AND N.NRLANCTONF = @P_LANCTONF
      AND NOT EXISTS (SELECT DSDADOADIC
                        FROM DADOSADIC
                       WHERE (CDFILIAL = @P_FILIAL)
                         AND (NRLANCTONF = @P_LANCTONF)
                         AND (DSDADOADIC LIKE TEKNISA.TRANSLATE(SUBSTRING('Devolver as embalagens vazias no seguinte endereo: ' +
                                              PRE.DSPOSTORECEMB +
                                              ', ' + PRE.DSENDERECEMB +
                                              CASE ISNULL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' + PRE.DSCOMPENDERECEMB END +
                                              ', ' + B.NMBAIRRO +
                                              ', CEP:' + PRE.NRCEPRECEMB +
                                              ', ' + M.NMMUNICIPIO +
                                              ', ' + E.SGESTADO +
                                              ', ' + P.NMPAIS +
                                              CASE ISNULL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' + PRE.NRTELERECEMB END +
                                              CASE ISNULL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' + PRE.NRFAXRECEMB END, 1, 255), NULL, NULL) + '%'));
     
   IF (@V_DSENDEDEVOEMBA IS NOT NULL) BEGIN
      INSERT INTO DADOSADIC
         (CDFILIAL, 
          NRLANCTONF, 
          NRDADOADIC, 
          CDMENSAGEM, 
          DSDADOADIC)
      VALUES
         (@P_FILIAL, 
          @P_LANCTONF, 
          @V_DADOADIC, 
          '',
          @V_DSENDEDEVOEMBA);

      SET @V_DADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_DADOADIC) + 1)),3);
   END;
----------------------------------------------------------------------------------------------------------

   SELECT @V_IDOPERDEVONF = ISNULL(MAX(IDOPERDEVONF),'N'),
          @V_IDCTRLESTQ   = ISNULL(MAX(IDATUESTTPOP), @V_IDCTRLESTQ),
          @V_IDUTCUSORIGEST = ISNULL(MAX(IDUTCUSORIGEST), 'N'),
          @V_IDNOTADEVO = ISNULL(MAX(IDNOTADEVO), 'N'),
          @V_IDNFPRESTSERV = ISNULL(MAX(IDNFPRESTSERV), 'N'),
          @V_IDCOMPRABONI   = ISNULL(MAX(IDCMPVNDBONI), 'N'),
          @V_IDUTILVENC = ISNULL(MAX(IDUTILVENC), 'N'),
          @V_IDNFAJUSTE = ISNULL(MAX(IDNFAJUSTE), 'N')
   FROM TIPOOPERAC
   WHERE IDENTRSAIDOP = @P_ENTRSAID AND
         CDTIPOOPER   = @P_TIPOOPER;


--VARIVEIS PARA CONSULTA DE ALQUOTA, INCIDNCIA, CFOP
   SELECT @V_PAISDEST = MAX(CDPAIS),
          @V_ESTADEST = MAX(SGESTADO),
          @V_MUNIDEST = MAX(CDMUNICIPIO),
          @V_IDCALCDIFENTFISC = MAX(IDCALCDIFENTFISC)
   FROM INSCRESTAD
   WHERE (CDEMPRESA  = @P_EMPRESA) AND
         (CDINSCESTA = @P_INSCESTA);

   IF (@V_IDNFPRESTSERV = 'S') BEGIN

      SELECT @V_IDENTEMIS = ISNULL(MAX(IDENDEMISFIL),'P')
        FROM FILIAL
       WHERE (CDFILIAL = @V_CDFILIRECE);

      IF @V_IDENTEMIS = 'I' BEGIN
         SET @V_IDENTEMIS = 'P';
      END;

      SELECT @V_PAISDEST = MAX(CDPAIS),
             @V_ESTADEST = MAX(SGESTADO),
             @V_MUNIDEST = MAX(CDMUNICIPIO)
        FROM ENDEFILI
       WHERE (CDFILIAL     = @V_CDFILIRECE)
         AND (IDTPENDEFILI = @V_IDENTEMIS);
   END;

   SET @V_CDORIGDESTNF = @P_FORNECED;

   IF (@V_IDORIGDESTNF = 'L') BEGIN
      SET @V_IDENDCFOP = 'I';
      SET @V_IDENDEMIS = 'I';
      SET @V_CDEMPRESA = Null;
      SET @V_CDINSCESTA = Null;

      SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I'), @V_IDENDEMIS = ISNULL(MAX(IDENDEMISFIL),'I'),
             @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
        FROM FILIAL
       WHERE (CDFILIAL = @V_CDFILIEMIT);

      SELECT @V_CDPAISST = MAX(CDPAIS),
             @V_SGESTADOST = MAX(SGESTADO),
             @V_CDMUNICIPIOST = MAX(CDMUNICIPIO)
        FROM ENDEFILI
       WHERE CDFILIAL = @V_CDFILIEMIT
         AND IDTPENDEFILI = 'P';

      SELECT @V_CDINSCESTAST = MAX(CDINSCESTAST)
        FROM INSCRESTADST
       WHERE CDEMPRESA = @P_EMPRESA
         AND CDINSCESTAST = @P_INSCESTA
         AND CDPAIS = @V_CDPAISST
         AND SGESTADO = @V_SGESTADOST;

      IF @V_IDENDCFOP = 'I' BEGIN
         SELECT @V_PAISCFOP = CDPAIS, @V_ESTACFOP = SGESTADO
           FROM INSCRESTAD
          WHERE CDEMPRESA  = @V_CDEMPRESA AND
                CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISCFOP = CDPAIS, @V_ESTACFOP = SGESTADO
           FROM ENDEFILI
          WHERE (CDFILIAL     = @V_CDFILIEMIT) AND
                (IDTPENDEFILI = @V_IDENDCFOP);
      END;

      IF @V_IDENDEMIS = 'I' BEGIN
         SET @V_PAISORIG = Null;
         SET @V_ESTAORIG = Null;
         SET @V_MUNIORIG = Null;

         SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
         FROM INSCRESTAD
         WHERE CDEMPRESA  = @V_CDEMPRESA AND
               CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN
         SET @V_PAISORIG = Null;
         SET @V_ESTAORIG = Null;
         SET @V_MUNIORIG = Null;

         SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
         FROM ENDEFILI
         WHERE CDFILIAL     = @V_CDFILIEMIT AND
               IDTPENDEFILI = @V_IDENDEMIS;
      END;

      SET @V_CDORIGDESTNF = @V_CDFILIEMIT;
   END
   ELSE IF (@V_IDORIGDESTNF = 'C') BEGIN
      SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPCLI),'P')
        FROM CLIENTE
       WHERE (CDCLIENTE = @P_FORNECED);

      SELECT @V_CDPAISST = MAX(CDPAIS),
             @V_SGESTADOST = MAX(SGESTADO),
             @V_CDMUNICIPIOST = MAX(CDMUNICIPIO)
        FROM ENDECLIE
       WHERE CDCLIENTE = @P_FORNECED
         AND IDTPENDECLIE = 'P';

      SELECT @V_CDINSCESTAST = MAX(CDINSCESTAST)
        FROM INSCRESTADST
       WHERE CDEMPRESA = @P_EMPRESA
         AND CDINSCESTAST = @P_INSCESTA
         AND CDPAIS = @V_CDPAISST
         AND SGESTADO = @V_SGESTADOST;

      IF @V_IDENDCFOP = 'I' BEGIN
         SELECT @V_PAISCFOP = CDPAIS, @V_ESTACFOP = SGESTADO
           FROM INSCRESTAD
          WHERE CDEMPRESA  = @P_EMPRESA AND
                CDINSCESTA = @P_INSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISCFOP = CDPAIS, @V_ESTACFOP = SGESTADO
           FROM ENDECLIE
          WHERE (CDCLIENTE    = @P_FORNECED)
            AND (IDTPENDECLIE = @V_IDENDCFOP);
      END;


      SELECT @V_PAISORIG = MAX(CDPAIS),
             @V_ESTAORIG = MAX(SGESTADO),
             @V_MUNIORIG = MAX(CDMUNICIPIO)
      FROM ENDECLIE
      WHERE (CDCLIENTE    = @P_FORNECED) AND
            (IDTPENDECLIE = 'P');
   END
   ELSE IF (@V_IDORIGDESTNF = 'F') BEGIN
      SELECT @V_IDENDCFOP = ISNULL(IDENDCFOPFOR,'P')
        FROM FORNECEDOR
       WHERE (CDFORNECED = @P_FORNECED);

      SELECT @V_CDPAISST = MAX(CDPAIS),
             @V_SGESTADOST = MAX(SGESTADO),
             @V_CDMUNICIPIOST = MAX(CDMUNICIPIO)
        FROM ENDEFORN
       WHERE CDFORNECED = @P_FORNECED
         AND IDTPENDEFORN = 'P';

      SELECT @V_CDINSCESTAST = MAX(CDINSCESTAST)
        FROM INSCRESTADST
       WHERE CDEMPRESA = @P_EMPRESA
         AND CDINSCESTAST = @P_INSCESTA
         AND CDPAIS = @V_CDPAISST
         AND SGESTADO = @V_SGESTADOST;

      IF @V_IDENDCFOP = 'I' BEGIN
         SELECT @V_PAISCFOP = CDPAIS, @V_ESTACFOP = SGESTADO
           FROM INSCRESTAD
          WHERE CDEMPRESA  = @P_EMPRESA
            AND CDINSCESTA = @P_INSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISCFOP = CDPAIS, @V_ESTACFOP = SGESTADO
           FROM ENDEFORN
          WHERE (CDFORNECED   = @P_FORNECED) AND
                (IDTPENDEFORN = @V_IDENDCFOP);
      END;

      SELECT @V_PAISORIG = MAX(CDPAIS),
             @V_ESTAORIG = MAX(SGESTADO),
             @V_MUNIORIG = MAX(CDMUNICIPIO)
      FROM ENDEFORN
      WHERE (CDFORNECED   = @P_FORNECED) AND
            (IDTPENDEFORN = 'P');
   END
   ELSE BEGIN
      IF (@P_ENTRSAID = 'E') BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS),
                @V_ESTAORIG = MAX(SGESTADO),
                @V_MUNIORIG = MAX(CDMUNICIPIO)
         FROM ENDEFORN
         WHERE (CDFORNECED   = @P_FORNECED) AND
               (IDTPENDEFORN = 'P');

         SELECT @V_CDPAISST = MAX(CDPAIS),
                @V_SGESTADOST = MAX(SGESTADO),
                @V_CDMUNICIPIOST = MAX(CDMUNICIPIO)
           FROM ENDEFORN
          WHERE CDFORNECED = @P_FORNECED
            AND IDTPENDEFORN = 'P';

         SELECT @V_CDINSCESTAST = MAX(CDINSCESTAST)
           FROM INSCRESTADST
          WHERE CDEMPRESA = @P_EMPRESA
            AND CDINSCESTAST = @P_INSCESTA
            AND CDPAIS = @V_CDPAISST
            AND SGESTADO = @V_SGESTADOST;
      END
      ELSE IF (@P_ENTRSAID = 'S') BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS),
                @V_ESTAORIG = MAX(SGESTADO),
                @V_MUNIORIG = MAX(CDMUNICIPIO)
         FROM ENDECLIE
         WHERE (CDCLIENTE    = @P_FORNECED) AND
               (IDTPENDECLIE = 'P');

         SELECT @V_CDPAISST = MAX(CDPAIS),
                @V_SGESTADOST = MAX(SGESTADO),
                @V_CDMUNICIPIOST = MAX(CDMUNICIPIO)
           FROM ENDECLIE
          WHERE CDCLIENTE = @P_FORNECED
            AND IDTPENDECLIE = 'P';

         SELECT @V_CDINSCESTAST = MAX(CDINSCESTAST)
           FROM INSCRESTADST
          WHERE CDEMPRESA = @P_EMPRESA
            AND CDINSCESTAST = @P_INSCESTA
            AND CDPAIS = @V_CDPAISST
            AND SGESTADO = @V_SGESTADOST;
      END;
   END;

   IF (@V_CDINSCESTAST IS NOT NULL) OR (@V_CDINSCESTAST = '')  BEGIN

      UPDATE NOTAFISCAL
         SET CDINSCESTAST = @V_CDINSCESTAST
       WHERE CDFILIAL = @P_FILIAL
         AND NRLANCTONF = @P_LANCTONF;
         
      DECLARE C_MENSINSCESTAST CURSOR FOR SELECT M.CDMENSAGEM, I.DSMENSINSCESTAST
                                            FROM MENSINSCESTAST I LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = I.CDMENSAGEM)
                                           WHERE I.CDEMPRESA = @P_EMPRESA
                                             AND I.CDINSCESTA = @P_INSCESTA
                                             AND I.CDINSCESTAST = @V_CDINSCESTAST
                                             AND I.IDENTRSAIDMENSST <> 'E'
                                             AND (((I.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (I.CDMENSAGEM IS NULL))
                                             AND NOT EXISTS (SELECT DSDADOADIC
                                                               FROM DADOSADIC
                                                               WHERE (CDFILIAL = @P_FILIAL)
                                                                 AND (NRLANCTONF = @P_LANCTONF)
                                                                 AND (DSDADOADIC LIKE I.DSMENSINSCESTAST + '%'))
                                           ORDER BY NRMENSINSCESTAST;
      OPEN C_MENSINSCESTAST;
      FETCH NEXT FROM C_MENSINSCESTAST INTO @C_MENSINSCESTAST_CDMENSAGEM, @C_MENSINSCESTAST_DSMENSINSCESTAST;
      WHILE (@@FETCH_STATUS = 0) BEGIN
   
         /*PREENCHE AS MENSAGENS ATRELADAS A INSCRICAO ESTADUAL DO SUBSTITUTO TRIBUTRIO*/
         INSERT INTO DADOSADIC(CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM, DSDADOADIC)
                        VALUES(@P_FILIAL, @P_LANCTONF, @V_DADOADIC, @C_MENSINSCESTAST_CDMENSAGEM, @C_MENSINSCESTAST_DSMENSINSCESTAST);

         SET @V_DADOADIC = RIGHT(REPLICATE('0', 3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_DADOADIC) + 1)), 3);

         FETCH NEXT FROM C_MENSINSCESTAS INTO @C_MENSINSCESTAST_CDMENSAGEM, @C_MENSINSCESTAST_DSMENSINSCESTAST;
      END;
      CLOSE C_MENSINSC;
      DEALLOCATE C_MENSINSC;
   END;

---------------------------------------------------------------------------------------------------------

   SET @V_IDINTEREST = 'N';
   SET @V_IDINTERNA  = 'N';
   IF ((@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG)) BEGIN
      SET @V_IDINTEREST = 'S';
   END;

   IF (@V_PAISDEST <> @V_PAISORIG) BEGIN
      SET @V_IDINTERNA = 'S';
   END;

   SELECT @V_LIQUIDO = (SUM(VRTOTAITEM) - SUM(VRDESCITEM))
   FROM ITEMPRODUTO
   WHERE CDFILIAL   = @P_FILIAL AND
         NRLANCTONF = @P_LANCTONF;


   -- PREENCHER CLASSIFICACAO FISCAL NCM NA TABELA ITEMPRODUTO

   DECLARE C_ITEM CURSOR FOR (SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, P.CDCLASFISC
                                FROM ITEMPRODUTO I, PRODUTO P
                               WHERE I.CDFILIAL   = @P_FILIAL
                                 AND I.NRLANCTONF = @P_LANCTONF
                                 AND I.CDPRODUTO = P.CDPRODUTO);

   OPEN C_ITEM;
   FETCH NEXT FROM C_ITEM INTO @V_ITEM_CDFILIAL, @V_ITEM_NRLANCTONF, @V_ITEM_NRSEQITPROD, @V_ITEM_CDCLASFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      UPDATE ITEMPRODUTO
         SET CDPRODNCMTRANS = @V_ITEM_CDCLASFISC
       WHERE CDFILIAL    = @V_ITEM_CDFILIAL
         AND NRLANCTONF  = @V_ITEM_NRLANCTONF
         AND NRSEQITPROD = @V_ITEM_NRSEQITPROD;

      FETCH NEXT FROM C_ITEM INTO @V_ITEM_CDFILIAL, @V_ITEM_NRLANCTONF, @V_ITEM_NRSEQITPROD, @V_ITEM_CDCLASFISC;
   END;
   CLOSE C_ITEM;
   DEALLOCATE C_ITEM;

---------------------------------------------------------------------------------------------------------

   INSERT INTO ITEMENCARGO
      (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
      (SELECT @P_FILIAL, @P_LANCTONF, CDENCARGO, 0
       FROM ENCARGO
       WHERE NOT EXISTS(SELECT CDENCARGO
                        FROM ITEMENCARGO
                        WHERE CDFILIAL   = @P_FILIAL   AND
                              NRLANCTONF = @P_LANCTONF AND
                              CDENCARGO  = ENCARGO.CDENCARGO));

---------------------------------------------------------------------------------------------------------
   EXEC CONSULTA_GRUPOFISCAL @V_IDORIGDESTNF, @V_CDORIGDESTNF, @V_CDFILIRECE, 'E', @P_TIPOOPER, @P_CDGRUPOFISC = @V_CDGRUPOFISC OUTPUT;

   IF @V_IDOPERDEVONF = 'S' BEGIN
      SELECT @V_FILIORIG  = MAX(CDFILIALIT),
             @V_DEVOLORIG = MAX(NRLANCTONFIT)
      FROM ITEMNOTAFISC
      WHERE CDFILIAL   = @P_FILIAL AND
            NRLANCTONF = @P_LANCTONF;

      SET @V_IDIMPDESONERA = 'N';

      SELECT @V_IDIMPDESONERA = MAX(IDIMPDESONERAIT)
        FROM ITEMPROIMPOS
       WHERE CDFILIAL   = @V_FILIORIG
         AND NRLANCTONF = @V_DEVOLORIG
         AND IDIMPDESONERAIT = 'S';
   END;

   IF (@V_DEVOLORIG IS NOT NULL) BEGIN
      UPDATE ITEMPRODUTO
         SET VRTOTAITEM = ROUND(VRTOTAITEM, 2)
       WHERE CDFILIAL   = @P_FILIAL
         AND NRLANCTONF = @P_LANCTONF;

      SELECT @V_LIQUIDO = (SUM(VRTOTAITEM) - SUM(VRDESCITEM))
        FROM ITEMPRODUTO
       WHERE CDFILIAL   = @P_FILIAL
         AND NRLANCTONF = @P_LANCTONF;
   END;

   IF ((@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E')) AND (@V_DEVOLORIG IS NULL) BEGIN
      UPDATE ITEMPRODUTO
      SET VRBRUTITEM   = (VRTOTAITEM - VRDESCITEM) + ISNULL(VRICMSSTITORIG, 0),
          VRCONTITEM   = (VRTOTAITEM - VRDESCITEM) + ISNULL(VRICMSSTITORIG, 0)
      WHERE CDFILIAL   = @P_FILIAL   AND
            NRLANCTONF = @P_LANCTONF;
   END;


   SET @V_IDNFRETIND   = 'N';
   SELECT @V_IDNFRETIND = ISNULL(IDNFRETIND, 'N')
     FROM TIPOOPERAC
    WHERE CDTIPOOPER   = @P_TIPOOPER
      AND IDENTRSAIDOP = 'E';

   IF (@V_IDNFRETIND = 'S') BEGIN
      UPDATE ITEMPRODUTO
      SET VRBRUTITEM   = (VRTOTAITEM - VRDESCITEM),
          VRCONTITEM   = (VRTOTAITEM - VRDESCITEM)
      WHERE CDFILIAL   = @P_FILIAL    AND
            NRLANCTONF = @P_LANCTONF;
   END;
---------------------------------------------------------------------------------------------------------
   DECLARE C_IMPOSTORETI CURSOR FOR
  (SELECT CDIMPOSTO
   FROM IMPOSTO
   WHERE IDTRATIMPO   = 'R' AND
         IDUTVRMENSBC = 'S');

   OPEN C_IMPOSTORETI;

   FETCH NEXT FROM C_IMPOSTORETI INTO @V_IMPOSTORETI_CDIMPOSTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SELECT @V_IMPOSTO = MAX(CDIMPOSTO)
      FROM IMPOSTONF
      WHERE CDFILIAL     = @P_FILIAL                 AND
            NRLANCTONF   = @P_LANCTONF               AND
        	   CDIMPOSTO    = @V_IMPOSTORETI_CDIMPOSTO  AND
           	VRBASECALCNF <> 0.00                     AND
	         VRALIQNF     <> 0.00                     AND
   	      VRIMPOSTONF  = 0.00 ;

	   IF @V_IMPOSTO IS NULL BEGIN
	      SET @V_IDRECALCULO = 'S';
      END
	   ELSE BEGIN
      	SET @V_IDRECALCULO = 'N';
	   END;

		FETCH NEXT FROM C_IMPOSTORETI INTO @V_IMPOSTORETI_CDIMPOSTO;
   END;
   CLOSE C_IMPOSTORETI;
   DEALLOCATE C_IMPOSTORETI;
---------------------------------------------------------------------------------------------------------

-- ATUALIZAO DAS TABELAS DE NOTAFISCAL, ITEMPRODUTO E DADOS ADICIONAIS


   -- NF IMPORTAO
   SELECT @V_IDNFIMPORTACAO = MAX(ISNULL(IDNFIMPORTACAO, 'N'))
     FROM TIPOOPERAC
    WHERE CDTIPOOPER = @P_TIPOOPER;

   IF (@V_IDNFIMPORTACAO = 'N') BEGIN
      IF (NOT(@P_TIPOOPER IN ('07','09','10')) AND (@V_IDOPERDEVONF <> 'S')) OR ((@V_IDOPERDEVONF = 'S') AND (@V_DEVOLORIG IS NULL)) OR (@V_IDNFRETIND = 'S') BEGIN
   -- NOTA FISCAL DE MOVIMENTAO - 07

         DECLARE C_ITEMPRODUTO CURSOR FOR
        (SELECT VRTOTAITEM, VRDESCITEM, I.CDPRODUTO, NRSEQITPROD, P.CDARVPROD,
                QTITEMPROD, CDFISOPEITEM, CDSITUTRIBPR, IDORIGEMPROD
         FROM ITEMPRODUTO I, PRODUTO P
         WHERE CDFILIAL    = @P_FILIAL   AND
               NRLANCTONF  = @P_LANCTONF AND
               I.CDPRODUTO = P.CDPRODUTO);

         OPEN C_ITEMPRODUTO;

         FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPROD_VRTOTAITEM, @V_ITEMPROD_VRDESCITEM,
                                            @V_ITEMPROD_CDPRODUTO,  @V_ITEMPROD_NRSEQITPROD,
                                            @V_ITEMPROD_CDARVPROD,  @V_ITEMPROD_QTITEMPROD,
                                            @V_ITEMPROD_CDFISOPEITEM, @V_ITEMPROD_CDSITUTRIBPR,
                                            @V_ITEMPROD_IDORIGEMPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_LIQUIDOPROD = @V_ITEMPROD_VRTOTAITEM - @V_ITEMPROD_VRDESCITEM;

            IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN --IMPORTAO DE NFS ORIUNDAS DOS

               EXEC CONSULTA_CST @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD,
                                 @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF,
                                 @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA,
                                 NULL, @V_ITEMPROD_IDORIGEMPROD;

               IF (@V_IDCOMPRABONI = 'N') BEGIN
                  EXEC CONSULTA_CFOP @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                     @P_INSCESTA,   @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                     @V_PAISDEST,   @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                     @V_CDGRUPOFISC,@P_INIVALID, @V_ITEMPROD_IDORIGEMPROD;
               END;

               IF @V_ITEMPROD_CDFISOPEITEM IS NULL BEGIN

                  UPDATE NOTAFISCAL
                  SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP) FROM CFOPTEMP
                                      WHERE NRCFOPTEMP = @V_CFOPTEMP)
                  WHERE CDFILIAL   = @P_FILIAL   AND
                        NRLANCTONF = @P_LANCTONF;
               END;
   ---------------------------------------------------------------------------------------------------------
               SELECT @V_FISOPEITEM = MAX(CDFISOPETMP),   @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                      @V_DIFALIQITEM = MAX(IDDIFALIQTMP),
                      @V_DSCDFISOPEIT = MAX(DSCFOPTMP),
                      @V_IDDIFALIQCUSPRC = ISNULL(MAX(IDDIFALIQCUSPRC),'N')
               FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               SELECT @V_IDORDPRIMDFENT = MAX(IDORDPRIMDFENT)
                 FROM PARAMGERAL;


               SET @V_FISOPEITEM        = ISNULL(@V_CDFISCOPERREGRA, @V_FISOPEITEM);
               SET @V_DSCDFISOPEIT      = ISNULL(@V_DSCDFISOPEITREGRA, @V_DSCDFISOPEIT);
               SET @V_DIFALIQITEM       = ISNULL(@V_IDDIFEALIQREGRA, @V_DIFALIQITEM);
               SET @V_IDDIFALIQCUSPRC   = ISNULL(@V_IDDIFALIQCUSPRREGRA, @V_IDDIFALIQCUSPRC);
   ---------------------------------------------------------------------------------------------------------
               EXEC CONSULTA_CSOSN @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                   @P_INSCESTA,   @P_TIPOOPER, @P_FILIAL,   @P_LANCTONF,
                                   @V_CDGRUPOFISC,@V_IDINTEREST, @P_CDFISCOPERSN = @V_CDFISCOPERSN OUTPUT;


               IF (@V_FISOPEITEM IS NULL) AND (@V_ITEMPROD_CDFISOPEITEM IS NOT NULL) AND (@V_IDGERNFIGUALXML = 'S') AND (@V_IDNFGERADAVIAXML = 'S') BEGIN
                  SET @V_FISOPEITEM = @V_ITEMPROD_CDFISOPEITEM;
               END;
               
               IF (@V_ITEMPROD_CDFISOPEITEM  IS NOT NULL) AND (@V_IDGERNFIGUALXML = 'S') AND (@V_IDNFGERADAVIAXML = 'S') BEGIN
                  SELECT @V_DSCDFISOPEIT = SUBSTRING(DSCFOPPADRAO,1,45)
                    FROM CFOPPADRAO
                   WHERE CDCFOPPADRAO = @V_ITEMPROD_CDFISOPEITEM;

                  UPDATE NOTAFISCAL
                     SET DSCDFISOPENF = @V_DSCDFISOPEIT
                   WHERE CDFILIAL   = @P_FILIAL   AND
                         NRLANCTONF = @P_LANCTONF AND
                         DSCDFISOPENF IS NULL;

               END;

               UPDATE ITEMPRODUTO
               SET CDFISOPEITEM = @V_FISOPEITEM,
                   CDSUFXCFOPPR = @V_SUFXCFOPPR,
                   DSCDFISOPEIT = @V_DSCDFISOPEIT,
                   CDFISCOPERSN = @V_CDFISCOPERSN
               WHERE CDFILIAL    = @P_FILIAL   AND
                     NRLANCTONF  = @P_LANCTONF AND
                     NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;

               DELETE FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
               FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               SELECT @V_CDCSTDIGI = CDSITUTRIBPR
               FROM ITEMPRODUTO
               WHERE CDFILIAL    = @P_FILIAL   AND
                     NRLANCTONF  = @P_LANCTONF AND
                     NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;

               IF ((@V_IDPERALTCSTFENF = 'N') OR
                  ((@V_IDPERALTCSTFENF = 'S') AND (@V_CDCSTDIGI IS NULL))) BEGIN
                  UPDATE ITEMPRODUTO
                  SET CDSITUTRIBPR  = @V_SITUTRIBPR
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;
               END
               ELSE BEGIN
                  SET @V_SITUTRIBPR = @V_CDCSTDIGI;
               END;

               DELETE FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               -- Verifica se h grupo fiscal por servico
               SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
               FROM SERVCLIE SC, SERVICO S
               WHERE SC.CDFILIAL   = @V_CDFILIEMIT AND
                     SC.CDCLIENTE  = @P_FORNECED    AND
                     SC.CDFILIAL   = S.CDFILIAL   AND
                     SC.CDSERVFILI = S.CDSERVFILI AND
                     S.CDPRODUTO   = @V_ITEMPROD_CDPRODUTO;

               IF @V_CDGRPFISCSV IS NULL BEGIN
                  -- Verifica se h grupo fiscal por cliente da filial
                  SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                  FROM CLIENFILIAL
                  WHERE CDFILIAL   = @V_CDFILIEMIT AND
                        CDCLIENTE  = @P_FORNECED;
               END;

               EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                        @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF,
                                        @V_CDGRUPOFISC, @V_CDGRPFISCSV, @V_IDINTEREST,
                                        NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, @V_ITEMPROD_IDORIGEMPROD;

            END;
            DECLARE C_INCITEMP CURSOR FOR
               SELECT DSMENSINCTMP
                 FROM INCITEMP
                WHERE (NRINCITEMP = @V_INCITEMP)
                  AND (DSMENSINCTMP IS NOT NULL)
                  AND (NOT EXISTS(SELECT DSDADOADIC
                                    FROM DADOSADIC
                                   WHERE (CDFILIAL   = @P_FILIAL)
                                     AND (NRLANCTONF = @P_LANCTONF)
                                     AND (DSDADOADIC LIKE INCITEMP.DSMENSINCTMP+'%')));
            OPEN C_INCITEMP;
            FETCH NEXT FROM C_INCITEMP INTO @V_INCITEMP_DSMENSINCTMP;
            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF NOT(@v_INCITEMP_DSMENSINCTMP IS NULL) BEGIN
                  /*PREENCHE AS MENSAGENS ATRELADAS A INCIDENCIA*/
                  INSERT INTO DADOSADIC(CDFILIAL,  NRLANCTONF,  NRDADOADIC,  DSDADOADIC)
                                 VALUES(@P_FILIAL, @P_LANCTONF, @V_DADOADIC, @V_INCITEMP_DSMENSINCTMP);

                  SET @V_DADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_DADOADIC) + 1)),3);
               END;
               FETCH NEXT FROM C_INCITEMP INTO @V_INCITEMP_DSMENSINCTMP;
            END;
            CLOSE C_INCITEMP;
            DEALLOCATE C_INCITEMP;

   ---------------------------------------------------------------------------------------------------------
      --ATUALIZAO DA TABELA DE IMPOSTOS POR ITEM.

            DELETE FROM ITEMPROIMPOS
            WHERE (CDFILIAL    = @P_FILIAL)   AND
                  (NRLANCTONF  = @P_LANCTONF) AND
                  (NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD);

            IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN

               DECLARE C_INCIDENCIA CURSOR FOR
               SELECT CDIMPOTEMP, MAX(CDFISCTEMP) AS CDFISCTEMP,
                      MAX(IDTRATIMPTMP) AS IDTRATIMPTMP, MAX(IDCONSISTENT) AS IDCONSISTENT, MAX(ISNULL(IDUTMUNIORIG, 'N')) AS IDUTMUNIORIG,
                      MAX(IDIMPORECUP)  AS IDIMPORECUP,  MAX(ISNULL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR,
                      MAX(IDORGARRECAD) AS IDORGARRECAD, MAX(IDUTVLRQTDEIMPO) AS IDUTVLRQTDEIMPO,
                      MAX(IP.IDUTVRPAUTA) AS IDUTVRPAUTA, MAX(CDDETALHEPROD) AS CDDETALHEPROD,
                      MAX(CDENQLEGALIPI) AS CDENQLEGALIPI
               FROM INCITEMP IT, IMPOSTO IP
               WHERE (IT.NRINCITEMP = @V_INCITEMP)   AND
                     (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                     (IP.IDPRODNOTA = 'P')
               GROUP BY CDIMPOTEMP
               ORDER BY IT.CDIMPOTEMP;

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP,   @V_INCIDENC_CDFISCTEMP,
                                                 @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDCONSISTENT,
                                                 @V_INCIDENC_IDUTMUNIORIG, @V_INCIDENC_IDIMPORECUP,
                                                 @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDORGARRECAD,
                                                 @V_INCIDENC_IDUTVLRQTDEIMPO, @V_INCIDENC_IDUTVRPAUTA,
                                                 @V_INCIDENC_CDDETALHEPROD, @V_INCIDENC_CDENQLEGALIPI;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_MINBCPROD = 0;

                  IF @V_INCIDENC_IDUTVRPAUTA = 'S' BEGIN
                     EXEC CALCULO_MINBCPRODUTO @P_EMPRESA, @P_TIPOOPER, @P_INSCESTA,    @P_ENTRSAID, @V_PAISORIG, @V_ESTAORIG,
                                               @V_ITEMPROD_CDPRODUTO,   @V_CDGRUPOFISC, @P_INIVALID, @P_LANCTONF, @P_FILIAL,
                                               @V_ITEMPROD_NRSEQITPROD, @P_VRPRODUTO = @V_MINBCPROD OUTPUT;
                  END;

                  IF @V_MINBCPROD = 0 BEGIN
                     SET @V_LIQUIITEM = @V_ITEMPROD_VRTOTAITEM - @V_ITEMPROD_VRDESCITEM;
                  END
                  ELSE BEGIN
                     SET @V_LIQUIITEM = @V_MINBCPROD - @V_ITEMPROD_VRDESCITEM;
                  END;


                  IF @V_INCIDENC_IDUTMUNIORIG = 'D' BEGIN
                     IF @V_UTGRUPFISCS = 'S' BEGIN
                        SET @V_CDGRPFISCSV = NULL;
                        SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = @V_CDFILIEMIT AND
                              SC.CDCLIENTE  = @P_FORNECED    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = @V_ITEMPROD_CDPRODUTO;
                        IF @V_CDGRPFISCSV IS NULL BEGIN
                           SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = @V_CDFILIEMIT AND
                                CDCLIENTE  = @P_FORNECED;
                        END;
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                               @V_CDGRPFISCSV,@P_TIPOOPER, NULL, NULL, NULL, NULL, @P_FORNECED, NULL, @V_ITEMPROD_IDORIGEMPROD;
                     END
                     ELSE BEGIN
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                               @V_CDGRUPOFISC,@P_TIPOOPER, NULL, NULL, NULL, NULL,@P_FORNECED, NULL, @V_ITEMPROD_IDORIGEMPROD;
                     END;
                  END
                  ELSE BEGIN
                     /* CONSIDERA O MUNICIPIO DE ORIGEM */

                     SELECT @V_UTGRUPFISCS = MAX(IDGRUPFISSRV)
                       FROM IMPOSTO
                      WHERE CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                     IF @V_UTGRUPFISCS = 'S' BEGIN
                        SET @V_CDGRPFISCSV = NULL;
                        SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = @V_CDFILIEMIT AND
                              SC.CDCLIENTE  = @P_FORNECED    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = @V_ITEMPROD_CDPRODUTO;
                        IF @V_CDGRPFISCSV IS NULL BEGIN
                           SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = @V_CDFILIEMIT AND
                                CDCLIENTE  = @P_FORNECED;
                        END;
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                               @V_CDGRPFISCSV, @P_TIPOOPER, NULL, NULL, NULL, NULL, @P_FORNECED, NULL, @V_ITEMPROD_IDORIGEMPROD;

                     END
                     ELSE BEGIN
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                               @V_CDGRUPOFISC, @P_TIPOOPER, NULL, NULL, NULL, NULL, @P_FORNECED, NULL, @V_ITEMPROD_IDORIGEMPROD;
                     END;
                  END;

                  SET @V_PARDEDTMP    = 0;
                  SET @V_PREDBCTMP    = 0;
                  SET @V_PREDBCTMP1   = 0;
                  SET @V_ALIQUTMP     = 0;
                  SET @V_IMPOSTOIT    = 0;
                  SET @V_IMPOSTORED1  = 0;
                  SET @V_ALIQINFO     = 0;
                  SET @V_IMPOSINFO    = 0;
                  SET @V_VRPERREDBCIT = 0;
                  SET @V_VRBASECALCIT = 0;
                  SET @V_VRIMPOSTOST  = 0;
                  SET @V_VRPPRIIMPST  = 0;
                  SET @V_IDREDUCAO    = 'N';

                  /*VERIFICA CST POR IMPOSTO - NFE*/
                  SET @V_IMPOICMS = NULL;

                  SET @V_CDGRUPOFISCAUX = NULL;

                  SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                    FROM GRUPOFISCIMPFIL G,
                          (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                  ELSE CDFILIEMIT END AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                  IF @V_IDORIGDESTNF = 'F' BEGIN
                  SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                    FROM GRFISIMPIEFORN G,
                         (SELECT CDFORNECED
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = @P_EMPRESA
                     AND G.CDINSCESTA = @P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                  END
                  ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                      SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                       FROM GRFISIMPIECLIE G,
                            (SELECT CDCLIENTE
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) N
                      WHERE G.CDCLIENTE = N.CDCLIENTE
                        AND G.CDEMPRESA = @P_EMPRESA
                        AND G.CDINSCESTA = @P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                  END;

                  IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                     EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @V_ITEMPROD_IDORIGEMPROD, @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                           @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END
                  ELSE BEGIN
                     EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @V_ITEMPROD_IDORIGEMPROD, @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                           @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END;

                  SET @V_CDREGRAITALIQ  = NULL;

                  SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                  SELECT @V_PARDEDTMP     = ISNULL(MAX(VRPARDEDTMP),0),
                         @V_PREDBCTMP     = ISNULL(MAX(VRPREDBCTMP),0),
                         @V_ALIQUTMP      = ISNULL(MAX(VRALIQUTMP),0),
                         @V_IDTRIMPSTII   = ISNULL(MAX(IDTRIMPSTTMP),0),
                         @V_PBCSUBTRIB    = ISNULL(MAX(VRPBCSTTMP),0),
                         @V_PREDBCTMP1    = ISNULL(MAX(VR1PREDBCTMP), 0),
                         @V_CDREGRAITALIQ = MAX(CDREGRATMP),
                         @V_CDFISCOPERREGRA = MAX(CDFISCOPER),
                         @V_IDDIFEALIQREGRA = MAX(IDDIFEALIQ),
                         @V_IDDIFALIQCUSPRREGRA = MAX(IDDIFALIQCUSPR)
                  FROM ALIQTEMP
                  WHERE (NRALIQTEMP = @V_ALIQTEMP);

                  IF @V_PREDBCTMP > 0 BEGIN
                     SET @V_IDREDUCAO = 'S';
                  END;

                  /* Verifica primeiro digito do CFOP */
                  SET @V_CFOP1DIGT = '';

                  IF @V_PAISCFOP = @V_PAISDEST BEGIN
                     IF @V_ESTACFOP = @V_ESTADEST BEGIN
                        SET @V_CFOP1DIGT = '1';
                     END
                     ELSE BEGIN
                        SET @V_CFOP1DIGT = '2';
                     END;
                  END
                  ELSE BEGIN
                     SET @V_CFOP1DIGT = '3';
                  END;

                  IF (@V_CDFISCOPERREGRA IS NOT NULL) AND (@V_IDCOMPRABONI <> 'S') BEGIN
                     SET @V_CDFISCOPERREGRA = @V_CFOP1DIGT+@V_CDFISCOPERREGRA;
                     SELECT @V_DSCDFISOPEITREGRA = TEKNISA.DESCRICAO_CFOP(@V_CDFISCOPERREGRA);
                     SET @V_DSCDFISOPEITREGRA = SUBSTRING(@V_DSCDFISOPEITREGRA, 1,45);
                  END;

                  IF (@V_IDCOMPRABONI = 'S') BEGIN
                     SET @V_FISOPEITEM      = ISNULL(@V_CDFISCOPERREGRA, @V_FISOPEITEM);
                     SET @V_DSCDFISOPEIT    = ISNULL(@V_DSCDFISOPEITREGRA, @V_DSCDFISOPEIT);
                     SELECT @V_DSCDFISOPEITREGRA = TEKNISA.DESCRICAO_CFOP(@V_FISOPEITEM);
                     SET @V_DSCDFISOPEITREGRA = SUBSTRING(@V_DSCDFISOPEITREGRA, 1,45);
                  END;

                  SET @V_FISOPEITEM      = ISNULL(@V_CDFISCOPERREGRA, @V_FISOPEITEM);
                  SET @V_DSCDFISOPEIT    = ISNULL(@V_DSCDFISOPEITREGRA, @V_DSCDFISOPEIT);
                  SET @V_DIFALIQITEM     = ISNULL(@V_IDDIFEALIQREGRA, @V_DIFALIQITEM);
                  SET @V_IDDIFALIQCUSPRC = ISNULL(@V_IDDIFALIQCUSPRREGRA, @V_IDDIFALIQCUSPRC);
                
                  IF (@V_CDFISCOPERREGRA IS NOT NULL) BEGIN
                     IF (LEN(@V_CDFISCOPERREGRA) < 4) BEGIN
                        SET @V_CDFISCOPERREGRA = @V_CFOP1DIGT+@V_CDFISCOPERREGRA;
                     END;

                     UPDATE ITEMPRODUTO
                        SET CDFISOPEITEM = @V_CDFISCOPERREGRA
                      WHERE CDFILIAL     = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;
                  END;

                  -- ALTERA NATUREZA DE OPERAO DA NOTA FISCAL CASO NO EXISTA
                  IF (@V_DSCDFISOPEITREGRA IS NOT NULL) BEGIN
                     UPDATE NOTAFISCAL
                        SET DSCDFISOPENF = @V_DSCDFISOPEITREGRA
                      WHERE CDFILIAL   = @P_FILIAL   AND
                            NRLANCTONF = @P_LANCTONF;
                  END
                  ELSE BEGIN
                     UPDATE NOTAFISCAL
                        SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                              FROM CFOPTEMP
                                             WHERE NRCFOPTEMP = @V_CFOPTEMP)
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND DSCDFISOPENF IS NULL;

                  END;

                  SELECT @V_ALIQINFO     = ISNULL(MAX(VRALIQIMPOIT),0),
                         @V_IMPOSINFO    = ISNULL(MAX(VRIMPOSIT),0),
                         @V_IDVALORINFO  = ISNULL(MAX(IDVALORINFO),'N'),
                         @V_NRIMPOSTO    = COUNT(*),
                         @V_VRPERREDBCIT = ISNULL(MAX(VRREDBCIMPOIT),0),
                         @V_VRBASECALCIT = ISNULL(MAX(VRBCALCIMPOIT),0)
                  FROM TRABITPROIMPOS
                  WHERE CDFILIMPOIT  = @P_FILIAL               AND
                        NRLANCIMPOIT = @P_LANCTONF             AND
                        NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                        CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP;

                  SET @V_TAXABASECALC = (100 - @V_PREDBCTMP1)/100;
                  SET @V_BASECALCIT   = @V_LIQUIITEM * @V_TAXABASECALC;

                  SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
                  SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
                  SET @V_TAXAALIQINFO = (@V_ALIQINFO/100);
                  SET @V_TAXABCSUBSTR = 1 + (@V_PBCSUBTRIB/100);

                  IF @V_PREDBCTMP1 <> 0 BEGIN
                     SET @V_IMPOSTORED1 = @V_BASECALCIT * @V_TAXAALIQUOTA;
                     SET @V_BASECALCIT  = @V_BASECALCIT * @V_TAXABASECALC;
                  END
                  ELSE BEGIN
                     SET @V_BASECALCIT = @V_LIQUIITEM * @V_TAXABASECALC;
                  END;

                  SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;

                  IF @V_PBCSUBTRIB > 0 BEGIN
                     SET @V_BASECALCIT = (@V_BASECALCIT * @V_TAXABCSUBSTR);
                     SET @V_PREDBCTMP  = @V_PBCSUBTRIB;
                     SET @V_PERDBCALC  = 0;
                  END;

                  /* SELECT @V_CDIMPOSTRIB  = MAX(CDIMPOSTO),
                         @V_IDVRIMPSTRIB = MAX(IDVRIMPSTRIB)
                    FROM IMPOSTO
                   WHERE CDIMPOSTRIB = @V_INCIDENC_CDIMPOTEMP; */

                  SET @V_CDIMPOSTRIB  = null;
                  SET @V_IDVRIMPSTRIB = null;
                  SET @V_VRIMPOSTOST = 0;
                  SET @V_VRPPRIIMPST = 0;

                  DECLARE C_ICMSST CURSOR FOR
                        SELECT CDIMPOSTO
                          FROM IMPOSTO
                         WHERE CDIMPOSTRIB = @V_INCIDENC_CDIMPOTEMP;

                  OPEN C_ICMSST;
                  FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_CDIMPOSTRIB = ISNULL(@V_CDIMPOSTRIB,'')+@V_ICMSST_CDIMPOSTRIB+'_';
                     FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                  END;
                  CLOSE C_ICMSST;
                  DEALLOCATE C_ICMSST;

                  IF @V_CDIMPOSTRIB IS NOT NULL BEGIN

                     SELECT @V_IDVRIMPSTRIB = ISNULL(MAX(IDVRIMPSTRIB), 'N')
                       FROM TRABITPROIMPOS I, IMPOSTO II
                      WHERE (CDFILIMPOIT     = @P_FILIAL)
                        AND (NRLANCIMPOIT    = @P_LANCTONF)
                        AND (NRSEQIMPOIT     = @V_ITEMPROD_NRSEQITPROD)
                        AND (CHARINDEX(II.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0)
                        AND (I.CDIMPOSTOIT = II.CDIMPOSTO);

                     IF (@V_IDTRIMPSTII = '1') OR (ISNULL(@V_IDVRIMPSTRIB,'N') = 'N') BEGIN
                        SET @V_VRIMPOSTOST = 0;
                        SET @V_VRPPRIIMPST = 0;
                     END
                     ELSE BEGIN
                        SELECT @V_VRIMPOSTOST = ISNULL(MAX(VRIMPOSIT),0),
                               @V_VRPPRIIMPST = ISNULL(MAX(VR1IMPOSTOIT), 0)
                          FROM TRABITPROIMPOS I
                         WHERE (CDFILIMPOIT  = @P_FILIAL)
                           AND (NRLANCIMPOIT = @P_LANCTONF)
                           AND (NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD)
                           AND (CHARINDEX(CDIMPOSTOIT+'_', @V_CDIMPOSTRIB) > 0)
                           AND (NRSEQITPRO   = '1');
                     END;
                  END;

                  IF (@V_INCIDENC_IDUTVLRQTDEIMPO) = 'S' BEGIN
                     SET @V_IMPOSTOIT = (@V_ITEMPROD_QTITEMPROD * @V_ALIQUTMP) - @V_PARDEDTMP;

                     IF @V_VRPPRIIMPST <> 0 BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                     END;
                  END
                  ELSE BEGIN
                     SET @V_IMPOSTOIT = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

                     IF @V_VRPPRIIMPST <> 0 BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                     END;
                  END;

                  IF @P_AUDIT = 'S' BEGIN
                     IF (@V_INCIDENC_IDUTVLRQTDEIMPO) = 'S' BEGIN
                        SET @V_ALIQINFO  = @V_ALIQUTMP;
                        SET @V_IMPOSINFO = (@V_ITEMPROD_QTITEMPROD * @V_ALIQUTMP) - @V_PARDEDTMP;

                        IF @V_VRPPRIIMPST <> 0 BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                        END
                        ELSE BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_ALIQINFO  = @V_ALIQUTMP;
                        SET @V_IMPOSINFO = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

                        IF @V_VRPPRIIMPST <> 0 BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                        END
                        ELSE BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF (@V_IDVALORINFO <> 'S') BEGIN
                        IF (@V_INCIDENC_IDUTVLRQTDEIMPO) = 'S' BEGIN
                           SET @V_IMPOSINFO = (@V_ITEMPROD_QTITEMPROD * @V_ALIQINFO) - @V_PARDEDTMP;

                           IF @V_VRPPRIIMPST <> 0 BEGIN
                              SET @V_IMPOSINFO =  @V_IMPOSINFO - @V_VRPPRIIMPST;
                           END
                           ELSE BEGIN
                              SET @V_IMPOSINFO =  @V_IMPOSINFO - @V_VRIMPOSTOST;
                           END;
                        END
                        ELSE BEGIN
                           SET @V_IMPOSINFO = (@V_BASECALCIT * @V_TAXAALIQINFO) - @V_PARDEDTMP;

                           IF @V_VRPPRIIMPST <> 0 BEGIN
                              SET @V_IMPOSINFO = @V_IMPOSINFO - @V_VRPPRIIMPST;
                           END
                           ELSE BEGIN
                              SET @V_IMPOSINFO = @V_IMPOSINFO - @V_VRIMPOSTOST;
                           END;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_ALIQUTMP  = @V_ALIQINFO;     
                        SET @V_IMPOSTOIT = @V_IMPOSINFO;

                        SELECT @V_IDIMPORTAIMPXML = ISNULL(IDVALORINFO, 'N')
                          FROM TRABITPROIMPOS
                         WHERE CDFILIMPOIT  = @P_FILIAL
                           AND NRLANCIMPOIT = @P_LANCTONF
                           AND NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD
                           AND CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP
                           AND NRSEQITPRO   = '1';

                        IF (@V_IDNFGERADAVIAXML = 'S') AND ((@V_IDIMPORTAIMPXML = 'S') OR (@V_IDGERNFIGUALXML = 'S')) BEGIN
                           SET @V_PREDBCTMP  = @V_VRPERREDBCIT;
                           SET @V_BASECALCIT = @V_VRBASECALCIT;
                        END;
                     END;
                  END;

                  SET @V_CONTABCALC = @V_LIQUIDOPROD - (@V_LIQUIDOPROD * @V_TAXABASECALC);

                  IF (@V_IMPOSTOIT < 0) OR (@V_IMPOSTOIT IS NULL) BEGIN
                     SET @V_IMPOSTOIT = 0;
                  END;

                  IF (@V_IMPOSINFO < 0) OR (@V_IMPOSINFO IS NULL)BEGIN
                     SET @V_IMPOSINFO = 0;
                  END;

                  SET @V_BASECALCIRRF = @V_BASECALCIT;

                  IF (@V_ALIQUTMP = 0) AND (@V_IMPOSTOIT = 0) AND (@V_ALIQINFO = 0) BEGIN
                     SET @V_BASECALCIT = 0;
                  END;

   ---------------------------------------------------------------------------------------------------------
                  SELECT @V_FISOPEITEM = MAX(CDFISOPEITEM),
                         @V_SUFXCFOPPR = MAX(CDSUFXCFOPPR)
                  FROM ITEMPRODUTO
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;
   ---------------------------------------------------------------------------------------------------------


                  SET @V_IMPOICMS = NULL;
                  SET @V_CST1DIGT = NULL;

                  SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;


                  IF (@V_IMPOICMS IS NOT NULL) BEGIN

                     IF @V_IDORIGDESTNF = 'L' BEGIN

                        SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                          FROM PRODUTO
                         WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                        IF @V_CST1DIGT IS NULL BEGIN
                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1SAI)
                             FROM INSCRESTAD
                            WHERE CDEMPRESA   = @P_EMPRESA AND
                                  CDINSCESTA  = @P_INSCESTA;
                        END;
                     END
                     ELSE IF @V_IDORIGDESTNF = 'C'
                     BEGIN
                        SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                          FROM PRODUTO
                         WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                        IF @V_CST1DIGT IS NULL BEGIN
                           SELECT @V_CST1DIGT  = MAX(CDCSTDIG1CLI)
                             FROM NOTAFISCAL N LEFT JOIN CLIENTE C
                                              ON (N.CDCLIENTE = C.CDCLIENTE)
                            WHERE (CDFILIAL     = @P_FILIAL) AND
                                  (NRLANCTONF   = @P_LANCTONF);
                        END;
                     END
                     ELSE
                     BEGIN

                        SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                          FROM PRODUTO
                         WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                        IF @V_CST1DIGT IS NULL BEGIN
                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1ENT)
                             FROM NOTAFISCAL N, FORNECEDOR F
                            WHERE CDFILIAL     = @P_FILIAL
                              AND NRLANCTONF   = @P_LANCTONF
                              AND N.CDFORNECED = F.CDFORNECED;
                        END;
                     END;
                     IF (@V_CDSITTRIBTMP IS NOT NULL) BEGIN
                        UPDATE ITEMPRODUTO
                           SET CDSITUTRIBPR  = @V_CST1DIGT + @V_CDSITTRIBTMP
                         WHERE CDFILIAL      = @P_FILIAL AND
                               NRLANCTONF    = @P_LANCTONF AND
                               NRSEQITPROD   = @V_ITEMPROD_NRSEQITPROD;

                        SET @V_SITUTRIBPR = @V_CST1DIGT + @V_CDSITTRIBTMP;
                     END;

                     SET @V_CDGRUPOFISCAUX = NULL;

                     SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                       FROM GRUPOFISCIMPFIL G,
                             (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                     ELSE CDFILIEMIT END AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                     IF @V_IDORIGDESTNF = 'F' BEGIN
                     SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = @P_EMPRESA
                        AND G.CDINSCESTA = @P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                     END
                     ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                         SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                          FROM GRFISIMPIECLIE G,
                               (SELECT CDCLIENTE
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = @P_FILIAL
                                   AND NRLANCTONF = @P_LANCTONF) N
                         WHERE G.CDCLIENTE = N.CDCLIENTE
                           AND G.CDEMPRESA = @P_EMPRESA
                           AND G.CDINSCESTA = @P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                     END;

                     IF (@V_IDCOMPRABONI = 'N') BEGIN
                        IF (@V_CDGRUPOFISCAUX IS NOT NULL) BEGIN
                           EXEC CONSULTA_CFOP @P_ENTRSAID,      @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                              @P_INSCESTA,      @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                              @V_PAISDEST,      @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                              @V_CDGRUPOFISCAUX,@P_INIVALID, @V_ITEMPROD_IDORIGEMPROD;
                        END
                        ELSE BEGIN
                           EXEC CONSULTA_CFOP @P_ENTRSAID,      @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                              @P_INSCESTA,      @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                              @V_PAISDEST,      @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                              @V_CDGRUPOFISC,   @P_INIVALID, @V_ITEMPROD_IDORIGEMPROD;
                        END;

                        SELECT @V_FISOPEITEM = MAX(CDFISOPETMP),
                               @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                               @V_DSCDFISOPEIT = MAX(DSCFOPTMP)
                          FROM CFOPTEMP
                         WHERE NRCFOPTEMP = @V_CFOPTEMP;

                        SET @V_FISOPEITEM      = ISNULL(@V_CDFISCOPERREGRA, @V_FISOPEITEM);
                        SET @V_DSCDFISOPEIT    = ISNULL(@V_DSCDFISOPEITREGRA, @V_DSCDFISOPEIT);
                        SET @V_DIFALIQITEM     = ISNULL(@V_IDDIFEALIQREGRA, @V_DIFALIQITEM);
                        SET @V_IDDIFALIQCUSPRC = ISNULL(@V_IDDIFALIQCUSPRREGRA, @V_IDDIFALIQCUSPRC);

                        IF (@V_DSCDFISOPEITREGRA IS NOT NULL) BEGIN
                            UPDATE NOTAFISCAL
                               SET DSCDFISOPENF = @V_DSCDFISOPEITREGRA
                             WHERE CDFILIAL   = @P_FILIAL   AND
                                   NRLANCTONF = @P_LANCTONF;
                        END
                        ELSE BEGIN
                            UPDATE NOTAFISCAL
                               SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                     FROM CFOPTEMP
                                                    WHERE NRCFOPTEMP = @V_CFOPTEMP)
                             WHERE CDFILIAL   = @P_FILIAL
                               AND NRLANCTONF = @P_LANCTONF
                               AND DSCDFISOPENF IS NULL;

                        END;

                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM = @V_FISOPEITEM,
                               CDSUFXCFOPPR = @V_SUFXCFOPPR,
                               DSCDFISOPEIT = @V_DSCDFISOPEIT

                         WHERE CDFILIAL    = @P_FILIAL   AND
                               NRLANCTONF  = @P_LANCTONF AND
                               NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;

                        DELETE FROM CFOPTEMP
                         WHERE NRCFOPTEMP = @V_CFOPTEMP;
                     END;    
                  END;

                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                     CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                     VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDTRIMPSTII,
                     CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, VR1PERREDBCIT, VR1IMPREDBCIT,
                     CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT, VRBCALCIRRF, CDDETALHEPROD)
                  VALUES(
                     @P_FILIAL,     @P_LANCTONF,   @V_ITEMPROD_NRSEQITPROD,    @V_INCIDENC_CDIMPOTEMP, '1', @V_INCIDENC_CDFISCTEMP,
                     @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, @V_ALIQUTMP, ISNULL(@V_PREDBCTMP,0),      ISNULL(@V_PARDEDTMP,0),
                     ISNULL(ROUND(@V_BASECALCIT,2),0),      ISNULL(@V_BASECALCIT,0),    @V_IMPOSTOIT,
                     '00000', '00000', @V_IDTRIMPSTII, @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_PREDBCTMP1, @V_IMPOSTORED1,
                     @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ, ISNULL(ROUND(@V_BASECALCIRRF,2),0), @V_INCIDENC_CDDETALHEPROD);

                  UPDATE TRABITPROIMPOS
                  SET VRALIQIMPOIT   = @V_ALIQINFO,
                      VRCONTIMPOIT   = ISNULL(ROUND(@V_BASECALCIT,2),0),
                      VRREDBCIMPOIT  = @V_PREDBCTMP,
                      VRBCALCIMPOIT  = ISNULL(@V_BASECALCIT,0),
                      VRPDEDIMPOIT   = @V_PARDEDTMP,
                      VRIMPOSIT      = @V_IMPOSINFO,
                      CDFISCIMPOIT   = @V_INCIDENC_CDFISCTEMP,
                      CDSTRIBIMPOIT  = @V_SITUTRIBPR,
                      CDFOPERIMPOIT  = @V_FISOPEITEM,
                      CDSCFOPIMPOIT  = @V_SUFXCFOPPR,
                      IDERRIMPOIT    = '00000',
                      IDAVISIMPOIT   = '00000',
                      IDTRIMPSTTI    = @V_IDTRIMPSTII,
                      CDSTRIBITNFE = @V_CDSITTRIBTMP,
                      IDMODBCITEMNFE   = @V_IDMODBCNFE,
                      IDMODBCSTITENFE = @V_IDMODBCSTNFE,
                      VR1REDBCIMPOIT = @V_PREDBCTMP1,
                      VR1IMPOSTOIT = @V_IMPOSTORED1,
                      CDTPCREDPICOITE = @V_CDTPCRPICOSTNFE,
                      CDNATUBCALPCIT  = @V_CDNATUBCPCSTNFE,
                      IDMOTDESOTRABIT = @V_IDMOTIDESSTNFE,
                      VRBCALCIRRF     = ISNULL(ROUND(@V_BASECALCIRRF,2),0),
                      CDDETALHEPROD   = @V_INCIDENC_CDDETALHEPROD,
                      CDENQLEGALIPI   = @V_INCIDENC_CDENQLEGALIPI
                  WHERE CDFILIMPOIT  = @P_FILIAL               AND
                        NRLANCIMPOIT = @P_LANCTONF             AND
                        NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                        CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                        NRSEQITPRO   = '1';

                  IF @V_IDREDUCAO = 'S' BEGIN
                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                        CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                        VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT,
                        CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                     VALUES(
                        @P_FILIAL,     @P_LANCTONF,  @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '2', '2',
                        @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, 0,       ISNULL(@V_PERDBCALC,0),
                        ISNULL(@V_PARDEDTMP,0), ISNULL(ROUND(@V_CONTABCALC,2),0), 0, 0,'00000', '00000',
                        @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);

                     DELETE FROM TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                           NRSEQITPRO   = '2';

                     IF  @V_NRIMPOSTO  > 0 BEGIN
                        INSERT INTO TRABITPROIMPOS(
                           CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                           CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                           VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT,
                           CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                        VALUES(
                           @P_FILIAL,     @P_LANCTONF,   @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '2', '2',
                           @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, 0,        @V_PERDBCALC, ISNULL(@V_PARDEDTMP,0),
                           ISNULL(ROUND(@V_CONTABCALC,2),0), 0, 0,'00000', '00000', @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE,
                           @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);
                     END;
                  END
                  ELSE BEGIN
                     DELETE FROM TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                           NRSEQITPRO   = '2';
                  END;

                  DELETE FROM ALIQTEMP
                  WHERE NRALIQTEMP = @V_ALIQTEMP;

                  IF (@V_DIFALIQITEM = 'S')           AND
                     (@V_INCIDENC_IDIMPORECUP = 'S')  AND
                     (@V_INCIDENC_IDORGARRECAD = 'E') BEGIN

                     SET @V_ALIQDIFE    = 0;
                     SET @V_ALIQDEST    = 0;
                     SET @V_IMPOSTODIFE = 0;

                     IF @V_INCIDENC_IDUTMUNIORIG = 'D' BEGIN
                        /* CONSIDERA O MUNICIPIO DE DESTINO */
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL, @P_LANCTONF,
                                               @V_CDGRUPOFISC, @P_TIPOOPER, NULL, NULL, NULL, NULL, @P_FORNECED, NULL, @V_ITEMPROD_IDORIGEMPROD;
                     END
                     ELSE BEGIN
                        /* CONSIDERA O MUNICIPIO DE ORIGEM */
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @V_PAISDEST,
                                               @V_ESTADEST, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL, @P_LANCTONF,
                                               @V_CDGRUPOFISC, @P_TIPOOPER, NULL, NULL, NULL, NULL, @P_FORNECED, NULL, @V_ITEMPROD_IDORIGEMPROD;
                     END;

                     SELECT @V_ALIQDEST = MAX(VRALIQUTMP)
                     FROM ALIQTEMP
                     WHERE (NRALIQTEMP = @V_ALIQTEMP);

                     IF @V_ALIQDEST IS NULL BEGIN
                        SET @V_ALIQDEST = 0;
                     END;

                     IF (@V_ALIQUTMP < @V_ALIQDEST) BEGIN
                        SET @V_ALIQDIFE    = @V_ALIQDEST - @V_ALIQUTMP;
                        SET @V_BCALCDIFCOMP = 0;

                        IF (@V_IDCALCDIFENTFISC = 'S') BEGIN
                           SET @V_BCALCDIFCOMP = ROUND(((@V_BASECALCIT - @V_IMPOSTOIT) / ((100 - @V_ALIQDEST)/100)) , @V_NRDECITOTANF);
                           SET @V_IMPOSTODIFE  = ROUND(((@V_BCALCDIFCOMP * (@V_ALIQDEST/100)) - @V_IMPOSTOIT), @V_NRDECITOTANF);
                        END
                        ELSE BEGIN
                           SET @V_IMPOSTODIFE  = ROUND((@V_BASECALCIT * (@V_ALIQDIFE/100)), @V_NRDECITOTANF);
                           SET @V_BCALCDIFCOMP = @V_BASECALCIT;
                        END;

                        INSERT INTO ITEMPROIMPOS(
                           CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                           CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                           VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDVALORINFIT,
                           CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, IDDIFALIQCUSPRI,
                           CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                        VALUES(
                           @P_FILIAL, @P_LANCTONF, @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '3', @V_INCIDENC_CDFISCTEMP,
                           @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, @V_ALIQDIFE, ISNULL(@V_PREDBCTMP,0), ISNULL(@V_PARDEDTMP,0), ISNULL(ROUND(@V_BCALCDIFCOMP,2),0), ISNULL(@V_BCALCDIFCOMP,0),
                           ISNULL(@V_IMPOSTODIFE,0), '00000', '00000', @V_IDVALORINFO,
                           @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_IDDIFALIQCUSPRC, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);
                     END
                     ELSE BEGIN
                        DELETE FROM TRABITPROIMPOS
                        WHERE CDFILIMPOIT  = @P_FILIAL   AND
                              NRLANCIMPOIT = @P_LANCTONF AND
                              NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                              CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                              NRSEQITPRO   = '3';
                     END;

                     IF (@V_ALIQINFO < @V_ALIQDEST) BEGIN
                        SET @V_ALIQDIFE    = @V_ALIQDEST - @V_ALIQINFO;
                        SET @V_BCALCDIFCOMP = 0;

                        IF (@V_IDCALCDIFENTFISC = 'S') BEGIN
                           SET @V_BCALCDIFCOMP = ROUND(((@V_BASECALCIT - (@V_BASECALCIT * (@V_ALIQINFO/100))) / ((100 - @V_ALIQDEST)/100)) , @V_NRDECITOTANF);
                           SET @V_IMPOSTODIFE  = ROUND(((@V_BCALCDIFCOMP * (@V_ALIQDEST/100)) - @V_IMPOSTOIT), @V_NRDECITOTANF);
                        END
                        ELSE BEGIN
                           SET @V_IMPOSTODIFE  = ROUND((@V_BASECALCIT * (@V_ALIQDIFE/100)), @V_NRDECITOTANF);
                           SET @V_BCALCDIFCOMP = @V_BASECALCIT;
                        END;

                        DELETE FROM TRABITPROIMPOS
                        WHERE CDFILIMPOIT  = @P_FILIAL   AND
                              NRLANCIMPOIT = @P_LANCTONF AND
                              NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                              CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                              NRSEQITPRO   = '3';

                        INSERT INTO TRABITPROIMPOS(
                           CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                           CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                           VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                           CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, IDDIFALIQCUSPTI,
                           CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                        VALUES(
                           @P_FILIAL, @P_LANCTONF, @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '3', @V_INCIDENC_CDFISCTEMP,
                           @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, @V_ALIQDIFE, ISNULL(@V_PREDBCTMP,0), ISNULL(@V_PARDEDTMP,0), ISNULL(ROUND(@V_BCALCDIFCOMP,2),0),
                           ISNULL(@V_BCALCDIFCOMP,0), ISNULL(@V_IMPOSTODIFE,0), '00000', '00000', @V_IDVALORINFO,
                           @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_IDDIFALIQCUSPRC,
                           @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);
                     END;
                  END
                  ELSE BEGIN
                     DELETE FROM TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                           NRSEQITPRO   = '3';
                  END;

                  DELETE FROM ALIQTEMP
                  WHERE NRALIQTEMP = @V_ALIQTEMP;

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP,   @V_INCIDENC_CDFISCTEMP,
                                                    @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDCONSISTENT,
                                                    @V_INCIDENC_IDUTMUNIORIG, @V_INCIDENC_IDIMPORECUP,
                                                    @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDORGARRECAD,
                                                    @V_INCIDENC_IDUTVLRQTDEIMPO, @V_INCIDENC_IDUTVRPAUTA,
                                                    @V_INCIDENC_CDDETALHEPROD, @V_INCIDENC_CDENQLEGALIPI;
               END; /* WHILE DO CURSOR C_INCIDENCIA*/

               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;

               DELETE FROM INCITEMP
               WHERE NRINCITEMP = @V_INCITEMP;
            END;
            FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPROD_VRTOTAITEM, @V_ITEMPROD_VRDESCITEM,
                                               @V_ITEMPROD_CDPRODUTO,  @V_ITEMPROD_NRSEQITPROD,
                                               @V_ITEMPROD_CDARVPROD,  @V_ITEMPROD_QTITEMPROD,
                                               @V_ITEMPROD_CDFISOPEITEM, @V_ITEMPROD_CDSITUTRIBPR,
                                               @V_ITEMPROD_IDORIGEMPROD;
         END;
         CLOSE C_ITEMPRODUTO;
         DEALLOCATE C_ITEMPRODUTO;


         IF (@V_INTEGRACAO IS NOT NULL) AND (@P_ENTRSAID = 'S') BEGIN
            INSERT INTO ITEMPROIMPOS(
               CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
               CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
               VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
               (SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT, CDSTRIBIMPOIT,
                       CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, ISNULL(VRREDBCIMPOIT,0), ISNULL(VRPDEDIMPOIT,0), ISNULL(ROUND(VRCONTIMPOIT,2),0),
                       ISNULL(VRBCALCIMPOIT,0), ISNULL(VRIMPOSIT,0), IDERRIMPOIT, IDAVISIMPOIT, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT
                FROM TRABITPROIMPOS
                WHERE CDFILIMPOIT  = @P_FILIAL   AND
                      NRLANCIMPOIT = @P_LANCTONF);

            SELECT @V_TOTAPROD = SUM(VRTOTAITEM - VRDESCITEM)
            FROM ITEMPRODUTO
            WHERE CDFILIAL   = @P_FILIAL   AND
                  NRLANCTONF = @P_LANCTONF;

            IF (@V_TOTAPROD IS NULL) BEGIN
               SET @V_TOTAPROD = 0;
            END;

            IF (@V_TOTAPROD > 0) BEGIN
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM   = (@V_NOTAFISC/@V_TOTAPROD)*(VRTOTAITEM - VRDESCITEM)
               WHERE CDFILIAL   = @P_FILIAL   AND
                     NRLANCTONF = @P_LANCTONF;
            END;
         END;
      --------------------------------------------------------------------------------------------------------
      --RATEIO DOS ENCARGOS

         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN

            DECLARE C_ITEMENCARGO CURSOR FOR
             SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0)) VRITEMENCA, IDENCARGO,
                    EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
               FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL   = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF) I
              WHERE (IE.CDFILIAL   = @P_FILIAL)
                AND (IE.NRLANCTONF = @P_LANCTONF)
                AND (IE.VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0) > 0)
                AND (EN.CDENCARGO  = IE.CDENCARGO);

            OPEN C_ITEMENCARGO;

            FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                               @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                               @V_ITEMENC_CDCTBLSAIDEN;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_TOTAPRODENCA = 0;

               DECLARE C_VRLIQRATEIO CURSOR FOR
               SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
               FROM ITEMPRODUTO IP, ITEMPROIMPOS II
               WHERE (IP.CDFILIAL    = @P_FILIAL)      AND
                     (IP.NRLANCTONF  = @P_LANCTONF)    AND
                     (II.CDFILIAL    = IP.CDFILIAL)    AND
                     (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                     (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                     (II.NRITPROIMPOS = '1')           AND
                     (II.CDIMPOSTO IN (SELECT (BC.CDIMPOSTO)
                                       FROM BASECALC BC
                                       WHERE (BC.CDENCARGO = @V_ITEMENC_CDENCARGO)));

               OPEN C_VRLIQRATEIO;

               FETCH NEXT FROM C_VRLIQRATEIO INTO @V_VRLIQ_NRSEQITPROD, @V_VRLIQ_VRLIQUIDO;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF NOT (@V_VRLIQ_VRLIQUIDO IS NULL) BEGIN
                     SET @V_TOTAPRODENCA = @V_TOTAPRODENCA + @V_VRLIQ_VRLIQUIDO;
                  END;

                  FETCH NEXT FROM C_VRLIQRATEIO INTO @V_VRLIQ_NRSEQITPROD, @V_VRLIQ_VRLIQUIDO;
               END; /*WHILE DO CURSOR C_VRLIQRATEIO*/

               CLOSE C_VRLIQRATEIO;
               DEALLOCATE C_VRLIQRATEIO;

               IF (@V_TOTAPRODENCA = 0) BEGIN

                  IF (@V_IDNFRETIND = 'S') OR (@V_IDCOMPRABONI = 'S') BEGIN /* Retorno de industrializao grava encargo no brutitem do item que vai para o vencimento */

                     SELECT @V_TOTAPRODENCA = SUM(VRTOTAITEM - VRDESCITEM)
                       FROM ITEMPRODUTO IP, TPOPERCFOP T, NOTAFISCAL N
                      WHERE IP.CDFILIAL     = @P_FILIAL
                        AND IP.NRLANCTONF   = @P_LANCTONF
                        AND IP.CDFILIAL     = N.CDFILIAL
                        AND IP.NRLANCTONF   = N.NRLANCTONF
                        AND IP.CDFISOPEITEM = T.CDFISCOPER
                        AND N.CDTIPOOPER    = T.CDTIPOOPER
                        AND T.IDCOMPOEVENC  = 'S';

                     IF @V_TOTAPRODENCA <> 0 BEGIN
                        DECLARE C_ATUAVRCONT CURSOR FOR
                        SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                          FROM ITEMPRODUTO IP, TPOPERCFOP T, NOTAFISCAL N
                         WHERE (IP.CDFILIAL     = @P_FILIAL)
                           AND (IP.NRLANCTONF   = @P_LANCTONF)
                           AND (IP.CDFILIAL     = N.CDFILIAL)
                           AND (IP.NRLANCTONF   = N.NRLANCTONF)
                           AND (IP.CDFISOPEITEM = T.CDFISCOPER)
                           AND (N.CDTIPOOPER    = T.CDTIPOOPER)
                           AND (T.IDCOMPOEVENC  = 'S');

                        OPEN C_ATUAVRCONT;

                        FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;

                        WHILE (@@FETCH_STATUS = 0) BEGIN

                           IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                              SET @V_VRBRUTO  = (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                           END
                           ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                              SET @V_VRBRUTO  = - (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                           END
                           ELSE BEGIN
                              SET @V_VRBRUTO = 0;
                           END;

                           IF (@V_ITEMENC_CDCTBLENTREN IS NULL) BEGIN
                              SET @V_VRCONTAB = @V_VRBRUTO;
                           END
                           ELSE BEGIN
                              SET @V_VRCONTAB = 0;
                           END;

                           SELECT @V_VALRDESCITEM = (VRTOTAITEM - VRDESCITEM)
                           FROM ITEMPRODUTO
                           WHERE CDFILIAL    = @P_FILIAL   AND
                                 NRLANCTONF  = @P_LANCTONF AND
                                 NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                           UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = VRBRUTITEM + (@V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                               VRCONTITEM = VRCONTITEM + (@V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                           WHERE CDFILIAL    = @P_FILIAL   AND
                                 NRLANCTONF  = @P_LANCTONF AND
                                 NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                           UPDATE TRABITPROIMPOS
                           SET VRCONTIMPOIT = ISNULL(ROUND(VRCONTIMPOIT + ((@V_VRBRUTO * @V_VALRDESCITEM) * ((100 - VRREDBCIMPOIT)/100)),2),0)
                           WHERE CDFILIMPOIT  = @P_FILIAL   AND
                                 NRLANCIMPOIT = @P_LANCTONF AND
                                 NRSEQIMPOIT  = @V_ATUAVR_NRSEQITPROD;

                           FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;
                        END; /*WHILE DO CURSOR C_ATUAVRCONT*/

                        CLOSE C_ATUAVRCONT;
                        DEALLOCATE C_ATUAVRCONT;
                     END;
                  END
                  ELSE BEGIN
                     SELECT @V_TOTAPRODENCA = SUM(VRTOTAITEM - VRDESCITEM)
                       FROM ITEMPRODUTO IP
                      WHERE (IP.CDFILIAL   = @P_FILIAL)
                        AND (IP.NRLANCTONF = @P_LANCTONF);

                     IF @V_TOTAPRODENCA <> 0 BEGIN

                        DECLARE C_ATUAVRCONT CURSOR FOR
                        SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                        FROM ITEMPRODUTO IP
                        WHERE (IP.CDFILIAL    = @P_FILIAL) AND
                              (IP.NRLANCTONF  = @P_LANCTONF);

                        OPEN C_ATUAVRCONT;

                        FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;

                        WHILE (@@FETCH_STATUS = 0) BEGIN

                           IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                              SET @V_VRBRUTO  = (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                           END
                           ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                              SET @V_VRBRUTO  = - (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                           END
                           ELSE BEGIN
                              SET @V_VRBRUTO = 0;
                           END;

                           IF (@V_ITEMENC_CDCTBLENTREN IS NULL) BEGIN
                              SET @V_VRCONTAB = @V_VRBRUTO;
                           END
                           ELSE BEGIN
                              SET @V_VRCONTAB = 0;
                           END;

                           SELECT @V_VALRDESCITEM = (VRTOTAITEM - VRDESCITEM)
                           FROM ITEMPRODUTO
                           WHERE CDFILIAL    = @P_FILIAL   AND
                                 NRLANCTONF  = @P_LANCTONF AND
                                 NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                           UPDATE ITEMPRODUTO
                           SET VRBRUTITEM = VRBRUTITEM + (@V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                               VRCONTITEM = VRCONTITEM + (@V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                           WHERE CDFILIAL    = @P_FILIAL   AND
                                 NRLANCTONF  = @P_LANCTONF AND
                                 NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                           UPDATE TRABITPROIMPOS
                           SET VRCONTIMPOIT = ISNULL(ROUND(VRCONTIMPOIT + ((@V_VRBRUTO * @V_VALRDESCITEM) * ((100 - VRREDBCIMPOIT)/100)),2),0)
                           WHERE CDFILIMPOIT  = @P_FILIAL   AND
                                 NRLANCIMPOIT = @P_LANCTONF AND
                                 NRSEQIMPOIT  = @V_ATUAVR_NRSEQITPROD;

                           FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;
                        END; /*WHILE DO CURSOR C_ATUAVRCONT*/

                        CLOSE C_ATUAVRCONT;
                        DEALLOCATE C_ATUAVRCONT;
                     END;
                  END;
               END
               ELSE BEGIN

                  DECLARE C_ATUAVRCONT CURSOR FOR
                  SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                         NRITPROIMPOS
                  FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                  WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                        (IP.NRLANCTONF   = @P_LANCTONF)    AND
                        (II.CDFILIAL     = IP.CDFILIAL)    AND
                        (II.NRLANCTONF   = IP.NRLANCTONF)  AND
                        (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                        (II.NRITPROIMPOS = '1')            AND
                        (II.CDIMPOSTO IN (SELECT (BC.CDIMPOSTO)
                                          FROM BASECALC BC
                                          WHERE (BC.CDENCARGO = @V_ITEMENC_CDENCARGO)));
                  OPEN C_ATUAVRCONT;

                  FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO, @V_ATUAVR_NRITPROIMPOS;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                        SET @V_VRBRUTO = (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                     END
                     ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                        SET @V_VRBRUTO = - (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                     END
                     ELSE BEGIN
                        SET @V_VRBRUTO = 0;
                     END;

                     IF (@V_ITEMENC_CDCTBLENTREN IS NULL) BEGIN
                        SET @V_VRCONTAB = @V_VRBRUTO;
                     END
                     ELSE BEGIN
                        SET @V_VRCONTAB = 0;
                     END;

                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM + (@V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                         VRCONTITEM = VRCONTITEM + (@V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                     FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO, @V_ATUAVR_NRITPROIMPOS;
                  END; /*WHILE DO CURSOR C_ATUAVRCONT*/

                  CLOSE C_ATUAVRCONT;
                  DEALLOCATE C_ATUAVRCONT;

                  DECLARE C_ITEMPROIMPOS CURSOR FOR
                  SELECT II.NRSEQITPROD, II.CDIMPOSTO, II.VRPERREDBCIT, II.VRALIQITEM, II.VRPARDEDIT,
                         TI.VRALIQIMPOIT, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                         TI.IDVALORINFO, II.NRITPROIMPOS, II.IDTRIMPSTII
                  FROM ITEMPROIMPOS II, ITEMPRODUTO IP, BASECALC BC, TRABITPROIMPOS TI
                  WHERE (II.CDFILIAL     = @P_FILIAL)       AND
                        (II.NRLANCTONF   = @P_LANCTONF)     AND
                        (IP.CDFILIAL     = @P_FILIAL)       AND
                        (IP.NRLANCTONF   = @P_LANCTONF)     AND
                        (IP.NRSEQITPROD  = II.NRSEQITPROD) AND
                        (TI.CDFILIMPOIT  = @P_FILIAL)       AND
                        (TI.NRLANCIMPOIT = @P_LANCTONF)     AND
                        (TI.NRSEQIMPOIT  = II.NRSEQITPROD) AND
                        (TI.CDIMPOSTOIT  = II.CDIMPOSTO)   AND
                        (II.NRITPROIMPOS = TI.NRSEQITPRO)  AND
                        (BC.CDIMPOSTO    = II.CDIMPOSTO)   AND
                        (BC.CDENCARGO    = @V_ITEMENC_CDENCARGO);

                  OPEN C_ITEMPROIMPOS;

                  FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_ITEMPROI_NRSEQITPROD, @V_ITEMPROI_CDIMPOSTO,
                                                      @V_ITEMPROI_VRPERREDBCIT, @V_ITEMPROI_VRALIQITEM,
                                                      @V_ITEMPROI_VRPARDEDIT, @V_ITEMPROI_VRALIQIMPOIT,
                                                      @V_ITEMPROI_VRLIQUIDO, @V_ITEMPROI_IDVALORINFO,
                                                      @V_ITEMPROI_NRITPROIMPOS, @V_ITEMPROI_IDTRIMPSTII;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SELECT @V_TOTAPRENIMPO = SUM(VRTOTAITEM - VRDESCITEM)
                     FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                     WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                           (IP.NRLANCTONF   = @P_LANCTONF)    AND
                           (II.CDFILIAL     = @P_FILIAL)      AND
                           (II.NRLANCTONF   = @P_LANCTONF)    AND
                           (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                           (II.NRITPROIMPOS = '1')            AND
                           (II.CDIMPOSTO    = @V_ITEMPROI_CDIMPOSTO);

                     IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                        SET @V_PRODUENCARGO = +(@V_ITEMENC_VRITEMENCA/@V_TOTAPRENIMPO)*@V_ITEMPROI_VRLIQUIDO;
                     END
                     ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                        SET @V_PRODUENCARGO = -(@V_ITEMENC_VRITEMENCA/@V_TOTAPRENIMPO)*@V_ITEMPROI_VRLIQUIDO;
                     END
                     ELSE BEGIN
                        SET @V_PRODUENCARGO = 0;
                     END;

                     SELECT @V_IDIMPORTAIMPXML = ISNULL(IDVALORINFO, 'N')
                       FROM TRABITPROIMPOS
                      WHERE CDFILIMPOIT  = @P_FILIAL
                        AND NRLANCIMPOIT = @P_LANCTONF
                        AND NRSEQIMPOIT  = @V_ITEMPROI_NRSEQITPROD
                        AND CDIMPOSTOIT  = @V_ITEMPROI_CDIMPOSTO
                        AND NRSEQITPRO   = '1';

                     IF (@V_IDNFGERADAVIAXML = 'S') AND ((@V_IDIMPORTAIMPXML = 'S') OR (@V_IDGERNFIGUALXML = 'S')) BEGIN
                        SET @V_PRODUENCARGO = 0;
                     END;

                     SET @V_TAXAALIQUOTA = (@V_ITEMPROI_VRALIQITEM/100);
                     SET @V_TAXAALIQINFO = (@V_ITEMPROI_VRALIQIMPOIT/100);

                     /* SELECT @V_CDIMPOSTRIB = MAX(CDIMPOSTO), @V_IDVRIMPSTRIB = MAX(IDVRIMPSTRIB)
                     FROM IMPOSTO
                     WHERE CDIMPOSTRIB = @V_ITEMPROI_CDIMPOSTO; */

                     SET @V_CDIMPOSTRIB  = null;
                     SET @V_IDVRIMPSTRIB = null;
                     SET @V_VRIMPOSTOST = 0;
                     SET @V_VRPPRIIMPST = 0;

                     DECLARE C_ICMSST CURSOR FOR
                           SELECT CDIMPOSTO
                             FROM IMPOSTO
                            WHERE CDIMPOSTRIB = @V_ITEMPROI_CDIMPOSTO;

                     OPEN C_ICMSST;
                     FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                     WHILE (@@FETCH_STATUS = 0) BEGIN

                        SET @V_CDIMPOSTRIB = ISNULL(@V_CDIMPOSTRIB,'')+@V_ICMSST_CDIMPOSTRIB+'_';
                        FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                     END;
                     CLOSE C_ICMSST;
                     DEALLOCATE C_ICMSST;

                     IF @V_CDIMPOSTRIB IS NULL BEGIN
                        SET @V_TAXABASECALC = (100 - @V_ITEMPROI_VRPERREDBCIT)/100;
                     END
                     ELSE BEGIN
                        SET @V_TAXABASECALC = 1 + (@V_ITEMPROI_VRPERREDBCIT)/100;
                     END;

                     SET @V_VRIMPOSTOST = 0;

                     IF @V_CDIMPOSTRIB IS NOT NULL BEGIN
                        SELECT @V_IDVRIMPSTRIB = ISNULL(MAX(IDVRIMPSTRIB), 'N')
                          FROM TRABITPROIMPOS I, IMPOSTO II
                         WHERE (CDFILIMPOIT     = @P_FILIAL)
                           AND (NRLANCIMPOIT    = @P_LANCTONF)
                           AND (NRSEQIMPOIT     = @V_ITEMPROI_NRSEQITPROD)
                           AND (CHARINDEX(II.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0)
                           AND (I.CDIMPOSTOIT = II.CDIMPOSTO);


                        IF (@V_ITEMPROI_IDTRIMPSTII = '1') OR (ISNULL(@V_ITEMPROI_IDTRIMPSTII,'N') = 'N') BEGIN
                           SET @V_VRIMPOSTOST = 0;
                        END
                        ELSE BEGIN
                           SELECT @V_VRIMPOSTOST = ISNULL(MAX(VRIMPOSIT),0)
                           FROM TRABITPROIMPOS I
                           WHERE (CDFILIMPOIT  = @P_FILIAL)               AND
                                 (NRLANCIMPOIT = @P_LANCTONF)             AND
                                 (NRSEQIMPOIT  = @V_ITEMPROI_NRSEQITPROD) AND
                                 (CHARINDEX(CDIMPOSTOIT+'_', @V_CDIMPOSTRIB) > 0) AND
                                 (NRSEQITPRO   = '1');
                        END;
                     END;

                     IF @V_ITEMPROI_IDVALORINFO = 'S' BEGIN
                        SET @V_IMPOSTOIT = 0;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - ((@V_VRIMPOSTOST * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
                     END;

                     UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = ISNULL(VRBASECALCIT + (@V_PRODUENCARGO * @V_TAXABASECALC),0),
                         VRIMPOSTOIT  = VRIMPOSTOIT  + @V_IMPOSTOIT
                     WHERE (NRLANCTONF   = @P_LANCTONF) AND
                           (CDFILIAL     = @P_FILIAL)   AND
                           (NRSEQITPROD  = @V_ITEMPROI_NRSEQITPROD) AND
                           (CDIMPOSTO    = @V_ITEMPROI_CDIMPOSTO)   AND
                           (NRITPROIMPOS = @V_ITEMPROI_NRITPROIMPOS);

                     IF @V_ITEMPROI_IDVALORINFO = 'S' BEGIN
                        SET @V_IMPOSTOIT = 0;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQINFO);
                        SET @V_IMPOSTOIT  = @V_IMPOSTOIT - ((@V_VRIMPOSTOST * @V_TAXABASECALC) * @V_TAXAALIQINFO);
                     END;

                     UPDATE TRABITPROIMPOS
                     SET VRBCALCIMPOIT  = ISNULL(VRBCALCIMPOIT + (@V_PRODUENCARGO * @V_TAXABASECALC),0),
                         VRIMPOSIT      = VRIMPOSIT     + @V_IMPOSTOIT
                     WHERE CDFILIMPOIT  = @P_FILIAL               AND
                           NRLANCIMPOIT = @P_LANCTONF             AND
                           NRSEQIMPOIT  = @V_ITEMPROI_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_ITEMPROI_CDIMPOSTO   AND
                           NRSEQITPRO   = @V_ITEMPROI_NRITPROIMPOS;

                     FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_ITEMPROI_NRSEQITPROD, @V_ITEMPROI_CDIMPOSTO,
                                                         @V_ITEMPROI_VRPERREDBCIT, @V_ITEMPROI_VRALIQITEM,
                                                         @V_ITEMPROI_VRPARDEDIT, @V_ITEMPROI_VRALIQIMPOIT,
                                                         @V_ITEMPROI_VRLIQUIDO, @V_ITEMPROI_IDVALORINFO,
                                                         @V_ITEMPROI_NRITPROIMPOS, @V_ITEMPROI_IDTRIMPSTII;
                  END; /*WHILE DO CURSOR C_ITEMPROIMPOS*/

                  CLOSE C_ITEMPROIMPOS;
                  DEALLOCATE C_ITEMPROIMPOS;
               END;

               FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                                  @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                                  @V_ITEMENC_CDCTBLSAIDEN;
            END; /*WHILE DO CURSOR C_ITEMENCARGO*/

            CLOSE C_ITEMENCARGO;
            DEALLOCATE C_ITEMENCARGO;

            UPDATE ITEMPROIMPOS
            SET VRIMPOSTOIT = 0
            WHERE (NRLANCTONF  = @P_LANCTONF) AND
                  (CDFILIAL    = @P_FILIAL) AND
                  (VRIMPOSTOIT < 0);

            UPDATE TRABITPROIMPOS
            SET VRIMPOSIT      = 0
            WHERE CDFILIMPOIT  = @P_FILIAL   AND
                  NRLANCIMPOIT = @P_LANCTONF AND
                  VRIMPOSIT    < 0;
   ---------------------------------------------------------------------------------------------------------

      --CLCULO DO VALOR DOS IMPOSTOS QUE CONTM OUTROS IMPOSTOS NA SUA BASE DE CLCULO

            DECLARE C_PRODUTO CURSOR FOR
            SELECT IP.NRSEQITPROD AS NRSEQITPROD, TI.CDIMPOSTOIT AS CDIMPOSTO,
                   ISNULL(II.VRPERREDBCIT, 0) AS VRPERREDBCIT, ISNULL(II.VRALIQITEM, 0) AS VRALIQITEM,
                   ISNULL(II.VRPARDEDIT, 0) AS VRPARDEDIT, II.CDFISCALIT, ISNULL(TI.VRIMPOSIT, 0) AS VRIMPOSIT,
                   IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, TI.VRALIQIMPOIT,
                   II.NRITPROIMPOS, TI.NRSEQITPRO, ISNULL(TI.IDVALORINFO,'N') AS IDVALORINFO,
                   II.IDTRIMPSTII, IM.IDTIPCONTAB, ISNULL(II.VRBASECALCIT, 0) AS VRBASECALCIT,
                   P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, ISNULL(IM.IDCONTAIMPADIC, 'N') AS IDCONTAIMPADIC,
                   IP.IDORIGEMPROD
            FROM ITEMPRODUTO IP, TRABITPROIMPOS TI LEFT JOIN ITEMPROIMPOS II ON
                 (TI.CDFILIMPOIT  = II.CDFILIAL)     AND
                 (TI.NRLANCIMPOIT = II.NRLANCTONF)   AND
                 (TI.NRSEQIMPOIT  = II.NRSEQITPROD)  AND
                 (TI.NRSEQITPRO   = II.NRITPROIMPOS) AND
                 (TI.CDIMPOSTOIT  = II.CDIMPOSTO),
                 IMPOSTO IM, PRODUTO P
            WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                  (IP.NRLANCTONF   = @P_LANCTONF)    AND
                  (TI.CDFILIMPOIT  = @P_FILIAL)      AND
                  (TI.NRLANCIMPOIT = @P_LANCTONF)    AND
                  (TI.NRSEQIMPOIT  = IP.NRSEQITPROD) AND
                  (TI.CDIMPOSTOIT  = IM.CDIMPOSTO)   AND
                  (TI.NRSEQITPRO   = '1')            AND
                  (IP.CDPRODUTO    = P.CDPRODUTO)

            UNION ALL

            SELECT IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO AS CDIMPOSTO,
                   ISNULL(II.VRPERREDBCIT, 0) VRPERREDBCIT, ISNULL(II.VRALIQITEM, 0) VRALIQITEM,
                   ISNULL(II.VRPARDEDIT, 0) VRPARDEDIT, II.CDFISCALIT, ISNULL(II.VRIMPOSTOIT, 0) AS VRIMPOSIT,
                   IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, II.VRALIQITEM AS VRALIQIMPOIT,
                   II.NRITPROIMPOS, II.NRSEQITPROD AS NRSEQITPRO, ISNULL(II.IDVALORINFIT,'N') AS IDVALORINFO,
                   II.IDTRIMPSTII, IM.IDTIPCONTAB, ISNULL(II.VRBASECALCIT, 0) VRBASECALCIT,
                   P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, ISNULL(IM.IDCONTAIMPADIC, 'N') AS IDCONTAIMPADIC,
                   IP.IDORIGEMPROD
            FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM, PRODUTO P
            WHERE (IP.CDFILIAL     = @P_FILIAL)          AND
                  (IP.NRLANCTONF   = @P_LANCTONF)        AND
                  (II.CDFILIAL     = IP.CDFILIAL)        AND
                  (II.NRLANCTONF   = IP.NRLANCTONF)      AND
                  (II.NRSEQITPROD  = IP.NRSEQITPROD)     AND
                  (II.CDIMPOSTO    = IM.CDIMPOSTO)       AND
                  (II.NRITPROIMPOS = '1')                AND
                  (IP.CDPRODUTO    = P.CDPRODUTO)        AND
                  NOT EXISTS (SELECT T.CDFILIMPOIT
                              FROM  TRABITPROIMPOS T
                              WHERE T.CDFILIMPOIT  = IP.CDFILIAL    AND
                                    T.NRLANCIMPOIT = IP.NRLANCTONF)
            ORDER BY CDIMPOSTO DESC, NRSEQITPROD;

            OPEN C_PRODUTO;
            FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_NRSEQITPROD , @V_PRODUTO_CDIMPOSTO,

                                    @V_PRODUTO_VRPERREDBCIT, @V_PRODUTO_VRALIQITEM,
                                    @V_PRODUTO_VRPARDEDIT  , @V_PRODUTO_CDFISCALIT,
                                    @V_PRODUTO_VRIMPOSIT   , @V_PRODUTO_IDTRATIMPO,
                                    @V_PRODUTO_IDIMPORECUP , @V_PRODUTO_CDCCTBLPASS,
                                    @V_PRODUTO_CDCCTBLATIV , @V_PRODUTO_VRALIQIMPOIT,
                                    @V_PRODUTO_NRITPROIMPOS, @V_PRODUTO_NRSEQITPRO,
                                    @V_PRODUTO_IDVALORINFO , @V_PRODUTO_IDTRIMPSTII,
                                    @V_PRODUTO_IDTIPCONTAB , @V_PRODUTO_VRBASECALCIT,
                                    @V_PRODUTO_CDARVPROD   , @V_PRODUTO_CDPRODUTO,
                                    @V_PRODUTO_VRTOTAITEM  , @V_PRODUTO_VRDESCITEM,
                                    @V_PRODUTO_IDCONTAIMPADIC, @V_PRODUTO_IDORIGEMPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_IDIMPOBCALTPOP = NULL;

               SELECT @V_IDIMPOBCALTPOP = MAX('S'), @V_TOTAIMPBCALC = ISNULL(SUM(TI.VRIMPOSIT),0), @V_TOTAIMPBCINF = ISNULL(SUM(TI.VRIMPOSIT),0)
               FROM ITEMPRODUTO IP, TRABITPROIMPOS TI LEFT JOIN ITEMPROIMPOS II ON
                    (TI.CDFILIMPOIT  = II.CDFILIAL)         AND
                    (TI.NRLANCIMPOIT = II.NRLANCTONF)       AND
                    (TI.NRSEQIMPOIT  = II.NRSEQITPROD)      AND
                    (TI.NRSEQITPRO   = II.NRITPROIMPOS)     AND
                    (TI.CDIMPOSTOIT  = II.CDIMPOSTO),
               BASECALCTPOPER BC, IMPOSTO I
               WHERE BC.IDENTRSAIDOP = @P_ENTRSAID
                 AND BC.CDTIPOOPER   = @P_TIPOOPER
                 AND BC.CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO
                 AND IP.CDFILIAL     = @P_FILIAL
                 AND IP.NRLANCTONF   = @P_LANCTONF
                 AND IP.NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD
                 AND TI.CDFILIMPOIT  = @P_FILIAL
                 AND TI.NRLANCIMPOIT = @P_LANCTONF
                 AND TI.NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD
                 AND TI.CDIMPOSTOIT  = BC.CDIMPOBCALC
                 AND ((SUBSTRING(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP) OR (BC.CDCSTIMPOTPOP IS NULL))
                 AND ((SUBSTRING(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
                 AND ((@V_PRODUTO_CDFISCALIT          = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
                 AND BC.CDIMPOBCALC = I.CDIMPOSTO
                 AND I.IDTRATIMPO <> 'D';

               IF @V_IDIMPOBCALTPOP IS NULL BEGIN

                  SELECT @V_TOTAIMPBCALC = ISNULL(SUM(TI.VRIMPOSIT),0), @V_TOTAIMPBCINF = ISNULL(SUM(TI.VRIMPOSIT),0)
                  FROM ITEMPRODUTO IP, TRABITPROIMPOS TI LEFT JOIN ITEMPROIMPOS II ON
                       (TI.CDFILIMPOIT  = II.CDFILIAL)         AND
                       (TI.NRLANCIMPOIT = II.NRLANCTONF)       AND
                       (TI.NRSEQIMPOIT  = II.NRSEQITPROD)      AND
                       (TI.NRSEQITPRO   = II.NRITPROIMPOS)     AND
                       (TI.CDIMPOSTOIT  = II.CDIMPOSTO),
                  BASECALC BC, IMPOSTO I
                  WHERE (BC.CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                        (IP.CDFILIAL     = @P_FILIAL)              AND
                        (IP.NRLANCTONF   = @P_LANCTONF)            AND
                        (IP.NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                        (TI.CDFILIMPOIT  = @P_FILIAL)              AND
                        (TI.NRLANCIMPOIT = @P_LANCTONF)            AND
                        (TI.NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD) AND
                        (TI.CDIMPOSTOIT  = BC.CDIMPOBCALC)         AND
                        (TI.NRSEQITPRO   = '1')                    AND
                        ((SUBSTRING(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                        ((SUBSTRING(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                        ((@V_PRODUTO_CDFISCALIT          = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                        (BC.IDTIPOBCALC   = 'I')         AND
                        (BC.CDIMPOBCALC = I.CDIMPOSTO)   AND
                        (I.IDTRATIMPO <> 'D');
               END;

               SET @V_IDIMBCALTPOPDE = NULL;

               SELECT @V_IDIMBCALTPOPDE = MAX('S'), @V_TOTAIMPBCDES =(ISNULL(SUM(II.VRIMPOSTOIT),0)* -1)
               FROM ITEMPRODUTO IP, TRABITPROIMPOS TI LEFT JOIN ITEMPROIMPOS II ON
                    (TI.CDFILIMPOIT  = II.CDFILIAL)         AND
                    (TI.NRLANCIMPOIT = II.NRLANCTONF)       AND
                    (TI.NRSEQIMPOIT  = II.NRSEQITPROD)      AND
                    (TI.NRSEQITPRO   = II.NRITPROIMPOS)     AND
                    (TI.CDIMPOSTOIT  = II.CDIMPOSTO),
               BASECALCTPOPER BC, IMPOSTO I
               WHERE BC.IDENTRSAIDOP = @P_ENTRSAID
                 AND BC.CDTIPOOPER   = @P_TIPOOPER
                 AND BC.CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO
                 AND IP.CDFILIAL     = @P_FILIAL
                 AND IP.NRLANCTONF   = @P_LANCTONF
                 AND IP.NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD
                 AND TI.CDFILIMPOIT  = @P_FILIAL
                 AND TI.NRLANCIMPOIT = @P_LANCTONF
                 AND TI.NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD
                 AND TI.CDIMPOSTOIT  = BC.CDIMPOBCALC
                 AND ((SUBSTRING(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
                 AND ((SUBSTRING(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
                 AND ((@V_PRODUTO_CDFISCALIT          = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL))
                 AND BC.CDIMPOBCALC = I.CDIMPOSTO
                 AND I.IDTRATIMPO = 'D';

               IF @V_IDIMBCALTPOPDE IS NULL BEGIN

                  SELECT @V_TOTAIMPBCDES =(ISNULL(SUM(II.VRIMPOSTOIT),0)* -1)
                  FROM ITEMPRODUTO IP, TRABITPROIMPOS TI LEFT JOIN ITEMPROIMPOS II ON
                       (TI.CDFILIMPOIT  = II.CDFILIAL)         AND
                       (TI.NRLANCIMPOIT = II.NRLANCTONF)       AND
                       (TI.NRSEQIMPOIT  = II.NRSEQITPROD)      AND
                       (TI.NRSEQITPRO   = II.NRITPROIMPOS)     AND
                       (TI.CDIMPOSTOIT  = II.CDIMPOSTO),
                  BASECALC BC, IMPOSTO I
                  WHERE (BC.CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                        (IP.CDFILIAL     = @P_FILIAL)              AND
                        (IP.NRLANCTONF   = @P_LANCTONF)            AND
                        (IP.NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                        (TI.CDFILIMPOIT  = @P_FILIAL)              AND
                        (TI.NRLANCIMPOIT = @P_LANCTONF)            AND
                        (TI.NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD) AND
                        (TI.CDIMPOSTOIT  = BC.CDIMPOBCALC)         AND
                        (TI.NRSEQITPRO   = '1')                    AND
                        ((SUBSTRING(IP.CDSITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
                        ((SUBSTRING(IP.CDFISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
                        ((@V_PRODUTO_CDFISCALIT          = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
                        (BC.IDTIPOBCALC   = 'I')          AND
                        (BC.CDIMPOBCALC = I.CDIMPOSTO)    AND
                        (I.IDTRATIMPO = 'D');
               END;

               SET @V_IMPOSINFO = @V_PRODUTO_VRIMPOSIT;

               SET @V_CDIMPOSTRIB  = null;
               SET @V_IDVRIMPSTRIB = null;
               SET @V_VRIMPOSTOST = 0;
               SET @V_VRPPRIIMPST = 0;

               DECLARE C_ICMSST CURSOR FOR
                  SELECT CDIMPOSTO
                    FROM IMPOSTO
                   WHERE CDIMPOSTRIB = @V_PRODUTO_CDIMPOSTO;

               OPEN C_ICMSST;
               FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_CDIMPOSTRIB = ISNULL(@V_CDIMPOSTRIB,'')+@V_ICMSST_CDIMPOSTRIB+'_';
                  FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
               END;
               CLOSE C_ICMSST;
               DEALLOCATE C_ICMSST;

               SELECT @V_IDVRIMPSTRIB = ISNULL(MAX(IDVRIMPSTRIB), 'N')
                 FROM TRABITPROIMPOS I, IMPOSTO II
                WHERE (CDFILIMPOIT     = @P_FILIAL)
                  AND (NRLANCIMPOIT    = @P_LANCTONF)
                  AND (NRSEQIMPOIT     = @V_PRODUTO_NRSEQITPROD)
                  AND (CHARINDEX(II.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0)
                  AND (I.CDIMPOSTOIT = II.CDIMPOSTO);

               --leva ferro

               IF ((@V_IDGERNFIGUALXML = 'N') AND (@V_PRODUTO_IDVALORINFO <> 'S')) OR (@V_IDNFGERADAVIAXML = 'N') BEGIN
                  IF (NOT(@V_TOTAIMPBCALC IS NULL) AND (@V_TOTAIMPBCALC <> 0)) OR
                     (NOT(@V_TOTAIMPBCDES IS NULL) AND (@V_TOTAIMPBCDES <> 0)) OR
                     (@V_CDIMPOSTRIB IS NOT NULL) BEGIN

                     IF @V_CDIMPOSTRIB IS NULL BEGIN
                        SET @V_TAXABASECALC = (100 - @V_PRODUTO_VRPERREDBCIT)/100;
                        SET @V_TAXAALIQUOTA = (@V_PRODUTO_VRALIQITEM/100);
                        SET @V_IMPOSINFO    = @V_IMPOSINFO + (((@V_TOTAIMPBCALC+@V_TOTAIMPBCDES) * @V_TAXABASECALC) * @V_TAXAALIQUOTA);

                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT  = VRBASECALCIT + ((@V_TOTAIMPBCALC+@V_TOTAIMPBCDES) * @V_TAXABASECALC),
                               VRIMPOSTOIT   = (VRIMPOSTOIT  + (((@V_TOTAIMPBCALC+@V_TOTAIMPBCDES) * @V_TAXABASECALC) * @V_TAXAALIQUOTA))
                         WHERE (CDFILIAL     = @P_FILIAL)              AND
                               (NRLANCTONF   = @P_LANCTONF)            AND
                               (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                               (CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                               (NRITPROIMPOS = @V_PRODUTO_NRITPROIMPOS);

                        UPDATE TRABITPROIMPOS
                           SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * @V_TAXABASECALC),
                               VRIMPOSIT     = @V_IMPOSINFO
                         WHERE CDFILIMPOIT   = @P_FILIAL              AND
                               NRLANCIMPOIT  = @P_LANCTONF            AND
                               NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                               CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                               NRSEQITPRO    = @V_PRODUTO_NRSEQITPRO;

                        UPDATE ITEMPROIMPOS
                           SET VRBASECALCIT  = VRBASECALCIT + (@V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                               VRIMPOSTOIT   = VRIMPOSTOIT  + ((@V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                         WHERE (CDFILIAL     = @P_FILIAL)              AND
                               (NRLANCTONF   = @P_LANCTONF)            AND
                               (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                               (CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                               (NRITPROIMPOS = '2');

                        UPDATE TRABITPROIMPOS
                           SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                               VRIMPOSIT     = VRIMPOSIT + ((@V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                         WHERE CDFILIMPOIT   = @P_FILIAL              AND
                               NRLANCIMPOIT  = @P_LANCTONF            AND
                               NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                               CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                               NRSEQITPRO    = '2';

                        UPDATE TRABITPROIMPOS
                           SET VRBCALCIMPOIT  = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * @V_TAXABASECALC),
                               VRIMPOSIT      = VRIMPOSIT + ((@V_TOTAIMPBCINF * @V_TAXABASECALC) * (VRALIQIMPOIT/100))
                         WHERE CDFILIMPOIT  = @P_FILIAL              AND
                               NRLANCIMPOIT = @P_LANCTONF            AND
                               NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD AND
                               CDIMPOSTOIT  = @V_PRODUTO_CDIMPOSTO   AND
                               NRSEQITPRO   = '3';

                     END
                     ELSE BEGIN
                        IF (@V_IDTRIMPSTII = '1') OR (ISNULL(@V_IDVRIMPSTRIB,'N') = 'N') BEGIN
                            SET @V_VRIMPOSTOST = 0;
                        END
                        ELSE BEGIN

                           SELECT @V_VRIMPOSTOST = ISNULL(MAX(VRIMPOSIT),0)
                           FROM TRABITPROIMPOS I
                           WHERE (CDFILIMPOIT  = @P_FILIAL)               AND
                                 (NRLANCIMPOIT = @P_LANCTONF)             AND
                                 (NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD)  AND
                                 (CHARINDEX(CDIMPOSTOIT+'_', @V_CDIMPOSTRIB) > 0) AND
                                 (NRSEQITPRO = '1');

                        END;

                        -- Verifica se possui percentual de reduo

                        SET @V_UTGRUPFISCS = NULL;
                        SET @V_LIQUIITEM   = 0;

                        SET @V_LIQUIITEM = @V_PRODUTO_VRTOTAITEM - @V_PRODUTO_VRDESCITEM;

                        SELECT @V_UTGRUPFISCS = MAX(IDGRUPFISSRV)
                          FROM IMPOSTO
                         WHERE CDIMPOSTO = @V_PRODUTO_CDIMPOSTO;

                        IF @V_UTGRUPFISCS = 'S' BEGIN
                           SET @V_CDGRPFISCSV = NULL;
                           SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                             FROM SERVCLIE SC, SERVICO S
                            WHERE SC.CDFILIAL = @V_CDFILIEMIT
                              AND SC.CDCLIENTE = @P_FORNECED
                              AND SC.CDFILIAL = S.CDFILIAL
                              AND SC.CDSERVFILI = S.CDSERVFILI
                              AND S.CDPRODUTO = @V_PRODUTO_CDPRODUTO;

                           IF @V_CDGRPFISCSV IS NULL BEGIN
                              SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                                FROM CLIENFILIAL
                               WHERE CDFILIAL = @V_CDFILIEMIT
                                 AND CDCLIENTE = @P_FORNECED;
                           END;

                           EXEC CONSULTA_ALIQUOTA @V_PRODUTO_CDIMPOSTO, @P_ENTRSAID, @P_EMPRESA, @V_PRODUTO_CDARVPROD, @P_INSCESTA, @V_PAISORIG,
                                                  @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL, @P_LANCTONF, @V_CDGRPFISCSV, @P_TIPOOPER,
                                                  NULL, NULL, NULL, NULL, @P_FORNECED, NULL, @V_PRODUTO_IDORIGEMPROD;
                        END
                        ELSE BEGIN
                           EXEC CONSULTA_ALIQUOTA @V_PRODUTO_CDIMPOSTO, @P_ENTRSAID, @P_EMPRESA, @V_PRODUTO_CDARVPROD, @P_INSCESTA, @V_PAISORIG,
                                                  @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @P_TIPOOPER,
                                                  NULL, NULL, NULL, NULL, @P_FORNECED, NULL, @V_PRODUTO_IDORIGEMPROD;
                        END;

                        SET @V_PREDBCTMP  = 0;
                        SET @V_PBCSUBTRIB = 0;

                        SELECT @V_PREDBCTMP = (100 - (ISNULL(MAX(VRPREDBCTMP),0)))/100,
                               @V_PBCSUBTRIB = ISNULL(MAX(VRPBCSTTMP),0)
                          FROM ALIQTEMP
                         WHERE NRALIQTEMP = @V_ALIQTEMP;

                        SET @V_TAXABASECALC = 1 + (@V_PRODUTO_VRPERREDBCIT)/100;
                        SET @V_TAXAALIQUOTA = (@V_PRODUTO_VRALIQITEM/100);

                        IF @V_PBCSUBTRIB <> 0 BEGIN
                           IF (@V_IDVALORINFO <> 'S') BEGIN
                              SET @V_IMPOSINFO = ((@V_PRODUTO_VRBASECALCIT+ ((@V_TOTAIMPBCALC + @V_TOTAIMPBCDES) * @V_TAXABASECALC * @V_PREDBCTMP)) * @V_TAXAALIQUOTA);
                           END;
                        END
                        ELSE BEGIN
                           IF (@V_IDVALORINFO <> 'S') BEGIN
                              SET @V_IMPOSINFO = ((@V_PRODUTO_VRBASECALCIT+ ((@V_TOTAIMPBCALC + @V_TOTAIMPBCDES) * @V_TAXABASECALC)) * @V_TAXAALIQUOTA);
                           END;
                        END;

                        DELETE ALIQTEMP
                        WHERE NRALIQTEMP = @V_ALIQTEMP;
                       
                        IF @V_VRIMPOSTOST > @V_IMPOSINFO BEGIN
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT  = VRBASECALCIT + ((@V_TOTAIMPBCALC+@V_TOTAIMPBCDES) * @V_TAXABASECALC),
                                  VRIMPOSTOIT   = 0
                            WHERE (CDFILIAL     = @P_FILIAL)              AND
                                  (NRLANCTONF   = @P_LANCTONF)            AND
                                  (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                                  (CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                                  (NRITPROIMPOS = @V_PRODUTO_NRITPROIMPOS);
                              SET  @V_IMPOSINFO = 0;

                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * @V_TAXABASECALC),
                                  VRIMPOSIT     = @V_IMPOSINFO
                            WHERE CDFILIMPOIT   = @P_FILIAL              AND
                                  NRLANCIMPOIT  = @P_LANCTONF            AND
                                  NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                                  CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                                  NRSEQITPRO    = @V_PRODUTO_NRSEQITPRO;

                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT  = VRBASECALCIT + (@V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT   = VRIMPOSTOIT  + ((@V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = @P_FILIAL)              AND
                                  (NRLANCTONF   = @P_LANCTONF)            AND
                                  (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                                  (CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                                  (NRITPROIMPOS = '2');

                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT     = VRIMPOSIT + ((@V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT   = @P_FILIAL              AND
                                  NRLANCIMPOIT  = @P_LANCTONF            AND
                                  NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                                  CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                                  NRSEQITPRO    = '2';

                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * @V_TAXABASECALC),
                                  VRIMPOSIT     = VRIMPOSIT + ((@V_TOTAIMPBCINF * @V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT   = @P_FILIAL              AND
                                  NRLANCIMPOIT  = @P_LANCTONF            AND
                                  NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                                  CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                                  NRSEQITPRO    = '3';
                        END
                        ELSE BEGIN
                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT  = VRBASECALCIT + ((@V_TOTAIMPBCALC+@V_TOTAIMPBCDES) * @V_TAXABASECALC),
                                  VRIMPOSTOIT   = (VRIMPOSTOIT  + (((@V_TOTAIMPBCALC+@V_TOTAIMPBCDES) * @V_TAXABASECALC) * @V_TAXAALIQUOTA))
                            WHERE (CDFILIAL     = @P_FILIAL)              AND
                                  (NRLANCTONF   = @P_LANCTONF)            AND
                                  (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                                  (CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                                  (NRITPROIMPOS = @V_PRODUTO_NRITPROIMPOS);
                              IF (@V_IDVALORINFO <> 'S') BEGIN
                                 SET @V_IMPOSINFO = @V_IMPOSINFO - @V_VRIMPOSTOST;
                              END;

                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * @V_TAXABASECALC),
                                  VRIMPOSIT     = @V_IMPOSINFO
                            WHERE CDFILIMPOIT   = @P_FILIAL              AND
                                  NRLANCIMPOIT  = @P_LANCTONF            AND
                                  NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                                  CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                                  NRSEQITPRO    = @V_PRODUTO_NRSEQITPRO;

                           UPDATE ITEMPROIMPOS
                              SET VRBASECALCIT  = VRBASECALCIT + (@V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)),
                                  VRIMPOSTOIT   = VRIMPOSTOIT  + ((@V_TOTAIMPBCALC * ((100 - VRPERREDBCIT)/100)) * (VRALIQITEM/100))
                            WHERE (CDFILIAL     = @P_FILIAL)              AND
                                  (NRLANCTONF   = @P_LANCTONF)            AND
                                  (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                                  (CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)   AND
                                  (NRITPROIMPOS = '2');

                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)),
                                  VRIMPOSIT     = VRIMPOSIT + ((@V_TOTAIMPBCINF * ((100 - VRREDBCIMPOIT)/100)) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT   = @P_FILIAL              AND
                                  NRLANCIMPOIT  = @P_LANCTONF            AND
                                  NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                                  CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                                  NRSEQITPRO    = '2';

                           UPDATE TRABITPROIMPOS
                              SET VRBCALCIMPOIT = VRBCALCIMPOIT + (@V_TOTAIMPBCINF * @V_TAXABASECALC),
                                  VRIMPOSIT     = VRIMPOSIT + ((@V_TOTAIMPBCINF * @V_TAXABASECALC) * (VRALIQIMPOIT/100))
                            WHERE CDFILIMPOIT   = @P_FILIAL              AND
                                  NRLANCIMPOIT  = @P_LANCTONF            AND
                                  NRSEQIMPOIT   = @V_PRODUTO_NRSEQITPROD AND
                                  CDIMPOSTOIT   = @V_PRODUTO_CDIMPOSTO   AND
                                  NRSEQITPRO    = '3';

                        END;
                     END;
                  END;
               END;

               /* Utiliza o prprio valor do imposto na sua base de clculo */
               SELECT @V_IDUTILPVRIMPBC = ISNULL(MAX(IDUTILPVRIMPBC), 'N')
                 FROM IMPOSTO
                WHERE CDIMPOSTO = @V_PRODUTO_CDIMPOSTO;

               IF @V_IDUTILPVRIMPBC = 'S' BEGIN

                  IF @V_CDIMPOSTRIB IS NULL BEGIN
                     UPDATE ITEMPROIMPOS
                        SET VRBASECALCIT = (VRBASECALCIT )/((100 -VRALIQITEM)/100),
                            VRIMPOSTOIT  = ((VRBASECALCIT)/((100 -VRALIQITEM)/100))*(VRALIQITEM/100)
                      WHERE CDFILIAL     = @P_FILIAL
                        AND NRLANCTONF   = @P_LANCTONF
                        AND NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD
                        AND CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO
                        AND NRITPROIMPOS = @V_PRODUTO_NRITPROIMPOS;

                     UPDATE TRABITPROIMPOS
                        SET VRBCALCIMPOIT = (VRBCALCIMPOIT )/((100 -VRALIQIMPOIT)/100),
                            VRIMPOSIT     = ((VRBCALCIMPOIT)/((100 -VRALIQIMPOIT)/100))*(VRALIQIMPOIT/100)
                      WHERE CDFILIMPOIT  = @P_FILIAL
                        AND NRLANCIMPOIT = @P_LANCTONF
                        AND NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD
                        AND CDIMPOSTOIT  = @V_PRODUTO_CDIMPOSTO
                        AND NRSEQITPRO   = @V_PRODUTO_NRSEQITPRO;
                  END;
               END;

               SET @V_IMPOCONTAB = 0;

               IF (@V_PRODUTO_IDIMPORECUP = 'S') BEGIN
                  IF (@V_PRODUTO_CDFISCALIT = '1') BEGIN
                     IF (NOT(@V_PRODUTO_CDCCTBLATIV IS NULL)) BEGIN
                        IF @V_PRODUTO_IDTRATIMPO = 'V' BEGIN
                           SET @V_IMPOCONTAB = - @V_IMPOSINFO;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_PRODUTO_IDTRATIMPO = 'A' BEGIN
                        IF ((@V_CDIMPOSTRIB IS NOT NULL) AND (@V_PRODUTO_IDTRIMPSTII = '0')) OR
                           (@V_CDIMPOSTRIB IS NULL) BEGIN
                           SET @V_IMPOCONTAB = @V_IMPOSINFO;
                        END
                        ELSE BEGIN
                           SET @V_IMPOCONTAB = 0;
                           SET @V_IMPOSINFO  = 0;
                        END;
                     END
                     ELSE IF @V_PRODUTO_IDTRATIMPO IN ('D','R') BEGIN
                        SET @V_IMPOCONTAB = - @V_IMPOSINFO;
                     END;
                  END;
               END
               ELSE BEGIN
                  IF NOT(@V_PRODUTO_CDCCTBLPASS IS NULL) BEGIN
                     IF @V_PRODUTO_IDTRATIMPO = 'V' BEGIN
                        IF @V_PRODUTO_IDCONTAIMPADIC = 'N' BEGIN
                           SET @V_IMPOCONTAB = - @V_IMPOSINFO;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_PRODUTO_IDTRATIMPO = 'A' BEGIN
                        IF ((@V_CDIMPOSTRIB IS NOT NULL) AND (@V_PRODUTO_IDTRIMPSTII = '0')) OR
                           (@V_CDIMPOSTRIB IS NULL) BEGIN
                           SET @V_IMPOCONTAB = @V_IMPOSINFO;
                        END
                        ELSE BEGIN
                           SET @V_IMPOCONTAB = 0;
                           SET @V_IMPOSINFO  = 0;
                        END;
                     END
                     ELSE IF @V_PRODUTO_IDTRATIMPO IN ('D','R') BEGIN
                        SET @V_IMPOCONTAB = - @V_IMPOSINFO;
                     END;
                  END;
               END;

               IF (@V_IDOPERDEVONF = 'S') OR (@P_TIPOOPER = '16') BEGIN
                  IF (@V_PRODUTO_IDTRATIMPO = 'A') BEGIN
                    IF NOT (((@V_PRODUTO_IDIMPORECUP = 'S')  AND (@V_PRODUTO_CDFISCALIT = '1')) OR
                            ((@V_PRODUTO_IDIMPORECUP <> 'S') AND (@V_PRODUTO_CDCCTBLATIV IS NOT NULL))) BEGIN
                       IF ((@V_CDIMPOSTRIB IS NOT NULL) AND (@V_PRODUTO_IDTRIMPSTII = '0')) OR
                          (@V_CDIMPOSTRIB IS NULL) BEGIN
                          SET @V_IMPOCONTAB = @V_IMPOSINFO;
                       END
                       ELSE BEGIN
                          SET @V_IMPOCONTAB = 0;
                          SET @V_IMPOSINFO  = 0;
                       END;
                    END;
                  END
                  ELSE BEGIN
                    IF (@V_PRODUTO_IDTRATIMPO = 'D') BEGIN
                      IF NOT(((@V_PRODUTO_IDIMPORECUP = 'S') AND (@V_PRODUTO_CDFISCALIT = '1')) OR
                             ((@V_PRODUTO_IDIMPORECUP <> 'S') AND (@V_PRODUTO_CDCCTBLATIV IS NOT NULL))) BEGIN
                         SET @V_IMPOCONTAB = - @V_IMPOSINFO;
                      END;
                    END
                    ELSE BEGIN
                       IF (@V_PRODUTO_IDTRATIMPO = 'R') BEGIN
                          IF (@V_PRODUTO_IDIMPORECUP = 'S') BEGIN
                             IF (@V_PRODUTO_CDCCTBLATIV IS NULL) OR
                                (@V_PRODUTO_CDFISCALIT <> '1') BEGIN
                                SET @V_IMPOCONTAB = - @V_IMPOSINFO;
                             END;
                          END
                          ELSE BEGIN
                             IF (@V_PRODUTO_CDCCTBLATIV IS NULL) BEGIN
                                SET @V_IMPOCONTAB = - @V_IMPOSINFO;
                             END;
                          END;
                       END
                       ELSE BEGIN
                          SET @V_IMPOCONTAB = 0;
                       END;
                    END;
                  END;
               END;
               IF @V_PRODUTO_IDTRATIMPO = 'A' BEGIN
                  IF @V_PRODUTO_IDTIPCONTAB = 'D' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM + @V_IMPOSINFO,
                         VRCONTITEM = VRCONTITEM + @V_IMPOCONTAB
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_PRODUTO_NRSEQITPROD;
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM + @V_IMPOSINFO
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_PRODUTO_NRSEQITPROD;
                  END;
               END
               ELSE IF @V_PRODUTO_IDTRATIMPO = 'D' BEGIN
                  IF @V_PRODUTO_IDTIPCONTAB = 'D' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM - @V_IMPOSINFO,
                         VRCONTITEM = VRCONTITEM + @V_IMPOCONTAB
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_PRODUTO_NRSEQITPROD;
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM - @V_IMPOSINFO
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_PRODUTO_NRSEQITPROD;
                  END;
               END
               ELSE BEGIN
                  IF @V_PRODUTO_IDTIPCONTAB = 'D' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = VRCONTITEM + @V_IMPOCONTAB
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_PRODUTO_NRSEQITPROD;
                  END;
               END;

               FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_NRSEQITPROD , @V_PRODUTO_CDIMPOSTO,
                                              @V_PRODUTO_VRPERREDBCIT, @V_PRODUTO_VRALIQITEM,
                                              @V_PRODUTO_VRPARDEDIT  , @V_PRODUTO_CDFISCALIT,
                                              @V_PRODUTO_VRIMPOSIT   , @V_PRODUTO_IDTRATIMPO,
                                              @V_PRODUTO_IDIMPORECUP , @V_PRODUTO_CDCCTBLPASS,
                                              @V_PRODUTO_CDCCTBLATIV , @V_PRODUTO_VRALIQIMPOIT,
                                              @V_PRODUTO_NRITPROIMPOS, @V_PRODUTO_NRSEQITPRO,
                                              @V_PRODUTO_IDVALORINFO , @V_PRODUTO_IDTRIMPSTII,
                                              @V_PRODUTO_IDTIPCONTAB , @V_PRODUTO_VRBASECALCIT,
                                              @V_PRODUTO_CDARVPROD   , @V_PRODUTO_CDPRODUTO,
                                              @V_PRODUTO_VRTOTAITEM  , @V_PRODUTO_VRDESCITEM,
                                              @V_PRODUTO_IDCONTAIMPADIC, @V_PRODUTO_IDORIGEMPROD;
            END; /* WHILE DO CURSOR C_PRODUTO*/

            CLOSE C_PRODUTO;
            DEALLOCATE C_PRODUTO;

         END;
   ---------------------------------------------------------------------------------------------------------
      --FIM DA ATUALIZAO NA TABELA DE ITEMPROIMPOS

   ---------------------------------------------------------------------------------------------------------

      --TOTALIZAO DOS IMPOSTOS

         DELETE FROM IMPOSNFTOT
         WHERE (CDFILIAL = @P_FILIAL) AND
               (NRLANCTONF = @P_LANCTONF);

         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN
            DECLARE C_IMPOSNFTOT CURSOR FOR
            SELECT IP.CDIMPOSTO,
                   CDIMPOSTOIT,
                   ROUND(SUM(ISNULL(VRIMPOSIT,0)),@V_NRDECITOTANF) AS VRIMPOSTOIT,
                   ISNULL(SUM(VRBASECALCIT),0) AS VRBASECALCIT,
                   ISNULL(SUM(VRBCALCIMPOIT),0) AS VRBCALCIMPOIT,
                   MAX(ISNULL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR
            FROM ITEMPROIMPOS IP, TRABITPROIMPOS TI, IMPOSTO I
            WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                  (IP.NRLANCTONF   = @P_LANCTONF)    AND
                  (TI.CDFILIMPOIT  = @P_FILIAL)      AND
                  (TI.NRLANCIMPOIT = @P_LANCTONF)    AND
                  (IP.NRSEQITPROD  = TI.NRSEQIMPOIT) AND
                  (IP.NRITPROIMPOS = TI.NRSEQITPRO)  AND
                  (IP.CDIMPOSTO    = TI.CDIMPOSTOIT) AND
                  (I.CDIMPOSTO     = IP.CDIMPOSTO)   AND
                  (IP.NRITPROIMPOS  = 1 )
            GROUP BY IP.CDIMPOSTO, TI.CDIMPOSTOIT;

            OPEN C_IMPOSNFTOT;

            FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                              @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                              @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
               VALUES (@P_FILIAL, @P_LANCTONF, @V_IMPOSNF_CDIMPOSTO, ISNULL(@V_IMPOSNF_VRIMPOSTOIT,0), ISNULL(@V_IMPOSNF_VRBASECALCIT,0));

               IF @V_IMPOSNF_IDPREIMPENTR = 'N' BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT   = ISNULL(@V_IMPOSNF_VRBCALCIMPOIT,0)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_IMPOSNF_CDIMPOSTO;
               END
               ELSE BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT = ISNULL(@V_IMPOSNF_VRBCALCIMPOIT,0),
                      VRIMPOSTOT   = ISNULL(@V_IMPOSNF_VRIMPOSTOIT,0)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_IMPOSNF_CDIMPOSTO;
               END;

               FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                                 @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                                 @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;
            END; /*WHILE DO CURSOR C_IMPOSNFTOT*/

            CLOSE C_IMPOSNFTOT;
            DEALLOCATE C_IMPOSNFTOT;

         --INCLUSO DOS IMPOSTOS DE CORPO DE NOTA EM CASO DE NOTA FISCAL DE ENTRADA

            SET @V_SEQUIMPOSTNF = '01';

            DELETE FROM IMPOSTONF
            WHERE (CDFILIAL   = @P_FILIAL) AND
                  (NRLANCTONF = @P_LANCTONF);

            EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA, null, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @V_IDINTEREST;

            DECLARE C_INCIDENCIA CURSOR FOR
            SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP,
                   IDTRATIMPTMP, IDIMPORECUP, ISNULL(IDPREIMPENTR, 'N') AS IDPREIMPENTR, IDUTMUNIORIG
            FROM INCITEMP IT, IMPOSTO IP
            WHERE (IT.NRINCITEMP  = @V_INCITEMP)  AND
                  (IT.CDIMPOTEMP  = IP.CDIMPOSTO) AND
                  (IP.IDPRODNOTA  = 'C');

            OPEN C_INCIDENCIA;

            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP, @V_INCIDENC_CDFISCTEMP,
                                              @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDIMPORECUP,
                                              @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDUTMUNIORIG;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_ALIQUTMP   = 0;
               SET @V_PARDEDTMP  = 0;
               SET @V_PREDBCTMP1 = 0;
               SET @V_PREDBCTMP  = 0;
               SET @V_ALIQUTMP   = 0;

               /*VERIFICA CST POR IMPOSTO*/
               SET @V_IMPOICMS = NULL;

               SET @V_CDGRUPOFISCAUX = NULL;

               SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                 FROM GRUPOFISCIMPFIL G,
                       (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                               ELSE CDFILIEMIT END AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = @P_FILIAL
                          AND NRLANCTONF = @P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

               IF @V_IDORIGDESTNF = 'F' BEGIN
               SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                 FROM GRFISIMPIEFORN G,
                      (SELECT CDFORNECED
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = @P_FILIAL
                          AND NRLANCTONF = @P_LANCTONF) N
                WHERE G.CDFORNECED = N.CDFORNECED
                  AND G.CDEMPRESA = @P_EMPRESA
                  AND G.CDINSCESTA = @P_INSCESTA
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
               END
               ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                   SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = @P_EMPRESA
                     AND G.CDINSCESTA = @P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
               END;

               IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                  EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                        @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
               END
               ELSE BEGIN
                  EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                        @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
               END;

               SET @V_ICMS = 'N';
               DECLARE C_ICMS CURSOR FOR
                  (SELECT CDIMPOSTO
                                FROM IMPOSTONFE N, IMPOSTO I
                               WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                 AND N.CDIMPOSTONFE = '00'
                                 AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP
                              UNION ALL
                              SELECT CDIMPOSTO
                                FROM IMPOSTO
                               WHERE CDIMPOSTRIB = @V_INCIDENC_CDIMPOTEMP)

               OPEN C_ICMS;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_ICMS = 'S';
               END;

               CLOSE C_ICMS;
               DEALLOCATE C_ICMS;

               IF (@V_ITEMPROD_CDSITUTRIBPR IS NOT NULL) AND (@V_ICMS = 'S')  BEGIN
                  SET @V_CDSITTRIBTMP = SUBSTRING(@V_ITEMPROD_CDSITUTRIBPR, 2, LEN(@V_ITEMPROD_CDSITUTRIBPR));
               END;

               SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                 FROM IMPOSTONFE N, IMPOSTO I
                WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                  AND N.CDIMPOSTONFE = '00'
                  AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

               IF @V_INCIDENC_IDUTMUNIORIG = 'D' BEGIN
                  EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, null, @P_INSCESTA, @V_PAISORIG,
                                         @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID,
                                         @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @P_TIPOOPER;
               END
               ELSE BEGIN
                  EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, null, @P_INSCESTA, @V_PAISORIG,
                                         @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID,
                                         @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @P_TIPOOPER;
               END;

               SELECT @V_PARDEDTMP = MAX(VRPARDEDTMP),
                      @V_PREDBCTMP = MAX(VRPREDBCTMP),
                      @V_ALIQUTMP = MAX(VRALIQUTMP),
                      @V_PREDBCTMP1 = MAX(VR1PREDBCTMP)
               FROM ALIQTEMP
               WHERE (NRALIQTEMP = @V_ALIQTEMP);

               IF (@V_PREDBCTMP IS NULL) BEGIN
                  SET @V_PREDBCTMP = 0;
               END;

               IF (@V_PARDEDTMP IS NULL) BEGIN
                  SET @V_PARDEDTMP = 0;
               END;

               --VERIFICAR VALOR DA ALQUOTA P/ IMPOSTO RECUPERVEL COM CD. FISCAL = '3'
               IF (@V_ALIQUTMP IS NULL) BEGIN
                  SET @V_ALIQUTMP = 0;
               END;

               IF (@V_PREDBCTMP1 IS NULL) BEGIN
                  SET @V_PREDBCTMP1 = 0;
               END;

               SET @V_PRODUENCARGO = 0;

               SELECT @V_SOMAITEM = SUM(VRITEMENCA)
               FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
               WHERE (IE.CDFILIAL   = @P_FILIAL)    AND
                     (IE.NRLANCTONF = @P_LANCTONF)  AND
                     (EN.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDIMPOSTO  = @V_INCIDENC_CDIMPOTEMP) AND
                     (EN.IDENCARGO  = 'A');

               SELECT @V_DESCITEM = SUM(VRITEMENCA)
               FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
               WHERE (IE.CDFILIAL   = @P_FILIAL)    AND
                     (IE.NRLANCTONF = @P_LANCTONF)  AND
                     (EN.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDIMPOSTO  = @V_INCIDENC_CDIMPOTEMP) AND
                     (EN.IDENCARGO  = 'D');

               IF @V_SOMAITEM IS NULL BEGIN
                  SET @V_SOMAITEM = 0;
               END;

               IF @V_DESCITEM IS NULL BEGIN
                  SET @V_DESCITEM = 0;
               END;

               SET @V_PRODUENCARGO = @V_SOMAITEM - @V_DESCITEM;

               SELECT @V_IDIMPORTAIMPXML = ISNULL(IDIMPORTAIMPXML, 'N')
                 FROM IMPOSTO
                WHERE CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

               IF (@V_IDNFGERADAVIAXML = 'S') AND ((@V_IDIMPORTAIMPXML = 'S') OR (@V_IDGERNFIGUALXML = 'S')) BEGIN
                  SET @V_PRODUENCARGO = 0;
               END;

               SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
               SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
               SET @V_BASECALCIT   = (@V_LIQUIDO + @V_PRODUENCARGO) * @V_TAXABASECALC;
               SET @V_CONTIMPO     = @V_BASECALCIT;
               SET @V_IMPOSTOIT    = ROUND((@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP, @V_NRDECITOTANF);

               SET @V_CONTABCALC   = (@V_LIQUIDO + @V_PRODUENCARGO) - ((@V_LIQUIDO + @V_PRODUENCARGO) * @V_TAXABASECALC);
               SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;

               SELECT @V_IMPOSINFO = MAX(VRIMPOSTOT)
               FROM TRABIMPOSNFTOT
               WHERE CDFILIMPTOT  = @P_FILIAL   AND
                     NRLANCIMPTOT = @P_LANCTONF AND
                     CDIMPOSTOT   = @V_INCIDENC_CDIMPOTEMP;

               IF @V_IMPOSINFO IS NULL BEGIN
                  SET @V_IMPOSINFO = 0;
               END;

               IF (@V_BASECALCIT < 0) OR (@V_BASECALCIT IS NULL) BEGIN
                  SET @V_BASECALCIT = 0;
               END;

               IF (@V_IMPOSTOIT < 0) OR (@V_IMPOSTOIT IS NULL) BEGIN
                  SET @V_IMPOSTOIT = 0;
               END;

               IF @V_INCIDENC_IDPREIMPENTR = 'N' BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT   = ISNULL(@V_BASECALCIT,0)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_INCIDENC_CDIMPOTEMP;
               END
               ELSE BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT   = ISNULL(@V_BASECALCIT,0),
                      VRIMPOSTOT     = ROUND(CASE ISNULL(VRIMPOSTOT,0)
                                             WHEN 0
                                             THEN ISNULL(@V_IMPOSTOIT,0)
                                             ELSE VRIMPOSTOT
                                             END
                                             , @V_NRDECITOTANF)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_INCIDENC_CDIMPOTEMP;
               END;

               INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
               VALUES (@P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, ISNULL(@V_IMPOSTOIT,0), ISNULL(@V_BASECALCIT,0));

               IF (@V_INCIDENC_IDIMPORECUP = 'S') OR (@V_INCIDENC_IDIMPORECUP <> 'S' AND @V_ALIQUTMP <> 0) BEGIN
                  IF (@V_INCIDENC_IDIMPORECUP = 'S') AND
                     (@V_INCIDENC_CDFISCTEMP <> '1') BEGIN
                     SET @V_BASECALCIT = 0;
                     SET @V_ALIQUTMP   = 0;
                     SET @V_IMPOSTOIT  = 0;
                     SET @V_PREDBCTMP  = 0;
                     SET @V_PREDBCTMP1 = 0;
                     SET @V_PARDEDTMP  = 0;
                  END;

                  SELECT @V_IDFORMAPUR = MAX(IDFORMAPUR)
                  FROM IMPOSTO
                  WHERE CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                  IF @V_IDFORMAPUR = 'P' BEGIN
                     INSERT INTO IMPOSTONF(
                        CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                        VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                        CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, @V_SEQUIMPOSTNF, ROUND(@V_CONTIMPO,2), @V_PREDBCTMP,
                        @V_BASECALCIT, @V_ALIQUTMP, @V_PARDEDTMP, ROUND(@V_IMPOSTOIT, @V_NRDECITOTANF), @V_INCIDENC_CDFISCTEMP, '1', @V_CDSITTRIBTMP,
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE);

                     SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
                  END
                  ELSE BEGIN
                     INSERT INTO IMPOSTONF(
                        CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                        VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                        CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, @V_SEQUIMPOSTNF, ROUND(@V_CONTIMPO,2), @V_PREDBCTMP,
                        @V_BASECALCIT, @V_ALIQUTMP, @V_PARDEDTMP, ROUND(@V_IMPOSTOIT, @V_NRDECITOTANF), @V_INCIDENC_CDFISCTEMP, '1', @V_CDSITTRIBTMP,
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE);

                     SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
                  END;

                  IF (@V_INCIDENC_IDIMPORECUP = 'S') AND (@V_PREDBCTMP > 0) AND (@V_INCIDENC_CDFISCTEMP = '1') BEGIN
                     INSERT INTO IMPOSTONF(
                        CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                        VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                        CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, @V_SEQUIMPOSTNF, ROUND(@V_CONTABCALC,2), @V_PERDBCALC,
                        0, 0, @V_PARDEDTMP, 0, '2', '2', @V_CDSITTRIBTMP,
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE);

                     SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
                  END;
               END;

               DELETE FROM ALIQTEMP
               WHERE NRALIQTEMP = @V_ALIQTEMP;

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP, @V_INCIDENC_CDFISCTEMP,
                                                 @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDIMPORECUP,
                                                 @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDUTMUNIORIG;
            END; /*WHILE DO CURSOR C_INCIDENCIA*/

            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;

            SET @V_TOTIMPOCONT = 0;
            SET @V_TOTIMPOBRUT = 0;

            DECLARE C_IMPOSCONTAB CURSOR FOR
            SELECT VRIMPOSTOT, IDIMPORECUP, CDCCTBLPASS, CDCCTBLATIV,
                   IDTRATIMPO,  CDFISCTEMP
            FROM TRABIMPOSNFTOT INF, IMPOSTO IP, INCITEMP IT
            WHERE CDFILIMPTOT   = @P_FILIAL      AND
                  NRLANCIMPTOT  = @P_LANCTONF    AND
                  IP.CDIMPOSTO  = INF.CDIMPOSTOT AND
                  IT.CDIMPOTEMP = IP.CDIMPOSTO   AND
                  IT.NRINCITEMP = @V_INCITEMP    AND
                  IP.IDPRODNOTA = 'C';

            OPEN C_IMPOSCONTAB;
            FETCH NEXT FROM C_IMPOSCONTAB INTO @V_IMPOSCONT_VRIMPOSTOT, @V_IMPOSCONT_IDIMPORECUP,
                                               @V_IMPOSCONT_CDCCTBLPASS, @V_IMPOSCONT_CDCCTBLATIV,
                                               @V_IMPOSCONT_IDTRATIMPO, @V_IMPOSCONT_CDFISCTEMP;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF (@V_IMPOSCONT_IDIMPORECUP = 'S') BEGIN
                  IF (NOT(@V_IMPOSCONT_CDCCTBLATIV IS NULL)) AND
                     (@V_IMPOSCONT_CDFISCTEMP = '1') BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'V' BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'A' BEGIN
   ---------------------------------------------------------------------------------------------------------
                        IF NOT(@V_IMPOSCONT_CDCCTBLPASS IS NULL) BEGIN
   ---------------------------------------------------------------------------------------------------------
                           SET @V_TOTIMPOCONT = @V_TOTIMPOCONT + @V_IMPOSCONT_VRIMPOSTOT;
                        END;
                     END
                     ELSE IF @V_IMPOSCONT_IDTRATIMPO IN ('D','R') BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END;
               END
               ELSE BEGIN
                  IF NOT(@V_IMPOSCONT_CDCCTBLPASS IS NULL) BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'V' BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'A' BEGIN
   ---------------------------------------------------------------------------------------------------------
                        IF NOT(@V_IMPOSCONT_CDCCTBLATIV IS NULL) BEGIN
   ---------------------------------------------------------------------------------------------------------
                           SET @V_TOTIMPOCONT = @V_TOTIMPOCONT + @V_IMPOSCONT_VRIMPOSTOT;
                        END;
                     END
                     ELSE IF @V_IMPOSCONT_IDTRATIMPO IN ('D','R')
                     BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END;
               END;

               IF @V_IMPOSCONT_IDTRATIMPO = 'A' BEGIN
                  SET @V_TOTIMPOBRUT = @V_TOTIMPOBRUT + @V_IMPOSCONT_VRIMPOSTOT;
               END
               ELSE IF @V_IMPOSCONT_IDTRATIMPO = 'D' BEGIN
                  SET @V_TOTIMPOBRUT = @V_TOTIMPOBRUT - @V_IMPOSCONT_VRIMPOSTOT;
               END;

               FETCH NEXT FROM C_IMPOSCONTAB INTO @V_IMPOSCONT_VRIMPOSTOT, @V_IMPOSCONT_IDIMPORECUP,
                                                  @V_IMPOSCONT_CDCCTBLPASS, @V_IMPOSCONT_CDCCTBLATIV,
                                                  @V_IMPOSCONT_IDTRATIMPO, @V_IMPOSCONT_CDFISCTEMP;
            END; /*WHILE DO CURSOR C_IMPOSCONTAB*/

            CLOSE C_IMPOSCONTAB;
            DEALLOCATE C_IMPOSCONTAB;

            IF (@V_TOTIMPOBRUT <> 0) OR (@V_TOTIMPOCONT <> 0) BEGIN

               DECLARE C_ITPRODUTO CURSOR FOR
               SELECT NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
               FROM ITEMPRODUTO
               WHERE CDFILIAL   = @P_FILIAL AND
                     NRLANCTONF = @P_LANCTONF;

               OPEN C_ITPRODUTO;

               FETCH NEXT FROM C_ITPRODUTO INTO @V_ITPROD_NRSEQITPROD, @V_ITPROD_VRLIQUIDO;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = VRBRUTITEM + ((@V_TOTIMPOBRUT / @V_LIQUIDO) * @V_ITPROD_VRLIQUIDO),
                      VRCONTITEM = VRCONTITEM + ((@V_TOTIMPOCONT / @V_LIQUIDO) * @V_ITPROD_VRLIQUIDO)
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ITPROD_NRSEQITPROD;

                  FETCH NEXT FROM C_ITPRODUTO INTO @V_ITPROD_NRSEQITPROD, @V_ITPROD_VRLIQUIDO;
               END; /* WHILE CURSOR C_ITPRODUTO*/

               CLOSE C_ITPRODUTO;
               DEALLOCATE C_ITPRODUTO;

            END;

            DELETE FROM INCITEMP
            WHERE NRINCITEMP = @V_INCITEMP;
         END
         ELSE BEGIN
            DELETE FROM IMPOSTONF
            WHERE (CDFILIAL   = @P_FILIAL) AND
                  (NRLANCTONF = @P_LANCTONF);
         END;

   ---------------------------------------------------------------------------------------------------------

   --FIM DA TOTALIZAO DOS IMPOSTOS

   ---------------------------------------------------------------------------------------------------------

   -- NOTA FISCAL DE MOVIMENTAO - 07
      END
      ELSE IF @P_TIPOOPER IN ('07','10') OR (@V_IDOPERDEVONF = 'S') BEGIN
         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN

            DECLARE C_ITEMPROD CURSOR FOR
            SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD, I.CDPRODUTO,
                   CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                   VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                   IDCONFORITEM, CDFISOPEITEM, CDSUFXCFOPPR, CDSITUTRIBPR,
                   IDERROSITEM, IDAVISOSITEM, VRBRUTITEM, P.CDARVPROD,
                   I.NRLOTEESTQ, I.NRSUBLOTE, I.CDPRODUTO,
                   I.QTITEMPROD, I.CDFISCOPERSN, I.IDORIGEMPROD
            FROM ITEMPRODUTO I, PRODUTO P
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF AND
                  I.CDPRODUTO = P.CDPRODUTO;

            OPEN C_ITEMPROD;
            FETCH NEXT FROM C_ITEMPROD INTO @V_ITEMPPROD_CDFILIAL, @V_ITEMPPROD_NRLANCTONF,
                                            @V_ITEMPPROD_NRSEQITPROD, @V_ITEMPPROD_CDPRODUTO,
                                            @V_ITEMPPROD_CDPRODEMIS, @V_ITEMPPROD_DSPRODEMIS,
                                            @V_ITEMPPROD_IDATUVRESTOQ, @V_ITEMPPROD_QTITEMPROD,
                                            @V_ITEMPPROD_VRUNITITEM, @V_ITEMPPROD_VRDESCITEM,
                                            @V_ITEMPPROD_VRTOTAITEM, @V_ITEMPPROD_VRCONTITEM,
                                            @V_ITEMPPROD_IDCONFORITEM, @V_ITEMPPROD_CDFISOPEITEM,
                                            @V_ITEMPPROD_CDSUFXCFOPPR, @V_ITEMPPROD_CDSITUTRIBPR,
                                            @V_ITEMPPROD_IDERROSITEM, @V_ITEMPPROD_IDAVISOSITEM,
                                            @V_ITEMPPROD_VRBRUTITEM,@V_ITEMPPROD_CDARVPROD,
                                            @V_ITEMPPROD_NRLOTEESTQ, @V_ITEMPPROD_NRSUBLOTE, @V_ITEMPPROD_CDPRODUTO,
                                            @V_ITEMPPROD_QTITEMPROD, @V_ITEMPPROD_CDFISCOPERSN,
                                            @V_ITEMPPROD_IDORIGEMPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_LIQUIITEM = @V_ITEMPPROD_VRTOTAITEM - @V_ITEMPPROD_VRDESCITEM;

               EXEC CONSULTA_CST @P_ENTRSAID, @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA, NULL, @V_ITEMPPROD_IDORIGEMPROD;

               SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
               FROM CSTTEMP
               WHERE (NRCSTTEMP = @V_CSTTEMP);

               IF @V_IDOPERDEVONF <> 'S' BEGIN
                  IF NOT (SUBSTRING(@V_ITEMPPROD_CDSITUTRIBPR,1,1) = SUBSTRING(@V_SITUTRIBPR,1,1)) AND
                     NOT (@V_ITEMPPROD_CDSITUTRIBPR IS NULL) BEGIN
                     SET @V_SITUTRIBPR = @V_ITEMPPROD_CDSITUTRIBPR;
                  END;
               END
               ELSE BEGIN
                  IF @V_SITUTRIBPR IS NULL BEGIN
                     SET @V_SITUTRIBPR = @V_ITEMPPROD_CDSITUTRIBPR;
                  END;
               END;

               /* VERIFICA IMPOSTOS POR REDUCAO REFERENTE A NOTA FISCAL DE ORIGEM */
               IF (@V_IDOPERDEVONF = 'S') BEGIN

                  SET @V_VRFATOCONV = 0;

                  DECLARE C_IMPOSORIG CURSOR FOR
                     SELECT VRPERREDBCIT, NRITPROIMPOS, CDIMPOSTO, CDFISCALIT,
                            VRALIQITEM, VRPARDEDIT, IDVALORINFIT, SUM(QTITEMPROD) AS QTITEMPROD,
                            CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                            CDFISCOPERIT, CDSUFXCFOPIT,
                            SUM(VRCONTITIMP) AS VRCONTITIMP,
                            SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT, IDMOTDESONERAIT
                       FROM ITEMPROIMPOS IT, ITEMPRODUTO I
                      WHERE IT.CDFILIAL  = @V_FILIORIG
                        AND IT.NRLANCTONF = @V_DEVOLORIG
                        AND I.CDFILIAL    = @V_FILIORIG
                        AND I.NRLANCTONF  = @V_DEVOLORIG
                        AND IT.NRSEQITPROD = I.NRSEQITPROD
                        AND I.CDPRODUTO = @V_ITEMPPROD_CDPRODUTO
                        AND ROUND(I.VRUNITITEM, @V_NRDECITOTANF) = ROUND(@V_ITEMPPROD_VRUNITITEM, @V_NRDECITOTANF)
                        AND (ISNULL(I.NRLOTEESTQ  , ' ') = (ISNULL(@V_ITEMPPROD_NRLOTEESTQ, ' ')))
                        AND (ISNULL(I.NRSUBLOTE , ' ')   = (ISNULL(@V_ITEMPPROD_NRSUBLOTE,  ' ')))
                      GROUP BY VRPERREDBCIT, NRITPROIMPOS, CDIMPOSTO, CDFISCALIT,
                               VRALIQITEM, VRPARDEDIT, IDVALORINFIT, 
                               CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                               CDFISCOPERIT, CDSUFXCFOPIT, IDMOTDESONERAIT;

                  OPEN C_IMPOSORIG;
                  FETCH NEXT FROM C_IMPOSORIG INTO @V_IMPOSORIG_VRPERREDBCIT, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDIMPOSTO,
                                                   @V_IMPOSORIG_CDFISCALIT, @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPARDEDIT,
                                                   @V_IMPOSORIG_IDVALORINFIT, @V_IMPOSORIG_QTITEMPROD, @V_IMPOSORIG_CDSITUTRIBITNFE,
                                                   @V_IMPOSORIG_IDMODBCITNFE, @V_IMPOSORIG_IDMODBCSTITNFE,
                                                   @V_IMPOSORIG_CDFISCOPERIT, @V_IMPOSORIG_CDSUFXCFOPIT,
                                                   @V_IMPOSORIG_VRCONTITIMP, @V_IMPOSORIG_VRBASECALCIT,
                                                   @V_IMPOSORIG_VRIMPOSTOIT, @V_IMPOSORIG_IDMOTDESONERAIT;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_VRFATOCONV = ISNULL(@V_ITEMPPROD_QTITEMPROD, 0) / @V_IMPOSORIG_QTITEMPROD;

                     DELETE FROM TRABITPROIMPOS
                      WHERE CDFILIMPOIT = @P_FILIAL
                        AND NRLANCIMPOIT = @P_LANCTONF
                        AND NRSEQIMPOIT = @V_ITEMPPROD_NRSEQITPROD
                        AND CDIMPOSTOIT = @V_IMPOSORIG_CDIMPOSTO
                        AND NRSEQITPRO = @V_IMPOSORIG_NRITPROIMPOS;

                     DELETE FROM ITEMPROIMPOS
                      WHERE CDFILIAL = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD
                        AND CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO
                        AND NRITPROIMPOS = @V_IMPOSORIG_NRITPROIMPOS;

                     SET @V_IMPOICMS = NULL;
                     SET @V_CST1DIGT = NULL;

                     SET @V_CDGRUPOFISCAUX = NULL;

                     SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                       FROM GRUPOFISCIMPFIL G,
                             (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                     ELSE CDFILIEMIT END AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;

                     IF @V_IDORIGDESTNF = 'F' BEGIN
                     SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = @P_EMPRESA
                        AND G.CDINSCESTA = @P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;
                     END
                     ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                        SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                         FROM GRFISIMPIECLIE G,
                              (SELECT CDCLIENTE
                                 FROM NOTAFISCAL
                                WHERE CDFILIAL = @P_FILIAL
                                  AND NRLANCTONF = @P_LANCTONF) N
                        WHERE G.CDCLIENTE = N.CDCLIENTE
                          AND G.CDEMPRESA = @P_EMPRESA
                          AND G.CDINSCESTA = @P_INSCESTA
                          AND NOT G.CDGRUPOFISC IS NULL
                          AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;
                     END;

                     IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                           EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_INCIDITEM_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @V_ITEMPPROD_IDORIGEMPROD, @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                      @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                     END
                     ELSE BEGIN
                           EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDITEM_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @V_ITEMPPROD_IDORIGEMPROD, @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                      @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT
                     END;


                     SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO;


                     IF (@V_IMPOICMS IS NOT NULL) BEGIN

                        IF @V_IDORIGDESTNF = 'L' BEGIN

                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                             FROM PRODUTO
                            WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                           IF @V_CST1DIGT IS NULL BEGIN
                              SELECT @V_CST1DIGT = MAX(CDCSTDIG1SAI)
                                FROM INSCRESTAD
                               WHERE CDEMPRESA   = @P_EMPRESA AND
                                     CDINSCESTA  = @P_INSCESTA;
                           END;
                        END
                        ELSE IF @V_IDORIGDESTNF = 'C'
                        BEGIN
                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                             FROM PRODUTO
                            WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                           IF @V_CST1DIGT IS NULL BEGIN
                              SELECT @V_CST1DIGT  = MAX(CDCSTDIG1CLI)
                                FROM NOTAFISCAL N LEFT JOIN CLIENTE C
                                                 ON (N.CDCLIENTE = C.CDCLIENTE)
                               WHERE (CDFILIAL     = @P_FILIAL) AND
                                     (NRLANCTONF   = @P_LANCTONF);
                           END;
                        END
                        ELSE
                        BEGIN

                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                             FROM PRODUTO
                            WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                           IF @V_CST1DIGT IS NULL BEGIN
                              SELECT @V_CST1DIGT = MAX(CDCSTDIG1ENT)
                                FROM NOTAFISCAL N, FORNECEDOR F
                               WHERE CDFILIAL     = @P_FILIAL
                                 AND NRLANCTONF   = @P_LANCTONF
                                 AND N.CDFORNECED = F.CDFORNECED;
                           END;
                        END;
                        IF (@V_CDSITTRIBTMP IS NOT NULL) BEGIN
                           UPDATE ITEMPRODUTO
                              SET CDSITUTRIBPR  = @V_CST1DIGT + @V_CDSITTRIBTMP
                            WHERE CDFILIAL      = @P_FILIAL AND
                                  NRLANCTONF    = @P_LANCTONF AND
                                  NRSEQITPROD   = @V_ITEMPPROD_NRSEQITPROD;

                           SET @V_SITUTRIBPR = @V_CST1DIGT + @V_CDSITTRIBTMP;
                        END;

                        SET @V_CDGRUPOFISCAUX = NULL;

                        SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                          FROM GRUPOFISCIMPFIL G,
                                (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                        ELSE CDFILIEMIT END AS CDFILIAL
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = @P_FILIAL
                                   AND NRLANCTONF = @P_LANCTONF) F
                         WHERE G.CDFILIAL = F.CDFILIAL
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO;

                        IF @V_IDORIGDESTNF = 'F' BEGIN
                        SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                          FROM GRFISIMPIEFORN G,
                               (SELECT CDFORNECED
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = @P_FILIAL
                                   AND NRLANCTONF = @P_LANCTONF) N
                         WHERE G.CDFORNECED = N.CDFORNECED
                           AND G.CDEMPRESA = @P_EMPRESA
                           AND G.CDINSCESTA = @P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO;
                        END
                        ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                            SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                             FROM GRFISIMPIECLIE G,
                                  (SELECT CDCLIENTE
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = @P_FILIAL
                                      AND NRLANCTONF = @P_LANCTONF) N
                            WHERE G.CDCLIENTE = N.CDCLIENTE
                              AND G.CDEMPRESA = @P_EMPRESA
                              AND G.CDINSCESTA = @P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO;
                        END;

                        IF (@V_CDGRUPOFISCAUX IS NOT NULL) BEGIN

                           EXEC CONSULTA_CFOP @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                     @P_INSCESTA,   @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                     @V_PAISDEST,   @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                     @V_CDGRUPOFISCAUX,@P_INIVALID, @V_ITEMPPROD_IDORIGEMPROD;
                        END
                        ELSE BEGIN
                           EXEC CONSULTA_CFOP @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                     @P_INSCESTA,   @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                     @V_PAISDEST,   @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                     @V_CDGRUPOFISC,@P_INIVALID, @V_ITEMPPROD_IDORIGEMPROD;
                        END;

                        -- ALTERA NATUREZA DE OPERAO DA NOTA FISCAL CASO NO EXISTA
                        IF (@V_DSCDFISOPEITREGRA IS NOT NULL) BEGIN
                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = @V_DSCDFISOPEITREGRA
                            WHERE CDFILIAL   = @P_FILIAL   AND
                                  NRLANCTONF = @P_LANCTONF;
                        END
                        ELSE BEGIN
                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP)
                                                    FROM CFOPTEMP
                                                   WHERE NRCFOPTEMP = @V_CFOPTEMP)
                            WHERE CDFILIAL   = @P_FILIAL
                              AND NRLANCTONF = @P_LANCTONF
                              AND DSCDFISOPENF IS NULL;

                        END;


                        SELECT @V_FISOPEITEM = MAX(CDFISOPETMP),
                               @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                               @V_DSCDFISOPEIT = MAX(DSCFOPTMP)
                          FROM CFOPTEMP
                         WHERE NRCFOPTEMP = @V_CFOPTEMP;

                        SET @V_FISOPEITEM      = ISNULL(@V_CDFISCOPERREGRA, @V_FISOPEITEM);
                        SET @V_DSCDFISOPEIT    = ISNULL(@V_DSCDFISOPEITREGRA, @V_DSCDFISOPEIT);
                        SET @V_DIFALIQITEM     = ISNULL(@V_IDDIFEALIQREGRA, @V_DIFALIQITEM);
                        SET @V_IDDIFALIQCUSPRC = ISNULL(@V_IDDIFALIQCUSPRREGRA, @V_IDDIFALIQCUSPRC);

                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM = @V_FISOPEITEM,
                               CDSUFXCFOPPR = @V_SUFXCFOPPR,
                               DSCDFISOPEIT = @V_DSCDFISOPEIT

                         WHERE CDFILIAL    = @P_FILIAL   AND
                               NRLANCTONF  = @P_LANCTONF AND
                               NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;


                        DELETE FROM CFOPTEMP
                            WHERE NRCFOPTEMP = @V_CFOPTEMP;

                     END;

                     INSERT INTO TRABITPROIMPOS(
                        CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                        CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                        VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                        CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_ITEMPPROD_NRSEQITPROD, @V_IMPOSORIG_CDIMPOSTO, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDFISCALIT,
                        @V_SITUTRIBPR, ISNULL(@V_FISOPEITEM, @V_IMPOSORIG_CDFISCOPERIT), ISNULL(@V_SUFXCFOPPR, @V_IMPOSORIG_CDSUFXCFOPIT), @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPERREDBCIT, (@V_IMPOSORIG_VRPARDEDIT * @V_VRFATOCONV),
                        ROUND((@V_IMPOSORIG_VRCONTITIMP * @V_VRFATOCONV),2), (@V_IMPOSORIG_VRBASECALCIT * @V_VRFATOCONV), (@V_IMPOSORIG_VRIMPOSTOIT * @V_VRFATOCONV), '00000', '00000', @V_IMPOSORIG_IDVALORINFIT,
                        @V_CDSITTRIBTMP, ISNULL(@V_IDMODBCNFE, @V_IMPOSORIG_IDMODBCITNFE), ISNULL(@V_IDMODBCSTNFE, @V_IMPOSORIG_IDMODBCSTITNFE),
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, ISNULL(@V_IDMOTIDESSTNFE, @V_IMPOSORIG_IDMOTDESONERAIT), @V_CDREGRAITALIQ);

                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                        CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                        VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
                        IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_ITEMPPROD_NRSEQITPROD, @V_IMPOSORIG_CDIMPOSTO, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDFISCALIT,
                        @V_SITUTRIBPR, ISNULL(@V_FISOPEITEM, @V_IMPOSORIG_CDFISCOPERIT), ISNULL(@V_SUFXCFOPPR, @V_IMPOSORIG_CDSUFXCFOPIT), @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPERREDBCIT, (@V_IMPOSORIG_VRPARDEDIT * @V_VRFATOCONV),
                        ROUND((@V_IMPOSORIG_VRCONTITIMP * @V_VRFATOCONV),2), (@V_IMPOSORIG_VRBASECALCIT * @V_VRFATOCONV), (@V_IMPOSORIG_VRIMPOSTOIT * @V_VRFATOCONV), '00000', '00000', @V_CDSITTRIBTMP,
                        ISNULL(@V_IDMODBCNFE, @V_IMPOSORIG_IDMODBCITNFE), ISNULL(@V_IDMODBCSTNFE, @V_IMPOSORIG_IDMODBCSTITNFE),
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, ISNULL(@V_IDMOTIDESSTNFE, @V_IMPOSORIG_IDMOTDESONERAIT), @V_CDREGRAITALIQ);

                     FETCH NEXT FROM C_IMPOSORIG INTO @V_IMPOSORIG_VRPERREDBCIT, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDIMPOSTO,
                                                      @V_IMPOSORIG_CDFISCALIT, @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPARDEDIT,
                                                      @V_IMPOSORIG_IDVALORINFIT, @V_IMPOSORIG_QTITEMPROD, @V_IMPOSORIG_CDSITUTRIBITNFE,
                                                      @V_IMPOSORIG_IDMODBCITNFE, @V_IMPOSORIG_IDMODBCSTITNFE,
                                                      @V_IMPOSORIG_CDFISCOPERIT, @V_IMPOSORIG_CDSUFXCFOPIT,
                                                      @V_IMPOSORIG_VRCONTITIMP, @V_IMPOSORIG_VRBASECALCIT,
                                                      @V_IMPOSORIG_VRIMPOSTOIT, @V_IMPOSORIG_IDMOTDESONERAIT;
                  END;
                  CLOSE C_IMPOSORIG;
                  DEALLOCATE C_IMPOSORIG;
               END;

               IF (@V_IDOPERDEVONF = 'S') BEGIN
                  EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF,
                                           @V_CDGRUPOFISC, NULL, @V_IDINTEREST, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, @V_ITEMPPROD_IDORIGEMPROD;

                  DECLARE C_INCIDITEM CURSOR FOR
                  SELECT CDIMPOTEMP, CDFISCTEMP, CDENQLEGALIPI
                  FROM INCITEMP
                  WHERE NRINCITEMP = @V_INCITEMP;

                  OPEN C_INCIDITEM;

                  FETCH NEXT FROM C_INCIDITEM INTO @V_INCIDITEM_CDIMPOTEMP, @V_INCIDITEM_CDFISCTEMP, @V_INCIDITEM_CDENQLEGALIPI;

                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     /*VERIFICA CST POR IMPOSTO*/
                     SET @V_IMPOICMS = NULL;
                     SET @V_CDGRUPOFISCAUX = NULL;

                     SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                       FROM GRUPOFISCIMPFIL G,
                             (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                     ELSE CDFILIEMIT END AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;

                     IF @V_IDORIGDESTNF = 'F' BEGIN
                     SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = @P_EMPRESA
                        AND G.CDINSCESTA = @P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;
                     END
                     ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                        SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                         FROM GRFISIMPIECLIE G,
                              (SELECT CDCLIENTE
                                 FROM NOTAFISCAL
                                WHERE CDFILIAL = @P_FILIAL
                                  AND NRLANCTONF = @P_LANCTONF) N
                        WHERE G.CDCLIENTE = N.CDCLIENTE
                          AND G.CDEMPRESA = @P_EMPRESA
                          AND G.CDINSCESTA = @P_INSCESTA
                          AND NOT G.CDGRUPOFISC IS NULL
                          AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;
                     END;

                     IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                           EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_INCIDITEM_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @V_ITEMPPROD_IDORIGEMPROD, @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                      @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                     END
                     ELSE BEGIN
                           EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDITEM_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, @V_ITEMPPROD_IDORIGEMPROD, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                      @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                     END;

                     SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;

                     UPDATE ITEMPROIMPOS
                     SET   CDFISCALIT = @V_INCIDITEM_CDFISCTEMP,
                           CDSITUTRIBITNFE = @V_CDSITTRIBTMP,
                           IDMODBCITNFE = @V_IDMODBCNFE,
                           IDMODBCSTITNFE = @V_IDMODBCSTNFE,
                           CDTPCREDPICOITE = @V_CDTPCRPICOSTNFE,
                           CDNATUBCALPCIT  = @V_CDNATUBCPCSTNFE,
                           IDMOTDESONERAIT = @V_IDMOTIDESSTNFE,
                           CDREGRAIT       = @V_CDREGRAITALIQ,
                           CDENQLEGALIPI   = @V_INCIDITEM_CDENQLEGALIPI
                     WHERE CDFILIAL   = @P_FILIAL   AND
                           NRLANCTONF = @P_LANCTONF AND
                           NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD  AND
                           CDIMPOSTO  = @V_INCIDITEM_CDIMPOTEMP;


                     UPDATE TRABITPROIMPOS
                     SET CDFISCIMPOIT   = @V_INCIDITEM_CDFISCTEMP,
                         CDSTRIBITNFE = @V_CDSITTRIBTMP,
                         IDMODBCITEMNFE = @V_IDMODBCNFE,
                         IDMODBCSTITENFE = @V_IDMODBCSTNFE,
                         CDTPCREDPICOITE = @V_CDTPCRPICOSTNFE,
                         CDNATUBCALPCIT  = @V_CDNATUBCPCSTNFE,
                         IDMOTDESOTRABIT = @V_IDMOTIDESSTNFE,
                         CDREGRATRABIT   = @V_CDREGRAITALIQ,
                         CDENQLEGALIPI   = @V_INCIDITEM_CDENQLEGALIPI
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDITEM_CDIMPOTEMP;
                     FETCH NEXT FROM C_INCIDITEM INTO @V_INCIDITEM_CDIMPOTEMP, @V_INCIDITEM_CDFISCTEMP, @V_INCIDITEM_CDENQLEGALIPI;
                  END;

                  CLOSE C_INCIDITEM;
                  DEALLOCATE C_INCIDITEM;

                  UPDATE ITEMPROIMPOS
                  SET CDFISCALIT = '2'
                  WHERE CDFILIAL    = @P_FILIAL    AND
                        NRLANCTONF  = @P_LANCTONF  AND
                        VRPERREDBCIT > 0.00        AND
                        NRITPROIMPOS = '2';

                  UPDATE TRABITPROIMPOS
                  SET CDFISCIMPOIT = '2'
                  WHERE CDFILIMPOIT  = @P_FILIAL   AND
                        NRLANCIMPOIT = @P_LANCTONF AND
                        VRREDBCIMPOIT > 0.00       AND
                        NRSEQITPRO = '2';

                  DELETE FROM INCITEMP
                  WHERE NRINCITEMP = @V_INCITEMP;
               END;

               EXEC CONSULTA_CFOP @P_ENTRSAID, @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_PAISCFOP,
                                  @V_ESTACFOP, @V_PAISDEST, @V_ESTADEST, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC,@P_INIVALID, @V_ITEMPPROD_IDORIGEMPROD;

               /* Verifica primeiro digito do CFOP */
               SET @V_CFOP1DIGT = '';

               IF @V_PAISCFOP = @V_PAISDEST BEGIN
                  IF @V_ESTACFOP = @V_ESTADEST BEGIN
                     SET @V_CFOP1DIGT = '1';
                  END
                  ELSE BEGIN
                     SET @V_CFOP1DIGT = '2';
                  END;
               END
               ELSE BEGIN
                  SET @V_CFOP1DIGT = '3';
               END;

               SELECT @V_FISOPEITEM = MAX(CDFISOPETMP), @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                      @V_DSCDFISOPEIT = MAX(DSCFOPTMP)
               FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               SET @V_FISOPEITEM      = ISNULL(@V_CDFISCOPERREGRA, @V_FISOPEITEM);
               SET @V_DSCDFISOPEIT    = ISNULL(@V_DSCDFISOPEITREGRA, @V_DSCDFISOPEIT);
               SET @V_DIFALIQITEM     = ISNULL(@V_IDDIFEALIQREGRA, @V_DIFALIQITEM);
               SET @V_IDDIFALIQCUSPRC = ISNULL(@V_IDDIFALIQCUSPRREGRA, @V_IDDIFALIQCUSPRC);

               IF (@V_IMPOICMS IS NOT NULL) BEGIN
                  IF NOT @V_FISOPEITEM IS NULL BEGIN
                     UPDATE NOTAFISCAL
                     SET CDFISOPENTF = @V_FISOPEITEM,
                         DSCDFISOPENF = @V_DSCDFISOPEIT
                     WHERE CDFILIAL   = @P_FILIAL   AND
                           NRLANCTONF = @P_LANCTONF;

                  END;
               END;   

   ---------------------------------------------------------------------------------------------------------
               SELECT @V_IDORDPRIMDFENT = MAX(IDORDPRIMDFENT)
                 FROM PARAMGERAL;


   ---------------------------------------------------------------------------------------------------------
               EXEC CONSULTA_CSOSN @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPPROD_CDARVPROD,
                                   @P_INSCESTA,   @P_TIPOOPER, @P_FILIAL,   @P_LANCTONF,
                                   @V_CDGRUPOFISC,@V_IDINTEREST, @P_CDFISCOPERSN = @V_CDFISCOPERSN OUTPUT;

               IF (NOT @V_CDFISCOPERSN IS NULL) AND (LEN(@V_CDFISCOPERSN) = 4) BEGIN
                  UPDATE ITEMPRODUTO
                     SET CDFISCOPERSN = @V_CDFISCOPERSN
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
               END
               ELSE BEGIN
                  UPDATE ITEMPRODUTO
                     SET CDFISCOPERSN = (SELECT MAX(I.CDFISCOPERSN)
                                           FROM ITEMPRODUTO I
                                          WHERE I.CDFILIAL   = @V_FILIORIG
                                            AND I.NRLANCTONF = @V_DEVOLORIG
                                            AND I.CDPRODUTO  = @V_ITEMPPROD_CDPRODUTO)
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
               END;

               IF NOT @V_FISOPEITEM IS NULL BEGIN
                  UPDATE ITEMPRODUTO
                  SET CDFISOPEITEM = @V_FISOPEITEM,
                      CDSUFXCFOPPR = @V_SUFXCFOPPR,
                      DSCDFISOPEIT = @V_DSCDFISOPEIT
                  WHERE CDFILIAL    = @P_FILIAL                 AND
                        NRLANCTONF  = @P_LANCTONF               AND
                        NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;

                  IF (@V_IDOPERDEVONF = 'S') BEGIN
                     UPDATE TRABITPROIMPOS
                     SET CDSTRIBIMPOIT = @V_SITUTRIBPR,
                         CDFOPERIMPOIT = @V_FISOPEITEM,
                         CDSCFOPIMPOIT = @V_SUFXCFOPPR
                     WHERE CDFILIMPOIT = @P_FILIAL                AND
                           NRLANCIMPOIT = @P_LANCTONF             AND
                           NRSEQIMPOIT = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END
               ELSE BEGIN
                  UPDATE ITEMPRODUTO
                  SET CDFISOPEITEM = @V_CFOP1DIGT + SUBSTRING(CDFISOPEITEM,2,10)
                  WHERE CDFILIAL    = @P_FILIAL                 AND
                        NRLANCTONF  = @P_LANCTONF               AND
                        NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;

                  IF (@V_IDOPERDEVONF = 'S') BEGIN
                     UPDATE TRABITPROIMPOS
                     SET CDFOPERIMPOIT = @V_CFOP1DIGT + SUBSTRING(CDFOPERIMPOIT,2,10)
                     WHERE CDFILIMPOIT = @P_FILIAL                AND
                           NRLANCIMPOIT = @P_LANCTONF             AND
                           NRSEQIMPOIT = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END;

               DELETE FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
               FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               IF @P_ENTRSAID = 'E' BEGIN
                  IF (SUBSTRING(@V_ITEMPPROD_CDSITUTRIBPR,1,1) = SUBSTRING(@V_SITUTRIBPR,1,1)) OR
                     (@V_ITEMPPROD_CDSITUTRIBPR IS NULL) BEGIN
                     UPDATE ITEMPRODUTO
                     SET CDSITUTRIBPR  = @V_SITUTRIBPR
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END
               ELSE IF @P_ENTRSAID = 'S' BEGIN
                  IF (SUBSTRING(@V_ITEMPPROD_CDSITUTRIBPR,1,1) = SUBSTRING(@V_SITUTRIBPR,1,1)) OR
                     (@V_ITEMPPROD_CDSITUTRIBPR IS NULL) BEGIN
                     UPDATE ITEMPRODUTO
                     SET CDSITUTRIBPR  = @V_SITUTRIBPR
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           CDSITUTRIBPR IS NULL      AND
                           NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END;

               DELETE FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               FETCH NEXT FROM C_ITEMPROD INTO @V_ITEMPPROD_CDFILIAL, @V_ITEMPPROD_NRLANCTONF,
                                               @V_ITEMPPROD_NRSEQITPROD, @V_ITEMPPROD_CDPRODUTO,
                                               @V_ITEMPPROD_CDPRODEMIS, @V_ITEMPPROD_DSPRODEMIS,
                                               @V_ITEMPPROD_IDATUVRESTOQ, @V_ITEMPPROD_QTITEMPROD,
                                               @V_ITEMPPROD_VRUNITITEM, @V_ITEMPPROD_VRDESCITEM,
                                               @V_ITEMPPROD_VRTOTAITEM, @V_ITEMPPROD_VRCONTITEM,
                                               @V_ITEMPPROD_IDCONFORITEM, @V_ITEMPPROD_CDFISOPEITEM,
                                               @V_ITEMPPROD_CDSUFXCFOPPR, @V_ITEMPPROD_CDSITUTRIBPR,
                                               @V_ITEMPPROD_IDERROSITEM, @V_ITEMPPROD_IDAVISOSITEM,
                                               @V_ITEMPPROD_VRBRUTITEM, @V_ITEMPPROD_CDARVPROD,
                                               @V_ITEMPPROD_NRLOTEESTQ, @V_ITEMPPROD_NRSUBLOTE, @V_ITEMPPROD_CDPRODUTO,
                                               @V_ITEMPPROD_QTITEMPROD, @V_ITEMPPROD_CDFISCOPERSN,
                                               @V_ITEMPPROD_IDORIGEMPROD;
            END;

            CLOSE C_ITEMPROD;
            DEALLOCATE C_ITEMPROD;

            IF(@V_IDOPERDEVONF <> 'S') BEGIN
               DECLARE C_ITEMENCARGO CURSOR FOR
               SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0)) VRITEMENCA, IDENCARGO,
                    EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
               FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL   = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF) I
              WHERE (IE.CDFILIAL   = @P_FILIAL)
                AND (IE.NRLANCTONF = @P_LANCTONF)
                AND (IE.VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0) > 0)
                AND (EN.CDENCARGO  = IE.CDENCARGO);

               OPEN C_ITEMENCARGO;

               FETCH NEXT FROM  C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                                   @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                                   @V_ITEMENC_CDCTBLSAIDEN;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_TOTAPRODENCA = SUM(VRTOTAITEM - VRDESCITEM)
                  FROM ITEMPRODUTO IP
                  WHERE (IP.CDFILIAL   = @P_FILIAL)   AND
                        (IP.NRLANCTONF = @P_LANCTONF);

                  IF @V_TOTAPRODENCA <> 0 BEGIN

                     DECLARE C_ATUAVRCONT CURSOR FOR
                     SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                     FROM ITEMPRODUTO IP
                     WHERE (IP.CDFILIAL    = @P_FILIAL) AND
                           (IP.NRLANCTONF  = @P_LANCTONF);

                     OPEN C_ATUAVRCONT;

                     FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;

                     WHILE (@@FETCH_STATUS = 0) BEGIN

                        IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                           SET @V_VRBRUTO = (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                        END
                        ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                           SET @V_VRBRUTO = - (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                        END
                        ELSE BEGIN
                           SET @V_VRBRUTO = 0;
                        END;

                        IF (@V_ITEMENC_CDCTBLSAIDEN IS NULL) BEGIN
                           SET @V_VRCONTAB = @V_VRBRUTO;
                        END
                        ELSE BEGIN
                           SET @V_VRCONTAB = 0;
                        END;

                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM + (@V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                            VRCONTITEM = VRCONTITEM + (@V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                        WHERE CDFILIAL    = @P_FILIAL   AND
                              NRLANCTONF  = @P_LANCTONF AND
                              NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                        FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;

                     END;

                     CLOSE C_ATUAVRCONT;
                     DEALLOCATE C_ATUAVRCONT;
                  END;
                  FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                                     @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                                     @V_ITEMENC_CDCTBLSAIDEN;
               END;

               CLOSE C_ITEMENCARGO;
               DEALLOCATE C_ITEMENCARGO;

            END;

            DECLARE C_QTITEM CURSOR FOR
            SELECT NRSEQITPROD
            FROM ITEMPRODUTO
            WHERE (CDFILIAL   = @P_FILIAL)   AND
                  (NRLANCTONF = @P_LANCTONF) AND
                  (QTITEMPROD = 0);

            OPEN C_QTITEM;
            FETCH NEXT FROM C_QTITEM INTO @V_QTITEM_NRSEQITPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               DELETE FROM TRABITPROIMPOS
               WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                     (NRLANCIMPOIT = @P_LANCTONF) AND
                     (NRSEQIMPOIT  = @V_QTITEM_NRSEQITPROD);

              FETCH NEXT FROM C_QTITEM INTO @V_QTITEM_NRSEQITPROD;
            END;
            CLOSE C_QTITEM;
            DEALLOCATE C_QTITEM;

            SELECT @V_IMPOSITEM = MAX(CDFILIMPOIT+NRLANCIMPOIT)
            FROM TRABITPROIMPOS
            WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                  (NRLANCIMPOIT = @P_LANCTONF);

            IF @V_IMPOSITEM IS NULL BEGIN
               DELETE FROM TRABIMPOSNFTOT
               WHERE (CDFILIMPTOT  = @P_FILIAL) AND
                     (NRLANCIMPTOT = @P_LANCTONF);
            END;

   ---------------------------------------------------------------------------------------------------------
            DELETE ITEMPRODUTO
            WHERE (CDFILIAL   = @P_FILIAL)   AND
                  (NRLANCTONF = @P_LANCTONF) AND
                  (QTITEMPROD = 0);
   ---------------------------------------------------------------------------------------------------------

            DECLARE C_IMPOSPROD CURSOR FOR
   ---------------------------------------------------------------------------------------------------------
            SELECT IT.CDIMPOSTOIT,
                   ISNULL(SUM(IT.VRIMPOSIT),0)  AS VRIMPOSTOIT,
                   ISNULL(SUM(IT.VRBCALCIMPOIT),0) AS VRBASECALCIT
            FROM TRABITPROIMPOS IT
            WHERE (IT.CDFILIMPOIT  = @P_FILIAL)   AND
                  (IT.NRLANCIMPOIT = @P_LANCTONF)
            GROUP BY IT.CDIMPOSTOIT;
   ---------------------------------------------------------------------------------------------------------
            OPEN C_IMPOSPROD;
            FETCH NEXT FROM C_IMPOSPROD INTO @V_IMPOSPROD_CDIMPOSTOIT, @V_IMPOSPROD_VRIMPOSTOIT, @V_IMPOSPROD_VRBASECALCIT;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               UPDATE TRABIMPOSNFTOT
               SET VRIMPOSTOT   = @V_IMPOSPROD_VRIMPOSTOIT,
                   VRBCALIMPTOT = @V_IMPOSPROD_VRBASECALCIT
               WHERE (CDFILIMPTOT  = @P_FILIAL)   AND
                     (NRLANCIMPTOT = @P_LANCTONF) AND
                     (CDIMPOSTOT   = @V_IMPOSPROD_CDIMPOSTOIT);
               FETCH NEXT FROM C_IMPOSPROD INTO @V_IMPOSPROD_CDIMPOSTOIT, @V_IMPOSPROD_VRIMPOSTOIT, @V_IMPOSPROD_VRBASECALCIT;
            END;
            CLOSE C_IMPOSPROD;
            DEALLOCATE C_IMPOSPROD;

   ---------------------------------------------------------------------------------------------------------
            IF @V_IDOPERDEVONF <> 'S' BEGIN
               DECLARE C_PREDBCALC CURSOR FOR
               SELECT NRSEQIMPOIT, CDIMPOSTOIT, CDSTRIBIMPOIT, CDFOPERIMPOIT,
                      CDSCFOPIMPOIT, VRCONTIMPOIT, VRREDBCIMPOIT, VRBCALCIMPOIT,
                      IDVALORINFO, P.CDARVPROD, I.IDORIGEMPROD
               FROM TRABITPROIMPOS T, ITEMPRODUTO I, PRODUTO P
               WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
                     (NRLANCIMPOIT = @P_LANCTONF) AND
                     (T.CDFILIMPOIT = I.CDFILIAL) AND
                     (T.NRLANCIMPOIT = I.NRLANCTONF) AND
                     (T.NRSEQIMPOIT = I.NRSEQITPROD) AND
                     (I.CDPRODUTO = P.CDPRODUTO) AND
                     (VRREDBCIMPOIT > 0)
               OPEN C_PREDBCALC;
               FETCH NEXT FROM C_PREDBCALC INTO @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, @V_PREDBCALC_CDSTRIBIMPOIT,@V_PREDBCALC_CDFOPERIMPOIT,
                                                @V_PREDBCALC_CDSCFOPIMPOIT, @V_PREDBCALC_VRCONTIMPOIT, @V_PREDBCALC_VRREDBCIMPOIT,@V_PREDBCALC_VRBCALCIMPOIT,
                                                @V_PREDBCALC_IDVALORINFO, @V_PREDBCALC_CDARVPROD, @V_PREDBCALC_IDORIGEMPROD ;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  DELETE ITEMPROIMPOS
                  WHERE CDFILIAL     = @P_FILIAL   AND
                        NRLANCTONF   = @P_LANCTONF AND
                        NRSEQITPROD  = @V_PREDBCALC_NRSEQIMPOIT AND
                        CDIMPOSTO    = @V_PREDBCALC_CDIMPOSTOIT AND
                        NRITPROIMPOS = '2';

                  /*VERIFICA CST POR IMPOSTO*/
                  SET @V_IMPOICMS = NULL;
                  SET @V_CDGRUPOFISCAUX = NULL;

                  SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                    FROM GRUPOFISCIMPFIL G,
                          (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                  ELSE CDFILIEMIT END AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;

                  IF @V_IDORIGDESTNF = 'F' BEGIN
                  SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                    FROM GRFISIMPIEFORN G,
                         (SELECT CDFORNECED
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = @P_EMPRESA
                     AND G.CDINSCESTA = @P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;
                  END
                  ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                     SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                      FROM GRFISIMPIECLIE G,
                           (SELECT CDCLIENTE
                              FROM NOTAFISCAL
                             WHERE CDFILIAL = @P_FILIAL
                               AND NRLANCTONF = @P_LANCTONF) N
                     WHERE G.CDCLIENTE = N.CDCLIENTE
                       AND G.CDEMPRESA = @P_EMPRESA
                       AND G.CDINSCESTA = @P_INSCESTA
                       AND NOT G.CDGRUPOFISC IS NULL
                       AND G.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;
                  END;

                  IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                     EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_PREDBCALC_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_PREDBCALC_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @V_PREDBCALC_IDORIGEMPROD, @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END
                  ELSE BEGIN
                     EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_PREDBCALC_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_PREDBCALC_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @V_PREDBCALC_IDORIGEMPROD, @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END;

                  SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;

                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                     CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                     VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                     CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                  VALUES(
                     @P_FILIAL, @P_LANCTONF, @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, '2', '2',
                     @V_PREDBCALC_CDSTRIBIMPOIT, @V_PREDBCALC_CDFOPERIMPOIT, @V_PREDBCALC_CDSCFOPIMPOIT, 0,
                     0, 0, ROUND(@V_PREDBCALC_VRCONTIMPOIT - @V_PREDBCALC_VRBCALCIMPOIT,2), 0, 0, '00000', '00000',
                     @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);

                  DELETE TRABITPROIMPOS
                  WHERE CDFILIMPOIT  = @P_FILIAL   AND
                        NRLANCIMPOIT = @P_LANCTONF AND
                        NRSEQIMPOIT  = @V_PREDBCALC_NRSEQIMPOIT AND
                        CDIMPOSTOIT  = @V_PREDBCALC_CDIMPOSTOIT AND
                        NRSEQITPRO   = '2';

                  INSERT INTO TRABITPROIMPOS(
                     CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                     CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                     VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                     CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                  VALUES(
                     @P_FILIAL, @P_LANCTONF, @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, '2', '2',
                     @V_PREDBCALC_CDSTRIBIMPOIT, @V_PREDBCALC_CDFOPERIMPOIT, @V_PREDBCALC_CDSCFOPIMPOIT, 0,
                     0, 0, ROUND(@V_PREDBCALC_VRCONTIMPOIT - @V_PREDBCALC_VRBCALCIMPOIT,2), 0, 0, '00000', '00000',
                     @V_PREDBCALC_IDVALORINFO,  @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE,
                     @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);

                     FETCH NEXT FROM C_PREDBCALC INTO @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, @V_PREDBCALC_CDSTRIBIMPOIT,@V_PREDBCALC_CDFOPERIMPOIT,
                                                @V_PREDBCALC_CDSCFOPIMPOIT, @V_PREDBCALC_VRCONTIMPOIT, @V_PREDBCALC_VRREDBCIMPOIT,@V_PREDBCALC_VRBCALCIMPOIT,
                                                @V_PREDBCALC_IDVALORINFO, @V_PREDBCALC_CDARVPROD, @V_PREDBCALC_IDORIGEMPROD ;
               END;
               CLOSE C_PREDBCALC;
               DEALLOCATE C_PREDBCALC;
            END;
   ---------------------------------------------------------------------------------------------------------

            DELETE FROM IMPOSTONF
            WHERE (CDFILIAL   = @P_FILIAL)   AND
                  (NRLANCTONF = @P_LANCTONF);

            DECLARE C_IMPOSUBTRIB CURSOR FOR
            SELECT NRSEQITPROD, CDIMPOSTO, IDTRIMPSTII
            FROM ITEMPROIMPOS I
            WHERE CDFILIAL     = @V_FILIORIG  AND
                  NRLANCTONF   = @V_DEVOLORIG AND
                  NRITPROIMPOS = '1'         AND
                  EXISTS (SELECT CDIMPOSTO
                          FROM IMPOSTO
                          WHERE CDIMPOSTRIB = I.CDIMPOSTO);

            OPEN C_IMPOSUBTRIB;
            FETCH NEXT FROM C_IMPOSUBTRIB INTO @V_NRSEQITPROD, @V_CDIMPOSTO, @V_IDTRIMPSTII;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               UPDATE TRABITPROIMPOS
               SET IDTRIMPSTTI = @V_IDTRIMPSTII
               WHERE CDFILIMPOIT  = @P_FILIAL      AND
                     NRLANCIMPOIT = @P_LANCTONF    AND
                     NRSEQIMPOIT  = @V_NRSEQITPROD AND
                     CDIMPOSTOIT  = @V_CDIMPOSTO   AND
                     NRSEQITPRO   = '1';

               FETCH NEXT FROM C_IMPOSUBTRIB INTO @V_NRSEQITPROD, @V_CDIMPOSTO, @V_IDTRIMPSTII;
            END;
            CLOSE C_IMPOSUBTRIB;
            DEALLOCATE C_IMPOSUBTRIB;

         END
         ELSE BEGIN
            SELECT @V_TOTAPROD = ISNULL(SUM(VRTOTAITEM - VRDESCITEM),0)
            FROM ITEMPRODUTO
            WHERE CDFILIAL   = @P_FILIAL   AND
                  NRLANCTONF = @P_LANCTONF;
         END;
      END
      ELSE BEGIN
         SELECT @V_TOTAPROD = ISNULL(SUM(VRTOTAITEM - VRDESCITEM),0)
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = @P_FILIAL   AND
               NRLANCTONF = @P_LANCTONF;
      END;

      IF @P_TIPOOPER = '11' AND @V_IDNFOUTRASNF = 'S' BEGIN
         SELECT @V_QTDEREGTRAB = COUNT(*)
         FROM TRABITPROIMPOS
         WHERE CDFILIMPOIT  = @P_FILIAL   AND
               NRLANCIMPOIT = @P_LANCTONF;

         IF @V_QTDEREGTRAB = 0 BEGIN
            INSERT INTO TRABITPROIMPOS(
               CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, VRCONTIMPOIT,
               VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
               CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE,
               CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
               (SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                       CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, ROUND(VRCONTITIMP,2),
                       VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, ISNULL(IDVALORINFIT, 'N'),
                       CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                       CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT
                FROM ITEMPROIMPOS
                WHERE CDFILIAL   = @P_FILIAL   AND
                      NRLANCTONF = @P_LANCTONF);


            DECLARE C_IMPOSNFTOT CURSOR FOR
            SELECT IP.CDIMPOSTO,
                   CDIMPOSTOIT,
                   ROUND(SUM(ISNULL(VRIMPOSIT,0)),@V_NRDECITOTANF) AS VRIMPOSTOIT,
                   ISNULL(SUM(VRBASECALCIT),0) AS VRBASECALCIT,
                   ISNULL(SUM(VRBCALCIMPOIT),0) AS VRBCALCIMPOIT,
                   MAX(ISNULL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR
            FROM ITEMPROIMPOS IP, TRABITPROIMPOS TI, IMPOSTO I
            WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                  (IP.NRLANCTONF   = @P_LANCTONF)    AND
                  (TI.CDFILIMPOIT  = @P_FILIAL)      AND
                  (TI.NRLANCIMPOIT = @P_LANCTONF)    AND
                  (IP.NRSEQITPROD  = TI.NRSEQIMPOIT) AND
                  (IP.NRITPROIMPOS = TI.NRSEQITPRO)  AND
                  (IP.CDIMPOSTO    = TI.CDIMPOSTOIT) AND
   ---------------------------------------------------------------------------------------------------------
                  (I.CDIMPOSTO     = IP.CDIMPOSTO)   AND
                  (IP.NRITPROIMPOS  = 1 )
   ---------------------------------------------------------------------------------------------------------
            GROUP BY IP.CDIMPOSTO, TI.CDIMPOSTOIT;

            OPEN C_IMPOSNFTOT;

            FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                              @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                              @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
               VALUES (@P_FILIAL, @P_LANCTONF, @V_IMPOSNF_CDIMPOSTO, ISNULL(@V_IMPOSNF_VRIMPOSTOIT,0), ISNULL(@V_IMPOSNF_VRBASECALCIT,0));


               FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                                 @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                                 @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;
            END; /*WHILE DO CURSOR C_IMPOSNFTOT*/

            CLOSE C_IMPOSNFTOT;
            DEALLOCATE C_IMPOSNFTOT;

            DELETE TRABIMPOSNFTOT WHERE CDFILIMPTOT = @P_FILIAL AND NRLANCIMPTOT = @P_LANCTONF;

            INSERT INTO TRABIMPOSNFTOT(
               CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, VRBCALIMPTOT,
                       IDERROSTOT, IDAVISOSTOT)
               (SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                       IDERROSIMPTT, IDAVISIMPTT
                        FROM IMPOSNFTOT
                        WHERE CDFILIAL   = @P_FILIAL AND
                              NRLANCTONF = @P_LANCTONF);
         END;
      END;

      /* Altera CFOP e CST para as tabelas NOTAFISCAL e ITEMPRODUTO para nf's de devoluo e complemento */
      IF (@V_IDOPERDEVONF = 'S') OR (@P_TIPOOPER = '03') BEGIN

         DECLARE C_ITPROD CURSOR FOR (SELECT NRSEQITPROD
                                        FROM ITEMPRODUTO
                                       WHERE CDFILIAL = @P_FILIAL
                                         AND NRLANCTONF = @P_LANCTONF);

         OPEN C_ITPROD;
         FETCH NEXT FROM C_ITPROD INTO @V_ITPRODU_NRSEQITPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_CDSITUTRIBIT = '';
            SET @V_CDFISCOPERIT = '';
            SET @V_CDSUFXCFOPIT = '';

            SELECT @V_CDSITUTRIBIT = MAX(CDSTRIBIMPOIT),
                   @V_CDFISCOPERIT = MAX(CDFOPERIMPOIT),
                   @V_CDSUFXCFOPIT = MAX(CDSCFOPIMPOIT)
              FROM TRABITPROIMPOS
             WHERE CDFILIMPOIT = @P_FILIAL
               AND NRLANCIMPOIT = @P_LANCTONF
               AND NRSEQIMPOIT = @V_ITPRODU_NRSEQITPROD;

         UPDATE ITEMPRODUTO
            SET CDSITUTRIBPR = @V_CDSITUTRIBIT,
                CDFISOPEITEM = @V_CDFISCOPERIT,
                CDSUFXCFOPPR = @V_CDSUFXCFOPIT
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND NRSEQITPROD = @V_ITPRODU_NRSEQITPROD;

            FETCH NEXT FROM C_ITPROD INTO @V_ITPRODU_NRSEQITPROD;
         END;
         CLOSE C_ITPROD;
         DEALLOCATE C_ITPROD;
      END;



      SET @V_DIFERENCA = 0;
    /* RATEIO DOS ENCARGOS PARA OS PRODUTOS DA NOTA. ESTE RATEIO  NECESSRIO PARA A NOTA FISCAL ELETRNICA */
      DECLARE C_ITEMENCARGO CURSOR FOR (SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0)) VRITEMENCA
                                          FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                                              FROM ITEMPRODUTO
                                                                             WHERE CDFILIAL   = @P_FILIAL
                                                                               AND NRLANCTONF = @P_LANCTONF) I
                                         WHERE (IE.CDFILIAL   = @P_FILIAL)
                                           AND (IE.NRLANCTONF = @P_LANCTONF)
                                           AND (IE.VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0) > 0)
                                           AND (EN.CDENCARGO  = IE.CDENCARGO));
      OPEN C_ITEMENCARGO;
      FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENCARGO_CDENCARGONFE, @V_ITEMENCARGO_VRITEMENCA;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         /* ENCARGO FRETE */
         IF (@V_ITEMENCARGO_CDENCARGONFE = '01') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT NRSEQITPROD, VRTOTAITEM
                                                   FROM ITEMPRODUTO
                                                   WHERE CDFILIAL = @P_FILIAL
                                                     AND NRLANCTONF = @P_LANCTONF);
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_VRTOTAITEM = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRFRETEITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRFRETEITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VRFRETEITEM = SUM(VRFRETEITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VRFRETEITEM;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = VRFRETEITEM + @V_DIFERENCA
                   WHERE CDFILIAL = @P_FILIAL
                     AND NRLANCTONF = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRFRETEITEM = 0
                WHERE CDFILIAL  = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;

         /* ENCARGO SEGURO */
         IF (@V_ITEMENCARGO_CDENCARGONFE = '02') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT NRSEQITPROD, VRTOTAITEM
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF);

               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_VRTOTAITEM = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRSEGURITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRSEGURITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VRSEGURITEM = SUM(VRSEGURITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VRSEGURITEM;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = VRSEGURITEM + @V_DIFERENCA
                   WHERE CDFILIAL = @P_FILIAL
                     AND NRLANCTONF = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRSEGURITEM = 0
                WHERE CDFILIAL  = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;

         /* ENCARGO DESCONTO */
         IF (@V_ITEMENCARGO_CDENCARGONFE = '03') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT NRSEQITPROD, VRTOTAITEM
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF);
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_VRTOTAITEM = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRENCARGODESC = ROUND(VRDESCITEM + (@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100)), 2, 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRENCARGODESC = ROUND(VRDESCITEM + (@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100)), 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VRENCARGODESC = SUM(VRENCARGODESC)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SELECT @V_SUMVRDESCITEM = SUM(VRDESCITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL  = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = (@V_ITEMENCARGO_VRITEMENCA+@V_SUMVRDESCITEM) - @V_VRENCARGODESC;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = VRENCARGODESC + @V_DIFERENCA
                   WHERE CDFILIAL = @P_FILIAL
                     AND NRLANCTONF = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRENCARGODESC = VRDESCITEM + 0
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;

         /*ENCARGO OUTRAS DESPESAS*/
         IF (@V_ITEMENCARGO_CDENCARGONFE = '04') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR(SELECT NRSEQITPROD, VRTOTAITEM
                                                  FROM ITEMPRODUTO
                                                 WHERE CDFILIAL   = @P_FILIAL
                                                   AND NRLANCTONF = @P_LANCTONF)
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE(@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_VRTOTAITEM   = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM  = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL    = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF  = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VROUTRASDESPITEM = SUM(VROUTRASDESPITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;


               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VROUTRASDESPITEM;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VROUTRASDESPITEM = VROUTRASDESPITEM + @V_DIFERENCA
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL   = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL   = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END;
            ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VROUTRASDESPITEM = 0
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END
         END;

         /*ENCARGO DESPESAS ADUANEIRAS*/
         IF (@V_ITEMENCARGO_CDENCARGONFE = '05') BEGIN
            /*REFAZ O RATEIO DO ENCARGO VERIFICANDO A INCIDENCIA DO IMPOSTO DE IMPORTACAO*/
            UPDATE ITEMPRODUTO
               SET VRDESPADUANEIRA = 0
             WHERE CDFILIAL   = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT DISTINCT(I.NRSEQITPROD)
                                       FROM ITEMPROIMPOS I, IMPOSTO II
                                      WHERE I.NRLANCTONF    = @P_LANCTONF
                                        AND I.CDFILIAL      = @P_FILIAL
                                        AND I.CDIMPOSTO     = II.CDIMPOSTO
                                        AND II.CDIMPOSTONFE = '20')
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD;
               WHILE(@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_VRTOTAITEM   = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM  = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL   = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL    = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF  = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRDESPADUANEIRA = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRDESPADUANEIRA = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;

               /*AJUSTE DE VALORES*/
               SELECT @V_VRDESPADUANEIRA = SUM(VRDESPADUANEIRA)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VRDESPADUANEIRA;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = VRDESPADUANEIRA + @V_DIFERENCA
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(II.NRSEQITPROD)
                                          FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                         WHERE I.CDFILIAL     = @P_FILIAL
                                           AND I.NRLANCTONF   = @P_LANCTONF
                                           AND I.CDFILIAL     = II.CDFILIAL
                                           AND I.NRLANCTONF   = II.NRLANCTONF
                                           AND I.NRSEQITPROD  = II.NRSEQITPROD
                                           AND II.CDIMPOSTO   = S.CDIMPOSTO
                                           AND S.CDIMPOSTONFE = '20'
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                               FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                                              WHERE I.CDFILIAL     = @P_FILIAL
                                                                AND I.NRLANCTONF   = @P_LANCTONF
                                                                AND I.CDFILIAL     = II.CDFILIAL
                                                                AND I.NRLANCTONF   = II.NRLANCTONF
                                                                AND I.NRSEQITPROD  = II.NRSEQITPROD
                                                                AND II.CDIMPOSTO   = S.CDIMPOSTO
                                                                AND S.CDIMPOSTONFE = '20'));
               END;
            END
            ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRDESPADUANEIRA = 0
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;      
         FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENCARGO_CDENCARGONFE, @V_ITEMENCARGO_VRITEMENCA;
      END;
      CLOSE C_ITEMENCARGO;
      DEALLOCATE C_ITEMENCARGO;

   --CLCULO DO VALOR TOTAL DA NOTA FISCAL

      SET @V_TOTALNOTA = 0;

      SELECT @V_SOMAENCA = SUM(VRITEMENCA)
      FROM ITEMENCARGO IE, ENCARGO EN
      WHERE IE.CDFILIAL   = @P_FILIAL    AND
            IE.NRLANCTONF = @P_LANCTONF  AND
            IE.CDENCARGO  = EN.CDENCARGO AND
            IDENCARGO = 'A';

      SELECT @V_MENOENCA = SUM(VRITEMENCA)
      FROM ITEMENCARGO IE, ENCARGO EN
      WHERE IE.CDFILIAL   = @P_FILIAL    AND
            IE.NRLANCTONF = @P_LANCTONF  AND
            IE.CDENCARGO  = EN.CDENCARGO AND
            IDENCARGO = 'D';

      SELECT @V_SOMAIMPO = SUM(VRIMPOSTOT)
      FROM TRABIMPOSNFTOT T, IMPOSTO I
      WHERE CDFILIMPTOT  = @P_FILIAL   AND
            NRLANCIMPTOT = @P_LANCTONF AND
            T.CDIMPOSTOT = I.CDIMPOSTO AND
            IDTRATIMPO   = 'A'         AND
            ISNULL(IDACRPRODENTRNF, 'N') = 'N' AND
            NOT EXISTS(SELECT CDIMPOSTO
                       FROM IMPOSTO
                       WHERE IMPOSTO.CDIMPOSTRIB = T.CDIMPOSTOT);

      SELECT @V_MENOIMPO = SUM(VRIMPOSTOT)
      FROM TRABIMPOSNFTOT T, IMPOSTO I
      WHERE CDFILIMPTOT  = @P_FILIAL   AND
            NRLANCIMPTOT = @P_LANCTONF AND
            T.CDIMPOSTOT = I.CDIMPOSTO AND
            IDTRATIMPO   = 'D';

      IF NOT (@V_LIQUIDO IS NULL) BEGIN
         SET @V_TOTALNOTA = @V_LIQUIDO;
      END;

      IF NOT (@V_SOMAIMPO IS NULL) BEGIN
         SET @V_TOTALNOTA = @V_TOTALNOTA + ROUND(@V_SOMAIMPO, 2);
      END;

      IF NOT (@V_MENOIMPO IS NULL) BEGIN
         SET @V_TOTALNOTA = @V_TOTALNOTA - ROUND(@V_MENOIMPO, 2);
      END;

      IF NOT (@V_SOMAENCA IS NULL) BEGIN
         SET @V_TOTALNOTA = @V_TOTALNOTA + @V_SOMAENCA;
      END;

      IF NOT (@V_MENOENCA IS NULL) BEGIN
         SET @V_TOTALNOTA = @V_TOTALNOTA - @V_MENOENCA;
      END;

      --VALOR SUBSTITUIO TRIBUTRIA COM IDENTIFICAO PARA ACRESCER AO TOTAL DA NF
      SELECT @V_SOMAIMPO = ISNULL(SUM(ROUND(T.VRIMPOSIT, @V_NRDECITOTANF)),0)
      FROM TRABITPROIMPOS T, IMPOSTO I
      WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
            T.NRLANCIMPOIT = @P_LANCTONF AND
            ISNULL(T.IDTRIMPSTTI, '0')  = '0'         AND
            T.CDIMPOSTOIT    = I.CDIMPOSTO AND
            ISNULL(I.IDACRPRODENTRNF, 'N') = 'N' AND
            EXISTS(SELECT CDIMPOSTO
                   FROM IMPOSTO
                   WHERE CDIMPOSTRIB = T.CDIMPOSTOIT);

      IF NOT (@V_SOMAIMPO IS NULL) BEGIN
         SET @V_TOTALNOTA = @V_TOTALNOTA + ROUND(@V_SOMAIMPO, 2);
      END;

      IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN
   ---------------------------------------------------------------------------------------------------------
         IF ((@V_TOTALNOTA <> 0) AND (ISNULL(@V_LIQUIDO,0) = 0)) BEGIN
            SELECT @V_VRPRODUTOS = ISNULL(MAX(VRPRODUTOS),0)
            FROM NOTAFISCAL
            WHERE CDFILIAL = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END
         ELSE BEGIN
            SET @V_VRPRODUTOS = ISNULL(@V_LIQUIDO, 0);

            UPDATE NOTAFISCAL
            SET VRPRODUTOS = ISNULL(@V_LIQUIDO, 0)
            WHERE CDFILIAL = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END;
   ---------------------------------------------------------------------------------------------------------
      END
      ELSE BEGIN
         UPDATE NOTAFISCAL
         SET VRPRODUTOS = ISNULL(@V_TOTAPROD, 0)
         WHERE CDFILIAL = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;
      END;

      EXEC CONSULTA_DESONERACAO @P_FILIAL, @P_LANCTONF, @P_VRDESONERA = @V_IMPOSDESONERA OUTPUT;

      IF @V_IDIMPDESONERA = 'N' BEGIN
         SET @P_VRNOTAFISC = ROUND(@V_TOTALNOTA, 2);
         SET @V_TOTALNOTA  = ROUND(@V_TOTALNOTA, 2);
      END
      ELSE BEGIN
         SET @P_VRNOTAFISC = ROUND(@V_TOTALNOTA - @V_IMPOSDESONERA, 2);
         SET @V_TOTALNOTA  = ROUND(@V_TOTALNOTA - @V_IMPOSDESONERA, 2);
      END;
      
   ---------------------------------------------------------------------------------------------------------
      IF @P_TIPOOPER = '08' BEGIN
         UPDATE NOTAFISCAL
         SET VRNOTAFISC = ISNULL(@V_TOTALNOTA,0),
             VRPRODUTOS = ISNULL(@V_LIQUIDO,0),
             IDERROS    = '000'
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;
      END;
   ---------------------------------------------------------------------------------------------------------

      IF (@V_IDOPERDEVONF <> 'S') OR ((@V_IDOPERDEVONF = 'S') AND (@V_DEVOLORIG IS NULL)) BEGIN
         DECLARE C_VRIMPOSTO CURSOR FOR
         SELECT II.CDIMPOSTOIT, SUM(II.VRIMPOSIT) AS VRIMPOSIT
         FROM TRABITPROIMPOS II, IMPOSTO I
         WHERE II.CDIMPOSTOIT  = I.CDIMPOSTO AND
               II.CDFILIMPOIT  = @P_FILIAL   AND
               II.NRLANCIMPOIT = @P_LANCTONF AND
               II.NRSEQITPRO   = '1'         AND
               I.IDTRATIMPO  IN ('A', 'D')
         GROUP BY II.CDIMPOSTOIT;

         OPEN C_VRIMPOSTO;
         FETCH NEXT FROM C_VRIMPOSTO INTO @V_VRIMPOSTO_CDIMPOSTOIT, @V_VRIMPOSTO_VRIMPOSIT;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_VRTOTIMPONF = SUM(VRIMPOSTOT)
            FROM TRABIMPOSNFTOT
            WHERE CDFILIMPTOT  = @P_FILIAL   AND
                  NRLANCIMPTOT = @P_LANCTONF AND
                  CDIMPOSTOT   = @V_VRIMPOSTO_CDIMPOSTOIT;

            SET @V_VRDIFERENCA = @V_VRTOTIMPONF - @V_VRIMPOSTO_VRIMPOSIT;

            SELECT @V_VRBRUTO = SUM(I.VRBRUTITEM)
            FROM ITEMPRODUTO I, TRABITPROIMPOS II
            WHERE I.CDFILIAL      = @P_FILIAL     AND
                  I.NRLANCTONF    = @P_LANCTONF   AND
                  II.CDFILIMPOIT  = @P_FILIAL     AND
                  II.NRLANCIMPOIT = @P_LANCTONF   AND
                  II.NRSEQIMPOIT  = I.NRSEQITPROD AND
                  II.NRSEQITPRO   = '1'           AND
                  II.CDIMPOSTOIT  = @V_VRIMPOSTO_CDIMPOSTOIT;

            DECLARE C_ATUALIZA CURSOR FOR
            SELECT NRSEQIMPOIT
            FROM TRABITPROIMPOS
            WHERE CDFILIMPOIT  = @P_FILIAL   AND
                  NRLANCIMPOIT = @P_LANCTONF AND
                  CDIMPOSTOIT  = @V_VRIMPOSTO_CDIMPOSTOIT AND
                  NRSEQITPRO = '1'
            ORDER BY NRSEQIMPOIT;

            OPEN C_ATUALIZA;
            FETCH NEXT FROM C_ATUALIZA INTO @V_ATUALIZA_NRSEQIMPOIT;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF @V_VRBRUTO > 0 BEGIN
                  UPDATE ITEMPRODUTO
      ---------------------------------------------------------------------------------------------------------
                  SET VRBRUTITEM = VRBRUTITEM + ((VRBRUTITEM/@V_VRBRUTO) * ISNULL(@V_VRDIFERENCA,0))
      ---------------------------------------------------------------------------------------------------------
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ATUALIZA_NRSEQIMPOIT;
               END;
               FETCH NEXT FROM C_ATUALIZA INTO @V_ATUALIZA_NRSEQIMPOIT;
            END;
            CLOSE C_ATUALIZA;
            DEALLOCATE C_ATUALIZA;

            FETCH NEXT FROM C_VRIMPOSTO INTO @V_VRIMPOSTO_CDIMPOSTOIT, @V_VRIMPOSTO_VRIMPOSIT;
         END;
         CLOSE C_VRIMPOSTO;
         DEALLOCATE C_VRIMPOSTO;

         SELECT @V_VRBRUTO = SUM(VRBRUTITEM)
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;

         SELECT @V_VRNOTAFISC = MAX(VRNOTAFISC)
         FROM NOTAFISCAL
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;

         SET @V_VRDIFERENCA = @V_VRNOTAFISC - @V_VRBRUTO;

         IF (@V_VRDIFERENCA <> 0) AND (ABS(@V_VRDIFERENCA) <= 0.05) BEGIN
            SELECT @V_NRSEQITPROD = MAX(NRSEQITPROD)
            FROM ITEMPRODUTO
            WHERE CDFILIAL   = @P_FILIAL   AND
                  NRLANCTONF = @P_LANCTONF AND
                  VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                FROM ITEMPRODUTO
                                WHERE CDFILIAL = @P_FILIAL AND
                                      NRLANCTONF = @P_LANCTONF);

            UPDATE ITEMPRODUTO
            SET VRBRUTITEM = VRBRUTITEM + @V_VRDIFERENCA
            WHERE CDFILIAL    = @P_FILIAL   AND
                  NRLANCTONF  = @P_LANCTONF AND
                  NRSEQITPROD = @V_NRSEQITPROD;
         END;

         -- RECALCULO DO VALOR CONTABIL DO ITEM

         IF (@P_TIPOOPER <> '03') BEGIN

            UPDATE ITEMPRODUTO
               SET VRBRUTITEM = ROUND(VRBRUTITEM, 2)
             WHERE CDFILIAL   = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;

            SET @V_VRTOTBRUT = 0;
            SET @V_VRTOTANF  = 0;
            SET @V_DIFBRUTNF = 0;

            SELECT @V_VRTOTBRUT = SUM(VRBRUTITEM)
              FROM ITEMPRODUTO
             WHERE CDFILIAL   = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;

            IF @V_VRTOTBRUT IS NULL BEGIN
               SET @V_VRTOTBRUT = 0;
            END;


            IF @V_VRNOTAFISC = 0 BEGIN
               UPDATE NOTAFISCAL
                  SET VRNOTAFISC = ROUND(@V_TOTALNOTA, 2)
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               IF (@V_VRTOTBRUT <> ROUND(@V_TOTALNOTA, 2)) BEGIN
                  SET @V_DIFBRUTNF = ROUND(@V_TOTALNOTA, 2) - @V_VRTOTBRUT;

                  IF (ABS(@V_DIFBRUTNF) <= 0.2) BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = (VRBRUTITEM + (@V_DIFBRUTNF))
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                             FROM ITEMPRODUTO
                                            WHERE CDFILIAL   = @P_FILIAL
                                              AND NRLANCTONF = @P_LANCTONF
                                              AND VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                                                  FROM ITEMPRODUTO
                                                                 WHERE CDFILIAL   = @P_FILIAL
                                                                   AND NRLANCTONF = @P_LANCTONF));
                  END;
               END;
            END
            ELSE BEGIN
               UPDATE NOTAFISCAL
                  SET VRNOTAFISC = ROUND(VRNOTAFISC, 2)
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SELECT @V_VRTOTANF = ROUND(VRNOTAFISC, 2)
                 FROM NOTAFISCAL
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               IF (@V_VRTOTBRUT <> @V_VRTOTANF) BEGIN
                  SET @V_DIFBRUTNF = @V_VRTOTANF - @V_VRTOTBRUT;

                  IF (ABS(@V_DIFBRUTNF) <= 0.2) BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = (VRBRUTITEM + (@V_DIFBRUTNF))
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                             FROM ITEMPRODUTO
                                            WHERE CDFILIAL   = @P_FILIAL
                                              AND NRLANCTONF = @P_LANCTONF
                                              AND VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                                                  FROM ITEMPRODUTO
                                                                 WHERE CDFILIAL   = @P_FILIAL
                                                                   AND NRLANCTONF = @P_LANCTONF));
                  END;
               END;
            END;
         END;

         DECLARE C_ITEM CURSOR FOR SELECT ROUND(VRBRUTITEM, 2) AS VRBRUTITEM, NRSEQITPROD
                                   FROM ITEMPRODUTO I
                                   WHERE CDFILIAL    = @P_FILIAL   AND
                                         NRLANCTONF  = @P_LANCTONF;
         OPEN C_ITEM;
         FETCH NEXT FROM C_ITEM INTO @C_ITEM_VRBRUTITEM, @C_ITEM_NRSEQITPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT = ROUND(VRCONTIMPOIT,2)
            WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                  (NRLANCIMPOIT = @P_LANCTONF)   AND
                  (NRSEQIMPOIT  = @C_ITEM_NRSEQITPROD) AND
                  (NRSEQITPRO   = '2');

            SELECT @V_VRREDUCAO = MAX(ISNULL(VRCONTIMPOIT,0))
            FROM TRABITPROIMPOS
            WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                  (NRLANCIMPOIT = @P_LANCTONF)   AND
                  (NRSEQIMPOIT  = @C_ITEM_NRSEQITPROD) AND
                  (NRSEQITPRO   = '2');

            IF @V_VRREDUCAO IS NULL BEGIN
               SET @V_VRREDUCAO = 0;
            END;

            UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT  = ISNULL(ROUND((@C_ITEM_VRBRUTITEM - @V_VRREDUCAO),2),0)
            WHERE CDFILIMPOIT  = @P_FILIAL              AND
                  NRLANCIMPOIT = @P_LANCTONF            AND
                  NRSEQITPRO   = '1'                    AND
                  NRSEQIMPOIT  = @C_ITEM_NRSEQITPROD;

            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = ROUND((@C_ITEM_VRBRUTITEM - @V_VRREDUCAO),2)
            WHERE (NRLANCTONF   = @P_LANCTONF) AND
                  (CDFILIAL     = @P_FILIAL)   AND
                  (NRITPROIMPOS = '1')         AND
                  (NRSEQITPROD  = @C_ITEM_NRSEQITPROD);

            FETCH NEXT FROM C_ITEM INTO @C_ITEM_VRBRUTITEM, @C_ITEM_NRSEQITPROD;

         END;
         CLOSE C_ITEM;
         DEALLOCATE C_ITEM;
      END;

      ---------------------------------------------------------------------------------------------------------
      EXEC ARREDONDA_BASECALC 'E', @P_FILIAL, @P_LANCTONF;
      ---------------------------------------------------------------------------------------------------------

      IF @V_SEQUIMPOSTNF IS NULL BEGIN
         SET @V_SEQUIMPOSTNF = '01';
      END;

      IF @V_SEQUIMPOSTNF = '01' BEGIN
         DELETE FROM IMPOSTONF
         WHERE (CDFILIAL   = @P_FILIAL) AND
               (NRLANCTONF = @P_LANCTONF);
      END;

   ---------------------------------------------------------------------------------------------------------
      DECLARE C_IMPOSTONF CURSOR FOR
      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    <> '03')         AND
            ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3')) AND
            VRCONTIMPOIT > 0
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    <> '03')         AND
            (NRSEQITPRO   <> '3')        AND
            ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0))) AND
            VRCONTIMPOIT > 0
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION ALL


      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    = '03')         AND
            ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3'))
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    = '03')         AND
            (NRSEQITPRO   <> '3')        AND
            ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0)))
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT

      UNION ALL


      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N, TIPOOPERAC T
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)      AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)   AND
            (CDIMPOSTOIT  = I.CDIMPOSTO)       AND
            (N.CDTIPOOPER    = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP  = T.IDENTRSAIDOP) AND
            (T.IDNFAJUSTE    = 'S')            AND
            ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3'))
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N, TIPOOPERAC T
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP  = T.IDENTRSAIDOP) AND
            (T.IDNFAJUSTE    = 'S')            AND
            (NRSEQITPRO   <> '3')        AND
            ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0)))
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT

      OPEN C_IMPOSTONF;
      FETCH NEXT FROM C_IMPOSTONF INTO @V_IMPOSTON_CDIMPOSTOIT, @V_IMPOSTON_VRALIQIMPOIT,
                                       @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRPDEDIMPOIT,
                                       @V_IMPOSTON_CDFISCIMPOIT, @V_IMPOSTON_CDSTRIBIMPOIT,
                                       @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
                                       @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_VRCONTIMPOIT,
                                       @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRIMPOSIT,
                                       @V_IMPOSTON_IDTRATIMPO, @V_IMPOSTON_VRIMPOSCONT,
                                       @V_IMPOSTON_IDDIFALIQCUSPTI, @V_IMPOSTON_IDMOTDESOTRABIT;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT  @V_IDFORMAPUR = MAX(IDFORMAPUR)
         FROM IMPOSTO
         WHERE CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;

         SET @V_VRIMPOSCONT = 0;
         IF @V_IMPOSTON_IDTRATIMPO = 'A' BEGIN
            SET @V_VRIMPOSCONT = @V_IMPOSTON_VRIMPOSCONT;
         END
         ELSE IF @V_IMPOSTON_IDTRATIMPO = 'D' BEGIN
            SET @V_VRIMPOSCONT = - @V_IMPOSTON_VRIMPOSCONT;
         END;
   ---------------------------------------------------------------------------------------------------------

         IF @V_IDFORMAPUR = 'P' BEGIN
            INSERT INTO IMPOSTONF(
               CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
               VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
               IDIMPOSTONF, IDDIFALIQCUSPRN, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
            VALUES(
               @P_FILIAL, @P_LANCTONF, @V_IMPOSTON_CDIMPOSTOIT, @V_SEQUIMPOSTNF, ROUND(@V_IMPOSTON_VRCONTIMPOIT,2),
               @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRALIQIMPOIT,
               @V_IMPOSTON_VRPDEDIMPOIT, @V_IMPOSTON_VRIMPOSIT, @V_IMPOSTON_CDFISCIMPOIT,
               @V_IMPOSTON_CDSTRIBIMPOIT, @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
               @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_IDDIFALIQCUSPTI, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IMPOSTON_IDMOTDESOTRABIT);

            SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
         END
         ELSE BEGIN
            SET @V_CDGRUPOFISCAUX = NULL;

            SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
              FROM GRUPOFISCIMPFIL G,
                    (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                            ELSE CDFILIEMIT END AS CDFILIAL
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = @P_FILIAL
                       AND NRLANCTONF = @P_LANCTONF) F
             WHERE G.CDFILIAL = F.CDFILIAL
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;
            IF @V_IDORIGDESTNF = 'F' BEGIN
            SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
              FROM GRFISIMPIEFORN G,
                   (SELECT CDFORNECED
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = @P_FILIAL
                       AND NRLANCTONF = @P_LANCTONF) N
             WHERE G.CDFORNECED = N.CDFORNECED
               AND G.CDEMPRESA = @P_EMPRESA
               AND G.CDINSCESTA = @P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;
            END
            ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
               SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                FROM GRFISIMPIECLIE G,
                     (SELECT CDCLIENTE
                        FROM NOTAFISCAL
                       WHERE CDFILIAL = @P_FILIAL
                         AND NRLANCTONF = @P_LANCTONF) N
               WHERE G.CDCLIENTE = N.CDCLIENTE
                 AND G.CDEMPRESA = @P_EMPRESA
                 AND G.CDINSCESTA = @P_INSCESTA
                 AND NOT G.CDGRUPOFISC IS NULL
                 AND G.CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;
            END;

            IF @V_CDGRUPOFISCAUX IS NULL BEGIN
               EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_IMPOSTON_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                     @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
            END
            ELSE BEGIN
               EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_IMPOSTON_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                     @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
            END;

   ---------------------------------------------------------------------------------------------------------
            INSERT INTO IMPOSTONF(
               CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
               VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
               IDIMPOSTONF, IDDIFALIQCUSPRN, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
            VALUES(
               @P_FILIAL, @P_LANCTONF, @V_IMPOSTON_CDIMPOSTOIT, @V_SEQUIMPOSTNF, ROUND(@V_IMPOSTON_VRCONTIMPOIT,2),
               @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRALIQIMPOIT,
               @V_IMPOSTON_VRPDEDIMPOIT, @V_IMPOSTON_VRIMPOSIT, @V_IMPOSTON_CDFISCIMPOIT,
               @V_IMPOSTON_CDSTRIBIMPOIT, @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
               @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_IDDIFALIQCUSPTI, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IMPOSTON_IDMOTDESOTRABIT);
   ---------------------------------------------------------------------------------------------------------

            SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
         END;

         FETCH NEXT FROM C_IMPOSTONF INTO @V_IMPOSTON_CDIMPOSTOIT, @V_IMPOSTON_VRALIQIMPOIT,
                                          @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRPDEDIMPOIT,
                                          @V_IMPOSTON_CDFISCIMPOIT, @V_IMPOSTON_CDSTRIBIMPOIT,
                                          @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
                                          @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_VRCONTIMPOIT,
                                          @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRIMPOSIT,
                                          @V_IMPOSTON_IDTRATIMPO, @V_IMPOSTON_VRIMPOSCONT,
                                          @V_IMPOSTON_IDDIFALIQCUSPTI, @V_IMPOSTON_IDMOTDESOTRABIT;
      END; /* WHILE DO CURSOR C_IMPOSTONF*/

      CLOSE C_IMPOSTONF;
      DEALLOCATE C_IMPOSTONF;

      ---------------------------------------------------------------------------------------------------------
         DECLARE C_IMPOSTORETI CURSOR FOR SELECT N.CDEMPRESA, CDIMPOSTO, N.IDTPIJURNF, N.NRINSJURNF, N.DTENTRSAID
                                          FROM IMPOSTO I, NOTAFISCAL N
                                          WHERE IDTRATIMPO    = 'R'        AND
                                                IDUTVRMENSBC  = 'S'        AND
                                                N.CDFILIAL    = @P_FILIAL   AND
                                                N.NRLANCTONF  = @P_LANCTONF;

         OPEN C_IMPOSTORETI;
         FETCH NEXT FROM C_IMPOSTORETI INTO @V_IMPOSTORETI_CDEMPRESA, @V_IMPOSTORETI_CDIMPOSTO ,@V_IMPOSTORETI_IDTPIJURNF , @V_IMPOSTORETI_NRINSJURNF, @V_IMPOSTORETI_DTENTRSAID;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            EXEC BASECALC_RETIDO 'S', @P_FILIAL, @P_LANCTONF, @V_IMPOSTORETI_IDTPIJURNF, @V_IMPOSTORETI_NRINSJURNF,
                                      @V_IMPOSTORETI_DTENTRSAID, @V_IMPOSTORETI_CDIMPOSTO, 'E', @V_IMPOSTORETI_CDEMPRESA,
                                      @P_INSCESTA, @V_PAISORIG, @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_CDGRUPOFISC, @V_CDGRPFISCSV, @P_TIPOOPER;


            FETCH NEXT FROM C_IMPOSTORETI INTO @V_IMPOSTORETI_CDEMPRESA, @V_IMPOSTORETI_CDIMPOSTO ,@V_IMPOSTORETI_IDTPIJURNF , @V_IMPOSTORETI_NRINSJURNF, @V_IMPOSTORETI_DTENTRSAID;

         END;

         CLOSE C_IMPOSTORETI;
         DEALLOCATE C_IMPOSTORETI;

      /* SE O IPI COMPOR A BASE DE CALCULO DO ICMS E O ICMS TIVER O CODIGO FISCAL IGUAL A 1 SERA ATUALIZADO COM O IDENTIFICADOR 4 */
         DECLARE C_IMPFISC CURSOR FOR
            SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, CDSITUTRIBNF, CDFISCOPERNF, CDFISCALNF
              FROM IMPOSTONF IP
             WHERE IP.CDFILIAL = @P_FILIAL
               AND IP.NRLANCTONF = @P_LANCTONF
               AND IP.IDIMPOSTONF = '1'
               AND IP.CDFISCALNF = '1'

         OPEN C_IMPFISC;
         FETCH NEXT FROM C_IMPFISC INTO @V_IMPFISC_CDFILIAL ,@V_IMPFISC_NRLANCTONF , @V_IMPFISC_CDIMPOSTO,
                                        @V_IMPFISC_CDSITUTRIBNF, @V_IMPFISC_CDFISCOPERNF, @V_IMPFISC_CDFISCALNF;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_CDIMPOBCALC = MAX(BC.CDIMPOBCALC)
              FROM BASECALCTPOPER BC
             WHERE BC.IDENTRSAIDOP = @P_ENTRSAID
               AND BC.CDTIPOOPER = @P_TIPOOPER
               AND BC.CDIMPOSTO = @V_IMPFISC_CDIMPOSTO
               AND BC.CDIMPOBCALC IS NOT NULL
               AND ((SUBSTRING(@V_IMPFISC_CDSITUTRIBNF,2,2)  = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
               AND ((SUBSTRING(@V_IMPFISC_CDFISCOPERNF,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
               AND (@V_IMPFISC_CDFISCALNF = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL);

            IF @V_CDIMPOBCALC IS NULL BEGIN
               SELECT @V_CDIMPOBCALC = MAX(BC.CDIMPOBCALC)
                 FROM BASECALC BC
                WHERE BC.CDIMPOSTO = @V_IMPFISC_CDIMPOSTO
                  AND BC.CDIMPOBCALC IS NOT NULL
                  AND ((SUBSTRING(@V_IMPFISC_CDSITUTRIBNF,2,2)  = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL))
                  AND ((SUBSTRING(@V_IMPFISC_CDFISCOPERNF,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL))
                  AND (@V_IMPFISC_CDFISCALNF = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)
                  AND BC.IDTIPOBCALC = 'I';

               IF NOT @V_CDIMPOBCALC IS NULL BEGIN
                  UPDATE IMPOSTONF
                  SET IDIMPOSTONF = '4'
                  WHERE CDFILIAL   = @V_IMPFISC_CDFILIAL   AND
                        NRLANCTONF = @V_IMPFISC_NRLANCTONF AND
                        CDIMPOSTO  = @V_CDIMPOBCALC        AND
                        IDIMPOSTONF = '1';
               END;
            END
            ELSE BEGIN
               UPDATE IMPOSTONF
               SET IDIMPOSTONF = '4'
               WHERE CDFILIAL   = @V_IMPFISC_CDFILIAL   AND
                     NRLANCTONF = @V_IMPFISC_NRLANCTONF AND
                     CDIMPOSTO  = @V_CDIMPOBCALC        AND
                     IDIMPOSTONF = '1';
            END;

            FETCH NEXT FROM C_IMPFISC INTO @V_IMPFISC_CDFILIAL ,@V_IMPFISC_NRLANCTONF , @V_IMPFISC_CDIMPOSTO,
                                           @V_IMPFISC_CDSITUTRIBNF, @V_IMPFISC_CDFISCOPERNF, @V_IMPFISC_CDFISCALNF;
         END;

         CLOSE C_IMPFISC;
         DEALLOCATE C_IMPFISC;

      ---------------------------------------------------------------------------------------------------------

      --INCLUSO DOS ENCARGOS DA NF EM CASO DE IMPORTAO
         IF (@V_INTEGRACAO IS NOT NULL) BEGIN
            INSERT INTO ITEMENCARGO
            (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
            (SELECT @P_FILIAL, @P_LANCTONF, CDENCARGO, 0 AS VRITEMENCA
             FROM ENCARGO
             WHERE NOT EXISTS
             (SELECT CDFILIAL, NRLANCTONF, CDENCARGO, 0 AS VRITEMENCA
              FROM ITEMENCARGO
              WHERE CDFILIAL   = @P_FILIAL AND
                    NRLANCTONF = @P_LANCTONF AND
                    (ITEMENCARGO.CDENCARGO = ENCARGO.CDENCARGO)));
          END;

      --ATUALIZAO DO CDIGO FISCAL DA OPERAO NA TABELA DE NOTA FISCAL

         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN
            IF NOT(@P_TIPOOPER  = '09') BEGIN

               SELECT @V_CDCFOPINFUSU = MAX(CDCFOPINFUSU),
                      @V_DSCFOPINFUSU = MAX(DSCFOPINFUSU)
               FROM NOTAFISCAL
               WHERE CDFILIAL = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;

               IF (@V_CDCFOPINFUSU IS NULL) OR (@V_CDCFOPINFUSU = '***') BEGIN
                  SELECT @V_COUNT = COUNT(DISTINCT CDFISOPEITEM),
                         @V_CDFISOPENTF = MAX(CDFISOPEITEM)
                    FROM ITEMPRODUTO
                   WHERE (CDFILIAL   = @P_FILIAL) 
                     AND (NRLANCTONF = @P_LANCTONF);        

                  IF (@V_COUNT > 1) BEGIN
                     UPDATE NOTAFISCAL
                        SET CDFISOPENTF = '***'
                      WHERE CDFILIAL   = @P_FILIAL 
                        AND NRLANCTONF = @P_LANCTONF;
                  END
                  ELSE IF (@V_COUNT = 1) BEGIN    
                     UPDATE NOTAFISCAL
                        SET CDFISOPENTF = @V_CDFISOPENTF
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF;

                     UPDATE NOTAFISCAL
                        SET DSCDFISOPENF = @V_DSCDFISOPEIT
                      WHERE (CDFILIAL    = @P_FILIAL)
                        AND (NRLANCTONF  = @P_LANCTONF)
                        AND DSCDFISOPENF IS NULL;     
                  END;
               ELSE
                  SELECT @V_COUNT = COUNT(DISTINCT CDFISOPEITEM),
                         @V_CDFISOPENTF = MAX(CDFISOPEITEM)
                    FROM ITEMPRODUTO
                   WHERE (CDFILIAL   = @P_FILIAL)
                     AND (NRLANCTONF = @P_LANCTONF);

                  IF (@V_COUNT > 1) BEGIN
                     UPDATE NOTAFISCAL
                        SET CDFISOPENTF  = '***'
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF;
                  END
                  ELSE IF (@V_COUNT = 1) BEGIN
                        UPDATE NOTAFISCAL
                           SET CDFISOPENTF  = @V_CDFISOPENTF,
                               DSCDFISOPENF = @V_DSCDFISOPEIT
                         WHERE (CDFILIAL    = @P_FILIAL)
                           AND (NRLANCTONF  = @P_LANCTONF);
                  END;
               END;
            END;
         END;

      ---------------------------------------------------------------------------------------------------------
         IF (@V_INTEGRACAO IS NOT NULL) BEGIN
            IF (@P_ENTRSAID = 'S') BEGIN
               SELECT @V_VRCONTAREC = ISNULL(SUM(VRORIGREC),0)
               FROM CONTARECEBER
               WHERE CDFILIAL   = @P_FILIAL AND
                     NRLANCTONF = @P_LANCTONF;

               SELECT @V_IMPOSRETI = ISNULL(SUM(IT.VRIMPOSTOT),0)
               FROM TRABIMPOSNFTOT IT, IMPOSTO I
               WHERE I.CDIMPOSTO     = IT.CDIMPOSTOT AND
                     IT.CDFILIMPTOT  = @P_FILIAL      AND
                     IT.NRLANCIMPTOT = @P_LANCTONF    AND
                     I.IDDESCRFONTE  <> 'A'          AND
                     I.IDTRATIMPO    = 'R';

               IF (@V_VRCONTAREC = @V_VRNOTAFISC) AND (@V_IMPOSRETI > 0) BEGIN
                  EXEC APURAC_VENC @P_FILIAL, @P_FORNECED, @P_LANCTONF;
               END;
            END
            ELSE BEGIN
               IF (@V_IDDOCFINANC <> 'L') AND (@V_IDSTATUS NOT IN ('A', 'E')) AND
                  (SUBSTRING(@V_INTEGRACAO,1,1) IN ('F', 'M')) BEGIN
                  IF @V_IDORIGDESTNF = 'F' BEGIN
                     SELECT @V_IDTPFORPGTFO = MAX(IDTPFORPGTFO)
                     FROM FORNECEDOR
                     WHERE CDFORNECED = @P_FORNECED;

                     IF @V_IDTPFORPGTFO IS NOT NULL BEGIN
                        EXEC GERA_CONTAPAGAR @P_FILIAL, @P_FORNECED, @P_LANCTONF, 'F';
                     END;
                  END;
               END;
            END;
            
            SELECT @V_CDPRGENEREV = MAX(CDPRODUTO)
            FROM ITEMPRODUTO
            WHERE CDPRODUTO  = @V_CDPRGENEREV AND
                  CDFILIAL   = @P_FILIAL      AND
                  NRLANCTONF = @P_LANCTONF;

            IF @V_CDPRGENEREV IS NOT NULL BEGIN

               DELETE IMPOSINFUSU
               WHERE CDFILIAL   = @P_FILIAL AND
                     NRLANCTONF = @P_LANCTONF;

               INSERT INTO IMPOSINFUSU
                  (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO,
                   CDFISCINFUSU, VRALIQINFUSU, VRRDBCINFUSU, VRPDEDINFUSU)
               (SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT,
                       ISNULL(CDFISCIMPOIT,' '), ISNULL(VRALIQIMPOIT,0), VRREDBCIMPOIT,
                       VRPDEDIMPOIT
                FROM TRABITPROIMPOS
                WHERE CDFILIMPOIT  = @P_FILIAL AND
                      NRLANCIMPOIT = @P_LANCTONF AND
                      NRSEQITPRO   = '1');
            END;
         END;
      ---------------------------------------------------------------------------------------------------------

         /* ESTA ROTINA ABAIXO SERVE PARA ATUALIZAR O VALOR CONTBIL E BRUTO DOS PRODUTOS COM A DIFERENA
            DE CENTAVOS ENTRE O VALOR DOS IMPOSTOS POR TEM E A SUA RESPECTIVA TOTALIZAO. ESTA DIFERENA
             IGNORADA NO FECHAMENTO DA NF CASO O CLIENTE TRABALHE COM UM NMERO MENOR DE CASAS DECIMAIS E
            PROVOCA ERROS NA CONTABILIZAO*/

         IF @V_NRDECITOTANF <> 2 BEGIN
            DECLARE C_ATUAVRCONT CURSOR FOR
            SELECT T.CDIMPOSTOIT, SUM(T.VRIMPOSIT) AS VRIMPOSIT, T.CDFISCIMPOIT,
                   I.IDIMPORECUP, I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO
            FROM TRABITPROIMPOS T, IMPOSTO I
            WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                  T.NRLANCIMPOIT = @P_LANCTONF AND
                  T.NRSEQITPRO   = '1'         AND
                  T.CDIMPOSTOIT  = I.CDIMPOSTO AND
                  I.IDTIPCONTAB  = 'D'
            GROUP BY T.CDIMPOSTOIT, T.CDFISCIMPOIT, I.IDIMPORECUP,
                     I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO;

            OPEN C_ATUAVRCONT;
            FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_CDIMPOSTOIT, @V_ATUAVR_VRIMPOSIT,
                                              @V_ATUAVR_CDFISCIMPOIT, @V_ATUAVR_IDIMPORECUP,
                                              @V_ATUAVR_CDCCTBLATIV, @V_ATUAVR_CDCCTBLPASS,
                                              @V_ATUAVR_IDTRATIMPO;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_VRDIFERENCA = SUM(VRIMPOSTOT) - @V_ATUAVR_VRIMPOSIT
               FROM TRABIMPOSNFTOT
               WHERE CDFILIMPTOT  = @P_FILIAL   AND
                     NRLANCIMPTOT = @P_LANCTONF AND
                     CDIMPOSTOT   = @V_ATUAVR_CDIMPOSTOIT;

               SELECT @V_VRBRUTO = SUM(VRBRUTITEM), @V_VRCONTAB = SUM(VRCONTITEM)
               FROM ITEMPRODUTO I, TRABITPROIMPOS T
               WHERE T.CDFILIMPOIT  = I.CDFILIAL    AND
                     T.NRLANCIMPOIT = I.NRLANCTONF  AND
                     T.NRSEQIMPOIT  = I.NRSEQITPROD AND
                     T.CDFILIMPOIT  = @P_FILIAL     AND
                     T.NRLANCIMPOIT = @P_LANCTONF   AND
                     T.NRSEQITPRO   = '1'           AND
                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT;

               IF @V_VRDIFERENCA <> 0 BEGIN
                  SET @V_IMPOCONTAB = 0;

                  IF (@V_ATUAVR_IDIMPORECUP = 'S') BEGIN
                     IF (@V_ATUAVR_CDFISCIMPOIT = '1') BEGIN
                        IF (@V_ATUAVR_CDCCTBLATIV IS NOT NULL) BEGIN
                           IF @V_ATUAVR_IDTRATIMPO = 'V' BEGIN
                              SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                           END;
                        END;
                     END
                     ELSE BEGIN
                        IF @V_ATUAVR_IDTRATIMPO = 'A' BEGIN
                           SET @V_IMPOCONTAB = @V_VRDIFERENCA;
                        END
                        ELSE IF @V_ATUAVR_IDTRATIMPO IN ('D','R') BEGIN
                           SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF NOT(@V_ATUAVR_CDCCTBLPASS IS NULL) BEGIN
                        IF @V_ATUAVR_IDTRATIMPO = 'V' BEGIN
                           SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                        END;
                     END
                     ELSE BEGIN
                        IF @V_ATUAVR_IDTRATIMPO = 'A' BEGIN
                           SET @V_IMPOCONTAB = @V_VRDIFERENCA;
                        END
                        ELSE IF @V_ATUAVR_IDTRATIMPO IN ('D','R') BEGIN
                           SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                        END;
                     END;
                  END;

                  IF @V_ATUAVR_IDTRATIMPO = 'A' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = VRCONTITEM + ((@V_IMPOCONTAB  / @V_VRCONTAB) * VRCONTITEM)
                     WHERE CDFILIAL+NRLANCTONF+NRSEQITPROD IN (SELECT CDFILIMPOIT+NRLANCIMPOIT+NRSEQIMPOIT
                                                               FROM TRABITPROIMPOS T
                                                               WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                                                                     T.NRLANCIMPOIT = @P_LANCTONF AND
                                                                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT);
                  END
                  ELSE IF @V_ATUAVR_IDTRATIMPO = 'D' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = VRCONTITEM + ((@V_IMPOCONTAB  / @V_VRCONTAB) * VRCONTITEM)
                     WHERE CDFILIAL+NRLANCTONF+NRSEQITPROD IN (SELECT CDFILIMPOIT+NRLANCIMPOIT+NRSEQIMPOIT
                                                               FROM TRABITPROIMPOS T
                                                               WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                                                                     T.NRLANCIMPOIT = @P_LANCTONF AND
                                                                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT);
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = VRCONTITEM + ((@V_IMPOCONTAB  / @V_VRCONTAB) * VRCONTITEM)
                     WHERE CDFILIAL+NRLANCTONF+NRSEQITPROD IN (SELECT CDFILIMPOIT+NRLANCIMPOIT+NRSEQIMPOIT
                                                               FROM TRABITPROIMPOS T
                                                               WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                                                                     T.NRLANCIMPOIT = @P_LANCTONF AND
                                                                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT);

                  END;
               END;
               FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_CDIMPOSTOIT, @V_ATUAVR_VRIMPOSIT,
                                                 @V_ATUAVR_CDFISCIMPOIT, @V_ATUAVR_IDIMPORECUP,
                                                 @V_ATUAVR_CDCCTBLATIV, @V_ATUAVR_CDCCTBLPASS,
                                                 @V_ATUAVR_IDTRATIMPO;
            END;
            CLOSE C_ATUAVRCONT;
            DEALLOCATE C_ATUAVRCONT;
         END;

      IF NOT(@P_LANCESTQ IS NULL) AND (@V_IDCTRLESTQ <> 'N') BEGIN
   ---------------------------------------------------------------------------------------------------------
        IF (@V_IDOPERDEVONF = 'S') BEGIN
            IF (@V_DEVOLORIG IS NOT NULL) BEGIN

               SET @V_DTSAIDNFORIG = NULL;

               SELECT @V_IDSISTEMA = MAX(IDSISTEMA),
                      @V_DTSAIDNFORIG = MAX(DTENTRSAID)
               FROM NOTAFISCAL N, ITEMNOTAFISC I
               WHERE I.CDFILIAL     = @P_FILIAL   AND
                     I.NRLANCTONF   = @P_LANCTONF AND
                     I.CDFILIALIT   = N.CDFILIAL AND
                     I.NRLANCTONFIT = N.NRLANCTONF;
            END
            ELSE BEGIN
               SET @V_IDSISTEMA = 'EXP';
               SET @V_DTSAIDNFORIG = @V_DTATUAL;
            END;

            IF (@V_IDSISTEMA = 'EXP') BEGIN
               SELECT @V_IDRETPROEXP = MAX(ISNULL(IDRETPROEXP,1))
               FROM PAREXPEDICAO;
            END;
         END;
   ---------------------------------------------------------------------------------------------------------

         DELETE FROM ITLANCTOEST
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCESTQ = @P_LANCESTQ;

         IF (@V_IDSISTEMA <> 'VMN') BEGIN

            DELETE FROM LANCTOESTOQ
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCESTQ = @P_LANCESTQ;

            DELETE FROM LANCTOESTOQ
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END
         ELSE BEGIN
            UPDATE LANCTOESTOQ
            SET DTLANCESTQ   = @P_INIVALID
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCESTQ = @P_LANCESTQ;
         END;

         IF @P_ENTRSAID = 'S' BEGIN
            IF (@P_TIPOOPER = '06') BEGIN
               SET @V_TIPOMOVI = '5';
            END
            ELSE BEGIN
               SET @V_TIPOMOVI = '4';
            END;
         END
         ELSE BEGIN
            SET @V_TIPOMOVI = '2';
         END;

         SELECT @V_NMTIPOOPER = T.NMTIPOOPER, @V_NMFILIEMIT = F.NMFILIAL
         FROM
            NOTAFISCAL N LEFT JOIN FILIAL F ON
            (N.CDFILIEMIT = F.CDFILIAL),
            TIPOOPERAC T
         WHERE
            (N.CDFILIAL     = @P_FILIAL)      AND
            (N.NRLANCTONF   = @P_LANCTONF)    AND
            (N.CDTIPOOPER   = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP = T.IDENTRSAIDOP)

         IF @V_IDORIGDESTNF = 'L' BEGIN
            SET @V_DESCLANC = 'NF: '+@P_LANCTONF+' - '+SUBSTRING(@V_NMTIPOOPER,1,25)+' - '+SUBSTRING(@V_NMFILIEMIT,1,15);
         END
         ELSE BEGIN
            SET @V_DESCLANC = 'LANC. ORIGEM: '+@V_NRINSJURNF+' N'+@V_NRNOTAFISC+' SERIE '+@V_SERIE;
         END;

   ---------------------------------------------------------------------------------------------------------
         SELECT @V_COUNT = COUNT(*)
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCESTQ = @P_LANCESTQ;

         IF @V_COUNT = 0 BEGIN
            INSERT INTO LANCTOESTOQ(CDFILIAL,NRLANCESTQ,NRLANCTONF,DSLANCESTQ,IDTPLANCTO,DTLANCESTQ,CDOPERADOR,CDFILIMOVI)
                             VALUES(@P_FILIAL, @P_LANCESTQ, @P_LANCTONF, @V_DESCLANC, @P_ENTRSAID, @P_INIVALID,@P_CDOPERADOR, @V_CDFILIRECE);
         END;
   ---------------------------------------------------------------------------------------------------------

         IF (@V_IDSISTEMA = 'PDV') BEGIN
            SELECT @V_IDATUEST = ISNULL(MAX(IDATUEST),1)
            FROM PARAVEND
            WHERE CDFILIAL = @P_FILIAL;
         END;

         IF ((@V_IDSISTEMA = 'EXP') AND (@V_IDRETPROEXP = '2')) OR ((@V_IDSISTEMA = 'PDV') AND (@V_IDATUEST = '1')) BEGIN
            DECLARE C_ITLANCTOEST CURSOR FOR
            SELECT NRSEQITPROD, IP.CDPRODUTO,  VRUNITITEM,
                   VRTOTAITEM,  QTITEMPROD,    CDPRODESTO,
                   VRBRUTITEM,  VRDESCITEM,    VRCONTITEM,
                   ISNULL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE,
                   ISNULL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                   ISNULL(NRLOTEESTQ, ' ') NRLOTEESTQ,
                   ISNULL(NRSUBLOTE, ' ') NRSUBLOTE, CDFILIMOVI,
                   CDFISOPEITEM,
                   ISNULL(IDORIGEMPROD, 'N') AS IDORIGEMPROD
            FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
            WHERE IP.CDFILIAL    = @P_FILIAL     AND
                  IP.NRLANCTONF  = @P_LANCTONF   AND
                  P.CDPRODUTO    = IP.CDPRODUTO  AND
                  PF.CDFILIAL    = @V_CDFILIRECE AND
                  PF.CDPRODUTO   = P.CDPRODESTO  AND
                  ISNULL(IDCNTRESTOQ, 'S') <> 'N';

            OPEN C_ITLANCTOEST;
            FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,   @V_ITLANC_CDPRODUTO,
                                               @V_ITLANC_VRUNITITEM,    @V_ITLANC_VRTOTAITEM,
                                               @V_ITLANC_QTITEMPROD,    @V_ITLANC_CDPRODESTO,
                                               @V_ITLANC_VRBRUTITEM,    @V_ITLANC_VRDESCITEM,
                                               @V_ITLANC_VRCONTITEM,    @V_ITLANC_CDALMOXARIFE,
                                               @V_ITLANC_CDLOCALESTOQ,  @V_ITLANC_NRLOTEESTQ,
                                               @V_ITLANC_NRSUBLOTE,     @V_ITLANC_CDFILIMOVI,
                                               @V_ITLANC_CDFISOPEITEM,  @V_ITLANC_IDORIGEMPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO LOTE
               (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
               (SELECT @V_ITLANC_CDFILIMOVI,  @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE,
                       @V_ITLANC_CDPRODESTO, 'L' , GETDATE()
                FROM PARAMGERAL
                WHERE
                NOT EXISTS
                (SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
                       @V_ITLANC_CDPRODESTO, 'L', GETDATE()
                 FROM LOTE
                 WHERE  @V_ITLANC_CDFILIMOVI  =  CDFILIAL     AND
                        @V_ITLANC_NRLOTEESTQ  =  NRLOTEESTQ   AND
                        @V_ITLANC_NRSUBLOTE   =  NRSUBLOTE    AND
                        @V_ITLANC_CDPRODESTO  =  CDPRODUTO));

               UPDATE ITEMPRODUTO
               SET CDPRODMOVI = @V_ITLANC_CDPRODESTO
               WHERE (CDFILIAL    = @P_FILIAL)    AND
                     (NRLANCTONF  = @P_LANCTONF ) AND
                     (NRSEQITPROD = @V_ITLANC_NRSEQITPROD);

               SELECT @V_EXISTE_ROT = COUNT(*)
               FROM ROTFABRICA
               WHERE CDPRODUTO = @V_ITLANC_CDPRODUTO;

               IF (@V_EXISTE_ROT) > 0 BEGIN

                  EXEC INSERE_SUBPRODMAN @P_FILIAL, @P_LANCESTQ, @P_TIPOOPER, @V_ITLANC_CDPRODUTO,
                                         @V_ITLANC_QTITEMPROD, @V_ITLANC_VRTOTAITEM, @V_ITLANC_VRDESCITEM,
                                         @V_ITLANC_VRBRUTITEM, @V_ITLANC_VRCONTITEM,
                                         @V_VRTOTALANCTO, @V_QTDELANCTO, @V_TIPOMOVI, @P_INIVALID,
                                         @V_ITLANC_CDPRODESTO, '','','F';

               END
               ELSE BEGIN
                  SELECT @V_FATOCONV = MAX(VRFATOCONV)
                  FROM PRODUTO P, ITEMPRODUTO IP
                  WHERE P.CDPRODUTO    = IP.CDPRODUTO AND
                        IP.CDFILIAL    = @P_FILIAL     AND
                        IP.NRLANCTONF  = @P_LANCTONF   AND
                        IP.NRSEQITPROD = @V_ITLANC_NRSEQITPROD;

                  IF (@V_FATOCONV IS NULL) OR (@V_FATOCONV = 0) BEGIN
                     SET @V_FATOCONV = 1;
                  END;

                  SET @V_QTDELANCTO   = @V_ITLANC_QTITEMPROD;
                  SET @V_VRTOTALANCTO = (@V_ITLANC_VRTOTAITEM - @V_ITLANC_VRDESCITEM);

                  IF NOT(@V_QTDELANCTO = 0) BEGIN
                     SET @V_VRUNITLANCTO = @V_VRTOTALANCTO/@V_QTDELANCTO;
                  END ELSE BEGIN
                     SET @V_VRUNITLANCTO = @V_VRTOTALANCTO;
                  END;

                  IF (@P_TIPOOPER = '06') BEGIN
                     SET @V_TOTABRUT   = 0;
                     SET @V_TOTACONTAB = 0;
                     SET @V_VRCUSTENTR = 0;
                  END
                  ELSE BEGIN
                     IF NOT(@V_QTDELANCTO = 0) BEGIN
                        SET @V_TOTABRUT   = (@V_ITLANC_VRBRUTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                        SET @V_TOTACONTAB = (@V_ITLANC_VRCONTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                     END ELSE BEGIN
                        SET @V_TOTABRUT   = @V_ITLANC_VRBRUTITEM/@V_FATOCONV;
                        SET @V_TOTACONTAB = @V_ITLANC_VRCONTITEM/@V_FATOCONV;
                     END;
                     SET @V_VRCUSTENTR = @V_ITLANC_VRCONTITEM;
                  END;

                  IF (@V_IDOPERDEVONF = 'S' AND @V_IDUTCUSORIGEST = 'S') BEGIN
                     SELECT @V_VRCUSTENTR = ROUND(TEKNISA.CUSTO_PRODUTO_LCEST (@V_CDFILIRECE, @V_ITLANC_CDPRODESTO, @V_CDTIPCUSTEST, @P_INIVALID,
                                                                               @V_DTATUAL, @V_ITLANC_CDALMOXARIFE, @V_ITLANC_CDLOCALESTOQ,
                                                                               @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE), 5)
                       FROM PARAMGERAL;

                     IF @V_VRCUSTENTR = 0 BEGIN
                        SET @V_TOTABRUT   = @V_ITLANC_VRUNITITEM;
                        SET @V_TOTACONTAB = @V_ITLANC_VRUNITITEM;
                     END
                     ELSE BEGIN
                        SET @V_TOTABRUT   = @V_VRCUSTENTR;
                        SET @V_TOTACONTAB = @V_VRCUSTENTR;
                     END;
                  END;

                  SELECT @V_NRSEQITPROD = ISNULL(MAX(NRSEQUITEM),0) + 1
                  FROM ITLANCTOEST
                  WHERE CDFILIAL   = @P_FILIAL AND
                        NRLANCESTQ = @P_LANCESTQ;

                  SELECT @V_VRPESOBRUTPR = ISNULL(MAX(A.VRPESOBRUTPR),0),
                         @V_VRPECUSTOLOG = ISNULL(MAX(VRPECUSTOLOG),0),
                         @V_VRVRCUSTOLOG = ISNULL(MAX(VRVRCUSTOLOG),0),
                         @V_VRPESEGURLOG = ISNULL(MAX(VRPESEGURLOG),0)
                  FROM PRODUTO P, CUSTOLOGIST C, PRODUTO A
                  WHERE
                     (CHARINDEX(P.CDARVPROD, A.CDARVPROD) = 1)     AND
                     A.CDPRODUTO    = @V_ITLANC_CDPRODUTO          AND
                     P.CDPRODUTO    = C.CDPRODUTO                  AND
                     C.CDFILIAL     = @V_CDFILIRECE                AND
                     C.CDFORNECED   = @P_FORNECED                  AND
                     C.DTINIVIGCLOG = (SELECT MAX(DTINIVIGCLOG)
                                       FROM CUSTOLOGIST A, PRODUTO B, PRODUTO Q
                                       WHERE
                                          A.CDFILIAL     = C.CDFILIAL    AND
                                          A.CDFORNECED   = C.CDFORNECED  AND
                                          (CHARINDEX(Q.CDARVPROD, B.CDARVPROD) = 1)    AND
                                          B.CDPRODUTO    = @V_ITLANC_CDPRODUTO         AND
                                          Q.CDPRODUTO    = A.CDPRODUTO                 AND
                                          A.DTINIVIGCLOG <= @P_INIVALID);

                  IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_ITLANC_QTITEMPROD * @V_VRPESOBRUTPR)* @V_VRVRCUSTOLOG;
                  END;

                  IF (@V_VRPECUSTOLOG > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_ITLANC_VRTOTAITEM * @V_VRPECUSTOLOG)/100;
                  END;

                  IF (@V_VRPESEGURLOG > 0) BEGIN
                     SET @V_VRCUSTOSEG = (@V_ITLANC_VRTOTAITEM * @V_VRPESEGURLOG)/100;
                  END;

                  INSERT INTO ITLANCTOEST
                     (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                      IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT,VRLANCTOEST,
                      VRCUSTENTR,CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE,NRLANCORIGRP,
                      VRCUSTLOGLAN, VRSEGULOGLAN, IDORIGEMPROD)
                  VALUES
                     (@P_FILIAL, @P_LANCESTQ,
                      (RIGHT('0000',4 - DATALENGTH(CONVERT(VARCHAR,@V_NRSEQITPROD))) + CONVERT(VARCHAR,@V_NRSEQITPROD)),
                      @V_ITLANC_CDPRODUTO, @V_QTDELANCTO, @V_VRUNITLANCTO, @V_VRTOTALANCTO,
                      @V_TIPOMOVI, @P_INIVALID,'2', @V_ITLANC_CDPRODESTO,
                     (@V_QTDELANCTO * @V_FATOCONV), @V_TOTABRUT, @V_TOTACONTAB, @V_VRCUSTENTR,
                     @V_CDFILIRECE, @V_ITLANC_CDALMOXARIFE, @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                     @V_ITLANC_NRSUBLOTE, @V_IDDOCREPLIC, @V_VRCUSTOLOG, @V_VRCUSTOSEG, @V_ITLANC_IDORIGEMPROD);
               END;
               FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,  @V_ITLANC_CDPRODUTO,
                                                  @V_ITLANC_VRUNITITEM,   @V_ITLANC_VRTOTAITEM,
                                                  @V_ITLANC_QTITEMPROD,   @V_ITLANC_CDPRODESTO,
                                                  @V_ITLANC_VRBRUTITEM,   @V_ITLANC_VRDESCITEM,
                                                  @V_ITLANC_VRCONTITEM,   @V_ITLANC_CDALMOXARIFE,
                                                  @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                                                  @V_ITLANC_NRSUBLOTE,    @V_ITLANC_CDFILIMOVI,
                                                  @V_ITLANC_CDFISOPEITEM, @V_ITLANC_IDORIGEMPROD;
            END;
            CLOSE C_ITLANCTOEST;
            DEALLOCATE C_ITLANCTOEST;
         END ELSE BEGIN
            DECLARE C_ITLANCTOEST CURSOR FOR
            SELECT NRSEQITPROD, IP.CDPRODUTO,  VRUNITITEM,
                   VRTOTAITEM,  QTITEMPROD,    CDPRODESTO,
                   VRBRUTITEM,  VRDESCITEM,    VRCONTITEM,
                   ISNULL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE,
                   ISNULL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                   ISNULL(NRLOTEESTQ, ' ') NRLOTEESTQ,
                   ISNULL(NRSUBLOTE, ' ') NRSUBLOTE, CDFILIMOVI,
                   CDFISOPEITEM, ISNULL(IDORIGEMPROD, 'N') AS IDORIGEMPROD
            FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
            WHERE IP.CDFILIAL    = @P_FILIAL     AND
                  IP.NRLANCTONF  = @P_LANCTONF   AND
                  P.CDPRODUTO    = IP.CDPRODUTO  AND
                  PF.CDFILIAL    = @V_CDFILIRECE AND
                  PF.CDPRODUTO   = P.CDPRODESTO  AND
                  ISNULL(IDCNTRESTOQ, 'S') <> 'N';

            OPEN C_ITLANCTOEST;
            FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,  @V_ITLANC_CDPRODUTO,
                                               @V_ITLANC_VRUNITITEM,   @V_ITLANC_VRTOTAITEM,
                                               @V_ITLANC_QTITEMPROD,   @V_ITLANC_CDPRODESTO,
                                               @V_ITLANC_VRBRUTITEM,   @V_ITLANC_VRDESCITEM,
                                               @V_ITLANC_VRCONTITEM,   @V_ITLANC_CDALMOXARIFE,
                                               @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                                               @V_ITLANC_NRSUBLOTE,    @V_ITLANC_CDFILIMOVI,
                                               @V_ITLANC_CDFISOPEITEM, @V_ITLANC_IDORIGEMPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               --Alterao para verificar se o CFOP atualiza estoque

               SET @V_ATUPORCFOP = 'S';
               SET @V_CFOPTPOPER = 0;
               SET @V_CFOPATUEST = 0;

               SELECT @V_CFOPTPOPER = COUNT(CDFISCOPER)
                 FROM TPOPERCFOP
                WHERE IDENTRSAIDOP = 'E'
                  AND CDTIPOOPER   = @P_TIPOOPER
                  AND CDFISCOPER   = @V_ITLANC_CDFISOPEITEM;

               IF(@V_CFOPTPOPER > 0) BEGIN

                  SELECT @V_CFOPATUEST = COUNT(CDFISCOPER)
                    FROM(SELECT CDFISCOPER
                           FROM TPOPERCFOP T
                          WHERE T.IDENTRSAIDOP   = 'E'
                            AND T.CDTIPOOPER     = @P_TIPOOPER
                            AND T.IDATUESTTPCFOP = 'S'
                            AND T.CDFISCOPER     = @V_ITLANC_CDFISOPEITEM
                            AND @V_ITLANC_CDPRODUTO NOT IN     (SELECT CDPRODUTO
                                                                  FROM TPOPERCFOPEXCP TE
                                                                 WHERE TE.IDENTRSAIDOP = 'E'
                                                                   AND TE.CDTIPOOPER   = @P_TIPOOPER
                                                                   AND TE.CDFISCOPER   = @V_ITLANC_CDFISOPEITEM
                                                                   AND TE.CDPRODUTO    = @V_ITLANC_CDPRODUTO)

                          UNION ALL
                         SELECT CDFISCOPER
                           FROM TPOPERCFOP T
                          WHERE T.IDENTRSAIDOP   = 'E'
                            AND T.CDTIPOOPER     = @P_TIPOOPER
                            AND T.IDATUESTTPCFOP = 'N'
                            AND T.CDFISCOPER     = @V_ITLANC_CDFISOPEITEM
                            AND @V_ITLANC_CDPRODUTO     IN (SELECT CDPRODUTO
                                                              FROM TPOPERCFOPEXCP TE
                                                             WHERE TE.IDENTRSAIDOP = 'E'
                                                               AND TE.CDTIPOOPER   = @P_TIPOOPER
                                                               AND TE.CDFISCOPER   = @V_ITLANC_CDFISOPEITEM
                                                               AND TE.CDPRODUTO    = @V_ITLANC_CDPRODUTO)) TP;

                  IF NOT (@V_CFOPATUEST > 0) BEGIN
                     SET @V_ATUPORCFOP = 'N';
                  END;
               END;
               --Alterao para verificar se o CFOP atualiza estoque

               IF (@V_ATUPORCFOP = 'S') BEGIN

                  INSERT INTO LOTE
                  (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
                  (SELECT @V_ITLANC_CDFILIMOVI,  @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE,
                          @V_ITLANC_CDPRODESTO, 'L' , GETDATE()
                   FROM PARAMGERAL
                   WHERE
                   NOT EXISTS
                   (SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
                          @V_ITLANC_CDPRODESTO, 'L', GETDATE()
                    FROM LOTE
                    WHERE  @V_ITLANC_CDFILIMOVI  =  CDFILIAL     AND
                           @V_ITLANC_NRLOTEESTQ  =  NRLOTEESTQ   AND
                           @V_ITLANC_NRSUBLOTE   =  NRSUBLOTE    AND
                           @V_ITLANC_CDPRODESTO  =  CDPRODUTO));

                  UPDATE ITEMPRODUTO
                  SET CDPRODMOVI = @V_ITLANC_CDPRODESTO
                  WHERE (CDFILIAL    = @P_FILIAL)    AND
                        (NRLANCTONF  = @P_LANCTONF ) AND
                        (NRSEQITPROD = @V_ITLANC_NRSEQITPROD);

                  SELECT @V_FATOCONV = MAX(VRFATOCONV)
                  FROM PRODUTO P, ITEMPRODUTO IP
                  WHERE P.CDPRODUTO    = IP.CDPRODUTO AND
                        IP.CDFILIAL    = @P_FILIAL     AND
                        IP.NRLANCTONF  = @P_LANCTONF   AND
                        IP.NRSEQITPROD = @V_ITLANC_NRSEQITPROD;

                  IF (@V_FATOCONV IS NULL) OR (@V_FATOCONV = 0) BEGIN
                     SET @V_FATOCONV = 1;
                  END;

                  SET @V_QTDELANCTO   = @V_ITLANC_QTITEMPROD;
                  SET @V_VRTOTALANCTO = (@V_ITLANC_VRTOTAITEM - @V_ITLANC_VRDESCITEM);


                  --SE A NOTA FISCAL  RETORNO DE INDUSTRIALIZAO O CUSTO DO ITEM QUE ATUALIZA ESTOQUE  A SOMA DE TODOS OS OUTROS ITENS

                  SET @V_IDNFRETIND   = 'N';
                  SELECT @V_IDNFRETIND = ISNULL(IDNFRETIND, 'N')
                    FROM TIPOOPERAC
                   WHERE CDTIPOOPER   = @P_TIPOOPER
                     AND IDENTRSAIDOP = 'E';


                  IF (@V_IDNFRETIND = 'S') AND (@V_QTDELANCTO > 0) BEGIN

                     SELECT @V_VRTOTALANCTO = (SUM(VRTOTAITEM) - SUM(VRDESCITEM)),
                            @V_TOTABRUT     = ((SUM(VRBRUTITEM)/@V_QTDELANCTO)/@V_FATOCONV),
                            @V_TOTACONTAB   = (((SUM(VRCONTITEM))/@V_QTDELANCTO)/@V_FATOCONV)
                       FROM ITEMPRODUTO
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF;

                  END;
                  --SE A NOTA FISCAL  RETORNO DE INDUSTRIALIZAO O CUSTO DO ITEM QUE ATUALIZA ESTOQUE  A SOMA DE TODOS OS OUTROS ITENS


                  IF NOT(@V_QTDELANCTO = 0) BEGIN
                     SET @V_VRUNITLANCTO = @V_VRTOTALANCTO/@V_QTDELANCTO;
                  END
                  ELSE BEGIN
                     SET @V_VRUNITLANCTO = @V_VRTOTALANCTO;
                  END;

                  IF (@P_TIPOOPER = '06') BEGIN
                     SET @V_TOTABRUT   = 0;
                     SET @V_TOTACONTAB = 0;
                     SET @V_VRCUSTPROD = 0;
                  END
                  ELSE IF (@V_IDCOMPRABONI = 'S') BEGIN

                     SELECT @V_COMPCUSTPROD = ISNULL(MAX(IDCOMPOEVENC),'S')
                       FROM TPOPERCFOP
                      WHERE CDTIPOOPER   = @P_TIPOOPER
                        AND IDENTRSAIDOP = @P_ENTRSAID
                        AND CDFISCOPER   = @V_ITLANC_CDFISOPEITEM;

                     IF (@V_COMPCUSTPROD = 'N') BEGIN
                        SET @V_TOTABRUT   = 0;
                        SET @V_TOTACONTAB = 0;
                        SET @V_VRCUSTPROD = 0;
                     END
                     ELSE BEGIN
                        IF NOT(@V_IDNFRETIND = 'S') BEGIN
                           IF NOT(@V_QTDELANCTO = 0) BEGIN
                              SET @V_TOTABRUT   = (@V_ITLANC_VRBRUTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                              SET @V_TOTACONTAB = (@V_ITLANC_VRCONTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                           END
                           ELSE BEGIN
                              SET @V_TOTABRUT   = @V_ITLANC_VRBRUTITEM;
                              SET @V_TOTACONTAB = @V_ITLANC_VRCONTITEM;
                           END;
                           SET @V_VRCUSTENTR = @V_ITLANC_VRCONTITEM;
                        END
                        ELSE BEGIN
                           SET @V_VRCUSTENTR = @V_TOTACONTAB;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF NOT(@V_IDNFRETIND = 'S') BEGIN
                        IF NOT(@V_QTDELANCTO = 0) BEGIN
                           SET @V_TOTABRUT   = (@V_ITLANC_VRBRUTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                           SET @V_TOTACONTAB = (@V_ITLANC_VRCONTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                        END
                        ELSE BEGIN
                           SET @V_TOTABRUT   = @V_ITLANC_VRBRUTITEM;
                           SET @V_TOTACONTAB = @V_ITLANC_VRCONTITEM;
                        END;
                        SET @V_VRCUSTENTR = @V_ITLANC_VRCONTITEM;
                     END
                     ELSE BEGIN
                        SET @V_VRCUSTENTR = @V_TOTACONTAB;
                     END;
                  END;

                  IF (@V_IDOPERDEVONF = 'S' AND @V_IDUTCUSORIGEST = 'S') BEGIN
                     SELECT @V_VRCUSTENTR = ROUND(TEKNISA.CUSTO_PRODUTO_LCEST (@V_CDFILIRECE, @V_ITLANC_CDPRODESTO, @V_CDTIPCUSTEST, @V_DTSAIDNFORIG,
                                                                               @V_DTATUAL, @V_ITLANC_CDALMOXARIFE, @V_ITLANC_CDLOCALESTOQ,
                                                                               @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE), 5)
                       FROM PARAMGERAL;

                     IF @V_VRCUSTENTR = 0 BEGIN
                        SET @V_TOTABRUT   = @V_ITLANC_VRUNITITEM;
                        SET @V_TOTACONTAB = @V_ITLANC_VRUNITITEM;
                     END
                     ELSE BEGIN
                        SET @V_TOTABRUT   = @V_VRCUSTENTR;
                        SET @V_TOTACONTAB = @V_VRCUSTENTR;
                     END;
                  END;

                  SELECT @V_VRPESOBRUTPR = ISNULL(MAX(A.VRPESOBRUTPR),0),
                         @V_VRPECUSTOLOG = ISNULL(MAX(VRPECUSTOLOG),0),
                         @V_VRVRCUSTOLOG = ISNULL(MAX(VRVRCUSTOLOG),0),
                         @V_VRPESEGURLOG = ISNULL(MAX(VRPESEGURLOG),0)
                  FROM PRODUTO P, CUSTOLOGIST C, PRODUTO A
                  WHERE
                     (CHARINDEX(P.CDARVPROD, A.CDARVPROD) = 1)     AND
                     A.CDPRODUTO    = @V_ITLANC_CDPRODUTO          AND
                     P.CDPRODUTO    = C.CDPRODUTO                  AND
                     C.CDFILIAL     = @V_CDFILIRECE                AND
                     C.CDFORNECED   = @P_FORNECED                  AND
                     C.DTINIVIGCLOG = (SELECT MAX(DTINIVIGCLOG)
                                       FROM CUSTOLOGIST A, PRODUTO B, PRODUTO Q
                                       WHERE
                                          A.CDFILIAL     = C.CDFILIAL    AND
                                          A.CDFORNECED   = C.CDFORNECED  AND
                                          (CHARINDEX(Q.CDARVPROD, B.CDARVPROD) = 1)    AND
                                          B.CDPRODUTO    = @V_ITLANC_CDPRODUTO         AND
                                          Q.CDPRODUTO    = A.CDPRODUTO                 AND
                                          A.DTINIVIGCLOG <= @P_INIVALID);

                  IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_ITLANC_QTITEMPROD * @V_VRPESOBRUTPR)* @V_VRVRCUSTOLOG;
                  END;

                  IF (@V_VRPECUSTOLOG > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_ITLANC_VRTOTAITEM * @V_VRPECUSTOLOG)/100;
                  END;

                  IF (@V_VRPESEGURLOG > 0) BEGIN
                     SET @V_VRCUSTOSEG = (@V_ITLANC_VRTOTAITEM * @V_VRPESEGURLOG)/100;
                  END;
                  INSERT INTO ITLANCTOEST
                     (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                      IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT,VRLANCTOEST,
                      VRCUSTENTR,CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE, NRLANCORIGRP,
                      VRCUSTLOGLAN, VRSEGULOGLAN, IDORIGEMPROD)
                  VALUES
                     (@P_FILIAL,@P_LANCESTQ,@V_ITLANC_NRSEQITPROD,@V_ITLANC_CDPRODUTO,
                      @V_QTDELANCTO,@V_VRUNITLANCTO,@V_VRTOTALANCTO,@V_TIPOMOVI,@P_INIVALID,'2',
                      @V_ITLANC_CDPRODESTO,(@V_QTDELANCTO * @V_FATOCONV),@V_TOTABRUT,
                      @V_TOTACONTAB,@V_VRCUSTPROD,@V_CDFILIRECE,
                      @V_ITLANC_CDALMOXARIFE,@V_ITLANC_CDLOCALESTOQ,@V_ITLANC_NRLOTEESTQ,
                      @V_ITLANC_NRSUBLOTE,@V_IDDOCREPLIC, @V_VRCUSTOLOG, @V_VRCUSTOSEG, @V_ITLANC_IDORIGEMPROD);

               END;
               FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,  @V_ITLANC_CDPRODUTO,
                                                  @V_ITLANC_VRUNITITEM,   @V_ITLANC_VRTOTAITEM,
                                                  @V_ITLANC_QTITEMPROD,   @V_ITLANC_CDPRODESTO,
                                                  @V_ITLANC_VRBRUTITEM,   @V_ITLANC_VRDESCITEM,
                                                  @V_ITLANC_VRCONTITEM,   @V_ITLANC_CDALMOXARIFE,
                                                  @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                                                  @V_ITLANC_NRSUBLOTE,    @V_ITLANC_CDFILIMOVI,
                                                  @V_ITLANC_CDFISOPEITEM, @V_ITLANC_IDORIGEMPROD;

            END;
            CLOSE C_ITLANCTOEST;
            DEALLOCATE C_ITLANCTOEST;
         END;
      END;

   ---------------------------------------------------------------------------------------------------------
      IF @P_TIPOOPER = '03' BEGIN
         SET @V_VRCOMPLEMEN = 0;

         DECLARE C_ENCARGO CURSOR FOR
         SELECT EN.IDENCARGO, SUM(VRITEMENCA) AS VRITEMENCA
         FROM ITEMENCARGO IE, ENCARGO EN
         WHERE (IE.CDFILIAL   = @P_FILIAL)    AND
               (IE.NRLANCTONF = @P_LANCTONF)  AND
               (IE.VRITEMENCA > 0)            AND
               (EN.CDCTBLENTREN IS NULL)      AND
               (EN.CDENCARGO  = IE.CDENCARGO)
         GROUP BY IDENCARGO

         OPEN C_ENCARGO;
         FETCH NEXT FROM C_ENCARGO INTO @V_ENCARGO_IDENCARGO,  @V_ENCARGO_VRITEMENCA;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF @V_ENCARGO_IDENCARGO = 'A' BEGIN
               SET @V_VRCOMPLEMEN = @V_VRCOMPLEMEN + @V_ENCARGO_VRITEMENCA;
            END
            ELSE IF @V_ENCARGO_IDENCARGO = 'D' BEGIN
               SET @V_VRCOMPLEMEN = @V_VRCOMPLEMEN - @V_ENCARGO_VRITEMENCA;
            END;
            FETCH NEXT FROM C_ENCARGO INTO @V_ENCARGO_IDENCARGO,  @V_ENCARGO_VRITEMENCA;
         END;
         CLOSE C_ENCARGO;
         DEALLOCATE C_ENCARGO;

         IF (@V_VRCOMPLEMEN > 0) AND (@V_LIQUIDO = 0) BEGIN
            SET @V_VRNOTAF = @V_VRCOMPLEMEN - @V_VRPRODUTOS;
            EXEC ATUALIZA_CUSTO_COMPLEMENTO @P_FILIAL, @P_LANCTONF, @V_VRNOTAF;
         END;

         IF @V_VRNOTAFISC = 0 BEGIN
            UPDATE NOTAFISCAL
               SET VRNOTAFISC = ROUND(@V_TOTALNOTA, 2)
             WHERE CDFILIAL   = @P_FILIAL    AND
                   NRLANCTONF = @P_LANCTONF;
         END
         ELSE BEGIN
            UPDATE NOTAFISCAL
               SET VRNOTAFISC = ROUND(VRNOTAFISC, 2)
             WHERE CDFILIAL   = @P_FILIAL    AND
                   NRLANCTONF = @P_LANCTONF;
         END;

         IF @V_VRPRODUTOS = 0 BEGIN
            UPDATE NOTAFISCAL
            SET VRPRODUTOS = @V_VRCOMPLEMEN
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END;
      END;
   ---------------------------------------------------------------------------------------------------------

      -- Recalcula diferencial de aliquota considerando valor contabil quando no possuir reduo de base de clculo
      DECLARE C_TRABITPROIMPOS CURSOR FOR (SELECT NRSEQITPROD, CDIMPOSTO, VRALIQITEM
                                             FROM ITEMPROIMPOS
                                            WHERE CDFILIAL = @P_FILIAL
                                              AND NRLANCTONF = @P_LANCTONF
                                              AND NRITPROIMPOS = '3');

      OPEN C_TRABITPROIMPOS;
      FETCH NEXT FROM C_TRABITPROIMPOS INTO @V_TRABITPROIMPOS_NRSEQITPROD, @V_TRABITPROIMPOS_CDIMPOSTO, @V_TRABITPROIMPOS_VRALIQITEM;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_CDFILIREDU = NULL;

         SELECT @V_CDFILIREDU = MAX(CDFILIAL)
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND NRSEQITPROD = @V_TRABITPROIMPOS_NRSEQITPROD
            AND CDIMPOSTO = @V_TRABITPROIMPOS_CDIMPOSTO
            AND NRITPROIMPOS = '2';

         IF @V_CDFILIREDU IS NULL BEGIN

            SET @V_VRCONTITIMP = 0;

            SELECT @V_VRCONTITIMP = MAX(VRCONTITIMP),
                   @V_IMPOSTOIT   = MAX(VRIMPOSTOIT),
                   @V_ALIQINFO    = MAX(VRALIQITEM)
              FROM ITEMPROIMPOS
             WHERE CDFILIAL = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF
               AND NRSEQITPROD = @V_TRABITPROIMPOS_NRSEQITPROD
               AND CDIMPOSTO = @V_TRABITPROIMPOS_CDIMPOSTO
               AND NRITPROIMPOS = '1';

            IF (@V_IDCALCDIFENTFISC = 'N') BEGIN

               UPDATE TRABITPROIMPOS
                  SET VRCONTIMPOIT  = @V_VRCONTITIMP,
                      VRBCALCIMPOIT = @V_VRCONTITIMP,
                      VRIMPOSIT     = ((@V_VRCONTITIMP * VRALIQIMPOIT) / 100)
                WHERE CDFILIMPOIT   = @P_FILIAL
                  AND NRLANCIMPOIT  = @P_LANCTONF
                  AND NRSEQIMPOIT   = @V_TRABITPROIMPOS_NRSEQITPROD
                  AND CDIMPOSTOIT   = @V_TRABITPROIMPOS_CDIMPOSTO
                  AND NRSEQITPRO    = '3';

               UPDATE ITEMPROIMPOS
                  SET VRCONTITIMP  = @V_VRCONTITIMP,
                      VRBASECALCIT = @V_VRCONTITIMP,
                      VRIMPOSTOIT  = ((@V_VRCONTITIMP * VRALIQITEM) / 100)
                WHERE CDFILIAL     = @P_FILIAL
                  AND NRLANCTONF   = @P_LANCTONF
                  AND NRSEQITPROD  = @V_TRABITPROIMPOS_NRSEQITPROD
                  AND CDIMPOSTO    = @V_TRABITPROIMPOS_CDIMPOSTO
                  AND NRITPROIMPOS = '3';
            END
            ELSE BEGIN
               SET @V_ALIQDEST     = 0;
               SET @V_ALIQDEST     = @V_ALIQINFO + @V_TRABITPROIMPOS_VRALIQITEM;
               SET @V_BCALCDIFCOMP = ROUND(((@V_VRCONTITIMP - @V_IMPOSTOIT) / ((100 - @V_ALIQDEST)/100)) , @V_NRDECITOTANF);
               SET @V_IMPOSTODIFE  = ROUND(((@V_BCALCDIFCOMP * (@V_ALIQDEST/100)) - @V_IMPOSTOIT), @V_NRDECITOTANF);

               UPDATE TRABITPROIMPOS
                  SET VRCONTIMPOIT  = @V_VRCONTITIMP,
                      VRBCALCIMPOIT = @V_BCALCDIFCOMP,
                      VRIMPOSIT     = @V_IMPOSTODIFE
                WHERE CDFILIMPOIT   = @P_FILIAL
                  AND NRLANCIMPOIT  = @P_LANCTONF
                  AND NRSEQIMPOIT   = @V_TRABITPROIMPOS_NRSEQITPROD
                  AND CDIMPOSTOIT   = @V_TRABITPROIMPOS_CDIMPOSTO
                  AND NRSEQITPRO    = '3';

               UPDATE ITEMPROIMPOS
                  SET VRCONTITIMP  = @V_VRCONTITIMP,
                      VRBASECALCIT = @V_BCALCDIFCOMP,
                      VRIMPOSTOIT  = @V_IMPOSTODIFE
                WHERE CDFILIAL     = @P_FILIAL
                  AND NRLANCTONF   = @P_LANCTONF
                  AND NRSEQITPROD  = @V_TRABITPROIMPOS_NRSEQITPROD
                  AND CDIMPOSTO    = @V_TRABITPROIMPOS_CDIMPOSTO
                  AND NRITPROIMPOS = '3';
            END;
         END;

         FETCH NEXT FROM C_TRABITPROIMPOS INTO @V_TRABITPROIMPOS_NRSEQITPROD, @V_TRABITPROIMPOS_CDIMPOSTO, @V_TRABITPROIMPOS_VRALIQITEM;
      END;
      CLOSE C_TRABITPROIMPOS;
      DEALLOCATE C_TRABITPROIMPOS;

      DECLARE C_TRABIMPOSNF CURSOR FOR SELECT CDIMPOSTO,
                                              SUM(VRCONTITIMP) AS VRCONTITIMP,
                                              SUM(VRBASECALCIT) AS VRBASECALCIT,
                                              SUM(VRIMPOSTOIT) AS VRIMPOSTOIT
                                         FROM ITEMPROIMPOS
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                          AND NRITPROIMPOS = '3'
                                        GROUP BY CDIMPOSTO;

      OPEN C_TRABIMPOSNF;
      FETCH NEXT FROM C_TRABIMPOSNF INTO @V_TRABIMPOSNF_CDIMPOSTO, @V_TRABIMPOSNF_VRCONTITIMP, @V_TRABIMPOSNF_VRBASECALCIT, @V_TRABIMPOSNF_VRIMPOSTOIT;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         UPDATE IMPOSTONF
            SET VRCONTABILNF = @V_TRABIMPOSNF_VRCONTITIMP,
                VRBASECALCNF = @V_TRABIMPOSNF_VRBASECALCIT,
                VRIMPOSTONF  = @V_TRABIMPOSNF_VRIMPOSTOIT
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND CDIMPOSTO = @V_TRABIMPOSNF_CDIMPOSTO
            AND IDIMPOSTONF = '3';

         FETCH NEXT FROM C_TRABIMPOSNF INTO @V_TRABIMPOSNF_CDIMPOSTO, @V_TRABIMPOSNF_VRCONTITIMP, @V_TRABIMPOSNF_VRBASECALCIT, @V_TRABIMPOSNF_VRIMPOSTOIT;
      END;
      CLOSE C_TRABIMPOSNF;
      DEALLOCATE C_TRABIMPOSNF;

      DECLARE C_TRABITPROIMP CURSOR FOR SELECT CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                               CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT,
                                               SUM(VRCONTITIMP) AS VRCONTITIMP,
                                               SUM(VRBASECALCIT) AS VRBASECALCIT,
                                               SUM(VRIMPOSTOIT) AS VRIMPOSTOIT
                                          FROM ITEMPROIMPOS
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND NRITPROIMPOS = '3'
                                         GROUP BY CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                                  CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT;

      OPEN C_TRABITPROIMP;
      FETCH NEXT FROM C_TRABITPROIMP INTO @V_TRABITPRO_CDIMPOSTO, @V_TRABITPRO_VRALIQITEM, @V_TRABITPRO_VRPERREDBCIT, @V_TRABITPRO_VRPARDEDIT,
                                          @V_TRABITPRO_CDFISCALIT, @V_TRABITPRO_CDSITUTRIBIT, @V_TRABITPRO_CDFISCOPERIT, @V_TRABITPRO_CDSUFXCFOPIT,
                                          @V_TRABITPRO_VRCONTITIMP, @V_TRABITPRO_VRBASECALCIT, @V_TRABITPRO_VRIMPOSTOIT

      WHILE (@@FETCH_STATUS = 0) BEGIN
         UPDATE IMPOSTONF
            SET VRCONTABILNF = @V_TRABITPRO_VRCONTITIMP,
                VRBASECALCNF = @V_TRABITPRO_VRBASECALCIT,
                VRIMPOSTONF  = @V_TRABITPRO_VRIMPOSTOIT
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND CDIMPOSTO = @V_TRABITPRO_CDIMPOSTO
            AND IDIMPOSTONF = '3'
            AND VRALIQNF = @V_TRABITPRO_VRALIQITEM
            AND VRPERREDBCNF = @V_TRABITPRO_VRPERREDBCIT
            AND VRPARDEDNF = @V_TRABITPRO_VRPARDEDIT
            AND CDFISCALNF = @V_TRABITPRO_CDFISCALIT
            AND CDSITUTRIBNF = @V_TRABITPRO_CDSITUTRIBIT
            AND CDFISCOPERNF = @V_TRABITPRO_CDFISCOPERIT
            AND ISNULL(CDSUFXCFOPNF, 'N') = ISNULL(@V_TRABITPRO_CDSUFXCFOPIT, 'N');

         FETCH NEXT FROM C_TRABITPROIMP INTO @V_TRABITPRO_CDIMPOSTO, @V_TRABITPRO_VRALIQITEM, @V_TRABITPRO_VRPERREDBCIT, @V_TRABITPRO_VRPARDEDIT,
                                             @V_TRABITPRO_CDFISCALIT, @V_TRABITPRO_CDSITUTRIBIT, @V_TRABITPRO_CDFISCOPERIT, @V_TRABITPRO_CDSUFXCFOPIT,
                                             @V_TRABITPRO_VRCONTITIMP, @V_TRABITPRO_VRBASECALCIT, @V_TRABITPRO_VRIMPOSTOIT
      END;
      CLOSE C_TRABITPROIMP;
      DEALLOCATE C_TRABITPROIMP;

      -- Atualiza custo do produto em estoque caso o diferencial compoem o custo do produto
      DECLARE C_ITLANCTOESTO CURSOR FOR
         SELECT NRSEQITPROD, VRBRUTITEM, P.VRFATOCONV, QTITEMPROD, VRCONTITEM
         FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
         WHERE IP.CDFILIAL    = @P_FILIAL     AND
               IP.NRLANCTONF  = @P_LANCTONF   AND
               P.CDPRODUTO    = IP.CDPRODUTO  AND
               PF.CDFILIAL    = @V_CDFILIRECE AND
               PF.CDPRODUTO   = P.CDPRODESTO;

      OPEN C_ITLANCTOESTO;
      FETCH NEXT FROM C_ITLANCTOESTO INTO @V_ITLANCT_NRSEQITPROD, @V_ITLANCT_VRBRUTITEM,
                                          @V_ITLANCT_VRFATOCONV, @V_ITLANCT_QTITEMPROD,
                                          @V_ITLANCT_VRCONTITEM;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_VRIMPDIFALIQ = 0;

         SELECT @V_VRIMPDIFALIQ = ISNULL(SUM(VRIMPOSTOIT), 0)
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND NRSEQITPROD = @V_ITLANCT_NRSEQITPROD
            AND IDDIFALIQCUSPRI = 'S';

         IF @V_VRIMPDIFALIQ > 0 BEGIN
            UPDATE ITEMPRODUTO
               SET VRCONTITEM   = (VRCONTITEM + @V_VRIMPDIFALIQ)
             WHERE (CDFILIAL    = @P_FILIAL)    AND
                   (NRLANCTONF  = @P_LANCTONF)  AND
                   (NRSEQITPROD = @V_ITLANCT_NRSEQITPROD);

            IF (@P_TIPOOPER = '06') BEGIN
               UPDATE ITLANCTOEST
                  SET VRLANCTOBRUT = (@V_VRIMPDIFALIQ / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRLANCTOEST  = (@V_VRIMPDIFALIQ / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRCUSTENTR = (VRCUSTENTR + @V_VRIMPDIFALIQ)
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCESTQ = @P_LANCESTQ
                  AND NRSEQUITEM = @V_ITLANCT_NRSEQITPROD;
            END
            ELSE BEGIN
               UPDATE ITLANCTOEST
                  SET VRLANCTOBRUT = ((@V_ITLANCT_VRBRUTITEM + @V_VRIMPDIFALIQ) / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRLANCTOEST = ((@V_ITLANCT_VRCONTITEM + @V_VRIMPDIFALIQ) / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRCUSTENTR = (VRCUSTENTR + @V_VRIMPDIFALIQ)
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCESTQ = @P_LANCESTQ
                  AND NRSEQUITEM = @V_ITLANCT_NRSEQITPROD;
            END;


         END;

         FETCH NEXT FROM C_ITLANCTOESTO INTO @V_ITLANCT_NRSEQITPROD, @V_ITLANCT_VRBRUTITEM,
                                             @V_ITLANCT_VRFATOCONV, @V_ITLANCT_QTITEMPROD,
                                             @V_ITLANCT_VRCONTITEM;
      END;
      CLOSE C_ITLANCTOESTO;
      DEALLOCATE C_ITLANCTOESTO;

      DELETE FROM REGRANOTA
      WHERE CDFILIAL = @P_FILIAL
        AND NRLANCTONF = @P_LANCTONF;

      DECLARE C_IMPOSNOTA CURSOR FOR
         SELECT DISTINCT CDREGRAIT
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND CDREGRAIT IS NOT NULL
         ORDER BY CDREGRAIT;
      OPEN C_IMPOSNOTA;
      FETCH NEXT FROM C_IMPOSNOTA INTO @V_IMPOSNOTA_CDREGRAIT;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         DECLARE C_REGRAMSG CURSOR FOR
            SELECT CDREGRAFISC, DSMENSREGRAFISC
              FROM TEKNISA.MSG_REGRAFISCAL(@V_IMPOSNOTA_CDREGRAIT, @P_EMPRESA, 'E', @P_TIPOOPER, @P_INSCESTA) M
             WHERE NOT EXISTS(SELECT DSDADOADIC
                                FROM DADOSADIC
                               WHERE (CDFILIAL   = @P_FILIAL)
                                 AND (NRLANCTONF = @P_LANCTONF)
                                 AND (DSDADOADIC = M.DSMENSREGRAFISC)) ;
         OPEN C_REGRAMSG;
         FETCH NEXT FROM C_REGRAMSG INTO @V_REGRAMSG_CDREGRAFISC, @V_REGRAMSG_DSMENSREGRAFISC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            INSERT INTO DADOSADIC(CDFILIAL,  NRLANCTONF,  NRDADOADIC,  DSDADOADIC)
                           VALUES(@P_FILIAL, @P_LANCTONF, @V_DADOADIC, @V_REGRAMSG_DSMENSREGRAFISC);

            SET @V_DADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_DADOADIC) + 1)),3);

            FETCH NEXT FROM C_REGRAMSG INTO @V_REGRAMSG_CDREGRAFISC, @V_REGRAMSG_DSMENSREGRAFISC;
         END;

         CLOSE C_REGRAMSG;
         DEALLOCATE C_REGRAMSG;
         INSERT INTO REGRANOTA(CDFILIAL, NRLANCTONF, CDREGRAFISC)
                        VALUES(@P_FILIAL, @P_LANCTONF, @V_IMPOSNOTA_CDREGRAIT);

         FETCH NEXT FROM C_IMPOSNOTA INTO @V_IMPOSNOTA_CDREGRAIT;
      END;

      /*Chamar a procedure para gerar financeiro. */
      IF (@V_IDNFRETIND = 'S') OR (@V_IDSTATUS = 'I') BEGIN
         SET @V_POSSUIFINANC = 0;

         IF (@V_IDUTILVENC = 'S') BEGIN
            SELECT @V_POSSUIFINANC = COUNT(*)
              FROM CONTAPAGAR
             WHERE CDFILIAL   = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;

            IF NOT(@V_POSSUIFINANC > 0) BEGIN
               EXEC GERA_DADOS_FINANCEIRO @P_FILIAL, @P_LANCTONF, @P_FILIAL, 'L', @P_RESULTADO = @P_RESULTADO OUTPUT;
            END;
         END;
      END;

      DELETE 
        FROM INFOPAGANFE
       WHERE CDFILIAL = @P_FILIAL
         AND NRLANCTONF = @P_LANCTONF;

      IF (ISNULL(@P_AUDIT, 'N') <> 'S') BEGIN
         EXEC CONFERE_ERROS_NF @P_FILIAL, @P_LANCTONF, @V_TOTALNOTA;
      END;

      IF @P_TIPOOPER = '01' BEGIN
         EXEC CONHECIMENTO_TRANSPORTE @P_FILIAL, @P_LANCTONF, @P_LANCESTQ;
      END;

   END;

   UPDATE TRABITPROIMPOS
      SET CDFISCIMPOIT = '2',
          VRBCALCIMPOIT = 0	      
    WHERE CDFILIMPOIT = @P_FILIAL
      AND NRLANCIMPOIT = @P_LANCTONF
      AND VRREDBCIMPOIT > 0.00
      AND NRSEQITPRO = '2';

   DECLARE C_CARGA CURSOR FOR SELECT DISTINCT CDIMPOSTO
                                FROM IMPOSTONF
                               WHERE CDFILIAL = @P_FILIAL
                                 AND NRLANCTONF = @P_LANCTONF;
   OPEN C_CARGA;
   FETCH NEXT FROM C_CARGA INTO @V_CARGA_CDIMPOSTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_CARGA = TEKNISA.VALOR_CARGA_TRIBUTARIA(@V_CARGA_CDIMPOSTO, @P_FILIAL, @P_LANCTONF);
      IF (@V_CARGA > 0) BEGIN
         UPDATE IMPOSTONF
            SET VRIMPCARGATRIBI = @V_CARGA
           WHERE CDFILIAL = @P_FILIAL
             AND NRLANCTONF = @P_LANCTONF
             AND CDIMPOSTO = @V_CARGA_CDIMPOSTO
             AND NRIMPOSNF = (SELECT MAX(NRIMPOSNF)
                                      FROM IMPOSTONF
                                     WHERE CDFILIAL = @P_FILIAL
                                       AND NRLANCTONF = @P_LANCTONF
                                       AND CDIMPOSTO = @V_CARGA_CDIMPOSTO);


      END;
      FETCH NEXT FROM C_CARGA INTO @V_CARGA_CDIMPOSTO;
   END;
   CLOSE C_CARGA;
   DEALLOCATE C_CARGA;

   IF (@V_IDNFIMPORTACAO = 'S') BEGIN
      --Fazer aqui o clculo dos impostos de importao

      IF (NOT(@P_TIPOOPER IN ('07','09','10')) AND (@V_IDOPERDEVONF <> 'S')) OR ((@V_IDOPERDEVONF = 'S') AND (@V_DEVOLORIG IS NULL)) BEGIN
   -- NOTA FISCAL DE MOVIMENTAO - 07

         DECLARE C_ITEMPRODUTO CURSOR FOR
        (SELECT VRTOTAITEM, VRDESCITEM, I.CDPRODUTO, NRSEQITPROD, P.CDARVPROD, QTITEMPROD, CDFISOPEITEM, CDSITUTRIBPR
         FROM ITEMPRODUTO I, PRODUTO P
         WHERE CDFILIAL    = @P_FILIAL   AND
               NRLANCTONF  = @P_LANCTONF AND
               I.CDPRODUTO = P.CDPRODUTO);

         OPEN C_ITEMPRODUTO;

         FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPROD_VRTOTAITEM, @V_ITEMPROD_VRDESCITEM,
                                            @V_ITEMPROD_CDPRODUTO,  @V_ITEMPROD_NRSEQITPROD,
                                            @V_ITEMPROD_CDARVPROD,  @V_ITEMPROD_QTITEMPROD,
                                            @V_ITEMPROD_CDFISOPEITEM, @V_ITEMPROD_CDSITUTRIBPR;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_LIQUIDOPROD = @V_ITEMPROD_VRTOTAITEM - @V_ITEMPROD_VRDESCITEM;

            IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN --IMPORTAO DE NFS ORIUNDAS DOS

               EXEC CONSULTA_CST @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD,
                                 @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF,
                                 @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA;

               EXEC CONSULTA_CFOP @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                  @P_INSCESTA,   @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                  @V_PAISDEST,   @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                  @V_CDGRUPOFISC,@P_INIVALID;

               IF @V_ITEMPROD_CDFISOPEITEM IS NULL BEGIN
                  UPDATE NOTAFISCAL
                  SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP) FROM CFOPTEMP
                                      WHERE NRCFOPTEMP = @V_CFOPTEMP)
                  WHERE CDFILIAL   = @P_FILIAL   AND
                        NRLANCTONF = @P_LANCTONF;
               END;
   ---------------------------------------------------------------------------------------------------------
               SELECT @V_FISOPEITEM = MAX(CDFISOPETMP),   @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                      @V_DIFALIQITEM = MAX(IDDIFALIQTMP),
                      @V_DSCDFISOPEIT = MAX(DSCFOPTMP),
                      @V_IDDIFALIQCUSPRC = ISNULL(MAX(IDDIFALIQCUSPRC),'N')
               FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               SELECT @V_IDORDPRIMDFENT = MAX(IDORDPRIMDFENT)
                 FROM PARAMGERAL;

   ---------------------------------------------------------------------------------------------------------
               EXEC CONSULTA_CSOSN @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                   @P_INSCESTA,   @P_TIPOOPER, @P_FILIAL,   @P_LANCTONF,
                                   @V_CDGRUPOFISC,@V_IDINTEREST, @P_CDFISCOPERSN = @V_CDFISCOPERSN OUTPUT;

               IF (@V_FISOPEITEM IS NULL) AND (@V_ITEMPROD_CDFISOPEITEM IS NOT NULL) AND (@V_IDGERNFIGUALXML = 'S') AND (@V_IDNFGERADAVIAXML = 'S') BEGIN
                  SET @V_FISOPEITEM = @V_ITEMPROD_CDFISOPEITEM;
               END;

               UPDATE ITEMPRODUTO
               SET CDFISOPEITEM = @V_FISOPEITEM,
                   CDSUFXCFOPPR = @V_SUFXCFOPPR,
                   DSCDFISOPEIT = @V_DSCDFISOPEIT,
                   CDFISCOPERSN = @V_CDFISCOPERSN
               WHERE CDFILIAL    = @P_FILIAL   AND
                     NRLANCTONF  = @P_LANCTONF AND
                     NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;

               DELETE FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
               FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               SELECT @V_CDCSTDIGI = CDSITUTRIBPR
               FROM ITEMPRODUTO
               WHERE CDFILIAL    = @P_FILIAL   AND
                     NRLANCTONF  = @P_LANCTONF AND
                     NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;

               IF ((@V_IDPERALTCSTFENF = 'N') OR
                  ((@V_IDPERALTCSTFENF = 'S') AND (@V_CDCSTDIGI IS NULL))) BEGIN
                  UPDATE ITEMPRODUTO
                  SET CDSITUTRIBPR  = @V_SITUTRIBPR
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;
               END
               ELSE BEGIN
                  SET @V_SITUTRIBPR = @V_CDCSTDIGI;
               END;

               DELETE FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               -- Verifica se h grupo fiscal por servico
               SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
               FROM SERVCLIE SC, SERVICO S
               WHERE SC.CDFILIAL   = @V_CDFILIEMIT AND
                     SC.CDCLIENTE  = @P_FORNECED    AND
                     SC.CDFILIAL   = S.CDFILIAL   AND
                     SC.CDSERVFILI = S.CDSERVFILI AND
                     S.CDPRODUTO   = @V_ITEMPROD_CDPRODUTO;

               IF @V_CDGRPFISCSV IS NULL BEGIN
                  -- Verifica se h grupo fiscal por cliente da filial
                  SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                  FROM CLIENFILIAL
                  WHERE CDFILIAL   = @V_CDFILIEMIT AND
                        CDCLIENTE  = @P_FORNECED;
               END;

               EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                        @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF,
                                        @V_CDGRUPOFISC, @V_CDGRPFISCSV, @V_IDINTEREST;

            END;

   ---------------------------------------------------------------------------------------------------------
      --ATUALIZAO DA TABELA DE IMPOSTOS POR ITEM.

            DELETE FROM ITEMPROIMPOS
            WHERE (CDFILIAL    = @P_FILIAL)   AND
                  (NRLANCTONF  = @P_LANCTONF) AND
                  (NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD);

            IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN

               DECLARE C_INCIDENCIA CURSOR FOR
               SELECT CDIMPOTEMP, MAX(CDFISCTEMP) AS CDFISCTEMP,
                      MAX(IDTRATIMPTMP) AS IDTRATIMPTMP, MAX(IDCONSISTENT) AS IDCONSISTENT, MAX(ISNULL(IDUTMUNIORIG, 'N')) AS IDUTMUNIORIG,
                      MAX(IDIMPORECUP)  AS IDIMPORECUP,  MAX(ISNULL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR,
                      MAX(IDORGARRECAD) AS IDORGARRECAD, MAX(IDUTVLRQTDEIMPO) AS IDUTVLRQTDEIMPO,
                      MAX(IP.IDUTVRPAUTA) AS IDUTVRPAUTA
               FROM INCITEMP IT, IMPOSTO IP
               WHERE (IT.NRINCITEMP = @V_INCITEMP)   AND
                     (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                     (IP.IDPRODNOTA = 'P')
               GROUP BY CDIMPOTEMP
               ORDER BY IT.CDIMPOTEMP;

               OPEN C_INCIDENCIA;
               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP,   @V_INCIDENC_CDFISCTEMP,
                                                 @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDCONSISTENT,
                                                 @V_INCIDENC_IDUTMUNIORIG, @V_INCIDENC_IDIMPORECUP,
                                                 @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDORGARRECAD,
                                                 @V_INCIDENC_IDUTVLRQTDEIMPO, @V_INCIDENC_IDUTVRPAUTA;;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SET @V_MINBCPROD = 0;

                  IF @V_INCIDENC_IDUTVRPAUTA = 'S' BEGIN
                     EXEC CALCULO_MINBCPRODUTO @P_EMPRESA, @P_TIPOOPER, @P_INSCESTA,    @P_ENTRSAID, @V_PAISORIG, @V_ESTAORIG,
                                               @V_ITEMPROD_CDPRODUTO,   @V_CDGRUPOFISC, @P_INIVALID, @P_LANCTONF, @P_FILIAL,
                                               @V_ITEMPROD_NRSEQITPROD, @P_VRPRODUTO = @V_MINBCPROD OUTPUT;
                  END;

                  IF @V_MINBCPROD = 0 BEGIN
                     SET @V_LIQUIITEM = @V_ITEMPROD_VRTOTAITEM - @V_ITEMPROD_VRDESCITEM;
                  END
                  ELSE BEGIN
                     SET @V_LIQUIITEM = @V_MINBCPROD - @V_ITEMPROD_VRDESCITEM;
                  END;


                  IF @V_INCIDENC_IDUTMUNIORIG = 'D' BEGIN
                     IF @V_UTGRUPFISCS = 'S' BEGIN
                        SET @V_CDGRPFISCSV = NULL;
                        SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = @V_CDFILIEMIT AND
                              SC.CDCLIENTE  = @P_FORNECED    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = @V_ITEMPROD_CDPRODUTO;
                        IF @V_CDGRPFISCSV IS NULL BEGIN
                           SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = @V_CDFILIEMIT AND
                                CDCLIENTE  = @P_FORNECED;
                        END;
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                            @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                            @V_CDGRPFISCSV,@P_TIPOOPER;
                     END
                     ELSE BEGIN
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                               @V_CDGRUPOFISC, @P_TIPOOPER;
                     END;
                  END
                  ELSE BEGIN
                     /* CONSIDERA O MUNICIPIO DE ORIGEM */

                     SELECT @V_UTGRUPFISCS = MAX(IDGRUPFISSRV)
                       FROM IMPOSTO
                      WHERE CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                     IF @V_UTGRUPFISCS = 'S' BEGIN
                        SET @V_CDGRPFISCSV = NULL;
                        SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                        FROM SERVCLIE SC, SERVICO S
                        WHERE SC.CDFILIAL   = @V_CDFILIEMIT AND
                              SC.CDCLIENTE  = @P_FORNECED    AND
                              SC.CDFILIAL   = S.CDFILIAL   AND
                              SC.CDSERVFILI = S.CDSERVFILI AND
                              S.CDPRODUTO   = @V_ITEMPROD_CDPRODUTO;
                        IF @V_CDGRPFISCSV IS NULL BEGIN
                           SELECT @V_CDGRPFISCSV = MAX(CDGRUPOFISC)
                           FROM CLIENFILIAL
                          WHERE CDFILIAL   = @V_CDFILIEMIT AND
                                CDCLIENTE  = @P_FORNECED;
                        END;
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                               @V_CDGRPFISCSV, @P_TIPOOPER;

                     END
                     ELSE BEGIN
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP,   @P_ENTRSAID, @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,     @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL,   @P_LANCTONF,
                                               @V_CDGRUPOFISC, @P_TIPOOPER;
                     END;
                  END;

                  SET @V_PARDEDTMP   = 0;
                  SET @V_PREDBCTMP   = 0;
                  SET @V_PREDBCTMP1  = 0;
                  SET @V_ALIQUTMP    = 0;
                  SET @V_IMPOSTOIT   = 0;
                  SET @V_IMPOSTORED1 = 0;
                  SET @V_ALIQINFO    = 0;
                  SET @V_IMPOSINFO   = 0;
                  SET @V_VRIMPOSTOST = 0;
                  SET @V_VRPPRIIMPST = 0;
                  SET @V_IDREDUCAO   = 'N';

                  /*VERIFICA CST POR IMPOSTO - NFE*/
                  SET @V_IMPOICMS = NULL;

                  SET @V_CDGRUPOFISCAUX = NULL;

                  SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                    FROM GRUPOFISCIMPFIL G,
                          (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                  ELSE CDFILIEMIT END AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                  IF @V_IDORIGDESTNF = 'F' BEGIN
                  SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                    FROM GRFISIMPIEFORN G,
                         (SELECT CDFORNECED
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = @P_EMPRESA
                     AND G.CDINSCESTA = @P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                  END
                  ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                      SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                       FROM GRFISIMPIECLIE G,
                            (SELECT CDCLIENTE
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) N
                      WHERE G.CDCLIENTE = N.CDCLIENTE
                        AND G.CDEMPRESA = @P_EMPRESA
                        AND G.CDINSCESTA = @P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                  END;

                  IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                     EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                           @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END
                  ELSE BEGIN
                     EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                           @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END;

                  SET @V_CDREGRAITALIQ  = NULL;

                  SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                  SELECT @V_PARDEDTMP     = ISNULL(MAX(VRPARDEDTMP),0),
                         @V_PREDBCTMP     = ISNULL(MAX(VRPREDBCTMP),0),
                         @V_ALIQUTMP      = ISNULL(MAX(VRALIQUTMP),0),
                         @V_IDTRIMPSTII   = ISNULL(MAX(IDTRIMPSTTMP),0),
                         @V_PBCSUBTRIB    = ISNULL(MAX(VRPBCSTTMP),0),
                         @V_PREDBCTMP1    = ISNULL(MAX(VR1PREDBCTMP), 0),
                         @V_CDREGRAITALIQ = MAX(CDREGRATMP),
                         @V_CDFISCOPERREGRA = MAX(CDFISCOPER),
                         @V_IDDIFEALIQREGRA = MAX(IDDIFEALIQ),
                         @V_IDDIFALIQCUSPRREGRA = MAX(IDDIFALIQCUSPR)
                  FROM ALIQTEMP
                  WHERE (NRALIQTEMP = @V_ALIQTEMP);

                  IF @V_PREDBCTMP > 0 BEGIN
                     SET @V_IDREDUCAO = 'S';
                  END;

                  SELECT @V_ALIQINFO    = ISNULL(MAX(VRALIQIMPOIT),0),
                         @V_IMPOSINFO   = ISNULL(MAX(VRIMPOSIT),0),
                         @V_IDVALORINFO = ISNULL(MAX(IDVALORINFO),'N'),
                         @V_NRIMPOSTO   = COUNT(*)
                  FROM TRABITPROIMPOS
                  WHERE CDFILIMPOIT  = @P_FILIAL               AND
                        NRLANCIMPOIT = @P_LANCTONF             AND
                        NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                        CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP;

                  SET @V_TAXABASECALC = (100 - @V_PREDBCTMP1)/100;
                  SET @V_BASECALCIT   = @V_LIQUIITEM * @V_TAXABASECALC;

                  SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
                  SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
                  SET @V_TAXAALIQINFO = (@V_ALIQINFO/100);
                  SET @V_TAXABCSUBSTR = 1 + (@V_PBCSUBTRIB/100);

                  IF @V_PREDBCTMP1 <> 0 BEGIN
                     SET @V_IMPOSTORED1 = @V_BASECALCIT * @V_TAXAALIQUOTA;
                     SET @V_BASECALCIT  = @V_BASECALCIT * @V_TAXABASECALC;
                  END
                  ELSE BEGIN
                     SET @V_BASECALCIT = @V_LIQUIITEM * @V_TAXABASECALC;
                  END;

                  SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;

                  IF @V_PBCSUBTRIB > 0 BEGIN
                     SET @V_BASECALCIT = (@V_BASECALCIT * @V_TAXABCSUBSTR);
                     SET @V_PREDBCTMP  = @V_PBCSUBTRIB;
                     SET @V_PERDBCALC  = 0;
                  END;

                  /*SELECT @V_CDIMPOSTRIB  = MAX(CDIMPOSTO),
                         @V_IDVRIMPSTRIB = MAX(IDVRIMPSTRIB)
                  FROM IMPOSTO
                  WHERE CDIMPOSTRIB = @V_INCIDENC_CDIMPOTEMP;*/

                  SET @V_CDIMPOSTRIB  = null;
                  SET @V_IDVRIMPSTRIB = null;
                  SET @V_VRIMPOSTOST = 0;
                  SET @V_VRPPRIIMPST = 0;


                  DECLARE C_ICMSST CURSOR FOR
                        SELECT CDIMPOSTO
                          FROM IMPOSTO
                         WHERE CDIMPOSTRIB = @V_INCIDENC_CDIMPOTEMP;

                  OPEN C_ICMSST;
                  FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_CDIMPOSTRIB = ISNULL(@V_CDIMPOSTRIB,'')+@V_ICMSST_CDIMPOSTRIB+'_';
                     FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                  END;
                  CLOSE C_ICMSST;
                  DEALLOCATE C_ICMSST;

                  IF @V_CDIMPOSTRIB IS NOT NULL BEGIN
                     SELECT @V_IDVRIMPSTRIB = ISNULL(MAX(IDVRIMPSTRIB), 'N')
                       FROM TRABITPROIMPOS I, IMPOSTO II
                      WHERE (CDFILIMPOIT     = @P_FILIAL)
                        AND (NRLANCIMPOIT    = @P_LANCTONF)
                        AND (NRSEQIMPOIT     = @V_ITEMPROD_NRSEQITPROD)
                        AND (CHARINDEX(II.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0)
                        AND (I.CDIMPOSTOIT = II.CDIMPOSTO);

                     IF (@V_IDTRIMPSTII = '1') OR (ISNULL(@V_IDVRIMPSTRIB,'N') = 'N') BEGIN
                        SET @V_VRIMPOSTOST = 0;
                        SET @V_VRPPRIIMPST = 0;
                     END
                     ELSE BEGIN
                        SELECT @V_VRIMPOSTOST = ISNULL(MAX(VRIMPOSIT),0)
                        FROM TRABITPROIMPOS I
                        WHERE (CDFILIMPOIT  = @P_FILIAL)               AND
                              (NRLANCIMPOIT = @P_LANCTONF)             AND
                              (NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD)  AND
                              (CHARINDEX(CDIMPOSTOIT+'_', @V_CDIMPOSTRIB) > 0) AND
                              (NRSEQITPRO   = '1');
                     END;
                  END;

                  IF (@V_INCIDENC_IDUTVLRQTDEIMPO) = 'S' BEGIN
                     SET @V_IMPOSTOIT = (@V_ITEMPROD_QTITEMPROD * @V_ALIQUTMP) - @V_PARDEDTMP;

                     IF @V_VRPPRIIMPST <> 0 BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                     END;
                  END
                  ELSE BEGIN
                     SET @V_IMPOSTOIT = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

                     IF @V_VRPPRIIMPST <> 0 BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                     END;
                  END;

                  IF @P_AUDIT = 'S' BEGIN
                     IF (@V_INCIDENC_IDUTVLRQTDEIMPO) = 'S' BEGIN
                        SET @V_ALIQINFO  = @V_ALIQUTMP;
                        SET @V_IMPOSINFO = (@V_ITEMPROD_QTITEMPROD * @V_ALIQUTMP) - @V_PARDEDTMP;

                        IF @V_VRPPRIIMPST <> 0 BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                        END
                        ELSE BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_ALIQINFO  = @V_ALIQUTMP;
                        SET @V_IMPOSINFO = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

                        IF @V_VRPPRIIMPST <> 0 BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRPPRIIMPST;
                        END
                        ELSE BEGIN
                           SET @V_IMPOSINFO = @V_IMPOSTOIT - @V_VRIMPOSTOST;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF (@V_IDVALORINFO <> 'S') BEGIN
                        IF (@V_INCIDENC_IDUTVLRQTDEIMPO) = 'S' BEGIN
                           SET @V_IMPOSINFO = (@V_ITEMPROD_QTITEMPROD * @V_ALIQINFO) - @V_PARDEDTMP;

                           IF @V_VRPPRIIMPST <> 0 BEGIN
                              SET @V_IMPOSINFO =  @V_IMPOSINFO - @V_VRPPRIIMPST;
                           END
                           ELSE BEGIN
                              SET @V_IMPOSINFO =  @V_IMPOSINFO - @V_VRIMPOSTOST;
                           END;
                        END
                        ELSE BEGIN
                           SET @V_IMPOSINFO = (@V_BASECALCIT * @V_TAXAALIQINFO) - @V_PARDEDTMP;

                           IF @V_VRPPRIIMPST <> 0 BEGIN
                              SET @V_IMPOSINFO = @V_IMPOSINFO - @V_VRPPRIIMPST;
                           END
                           ELSE BEGIN
                              SET @V_IMPOSINFO = @V_IMPOSINFO - @V_VRIMPOSTOST;
                           END;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_ALIQUTMP  = @V_ALIQINFO;
                        SET @V_IMPOSTOIT = @V_IMPOSINFO;

                        SELECT @V_IDIMPORTAIMPXML = ISNULL(IDIMPORTAIMPXML, 'N')
                          FROM IMPOSTO
                         WHERE CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                        IF (@V_IDNFGERADAVIAXML = 'S') AND ((@V_IDIMPORTAIMPXML = 'S') OR (@V_IDGERNFIGUALXML = 'S')) BEGIN
                           SET @V_PREDBCTMP  = @V_VRPERREDBCIT;
                           SET @V_BASECALCIT = @V_VRBASECALCIT;
                        END;
                     END;
                  END;

                  SET @V_CONTABCALC = @V_LIQUIDOPROD - (@V_LIQUIDOPROD * @V_TAXABASECALC);

                  IF (@V_IMPOSTOIT < 0) OR (@V_IMPOSTOIT IS NULL) BEGIN
                     SET @V_IMPOSTOIT = 0;
                  END;

                  IF (@V_IMPOSINFO < 0) OR (@V_IMPOSINFO IS NULL)BEGIN
                     SET @V_IMPOSINFO = 0;
                  END;

                  IF (@V_ALIQUTMP = 0) AND (@V_IMPOSTOIT = 0) AND (@V_ALIQINFO = 0) BEGIN
                     SET @V_BASECALCIT = 0;
                  END;

   ---------------------------------------------------------------------------------------------------------
                  SELECT @V_FISOPEITEM = MAX(CDFISOPEITEM),
                         @V_SUFXCFOPPR = MAX(CDSUFXCFOPPR)
                  FROM ITEMPRODUTO
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;
   ---------------------------------------------------------------------------------------------------------

                  SET @V_IMPOICMS = NULL;
                  SET @V_CST1DIGT = NULL;

                  SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;


                  IF (@V_IMPOICMS IS NOT NULL) BEGIN

                     IF @V_IDORIGDESTNF = 'L' BEGIN

                        SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                          FROM PRODUTO
                         WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                        IF @V_CST1DIGT IS NULL BEGIN
                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1SAI)
                             FROM INSCRESTAD
                            WHERE CDEMPRESA   = @P_EMPRESA AND
                                  CDINSCESTA  = @P_INSCESTA;
                        END;
                     END
                     ELSE IF @V_IDORIGDESTNF = 'C'
                     BEGIN
                        SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                          FROM PRODUTO
                         WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                        IF @V_CST1DIGT IS NULL BEGIN
                           SELECT @V_CST1DIGT  = MAX(CDCSTDIG1CLI)
                             FROM NOTAFISCAL N LEFT JOIN CLIENTE C
                                              ON (N.CDCLIENTE = C.CDCLIENTE)
                            WHERE (CDFILIAL     = @P_FILIAL) AND
                                  (NRLANCTONF   = @P_LANCTONF);
                        END;
                     END
                     ELSE
                     BEGIN

                        SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                          FROM PRODUTO
                         WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                        IF @V_CST1DIGT IS NULL BEGIN
                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1ENT)
                             FROM NOTAFISCAL N, FORNECEDOR F
                            WHERE CDFILIAL     = @P_FILIAL
                              AND NRLANCTONF   = @P_LANCTONF
                              AND N.CDFORNECED = F.CDFORNECED;
                        END;
                     END;
                     IF (@V_CDSITTRIBTMP IS NOT NULL) BEGIN
                        UPDATE ITEMPRODUTO
                           SET CDSITUTRIBPR  = @V_CST1DIGT + @V_CDSITTRIBTMP
                         WHERE CDFILIAL      = @P_FILIAL AND
                               NRLANCTONF    = @P_LANCTONF AND
                               NRSEQITPROD   = @V_ITEMPROD_NRSEQITPROD;

                        SET @V_SITUTRIBPR = @V_CST1DIGT + @V_CDSITTRIBTMP;
                     END;

                     SET @V_CDGRUPOFISCAUX = NULL;

                     SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                       FROM GRUPOFISCIMPFIL G,
                             (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                     ELSE CDFILIEMIT END AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                     IF @V_IDORIGDESTNF = 'F' BEGIN
                     SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = @P_EMPRESA
                        AND G.CDINSCESTA = @P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                     END
                     ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                         SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                          FROM GRFISIMPIECLIE G,
                               (SELECT CDCLIENTE
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = @P_FILIAL
                                   AND NRLANCTONF = @P_LANCTONF) N
                         WHERE G.CDCLIENTE = N.CDCLIENTE
                           AND G.CDEMPRESA = @P_EMPRESA
                           AND G.CDINSCESTA = @P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
                     END;

                     IF (@V_CDGRUPOFISCAUX IS NOT NULL) BEGIN

                        EXEC CONSULTA_CFOP @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                  @P_INSCESTA,   @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                  @V_PAISDEST,   @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                  @V_CDGRUPOFISCAUX,@P_INIVALID;

                        UPDATE NOTAFISCAL
                           SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP) FROM CFOPTEMP
                                               WHERE NRCFOPTEMP = @V_CFOPTEMP)
                         WHERE CDFILIAL   = @P_FILIAL AND
                               NRLANCTONF = @P_LANCTONF;

                        SELECT @V_FISOPEITEM = MAX(CDFISOPETMP),
                               @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                               @V_DSCDFISOPEIT = MAX(DSCFOPTMP)
                          FROM CFOPTEMP
                         WHERE NRCFOPTEMP = @V_CFOPTEMP;


                        UPDATE ITEMPRODUTO
                           SET CDFISOPEITEM = @V_FISOPEITEM,
                               CDSUFXCFOPPR = @V_SUFXCFOPPR,
                               DSCDFISOPEIT = @V_DSCDFISOPEIT

                         WHERE CDFILIAL    = @P_FILIAL   AND
                               NRLANCTONF  = @P_LANCTONF AND
                               NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;

                        DELETE FROM CFOPTEMP
                         WHERE NRCFOPTEMP = @V_CFOPTEMP;
                     END;

                  END;

                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                     CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                     VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDTRIMPSTII,
                     CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, VR1PERREDBCIT, VR1IMPREDBCIT,
                     CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                  VALUES(
                     @P_FILIAL,     @P_LANCTONF,   @V_ITEMPROD_NRSEQITPROD,    @V_INCIDENC_CDIMPOTEMP, '1', @V_INCIDENC_CDFISCTEMP,
                     @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, @V_ALIQUTMP, ISNULL(@V_PREDBCTMP,0),      ISNULL(@V_PARDEDTMP,0),
                     ISNULL(ROUND(@V_BASECALCIT,2),0),      ISNULL(@V_BASECALCIT,0),    @V_IMPOSTOIT,
                     '00000', '00000', @V_IDTRIMPSTII, @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_PREDBCTMP1, @V_IMPOSTORED1,
                     @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);

                  UPDATE TRABITPROIMPOS
                  SET VRALIQIMPOIT   = @V_ALIQINFO,
                      VRCONTIMPOIT   = ISNULL(ROUND(@V_BASECALCIT,2),0),
                      VRREDBCIMPOIT  = @V_PREDBCTMP,
                      VRBCALCIMPOIT  = ISNULL(@V_BASECALCIT,0),
                      VRPDEDIMPOIT   = @V_PARDEDTMP,
                      VRIMPOSIT      = @V_IMPOSINFO,
                      CDFISCIMPOIT   = @V_INCIDENC_CDFISCTEMP,
                      CDSTRIBIMPOIT  = @V_SITUTRIBPR,
                      CDFOPERIMPOIT  = @V_FISOPEITEM,
                      CDSCFOPIMPOIT  = @V_SUFXCFOPPR,
                      IDERRIMPOIT    = '00000',
                      IDAVISIMPOIT   = '00000',
                      IDTRIMPSTTI    = @V_IDTRIMPSTII,
                      CDSTRIBITNFE = @V_CDSITTRIBTMP,
                      IDMODBCITEMNFE   = @V_IDMODBCNFE,
                      IDMODBCSTITENFE = @V_IDMODBCSTNFE,
                      VR1REDBCIMPOIT = @V_PREDBCTMP1,
                      VR1IMPOSTOIT = @V_IMPOSTORED1,
                      CDTPCREDPICOITE = @V_CDTPCRPICOSTNFE,
                      CDNATUBCALPCIT  = @V_CDNATUBCPCSTNFE,
                      IDMOTDESOTRABIT = @V_IDMOTIDESSTNFE
                  WHERE CDFILIMPOIT  = @P_FILIAL               AND
                        NRLANCIMPOIT = @P_LANCTONF             AND
                        NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                        CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                        NRSEQITPRO   = '1';

                  IF @V_IDREDUCAO = 'S' BEGIN
                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                        CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                        VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT,
                        CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                     VALUES(
                        @P_FILIAL,     @P_LANCTONF,  @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '2', '2',
                        @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, 0,       ISNULL(@V_PERDBCALC,0),
                        ISNULL(@V_PARDEDTMP,0), ISNULL(ROUND(@V_CONTABCALC,2),0), 0, 0,'00000', '00000',
                        @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);

                     DELETE FROM TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                           NRSEQITPRO   = '2';

                     IF  @V_NRIMPOSTO  > 0 BEGIN
                        INSERT INTO TRABITPROIMPOS(
                           CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                           CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                           VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT,
                           CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                        VALUES(
                           @P_FILIAL,     @P_LANCTONF,   @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '2', '2',
                           @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, 0,        @V_PERDBCALC, ISNULL(@V_PARDEDTMP,0),
                           ISNULL(ROUND(@V_CONTABCALC,2),0), 0, 0,'00000', '00000', @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE,
                           @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);
                     END;
                  END
                  ELSE BEGIN
                     DELETE FROM TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                           NRSEQITPRO   = '2';
                  END;

                  DELETE FROM ALIQTEMP
                  WHERE NRALIQTEMP = @V_ALIQTEMP;

                  IF (@V_DIFALIQITEM = 'S')           AND
                     (@V_INCIDENC_IDIMPORECUP = 'S')  AND
                     (@V_INCIDENC_IDORGARRECAD = 'E') BEGIN

                     SET @V_ALIQDIFE    = 0;
                     SET @V_ALIQDEST    = 0;
                     SET @V_IMPOSTODIFE = 0;

                     IF @V_INCIDENC_IDUTMUNIORIG = 'D' BEGIN
                        /* CONSIDERA O MUNICIPIO DE DESTINO */
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @V_PAISORIG,
                                               @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL, @P_LANCTONF,
                                               @V_CDGRUPOFISC, @P_TIPOOPER;
                     END
                     ELSE BEGIN
                        /* CONSIDERA O MUNICIPIO DE ORIGEM */
                        EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, @V_ITEMPROD_CDARVPROD, @P_INSCESTA, @V_PAISDEST,
                                               @V_ESTADEST, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID, @P_FILIAL, @P_LANCTONF,
                                               @V_CDGRUPOFISC, @P_TIPOOPER;
                     END;

                     SELECT @V_ALIQDEST = MAX(VRALIQUTMP)
                     FROM ALIQTEMP
                     WHERE (NRALIQTEMP = @V_ALIQTEMP);

                     IF @V_ALIQDEST IS NULL BEGIN
                        SET @V_ALIQDEST = 0;
                     END;

                     IF (@V_ALIQUTMP < @V_ALIQDEST) BEGIN
                        SET @V_ALIQDIFE    = @V_ALIQDEST - @V_ALIQUTMP;
                        SET @V_IMPOSTODIFE = ROUND((@V_BASECALCIT * (@V_ALIQDIFE/100)), @V_NRDECITOTANF);

                        INSERT INTO ITEMPROIMPOS(
                           CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                           CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                           VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, IDVALORINFIT,
                           CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE, IDDIFALIQCUSPRI,
                           CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                        VALUES(
                           @P_FILIAL, @P_LANCTONF, @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '3', @V_INCIDENC_CDFISCTEMP,
                           @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, @V_ALIQDIFE, ISNULL(@V_PREDBCTMP,0), ISNULL(@V_PARDEDTMP,0), ISNULL(ROUND(@V_BASECALCIT,2),0), ISNULL(@V_BASECALCIT,0),
                           ISNULL(@V_IMPOSTODIFE,0), '00000', '00000', @V_IDVALORINFO,
                           @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_IDDIFALIQCUSPRC, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);
                     END
                     ELSE BEGIN
                        DELETE FROM TRABITPROIMPOS
                        WHERE CDFILIMPOIT  = @P_FILIAL   AND
                              NRLANCIMPOIT = @P_LANCTONF AND
                              NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                              CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                              NRSEQITPRO   = '3';
                     END;

                     IF (@V_ALIQINFO < @V_ALIQDEST) BEGIN
                        SET @V_ALIQDIFE    = @V_ALIQDEST - @V_ALIQINFO;
                        SET @V_IMPOSTODIFE = @V_BASECALCIT * (@V_ALIQDIFE/100);

                        DELETE FROM TRABITPROIMPOS
                        WHERE CDFILIMPOIT  = @P_FILIAL   AND
                              NRLANCIMPOIT = @P_LANCTONF AND
                              NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                              CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                              NRSEQITPRO   = '3';

                        INSERT INTO TRABITPROIMPOS(
                           CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                           CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                           VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                           CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, IDDIFALIQCUSPTI,
                           CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                        VALUES(
                           @P_FILIAL, @P_LANCTONF, @V_ITEMPROD_NRSEQITPROD, @V_INCIDENC_CDIMPOTEMP, '3', @V_INCIDENC_CDFISCTEMP,
                           @V_SITUTRIBPR, @V_FISOPEITEM, @V_SUFXCFOPPR, @V_ALIQDIFE, ISNULL(@V_PREDBCTMP,0), ISNULL(@V_PARDEDTMP,0), ISNULL(ROUND(@V_BASECALCIT,2),0),
                           ISNULL(@V_BASECALCIT,0), ISNULL(@V_IMPOSTODIFE,0), '00000', '00000', @V_IDVALORINFO,
                           @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_IDDIFALIQCUSPRC,
                           @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);
                     END;
                  END
                  ELSE BEGIN
                     DELETE FROM TRABITPROIMPOS
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDENC_CDIMPOTEMP  AND
                           NRSEQITPRO   = '3';
                  END;

                  DELETE FROM ALIQTEMP
                  WHERE NRALIQTEMP = @V_ALIQTEMP;

                  FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP,   @V_INCIDENC_CDFISCTEMP,
                                                    @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDCONSISTENT,
                                                    @V_INCIDENC_IDUTMUNIORIG, @V_INCIDENC_IDIMPORECUP,
                                                    @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDORGARRECAD,
                                                    @V_INCIDENC_IDUTVLRQTDEIMPO, @V_INCIDENC_IDUTVRPAUTA;
               END; /* WHILE DO CURSOR C_INCIDENCIA*/

               CLOSE C_INCIDENCIA;
               DEALLOCATE C_INCIDENCIA;

               DELETE FROM INCITEMP
               WHERE NRINCITEMP = @V_INCITEMP;
            END;
            FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPROD_VRTOTAITEM, @V_ITEMPROD_VRDESCITEM,
                                               @V_ITEMPROD_CDPRODUTO,  @V_ITEMPROD_NRSEQITPROD,
                                               @V_ITEMPROD_CDARVPROD,  @V_ITEMPROD_QTITEMPROD,
                                               @V_ITEMPROD_CDFISOPEITEM, @V_ITEMPROD_CDSITUTRIBPR;
         END;
         CLOSE C_ITEMPRODUTO;
         DEALLOCATE C_ITEMPRODUTO;

         IF (@V_INTEGRACAO IS NOT NULL) AND (@P_ENTRSAID = 'S') BEGIN
            INSERT INTO ITEMPROIMPOS(
               CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
               CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
               VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
               (SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT, CDSTRIBIMPOIT,
                       CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, ISNULL(VRREDBCIMPOIT,0), ISNULL(VRPDEDIMPOIT,0), ISNULL(ROUND(VRCONTIMPOIT,2),0),
                       ISNULL(VRBCALCIMPOIT,0), ISNULL(VRIMPOSIT,0), IDERRIMPOIT, IDAVISIMPOIT, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT
                FROM TRABITPROIMPOS
                WHERE CDFILIMPOIT  = @P_FILIAL   AND
                      NRLANCIMPOIT = @P_LANCTONF);

            SELECT @V_TOTAPROD = SUM(VRTOTAITEM - VRDESCITEM)
            FROM ITEMPRODUTO
            WHERE CDFILIAL   = @P_FILIAL   AND
                  NRLANCTONF = @P_LANCTONF;

            IF (@V_TOTAPROD IS NULL) BEGIN
               SET @V_TOTAPROD = 0;
            END;

            IF (@V_TOTAPROD > 0) BEGIN
               UPDATE ITEMPRODUTO
               SET VRBRUTITEM   = (@V_NOTAFISC/@V_TOTAPROD)*(VRTOTAITEM - VRDESCITEM)
               WHERE CDFILIAL   = @P_FILIAL   AND
                     NRLANCTONF = @P_LANCTONF;
            END;
         END;
      --------------------------------------------------------------------------------------------------------
      --RATEIO DOS ENCARGOS

         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN

            DECLARE C_ITEMENCARGO CURSOR FOR
             SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0)) VRITEMENCA, IDENCARGO,
                    EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
               FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL   = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF) I
              WHERE (IE.CDFILIAL   = @P_FILIAL)
                AND (IE.NRLANCTONF = @P_LANCTONF)
                AND (IE.VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0) > 0)
                AND (EN.CDENCARGO  = IE.CDENCARGO);

            OPEN C_ITEMENCARGO;

            FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                               @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                               @V_ITEMENC_CDCTBLSAIDEN;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_TOTAPRODENCA = 0;

               DECLARE C_VRLIQRATEIO CURSOR FOR
               SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
               FROM ITEMPRODUTO IP, ITEMPROIMPOS II
               WHERE (IP.CDFILIAL    = @P_FILIAL)      AND
                     (IP.NRLANCTONF  = @P_LANCTONF)    AND
                     (II.CDFILIAL    = IP.CDFILIAL)    AND
                     (II.NRLANCTONF  = IP.NRLANCTONF)  AND
                     (II.NRSEQITPROD = IP.NRSEQITPROD) AND
                     (II.NRITPROIMPOS = '1')           AND
                     (II.CDIMPOSTO IN (SELECT (BC.CDIMPOSTO)
                                       FROM BASECALC BC
                                       WHERE (BC.CDENCARGO = @V_ITEMENC_CDENCARGO)));

               OPEN C_VRLIQRATEIO;

               FETCH NEXT FROM C_VRLIQRATEIO INTO @V_VRLIQ_NRSEQITPROD, @V_VRLIQ_VRLIQUIDO;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF NOT (@V_VRLIQ_VRLIQUIDO IS NULL) BEGIN
                     SET @V_TOTAPRODENCA = @V_TOTAPRODENCA + @V_VRLIQ_VRLIQUIDO;
                  END;

                  FETCH NEXT FROM C_VRLIQRATEIO INTO @V_VRLIQ_NRSEQITPROD, @V_VRLIQ_VRLIQUIDO;
               END; /*WHILE DO CURSOR C_VRLIQRATEIO*/

               CLOSE C_VRLIQRATEIO;
               DEALLOCATE C_VRLIQRATEIO;

               IF (@V_TOTAPRODENCA = 0) BEGIN
                  SELECT @V_TOTAPRODENCA = SUM(VRTOTAITEM - VRDESCITEM)
                  FROM ITEMPRODUTO IP
                  WHERE (IP.CDFILIAL   = @P_FILIAL)   AND
                        (IP.NRLANCTONF = @P_LANCTONF);

                  IF @V_TOTAPRODENCA <> 0 BEGIN

                     DECLARE C_ATUAVRCONT CURSOR FOR
                     SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                     FROM ITEMPRODUTO IP
                     WHERE (IP.CDFILIAL    = @P_FILIAL) AND
                           (IP.NRLANCTONF  = @P_LANCTONF);

                     OPEN C_ATUAVRCONT;

                     FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;

                     WHILE (@@FETCH_STATUS = 0) BEGIN

                        IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                           SET @V_VRBRUTO  = (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                        END
                        ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                           SET @V_VRBRUTO  = - (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                        END
                        ELSE BEGIN
                           SET @V_VRBRUTO = 0;
                        END;

                        IF (@V_ITEMENC_CDCTBLENTREN IS NULL) BEGIN
                           SET @V_VRCONTAB = @V_VRBRUTO;
                        END
                        ELSE BEGIN
                           SET @V_VRCONTAB = 0;
                        END;

                        SELECT @V_VALRDESCITEM = (VRTOTAITEM - VRDESCITEM)
                        FROM ITEMPRODUTO
                        WHERE CDFILIAL    = @P_FILIAL   AND
                              NRLANCTONF  = @P_LANCTONF AND
                              NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM + (@V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                            VRCONTITEM = VRCONTITEM + (@V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                        WHERE CDFILIAL    = @P_FILIAL   AND
                              NRLANCTONF  = @P_LANCTONF AND
                              NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                        UPDATE TRABITPROIMPOS
                        SET VRCONTIMPOIT = ISNULL(ROUND(VRCONTIMPOIT + ((@V_VRBRUTO * @V_VALRDESCITEM) * ((100 - VRREDBCIMPOIT)/100)),2),0)
                        WHERE CDFILIMPOIT  = @P_FILIAL   AND
                              NRLANCIMPOIT = @P_LANCTONF AND
                              NRSEQIMPOIT  = @V_ATUAVR_NRSEQITPROD;

                        FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;
                     END; /*WHILE DO CURSOR C_ATUAVRCONT*/

                     CLOSE C_ATUAVRCONT;
                     DEALLOCATE C_ATUAVRCONT;
                  END;
               END
               ELSE BEGIN

                  DECLARE C_ATUAVRCONT CURSOR FOR
                  SELECT DISTINCT(IP.NRSEQITPROD) AS NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                         NRITPROIMPOS
                  FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                  WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                        (IP.NRLANCTONF   = @P_LANCTONF)    AND
                        (II.CDFILIAL     = IP.CDFILIAL)    AND
                        (II.NRLANCTONF   = IP.NRLANCTONF)  AND
                        (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                        (II.NRITPROIMPOS = '1')            AND
                        (II.CDIMPOSTO IN (SELECT BC.CDIMPOSTO
                                          FROM BASECALC BC
                                          WHERE (BC.CDENCARGO = @V_ITEMENC_CDENCARGO)));
                  OPEN C_ATUAVRCONT;

                  FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO, @V_ATUAVR_NRITPROIMPOS;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                        SET @V_VRBRUTO = (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                     END
                     ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                        SET @V_VRBRUTO = - (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                     END
                     ELSE BEGIN
                        SET @V_VRBRUTO = 0;
                     END;

                     IF (@V_ITEMENC_CDCTBLENTREN IS NULL) BEGIN
                        SET @V_VRCONTAB = @V_VRBRUTO;
                     END
                     ELSE BEGIN
                        SET @V_VRCONTAB = 0;
                     END;

                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM + (@V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                         VRCONTITEM = VRCONTITEM + (@V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                     FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO, @V_ATUAVR_NRITPROIMPOS;
                  END; /*WHILE DO CURSOR C_ATUAVRCONT*/

                  CLOSE C_ATUAVRCONT;
                  DEALLOCATE C_ATUAVRCONT;

                  DECLARE C_ITEMPROIMPOS CURSOR FOR
                  SELECT II.NRSEQITPROD, II.CDIMPOSTO, II.VRPERREDBCIT, II.VRALIQITEM, II.VRPARDEDIT,
                         TI.VRALIQIMPOIT, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO,
                         TI.IDVALORINFO, II.NRITPROIMPOS, II.IDTRIMPSTII
                  FROM ITEMPROIMPOS II, ITEMPRODUTO IP, BASECALC BC, TRABITPROIMPOS TI
                  WHERE (II.CDFILIAL     = @P_FILIAL)       AND
                        (II.NRLANCTONF   = @P_LANCTONF)     AND
                        (IP.CDFILIAL     = @P_FILIAL)       AND
                        (IP.NRLANCTONF   = @P_LANCTONF)     AND
                        (IP.NRSEQITPROD  = II.NRSEQITPROD) AND
                        (TI.CDFILIMPOIT  = @P_FILIAL)       AND
                        (TI.NRLANCIMPOIT = @P_LANCTONF)     AND
                        (TI.NRSEQIMPOIT  = II.NRSEQITPROD) AND
                        (TI.CDIMPOSTOIT  = II.CDIMPOSTO)   AND
                        (II.NRITPROIMPOS = TI.NRSEQITPRO)  AND
                        (BC.CDIMPOSTO    = II.CDIMPOSTO)   AND
                        (BC.CDENCARGO    = @V_ITEMENC_CDENCARGO);

                  OPEN C_ITEMPROIMPOS;

                  FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_ITEMPROI_NRSEQITPROD, @V_ITEMPROI_CDIMPOSTO,
                                                      @V_ITEMPROI_VRPERREDBCIT, @V_ITEMPROI_VRALIQITEM,
                                                      @V_ITEMPROI_VRPARDEDIT, @V_ITEMPROI_VRALIQIMPOIT,
                                                      @V_ITEMPROI_VRLIQUIDO, @V_ITEMPROI_IDVALORINFO,
                                                      @V_ITEMPROI_NRITPROIMPOS, @V_ITEMPROI_IDTRIMPSTII;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SELECT @V_TOTAPRENIMPO = SUM(VRTOTAITEM - VRDESCITEM)
                     FROM ITEMPRODUTO IP, ITEMPROIMPOS II
                     WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                           (IP.NRLANCTONF   = @P_LANCTONF)    AND
                           (II.CDFILIAL     = @P_FILIAL)      AND
                           (II.NRLANCTONF   = @P_LANCTONF)    AND
                           (II.NRSEQITPROD  = IP.NRSEQITPROD) AND
                           (II.NRITPROIMPOS = '1')            AND
                           (II.CDIMPOSTO    = @V_ITEMPROI_CDIMPOSTO);

                     IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                        SET @V_PRODUENCARGO = +(@V_ITEMENC_VRITEMENCA/@V_TOTAPRENIMPO)*@V_ITEMPROI_VRLIQUIDO;
                     END
                     ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                        SET @V_PRODUENCARGO = -(@V_ITEMENC_VRITEMENCA/@V_TOTAPRENIMPO)*@V_ITEMPROI_VRLIQUIDO;
                     END
                     ELSE BEGIN
                        SET @V_PRODUENCARGO = 0;
                     END;

                     SELECT @V_IDIMPORTAIMPXML = ISNULL(IDVALORINFO, 'N')
                       FROM TRABITPROIMPOS
                      WHERE CDFILIMPOIT  = @P_FILIAL
                        AND NRLANCIMPOIT = @P_LANCTONF
                        AND NRSEQIMPOIT  = @V_ITEMPROI_NRSEQITPROD
                        AND CDIMPOSTOIT  = @V_ITEMPROI_CDIMPOSTO
                        AND NRSEQITPRO   = '1';

                     IF (@V_IDNFGERADAVIAXML = 'S') AND ((@V_IDIMPORTAIMPXML = 'S') OR (@V_IDGERNFIGUALXML = 'S')) BEGIN
                        SET @V_PRODUENCARGO = 0;
                     END;

                     SET @V_TAXAALIQUOTA = (@V_ITEMPROI_VRALIQITEM/100);
                     SET @V_TAXAALIQINFO = (@V_ITEMPROI_VRALIQIMPOIT/100);

                     /*SELECT @V_CDIMPOSTRIB = MAX(CDIMPOSTO), @V_IDVRIMPSTRIB = MAX(IDVRIMPSTRIB)
                     FROM IMPOSTO
                     WHERE CDIMPOSTRIB = @V_ITEMPROI_CDIMPOSTO; */

                     SET @V_CDIMPOSTRIB  = null;
                     SET @V_IDVRIMPSTRIB = null;
                     SET @V_VRIMPOSTOST = 0;
                     SET @V_VRPPRIIMPST = 0;

                     DECLARE C_ICMSST CURSOR FOR
                           SELECT CDIMPOSTO
                             FROM IMPOSTO
                            WHERE CDIMPOSTRIB = @V_INCIDENC_CDIMPOTEMP;

                     OPEN C_ICMSST;
                     FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                     WHILE (@@FETCH_STATUS = 0) BEGIN

                        SET @V_CDIMPOSTRIB = ISNULL(@V_CDIMPOSTRIB,'')+@V_ICMSST_CDIMPOSTRIB+'_';
                        FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTRIB;
                     END;
                     CLOSE C_ICMSST;
                     DEALLOCATE C_ICMSST;

                     IF @V_CDIMPOSTRIB IS NULL BEGIN
                        SET @V_TAXABASECALC = (100 - @V_ITEMPROI_VRPERREDBCIT)/100;
                     END
                     ELSE BEGIN
                        SET @V_TAXABASECALC = 1 + (@V_ITEMPROI_VRPERREDBCIT)/100;
                     END;

                     SET @V_VRIMPOSTOST = 0;

                     IF @V_CDIMPOSTRIB IS NOT NULL BEGIN
                        SELECT @V_IDVRIMPSTRIB = ISNULL(MAX(IDVRIMPSTRIB), 'N')
                          FROM TRABITPROIMPOS I, IMPOSTO II
                         WHERE (CDFILIMPOIT     = @P_FILIAL)
                           AND (NRLANCIMPOIT    = @P_LANCTONF)
                           AND (NRSEQIMPOIT     = @V_ITEMPROI_NRSEQITPROD)
                           AND (CHARINDEX(II.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0)
                           AND (I.CDIMPOSTOIT = II.CDIMPOSTO);


                        IF (@V_ITEMPROI_IDTRIMPSTII = '1') OR (ISNULL(@V_ITEMPROI_IDTRIMPSTII,'N') = 'N') BEGIN
                           SET @V_VRIMPOSTOST = 0;
                        END
                        ELSE BEGIN
                           SELECT @V_VRIMPOSTOST = ISNULL(MAX(VRIMPOSIT),0)
                           FROM TRABITPROIMPOS I
                           WHERE (CDFILIMPOIT  = @P_FILIAL)               AND
                                 (NRLANCIMPOIT = @P_LANCTONF)             AND
                                 (NRSEQIMPOIT  = @V_ITEMPROI_NRSEQITPROD) AND
                                 (CHARINDEX(CDIMPOSTOIT+'_', @V_CDIMPOSTRIB) > 0) AND
                                 (NRSEQITPRO   = '1');
                        END;
                     END;

                     IF @V_ITEMPROI_IDVALORINFO = 'S' BEGIN
                        SET @V_IMPOSTOIT = 0;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
                        SET @V_IMPOSTOIT = @V_IMPOSTOIT - ((@V_VRIMPOSTOST * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
                     END;

                     UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = ISNULL(VRBASECALCIT + (@V_PRODUENCARGO * @V_TAXABASECALC),0),
                         VRIMPOSTOIT  = VRIMPOSTOIT  + @V_IMPOSTOIT
                     WHERE (NRLANCTONF   = @P_LANCTONF) AND
                           (CDFILIAL     = @P_FILIAL)   AND
                           (NRSEQITPROD  = @V_ITEMPROI_NRSEQITPROD) AND
                           (CDIMPOSTO    = @V_ITEMPROI_CDIMPOSTO)   AND
                           (NRITPROIMPOS = @V_ITEMPROI_NRITPROIMPOS);

                     IF @V_ITEMPROI_IDVALORINFO = 'S' BEGIN
                        SET @V_IMPOSTOIT = 0;
                     END
                     ELSE BEGIN
                        SET @V_IMPOSTOIT = ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQINFO);
                        SET @V_IMPOSTOIT  = @V_IMPOSTOIT - ((@V_VRIMPOSTOST * @V_TAXABASECALC) * @V_TAXAALIQINFO);
                     END;

                     UPDATE TRABITPROIMPOS
                     SET VRBCALCIMPOIT  = ISNULL(VRBCALCIMPOIT + (@V_PRODUENCARGO * @V_TAXABASECALC),0),
                         VRIMPOSIT      = VRIMPOSIT     + @V_IMPOSTOIT
                     WHERE CDFILIMPOIT  = @P_FILIAL               AND
                           NRLANCIMPOIT = @P_LANCTONF             AND
                           NRSEQIMPOIT  = @V_ITEMPROI_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_ITEMPROI_CDIMPOSTO   AND
                           NRSEQITPRO   = @V_ITEMPROI_NRITPROIMPOS;

                     FETCH NEXT FROM C_ITEMPROIMPOS INTO @V_ITEMPROI_NRSEQITPROD, @V_ITEMPROI_CDIMPOSTO,
                                                         @V_ITEMPROI_VRPERREDBCIT, @V_ITEMPROI_VRALIQITEM,
                                                         @V_ITEMPROI_VRPARDEDIT, @V_ITEMPROI_VRALIQIMPOIT,
                                                         @V_ITEMPROI_VRLIQUIDO, @V_ITEMPROI_IDVALORINFO,
                                                         @V_ITEMPROI_NRITPROIMPOS, @V_ITEMPROI_IDTRIMPSTII;
                  END; /*WHILE DO CURSOR C_ITEMPROIMPOS*/

                  CLOSE C_ITEMPROIMPOS;
                  DEALLOCATE C_ITEMPROIMPOS;
               END;

               FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                                  @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                                  @V_ITEMENC_CDCTBLSAIDEN;
            END; /*WHILE DO CURSOR C_ITEMENCARGO*/

            CLOSE C_ITEMENCARGO;
            DEALLOCATE C_ITEMENCARGO;

            UPDATE ITEMPROIMPOS
            SET VRIMPOSTOIT = 0
            WHERE (NRLANCTONF  = @P_LANCTONF) AND
                  (CDFILIAL    = @P_FILIAL) AND
                  (VRIMPOSTOIT < 0);

            UPDATE TRABITPROIMPOS
            SET VRIMPOSIT      = 0
            WHERE CDFILIMPOIT  = @P_FILIAL   AND
                  NRLANCIMPOIT = @P_LANCTONF AND
                  VRIMPOSIT    < 0;
   ---------------------------------------------------------------------------------------------------------

      --CLCULO DO VALOR DOS IMPOSTOS QUE CONTM OUTROS IMPOSTOS NA SUA BASE DE CLCULO

            SET @V_CALCPISIMP  = 'N';
            SET @V_CALCCOFIMP  = 'N';
            SET @V_CALCICMSIMP = 'N';
            SET @V_CALCIPIIMP  = 'N';
            SET @V_CALCIIIMP   = 'N';

            SET @V_PRODPISIMP  = 'N';
            SET @V_PRODCOFIMP  = 'N';
            SET @V_PRODIIIMP   = 'N';
            SET @V_PRODIPIIMP  = 'N';
            SET @V_PRODICMSIMP = 'N';
            SET @V_FATCONVIMP  = 1;
            /*
            SET @V_ENCBCIMP    = 0;
            SET @V_ENCBCIMPICMS= 0;
            */

            SET @V_VRPISIMP    = 0;
            SET @V_VRIPIIMP    = 0;
            SET @V_VRIIIMP     = 0;
            SET @V_VRCOFIMP    = 0;
            SET @V_VRICMSIMP   = 0;

            SET @V_ALIQCOFIMP  = 0;
            SET @V_ALIQIMPII   = 0;
            SET @V_ALIQIPIIMP  = 0;
            SET @V_ALIQICMSIMP = 0;

            SET @V_PRODSEQIMP  = 0;
            SET @V_PRODIMP     = 0;
            SET @V_PERCENC     = 0;

            SET @V_VRBASECALCII  = 0;
            SET @V_VRBASECALCIPI = 0;
            SET @V_VRBASECALCPIS = 0;
            SET @V_VRBASECALCCOF = 0;


            DECLARE C_PRODUTO CURSOR FOR
            SELECT IP.NRSEQITPROD AS NRSEQITPROD, TI.CDIMPOSTOIT AS CDIMPOSTO,
                   ISNULL(II.VRPERREDBCIT, 0) AS VRPERREDBCIT, ISNULL(II.VRALIQITEM, 0) AS VRALIQITEM,
                   ISNULL(II.VRPARDEDIT, 0) AS VRPARDEDIT, II.CDFISCALIT, ISNULL(TI.VRIMPOSIT, 0) AS VRIMPOSIT,
                   IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, TI.VRALIQIMPOIT,
                   II.NRITPROIMPOS, TI.NRSEQITPRO, ISNULL(TI.IDVALORINFO,'N') AS IDVALORINFO,
                   II.IDTRIMPSTII, IM.IDTIPCONTAB, ISNULL(II.VRBASECALCIT, 0) AS VRBASECALCIT,
                   P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, ISNULL(IM.IDCONTAIMPADIC, 'N') AS IDCONTAIMPADIC,
                   INFE.CDIMPOSTONFE AS CDIMPOSTONFE
            FROM ITEMPRODUTO IP, TRABITPROIMPOS TI LEFT JOIN ITEMPROIMPOS II ON
                 (TI.CDFILIMPOIT  = II.CDFILIAL)     AND
                 (TI.NRLANCIMPOIT = II.NRLANCTONF)   AND
                 (TI.NRSEQIMPOIT  = II.NRSEQITPROD)  AND
                 (TI.NRSEQITPRO   = II.NRITPROIMPOS) AND
                 (TI.CDIMPOSTOIT  = II.CDIMPOSTO),
                 IMPOSTO IM, PRODUTO P, IMPOSTONFE INFE
            WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                  (IP.NRLANCTONF   = @P_LANCTONF)    AND
                  (TI.CDFILIMPOIT  = @P_FILIAL)      AND
                  (TI.NRLANCIMPOIT = @P_LANCTONF)    AND
                  (TI.NRSEQIMPOIT  = IP.NRSEQITPROD) AND
                  (TI.CDIMPOSTOIT  = IM.CDIMPOSTO)   AND
                  (TI.NRSEQITPRO   = '1')            AND
                  (IP.CDPRODUTO    = P.CDPRODUTO)

            UNION ALL

            SELECT IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO AS CDIMPOSTO,
                   ISNULL(II.VRPERREDBCIT, 0) VRPERREDBCIT, ISNULL(II.VRALIQITEM, 0) VRALIQITEM,
                   ISNULL(II.VRPARDEDIT, 0) VRPARDEDIT, II.CDFISCALIT, ISNULL(II.VRIMPOSTOIT, 0) AS VRIMPOSIT,
                   IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, II.VRALIQITEM AS VRALIQIMPOIT,
                   II.NRITPROIMPOS, II.NRSEQITPROD AS NRSEQITPRO, ISNULL(II.IDVALORINFIT,'N') AS IDVALORINFO,
                   II.IDTRIMPSTII, IM.IDTIPCONTAB, ISNULL(II.VRBASECALCIT, 0) VRBASECALCIT,
                   P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, ISNULL(IM.IDCONTAIMPADIC, 'N') AS IDCONTAIMPADIC,
                   INFE.CDIMPOSTONFE AS CDIMPOSTONFE
            FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM, PRODUTO P, IMPOSTONFE INFE
            WHERE (IP.CDFILIAL     = @P_FILIAL)          AND
                  (IP.NRLANCTONF   = @P_LANCTONF)        AND
                  (II.CDFILIAL     = IP.CDFILIAL)        AND
                  (II.NRLANCTONF   = IP.NRLANCTONF)      AND
                  (II.NRSEQITPROD  = IP.NRSEQITPROD)     AND
                  (II.CDIMPOSTO    = IM.CDIMPOSTO)       AND
                  (II.NRITPROIMPOS = '1')                AND
                  (IP.CDPRODUTO    = P.CDPRODUTO)        AND
                  NOT EXISTS (SELECT T.CDFILIMPOIT
                              FROM  TRABITPROIMPOS T
                              WHERE T.CDFILIMPOIT  = IP.CDFILIAL    AND
                                    T.NRLANCIMPOIT = IP.NRLANCTONF)
            ORDER BY NRSEQITPROD, CDIMPOSTONFE;

            OPEN C_PRODUTO;
            FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_NRSEQITPROD , @V_PRODUTO_CDIMPOSTO,
                                           @V_PRODUTO_VRPERREDBCIT, @V_PRODUTO_VRALIQITEM,
                                           @V_PRODUTO_VRPARDEDIT  , @V_PRODUTO_CDFISCALIT,
                                           @V_PRODUTO_VRIMPOSIT   , @V_PRODUTO_IDTRATIMPO,
                                           @V_PRODUTO_IDIMPORECUP , @V_PRODUTO_CDCCTBLPASS,
                                           @V_PRODUTO_CDCCTBLATIV , @V_PRODUTO_VRALIQIMPOIT,
                                           @V_PRODUTO_NRITPROIMPOS, @V_PRODUTO_NRSEQITPRO,
                                           @V_PRODUTO_IDVALORINFO , @V_PRODUTO_IDTRIMPSTII,
                                           @V_PRODUTO_IDTIPCONTAB , @V_PRODUTO_VRBASECALCIT,
                                           @V_PRODUTO_CDARVPROD   , @V_PRODUTO_CDPRODUTO,
                                           @V_PRODUTO_VRTOTAITEM  , @V_PRODUTO_VRDESCITEM,
                                           @V_PRODUTO_IDCONTAIMPADIC, @V_PRODUTO_CDIMPOSTONFE;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_IDIMPOBCALTPOP = NULL;

               DECLARE C_IMPOSTOIMP CURSOR FOR
               SELECT IP.NRSEQITPROD AS NRSEQITPROD, TI.CDIMPOSTOIT AS CDIMPOSTO,
                      ISNULL(II.VRPERREDBCIT, 0) AS VRPERREDBCIT, ISNULL(II.VRALIQITEM, 0) AS VRALIQITEM,
                      ISNULL(II.VRPARDEDIT, 0) AS VRPARDEDIT, II.CDFISCALIT, ISNULL(TI.VRIMPOSIT, 0) AS VRIMPOSIT,
                      IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, TI.VRALIQIMPOIT,
                      II.NRITPROIMPOS, TI.NRSEQITPRO, ISNULL(TI.IDVALORINFO,'N') AS IDVALORINFO,
                      II.IDTRIMPSTII, IM.IDTIPCONTAB, ISNULL(II.VRBASECALCIT, 0) AS VRBASECALCIT,
                      P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, ISNULL(IM.IDCONTAIMPADIC, 'N') AS IDCONTAIMPADIC,
                      INFE.CDIMPOSTONFE AS CDIMPOSTONFE
                 FROM ITEMPRODUTO IP, TRABITPROIMPOS TI LEFT JOIN ITEMPROIMPOS II ON
                      (TI.CDFILIMPOIT  = II.CDFILIAL)     AND
                      (TI.NRLANCIMPOIT = II.NRLANCTONF)   AND
                      (TI.NRSEQIMPOIT  = II.NRSEQITPROD)  AND
                      (TI.NRSEQITPRO   = II.NRITPROIMPOS) AND
                      (TI.CDIMPOSTOIT  = II.CDIMPOSTO),
                      IMPOSTO IM, PRODUTO P, IMPOSTONFE INFE
                 WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                       (IP.NRLANCTONF   = @P_LANCTONF)    AND
                       (TI.CDFILIMPOIT  = @P_FILIAL)      AND
                       (TI.NRLANCIMPOIT = @P_LANCTONF)    AND
                       (TI.NRSEQIMPOIT  = IP.NRSEQITPROD) AND
                       (TI.NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD) AND
                       (TI.CDIMPOSTOIT  = IM.CDIMPOSTO)   AND
                       (IM.CDIMPOSTONFE = INFE.CDIMPOSTONFE)  AND
                       (TI.NRSEQITPRO   = '1')            AND
                       (IP.CDPRODUTO    = P.CDPRODUTO)

                 UNION ALL

                 SELECT IP.NRSEQITPROD AS NRSEQITPROD, II.CDIMPOSTO AS CDIMPOSTO,
                        ISNULL(II.VRPERREDBCIT, 0) VRPERREDBCIT, ISNULL(II.VRALIQITEM, 0) VRALIQITEM,
                        ISNULL(II.VRPARDEDIT, 0) VRPARDEDIT, II.CDFISCALIT, ISNULL(II.VRIMPOSTOIT, 0) AS VRIMPOSIT,
                        IM.IDTRATIMPO, IM.IDIMPORECUP, IM.CDCCTBLPASS, IM.CDCCTBLATIV, II.VRALIQITEM AS VRALIQIMPOIT,
                        II.NRITPROIMPOS, II.NRSEQITPROD AS NRSEQITPRO, ISNULL(II.IDVALORINFIT,'N') AS IDVALORINFO,
                        II.IDTRIMPSTII, IM.IDTIPCONTAB, ISNULL(II.VRBASECALCIT, 0) VRBASECALCIT,
                        P.CDARVPROD, P.CDPRODUTO, IP.VRTOTAITEM, IP.VRDESCITEM, ISNULL(IM.IDCONTAIMPADIC, 'N') AS IDCONTAIMPADIC,
                        INFE.CDIMPOSTONFE AS CDIMPOSTONFE
                 FROM ITEMPRODUTO IP, ITEMPROIMPOS II, IMPOSTO IM, PRODUTO P, IMPOSTONFE INFE
                 WHERE (IP.CDFILIAL     = @P_FILIAL)          AND
                       (IP.NRLANCTONF   = @P_LANCTONF)        AND
                       (II.CDFILIAL     = IP.CDFILIAL)        AND
                       (II.NRLANCTONF   = IP.NRLANCTONF)      AND
                       (II.NRSEQITPROD  = IP.NRSEQITPROD)     AND
                       (IP.NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                       (II.CDIMPOSTO    = IM.CDIMPOSTO)       AND
                       (IM.CDIMPOSTONFE = INFE.CDIMPOSTONFE)  AND
                       (II.NRITPROIMPOS = '1')                AND
                       (IP.CDPRODUTO    = P.CDPRODUTO)        AND
                       NOT EXISTS (SELECT T.CDFILIMPOIT
                                   FROM  TRABITPROIMPOS T
                                   WHERE T.CDFILIMPOIT  = IP.CDFILIAL    AND
                                         T.NRLANCIMPOIT = IP.NRLANCTONF)
                 ORDER BY IP.NRSEQITPROD, INFE.CDIMPOSTONFE;

               OPEN C_IMPOSTOIMP;
               FETCH NEXT FROM C_IMPOSTOIMP INTO @V_IMPOSTOIMP_NRSEQITPROD , @V_IMPOSTOIMP_CDIMPOSTO,
                                                 @V_IMPOSTOIMP_VRPERREDBCIT, @V_IMPOSTOIMP_VRALIQITEM,
                                                 @V_IMPOSTOIMP_VRPARDEDIT  , @V_IMPOSTOIMP_CDFISCALIT,
                                                 @V_IMPOSTOIMP_VRIMPOSIT   , @V_IMPOSTOIMP_IDTRATIMPO,
                                                 @V_IMPOSTOIMP_IDIMPORECUP , @V_IMPOSTOIMP_CDCCTBLPASS,
                                                 @V_IMPOSTOIMP_CDCCTBLATIV , @V_IMPOSTOIMP_VRALIQIMPOIT,
                                                 @V_IMPOSTOIMP_NRITPROIMPOS, @V_IMPOSTOIMP_NRSEQITPRO,
                                                 @V_IMPOSTOIMP_IDVALORINFO , @V_IMPOSTOIMP_IDTRIMPSTII,
                                                 @V_IMPOSTOIMP_IDTIPCONTAB , @V_IMPOSTOIMP_VRBASECALCIT,
                                                 @V_IMPOSTOIMP_CDARVPROD   , @V_IMPOSTOIMP_CDPRODUTO,
                                                 @V_IMPOSTOIMP_VRTOTAITEM  , @V_IMPOSTOIMP_VRDESCITEM,
                                                 @V_IMPOSTOIMP_IDCONTAIMPADIC, @V_IMPOSTOIMP_CDIMPOSTONFE;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF (@V_IMPOSTOIMP_CDIMPOSTONFE = '00') BEGIN
                     SET @V_ALIQICMSIMP = @V_IMPOSTOIMP_VRALIQIMPOIT;
                     SET @V_CDICMSIMP   = @V_IMPOSTOIMP_CDIMPOSTO;
                     SET @V_NRITICMSIMP = @V_IMPOSTOIMP_NRITPROIMPOS;
                     SET @V_CDICMSNFE   = @V_IMPOSTOIMP_CDIMPOSTONFE;
                     SET @V_FATCONVIMP  = 100 - @V_ALIQICMSIMP;

                     SELECT @V_IDUTILPVRIMPBC = ISNULL(MAX(IDUTILPVRIMPBC), 'N')
                       FROM IMPOSTO
                      WHERE CDIMPOSTO = @V_CDICMSIMP;

                  END;
                  IF (@V_IMPOSTOIMP_CDIMPOSTONFE = '10') BEGIN
                     SET @V_ALIQIPIIMP  = @V_IMPOSTOIMP_VRALIQIMPOIT;
                     SET @V_CDIPIIMP    = @V_IMPOSTOIMP_CDIMPOSTO;
                     SET @V_NRITIPIIMP  = @V_IMPOSTOIMP_NRITPROIMPOS;
                     SET @V_CDIPINFE    = @V_IMPOSTOIMP_CDIMPOSTONFE;
                  END;
                  IF (@V_IMPOSTOIMP_CDIMPOSTONFE = '50') BEGIN
                     SET @V_ALIQPISIMP  = @V_IMPOSTOIMP_VRALIQIMPOIT;
                     SET @V_CDPISIMP    = @V_IMPOSTOIMP_CDIMPOSTO;
                     SET @V_NRITPISIMP  = @V_IMPOSTOIMP_NRITPROIMPOS;
                     SET @V_CDPISNFE    = @V_IMPOSTOIMP_CDIMPOSTONFE;
                  END;
                  IF (@V_IMPOSTOIMP_CDIMPOSTONFE = '60') BEGIN
                     SET @V_ALIQCOFIMP  = @V_IMPOSTOIMP_VRALIQIMPOIT;
                     SET @V_CDCOFIMP    = @V_IMPOSTOIMP_CDIMPOSTO;
                     SET @V_NRITCOFIMP  = @V_IMPOSTOIMP_NRITPROIMPOS;
                     SET @V_CDCOFNFE    = @V_IMPOSTOIMP_CDIMPOSTONFE;
                  END;
                  IF (@V_IMPOSTOIMP_CDIMPOSTONFE = '20') BEGIN
                     SET @V_ALIQIMPII   = @V_IMPOSTOIMP_VRALIQIMPOIT;
                     SET @V_CDIIIMP     = @V_IMPOSTOIMP_CDIMPOSTO;
                     SET @V_NRITIIIMP   = @V_IMPOSTOIMP_NRITPROIMPOS;
                     SET @V_CDIINFE     = @V_IMPOSTOIMP_CDIMPOSTONFE;
                  END;

                  FETCH NEXT FROM C_IMPOSTOIMP INTO @V_IMPOSTOIMP_NRSEQITPROD , @V_IMPOSTOIMP_CDIMPOSTO,
                                                    @V_IMPOSTOIMP_VRPERREDBCIT, @V_IMPOSTOIMP_VRALIQITEM,
                                                    @V_IMPOSTOIMP_VRPARDEDIT  , @V_IMPOSTOIMP_CDFISCALIT,
                                                    @V_IMPOSTOIMP_VRIMPOSIT   , @V_IMPOSTOIMP_IDTRATIMPO,
                                                    @V_IMPOSTOIMP_IDIMPORECUP , @V_IMPOSTOIMP_CDCCTBLPASS,
                                                    @V_IMPOSTOIMP_CDCCTBLATIV , @V_IMPOSTOIMP_VRALIQIMPOIT,
                                                    @V_IMPOSTOIMP_NRITPROIMPOS, @V_IMPOSTOIMP_NRSEQITPRO,
                                                    @V_IMPOSTOIMP_IDVALORINFO , @V_IMPOSTOIMP_IDTRIMPSTII,
                                                    @V_IMPOSTOIMP_IDTIPCONTAB , @V_IMPOSTOIMP_VRBASECALCIT,
                                                    @V_IMPOSTOIMP_CDARVPROD   , @V_IMPOSTOIMP_CDPRODUTO,
                                                    @V_IMPOSTOIMP_VRTOTAITEM  , @V_IMPOSTOIMP_VRDESCITEM,
                                                    @V_IMPOSTOIMP_IDCONTAIMPADIC, @V_IMPOSTOIMP_CDIMPOSTONFE;

               END;  /* WHILE DO CURSOR DOS IMPOSTOS DE IMPORTO */

               CLOSE C_IMPOSTOIMP;
               DEALLOCATE C_IMPOSTOIMP;

               IF (@V_CDIINFE = '20' AND @V_CALCIIIMP <> 'S') OR
                  (@V_CALCICMSIMP = 'S' AND @V_PRODUTO_NRSEQITPROD <> @V_PRODIIIMP AND @V_CDIINFE IS NOT NULL) BEGIN
                  SET @V_CALCIIIMP = 'S';
                  SET @V_PRODIIIMP = @V_PRODUTO_NRSEQITPROD;

                  SELECT @V_VRIIIMP = ISNULL(VRIMPOSTOIT, 0),
                         @V_VRBASECALCII = ISNULL(VRBASECALCIT, 0)
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDIIIMP)             AND
                         (NRITPROIMPOS = @V_NRITIIIMP);
               END;

               IF (@V_CDIPINFE = '10' AND @V_CALCIPIIMP <> 'S') OR
                  (@V_CALCICMSIMP = 'S' AND @V_PRODUTO_NRSEQITPROD <> @V_PRODIPIIMP AND @V_CDIPINFE IS NOT NULL) BEGIN
                  SET @V_CALCIPIIMP = 'S';
                  SET @V_PRODIPIIMP = @V_PRODUTO_NRSEQITPROD;

                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT  = VRBASECALCIT + ((@V_VRBASECALCII) * (@V_ALIQIMPII/100)),
                         VRIMPOSTOIT   = (VRBASECALCIT + ((@V_VRBASECALCII) * (@V_ALIQIMPII/100))) * (@V_ALIQIPIIMP/100)
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDIPIIMP)            AND
                         (NRITPROIMPOS = @V_NRITIPIIMP);

                  UPDATE TRABITPROIMPOS
                     SET VRBCALCIMPOIT  = VRBCALCIMPOIT + ((@V_VRBASECALCII) * (@V_ALIQIMPII/100)),
                         VRIMPOSIT      = (VRBCALCIMPOIT + ((@V_VRBASECALCII) * (@V_ALIQIMPII/100))) * (@V_ALIQIPIIMP/100)
                     WHERE CDFILIMPOIT  = @P_FILIAL              AND
                           NRLANCIMPOIT = @P_LANCTONF            AND
                           NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_CDIPIIMP             AND
                           NRSEQITPRO   = @V_NRITIPIIMP;

                  SELECT @V_VRIPIIMP = ISNULL(VRIMPOSTOIT, 0),
                         @V_VRBASECALCIPI = ISNULL(VRBASECALCIT, 0)
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDIPIIMP)            AND
                         (NRITPROIMPOS = @V_NRITIPIIMP);

               END;

               IF (@V_CDPISNFE = '50' AND @V_CALCPISIMP <> 'S') OR
                  (@V_CALCICMSIMP = 'S' AND @V_PRODUTO_NRSEQITPROD <> @V_PRODPISIMP AND @V_CDPISNFE IS NOT NULL) BEGIN

                  SET @V_CALCPISIMP = 'S';
                  SET @V_PRODPISIMP = @V_PRODUTO_NRSEQITPROD;

                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = ((VRBASECALCIT) * ((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                        ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100))))),

                         VRIMPOSTOIT  = ROUND(((@V_ALIQPISIMP/100)*  ((VRBASECALCIT) * ((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                             ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100)))))), 3)
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDPISIMP)            AND
                         (NRITPROIMPOS = @V_NRITPISIMP);

                  UPDATE TRABITPROIMPOS
                     SET VRBCALCIMPOIT  = ((VRBCALCIMPOIT) * ((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                          ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100))))),

                         VRIMPOSIT      = ROUND(((@V_ALIQPISIMP/100)*  ((VRBCALCIMPOIT) * ((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                               ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100)))))), 3)
                     WHERE CDFILIMPOIT  = @P_FILIAL              AND
                           NRLANCIMPOIT = @P_LANCTONF            AND
                           NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_CDPISIMP            AND
                           NRSEQITPRO   = @V_NRITPISIMP;

                  SELECT @V_VRPISIMP = ISNULL(VRIMPOSTOIT, 0),
                         @V_VRBASECALCPIS = ISNULL(VRBASECALCIT, 0)
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDPISIMP)            AND
                         (NRITPROIMPOS = @V_NRITPISIMP);

               END;

               IF (@V_CDCOFNFE = '60' AND @V_CALCCOFIMP <> 'S') OR
                  (@V_CALCICMSIMP = 'S' AND @V_PRODUTO_NRSEQITPROD <> @V_PRODCOFIMP AND @V_CDCOFNFE IS NOT NULL) BEGIN

                 SET @V_CALCCOFIMP = 'S';
                 SET @V_PRODCOFIMP = @V_PRODUTO_NRSEQITPROD;

                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = ((VRBASECALCIT) * ((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                        ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100))))),

                         VRIMPOSTOIT  = ROUND(((@V_ALIQCOFIMP/100)*  ((VRBASECALCIT) * ((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                        ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100)))))), 3)
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDCOFIMP)            AND
                         (NRITPROIMPOS = @V_NRITCOFIMP);

                  UPDATE TRABITPROIMPOS
                     SET VRBCALCIMPOIT  = ((VRBCALCIMPOIT) * ((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                          ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100))))),

                         VRIMPOSIT      = ROUND(((@V_ALIQCOFIMP/100)*  ((VRBCALCIMPOIT) * /*ROUND*/((1+(@V_ALIQICMSIMP/100)*((@V_ALIQIMPII/100)+((@V_ALIQIPIIMP/100)*(1+(@V_ALIQIMPII/100)))))/
                                               ((1-(@V_ALIQPISIMP/100)-(@V_ALIQCOFIMP/100))*(1-(@V_ALIQICMSIMP/100)))))), 3)
                     WHERE CDFILIMPOIT  = @P_FILIAL              AND
                           NRLANCIMPOIT = @P_LANCTONF            AND
                           NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_CDCOFIMP            AND
                           NRSEQITPRO   = @V_NRITCOFIMP;

                  SELECT @V_VRCOFIMP = ISNULL(VRIMPOSTOIT, 0),
                         @V_VRBASECALCCOF = ISNULL(VRBASECALCIT, 0)
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDCOFIMP)            AND
                         (NRITPROIMPOS = @V_NRITCOFIMP);

               END;

               IF (@V_IDUTILPVRIMPBC = 'S') AND (@V_CDICMSNFE = '00' AND @V_CALCICMSIMP <> 'S') OR
                  (@V_CALCICMSIMP = 'S' AND @V_PRODUTO_NRSEQITPROD <> @V_PRODICMSIMP AND @V_CDICMSNFE IS NOT NULL) BEGIN

                  SET @V_CALCICMSIMP = 'S';
                  SET @V_PRODICMSIMP = @V_PRODUTO_NRSEQITPROD;

                  UPDATE ITEMPROIMPOS
                     SET VRBASECALCIT = (ROUND((VRBASECALCIT   +
                                              (@V_VRBASECALCII  * (@V_ALIQIMPII/100)) +
                                              (@V_VRBASECALCIPI * (@V_ALIQIPIIMP/100)) +
                                              (@V_VRBASECALCPIS * (@V_ALIQPISIMP/100)) +
                                              (@V_VRBASECALCCOF * (@V_ALIQCOFIMP/100))), 2)/@V_FATCONVIMP)* 100,



                         VRIMPOSTOIT  = @V_ALIQICMSIMP * ((ROUND((VRBASECALCIT   +
                                              (@V_VRBASECALCII  * (@V_ALIQIMPII/100)) +
                                              (@V_VRBASECALCIPI * (@V_ALIQIPIIMP/100)) +
                                              (@V_VRBASECALCPIS * (@V_ALIQPISIMP/100)) +
                                              (@V_VRBASECALCCOF * (@V_ALIQCOFIMP/100))), 2)/@V_FATCONVIMP)* 100)/100

                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDICMSIMP)           AND
                         (NRITPROIMPOS = @V_NRITICMSIMP);

                  UPDATE TRABITPROIMPOS
                     SET VRBCALCIMPOIT = (ROUND((VRBCALCIMPOIT   +
                                              (@V_VRBASECALCII  * (@V_ALIQIMPII/100)) +
                                              (@V_VRBASECALCIPI * (@V_ALIQIPIIMP/100)) +
                                              (@V_VRBASECALCPIS * (@V_ALIQPISIMP/100)) +
                                              (@V_VRBASECALCCOF * (@V_ALIQCOFIMP/100))), 2)/@V_FATCONVIMP)* 100,



                         VRIMPOSIT  = @V_ALIQICMSIMP * ((ROUND((VRBCALCIMPOIT   +
                                              (@V_VRBASECALCII  * (@V_ALIQIMPII/100)) +
                                              (@V_VRBASECALCIPI * (@V_ALIQIPIIMP/100)) +
                                              (@V_VRBASECALCPIS * (@V_ALIQPISIMP/100)) +
                                              (@V_VRBASECALCCOF * (@V_ALIQCOFIMP/100))), 2)/@V_FATCONVIMP)* 100)/100

                     WHERE CDFILIMPOIT  = @P_FILIAL              AND
                           NRLANCIMPOIT = @P_LANCTONF            AND
                           NRSEQIMPOIT  = @V_PRODUTO_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_CDICMSIMP           AND
                           NRSEQITPRO   = @V_NRITICMSIMP;

                  SELECT @V_VRICMSIMP = ISNULL(VRIMPOSTOIT, 0)
                    FROM ITEMPROIMPOS
                   WHERE (CDFILIAL     = @P_FILIAL)              AND
                         (NRLANCTONF   = @P_LANCTONF)            AND
                         (NRSEQITPROD  = @V_PRODUTO_NRSEQITPROD) AND
                         (CDIMPOSTO    = @V_CDICMSIMP)           AND
                         (NRITPROIMPOS = @V_NRITICMSIMP);

               END;

               IF @V_PRODUTO_CDIMPOSTO = @V_CDICMSIMP BEGIN
                  SET @V_IMPOSINFO = @V_VRICMSIMP;
               END;

               IF @V_PRODUTO_CDIMPOSTO = @V_CDPISIMP BEGIN
                  SET @V_IMPOSINFO = @V_VRPISIMP;
               END;

               IF @V_PRODUTO_CDIMPOSTO = @V_CDCOFIMP BEGIN
                  SET @V_IMPOSINFO = @V_VRCOFIMP;
               END;

               IF @V_PRODUTO_CDIMPOSTO = @V_CDIPIIMP BEGIN
                  SET @V_IMPOSINFO = @V_VRIPIIMP;
               END;

               IF @V_PRODUTO_CDIMPOSTO = @V_CDIIIMP BEGIN
                  SET @V_IMPOSINFO = @V_VRIIIMP;
               END;

               SET @V_IMPOCONTAB = 0;

               IF @V_IDNFIMPORTACAO = 'S' BEGIN
                  SET @V_IMPOCONTAB = @V_IMPOSINFO;
                  IF @V_PRODUTO_IDTIPCONTAB = 'D' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM + @V_IMPOSINFO,
                         VRCONTITEM = VRCONTITEM + @V_IMPOCONTAB
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_PRODUTO_NRSEQITPROD;
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRBRUTITEM = VRBRUTITEM + @V_IMPOSINFO
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_PRODUTO_NRSEQITPROD;
                  END;
               END;

               FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_NRSEQITPROD , @V_PRODUTO_CDIMPOSTO,
                                              @V_PRODUTO_VRPERREDBCIT, @V_PRODUTO_VRALIQITEM,
                                              @V_PRODUTO_VRPARDEDIT  , @V_PRODUTO_CDFISCALIT,
                                              @V_PRODUTO_VRIMPOSIT   , @V_PRODUTO_IDTRATIMPO,
                                              @V_PRODUTO_IDIMPORECUP , @V_PRODUTO_CDCCTBLPASS,
                                              @V_PRODUTO_CDCCTBLATIV , @V_PRODUTO_VRALIQIMPOIT,
                                              @V_PRODUTO_NRITPROIMPOS, @V_PRODUTO_NRSEQITPRO,
                                              @V_PRODUTO_IDVALORINFO , @V_PRODUTO_IDTRIMPSTII,
                                              @V_PRODUTO_IDTIPCONTAB , @V_PRODUTO_VRBASECALCIT,
                                              @V_PRODUTO_CDARVPROD   , @V_PRODUTO_CDPRODUTO,
                                              @V_PRODUTO_VRTOTAITEM  , @V_PRODUTO_VRDESCITEM,
                                              @V_PRODUTO_IDCONTAIMPADIC, @V_PRODUTO_CDIMPOSTONFE;
            END; /* WHILE DO CURSOR C_PRODUTO*/

            CLOSE C_PRODUTO;
            DEALLOCATE C_PRODUTO;

         END;
   ---------------------------------------------------------------------------------------------------------

      --FIM DA ATUALIZAO NA TABELA DE ITEMPROIMPOS

   ---------------------------------------------------------------------------------------------------------

      --TOTALIZAO DOS IMPOSTOS

         DELETE FROM IMPOSNFTOT
         WHERE (CDFILIAL = @P_FILIAL) AND
               (NRLANCTONF = @P_LANCTONF);

         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN
            DECLARE C_IMPOSNFTOT CURSOR FOR
            SELECT IP.CDIMPOSTO,
                   CDIMPOSTOIT,
                   ROUND(SUM(ISNULL(VRIMPOSIT,0)),@V_NRDECITOTANF) AS VRIMPOSTOIT,
                   ISNULL(SUM(VRBASECALCIT),0) AS VRBASECALCIT,
                   ISNULL(SUM(VRBCALCIMPOIT),0) AS VRBCALCIMPOIT,
                   MAX(ISNULL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR
            FROM ITEMPROIMPOS IP, TRABITPROIMPOS TI, IMPOSTO I
            WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                  (IP.NRLANCTONF   = @P_LANCTONF)    AND
                  (TI.CDFILIMPOIT  = @P_FILIAL)      AND
                  (TI.NRLANCIMPOIT = @P_LANCTONF)    AND
                  (IP.NRSEQITPROD  = TI.NRSEQIMPOIT) AND
                  (IP.NRITPROIMPOS = TI.NRSEQITPRO)  AND
                  (IP.CDIMPOSTO    = TI.CDIMPOSTOIT) AND
                  (I.CDIMPOSTO     = IP.CDIMPOSTO)   AND
                  (IP.NRITPROIMPOS  = 1 )
            GROUP BY IP.CDIMPOSTO, TI.CDIMPOSTOIT;

            OPEN C_IMPOSNFTOT;

            FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                              @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                              @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
               VALUES (@P_FILIAL, @P_LANCTONF, @V_IMPOSNF_CDIMPOSTO, ISNULL(@V_IMPOSNF_VRIMPOSTOIT,0), ISNULL(@V_IMPOSNF_VRBASECALCIT,0));

               IF @V_IMPOSNF_IDPREIMPENTR = 'N' BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT   = ISNULL(@V_IMPOSNF_VRBCALCIMPOIT,0)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_IMPOSNF_CDIMPOSTO;
               END
               ELSE BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT = ISNULL(@V_IMPOSNF_VRBCALCIMPOIT,0),
                      VRIMPOSTOT   = ISNULL(@V_IMPOSNF_VRIMPOSTOIT,0)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_IMPOSNF_CDIMPOSTO;
               END;

               FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                                 @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                                 @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;
            END; /*WHILE DO CURSOR C_IMPOSNFTOT*/

            CLOSE C_IMPOSNFTOT;
            DEALLOCATE C_IMPOSNFTOT;

         --INCLUSO DOS IMPOSTOS DE CORPO DE NOTA EM CASO DE NOTA FISCAL DE ENTRADA

            SET @V_SEQUIMPOSTNF = '01';

            DELETE FROM IMPOSTONF
            WHERE (CDFILIAL   = @P_FILIAL) AND
                  (NRLANCTONF = @P_LANCTONF);

            EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA, null, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @V_IDINTEREST;

            DECLARE C_INCIDENCIA CURSOR FOR
            SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP,
                   IDTRATIMPTMP, IDIMPORECUP, ISNULL(IDPREIMPENTR, 'N') AS IDPREIMPENTR, IDUTMUNIORIG
            FROM INCITEMP IT, IMPOSTO IP
            WHERE (IT.NRINCITEMP  = @V_INCITEMP)  AND
                  (IT.CDIMPOTEMP  = IP.CDIMPOSTO) AND
                  (IP.IDPRODNOTA  = 'C');

            OPEN C_INCIDENCIA;

            FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP, @V_INCIDENC_CDFISCTEMP,
                                              @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDIMPORECUP,
                                              @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDUTMUNIORIG;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_ALIQUTMP   = 0;
               SET @V_PARDEDTMP  = 0;
               SET @V_PREDBCTMP1 = 0;
               SET @V_PREDBCTMP  = 0;
               SET @V_ALIQUTMP   = 0;

               /*VERIFICA CST POR IMPOSTO*/
               SET @V_IMPOICMS = NULL;

               SET @V_CDGRUPOFISCAUX = NULL;

               SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                 FROM GRUPOFISCIMPFIL G,
                       (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                               ELSE CDFILIEMIT END AS CDFILIAL
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = @P_FILIAL
                          AND NRLANCTONF = @P_LANCTONF) F
                WHERE G.CDFILIAL = F.CDFILIAL
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

               IF @V_IDORIGDESTNF = 'F' BEGIN
               SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                 FROM GRFISIMPIEFORN G,
                      (SELECT CDFORNECED
                         FROM NOTAFISCAL
                        WHERE CDFILIAL = @P_FILIAL
                          AND NRLANCTONF = @P_LANCTONF) N
                WHERE G.CDFORNECED = N.CDFORNECED
                  AND G.CDEMPRESA = @P_EMPRESA
                  AND G.CDINSCESTA = @P_INSCESTA
                  AND NOT G.CDGRUPOFISC IS NULL
                  AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
               END
               ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                   SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                    FROM GRFISIMPIECLIE G,
                         (SELECT CDCLIENTE
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) N
                   WHERE G.CDCLIENTE = N.CDCLIENTE
                     AND G.CDEMPRESA = @P_EMPRESA
                     AND G.CDINSCESTA = @P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;
               END;


               IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                  EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                        @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
               END
               ELSE BEGIN
                  EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDENC_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                        @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
               END;

               SET @V_ICMS = 'N';
               DECLARE C_ICMS CURSOR FOR
                  (SELECT CDIMPOSTO
                                FROM IMPOSTONFE N, IMPOSTO I
                               WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                                 AND N.CDIMPOSTONFE = '00'
                                 AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP
                              UNION ALL
                              SELECT CDIMPOSTO
                                FROM IMPOSTO
                               WHERE CDIMPOSTRIB = @V_INCIDENC_CDIMPOTEMP)

               OPEN C_ICMS;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_ICMS = 'S';
               END;

               CLOSE C_ICMS;
               DEALLOCATE C_ICMS;

               IF (@V_ITEMPROD_CDSITUTRIBPR IS NOT NULL) AND (@V_ICMS = 'S')  BEGIN
                  SET @V_CDSITTRIBTMP = SUBSTRING(@V_ITEMPROD_CDSITUTRIBPR, 2, LEN(@V_ITEMPROD_CDSITUTRIBPR));
               END;

               SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                 FROM IMPOSTONFE N, IMPOSTO I
                WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                  AND N.CDIMPOSTONFE = '00'
                  AND I.CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

               IF @V_INCIDENC_IDUTMUNIORIG = 'D' BEGIN
                  EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, null, @P_INSCESTA, @V_PAISORIG,
                                         @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @P_INIVALID,
                                         @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @P_TIPOOPER;
               END
               ELSE BEGIN
                  EXEC CONSULTA_ALIQUOTA @V_INCIDENC_CDIMPOTEMP, @P_ENTRSAID, @P_EMPRESA, null, @P_INSCESTA, @V_PAISORIG,
                                         @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @P_INIVALID,
                                         @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @P_TIPOOPER;
               END;

               SELECT @V_PARDEDTMP = MAX(VRPARDEDTMP),
                      @V_PREDBCTMP = MAX(VRPREDBCTMP),
                      @V_ALIQUTMP = MAX(VRALIQUTMP),
                      @V_PREDBCTMP1 = MAX(VR1PREDBCTMP)
               FROM ALIQTEMP
               WHERE (NRALIQTEMP = @V_ALIQTEMP);

               IF (@V_PREDBCTMP IS NULL) BEGIN
                  SET @V_PREDBCTMP = 0;
               END;

               IF (@V_PARDEDTMP IS NULL) BEGIN
                  SET @V_PARDEDTMP = 0;
               END;

               --VERIFICAR VALOR DA ALQUOTA P/ IMPOSTO RECUPERVEL COM CD. FISCAL = '3'
               IF (@V_ALIQUTMP IS NULL) BEGIN
                  SET @V_ALIQUTMP = 0;
               END;

               IF (@V_PREDBCTMP1 IS NULL) BEGIN
                  SET @V_PREDBCTMP1 = 0;
               END;

               SET @V_PRODUENCARGO = 0;

               SELECT @V_SOMAITEM = SUM(VRITEMENCA)
               FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
               WHERE (IE.CDFILIAL   = @P_FILIAL)    AND
                     (IE.NRLANCTONF = @P_LANCTONF)  AND
                     (EN.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDIMPOSTO  = @V_INCIDENC_CDIMPOTEMP) AND
                     (EN.IDENCARGO  = 'A');

               SELECT @V_DESCITEM = SUM(VRITEMENCA)
               FROM ITEMENCARGO IE, ENCARGO EN, BASECALC BC
               WHERE (IE.CDFILIAL   = @P_FILIAL)    AND
                     (IE.NRLANCTONF = @P_LANCTONF)  AND
                     (EN.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDENCARGO  = IE.CDENCARGO) AND
                     (BC.CDIMPOSTO  = @V_INCIDENC_CDIMPOTEMP) AND
                     (EN.IDENCARGO  = 'D');

               IF @V_SOMAITEM IS NULL BEGIN
                  SET @V_SOMAITEM = 0;
               END;

               IF @V_DESCITEM IS NULL BEGIN
                  SET @V_DESCITEM = 0;
               END;

               SET @V_PRODUENCARGO = @V_SOMAITEM - @V_DESCITEM;

               SELECT @V_IDIMPORTAIMPXML = ISNULL(IDIMPORTAIMPXML, 'N')
                 FROM IMPOSTO
                WHERE CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

               IF (@V_IDNFGERADAVIAXML = 'S') AND ((@V_IDIMPORTAIMPXML = 'S') OR (@V_IDGERNFIGUALXML = 'S')) BEGIN
                  SET @V_PRODUENCARGO = 0;
               END;

               SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
               SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
               SET @V_BASECALCIT   = (@V_LIQUIDO + @V_PRODUENCARGO) * @V_TAXABASECALC;
               SET @V_CONTIMPO     = @V_BASECALCIT;
               SET @V_IMPOSTOIT    = ROUND((@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP, @V_NRDECITOTANF);

               SET @V_CONTABCALC   = (@V_LIQUIDO + @V_PRODUENCARGO) - ((@V_LIQUIDO + @V_PRODUENCARGO) * @V_TAXABASECALC);
               SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;

               SELECT @V_IMPOSINFO = MAX(VRIMPOSTOT)
               FROM TRABIMPOSNFTOT
               WHERE CDFILIMPTOT  = @P_FILIAL   AND
                     NRLANCIMPTOT = @P_LANCTONF AND
                     CDIMPOSTOT   = @V_INCIDENC_CDIMPOTEMP;

               IF @V_IMPOSINFO IS NULL BEGIN
                  SET @V_IMPOSINFO = 0;
               END;

               IF (@V_BASECALCIT < 0) OR (@V_BASECALCIT IS NULL) BEGIN
                  SET @V_BASECALCIT = 0;
               END;

               IF (@V_IMPOSTOIT < 0) OR (@V_IMPOSTOIT IS NULL) BEGIN
                  SET @V_IMPOSTOIT = 0;
               END;

               IF @V_INCIDENC_IDPREIMPENTR = 'N' BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT   = ISNULL(@V_BASECALCIT,0)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_INCIDENC_CDIMPOTEMP;
               END
               ELSE BEGIN
                  UPDATE TRABIMPOSNFTOT
                  SET VRBCALIMPTOT   = ISNULL(@V_BASECALCIT,0),
                      VRIMPOSTOT     = ROUND(CASE ISNULL(VRIMPOSTOT,0)
                                             WHEN 0
                                             THEN ISNULL(@V_IMPOSTOIT,0)
                                             ELSE VRIMPOSTOT
                                             END
                                             , @V_NRDECITOTANF)
                  WHERE CDFILIMPTOT  = @P_FILIAL   AND
                        NRLANCIMPTOT = @P_LANCTONF AND
                        CDIMPOSTOT   = @V_INCIDENC_CDIMPOTEMP;
               END;

               INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
               VALUES (@P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, ISNULL(@V_IMPOSTOIT,0), ISNULL(@V_BASECALCIT,0));

               IF (@V_INCIDENC_IDIMPORECUP = 'S') OR (@V_INCIDENC_IDIMPORECUP <> 'S' AND @V_ALIQUTMP <> 0) BEGIN
                  IF (@V_INCIDENC_IDIMPORECUP = 'S') AND
                     (@V_INCIDENC_CDFISCTEMP <> '1') BEGIN
                     SET @V_BASECALCIT = 0;
                     SET @V_ALIQUTMP   = 0;
                     SET @V_IMPOSTOIT  = 0;
                     SET @V_PREDBCTMP  = 0;
                     SET @V_PREDBCTMP1 = 0;
                     SET @V_PARDEDTMP  = 0;
                  END;

                  SELECT @V_IDFORMAPUR = MAX(IDFORMAPUR)
                  FROM IMPOSTO
                  WHERE CDIMPOSTO = @V_INCIDENC_CDIMPOTEMP;

                  IF @V_IDFORMAPUR = 'P' BEGIN
                     INSERT INTO IMPOSTONF(
                        CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                        VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                        CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, @V_SEQUIMPOSTNF, ROUND(@V_CONTIMPO,2), @V_PREDBCTMP,
                        @V_BASECALCIT, @V_ALIQUTMP, @V_PARDEDTMP, ROUND(@V_IMPOSTOIT, @V_NRDECITOTANF), @V_INCIDENC_CDFISCTEMP, '1', @V_CDSITTRIBTMP,
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE);

                     SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
                  END
                  ELSE BEGIN
                     INSERT INTO IMPOSTONF(
                        CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                        VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                        CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, @V_SEQUIMPOSTNF, ROUND(@V_CONTIMPO,2), @V_PREDBCTMP,
                        @V_BASECALCIT, @V_ALIQUTMP, @V_PARDEDTMP, ROUND(@V_IMPOSTOIT, @V_NRDECITOTANF), @V_INCIDENC_CDFISCTEMP, '1', @V_CDSITTRIBTMP,
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE);

                     SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
                  END;

                  IF (@V_INCIDENC_IDIMPORECUP = 'S') AND (@V_PREDBCTMP > 0) AND (@V_INCIDENC_CDFISCTEMP = '1') BEGIN
                     INSERT INTO IMPOSTONF(
                        CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                        VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, IDIMPOSTONF, CDSITUTRIBIMNFE,
                        CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_INCIDENC_CDIMPOTEMP, @V_SEQUIMPOSTNF, ROUND(@V_CONTABCALC,2), @V_PERDBCALC,
                        0, 0, @V_PARDEDTMP, 0, '2', '2', @V_CDSITTRIBTMP,
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE);

                     SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
                  END;
               END;

               DELETE FROM ALIQTEMP
               WHERE NRALIQTEMP = @V_ALIQTEMP;

               FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENC_CDIMPOTEMP, @V_INCIDENC_CDFISCTEMP,
                                                 @V_INCIDENC_IDTRATIMPTMP, @V_INCIDENC_IDIMPORECUP,
                                                 @V_INCIDENC_IDPREIMPENTR, @V_INCIDENC_IDUTMUNIORIG;
            END; /*WHILE DO CURSOR C_INCIDENCIA*/

            CLOSE C_INCIDENCIA;
            DEALLOCATE C_INCIDENCIA;

            SET @V_TOTIMPOCONT = 0;
            SET @V_TOTIMPOBRUT = 0;

            DECLARE C_IMPOSCONTAB CURSOR FOR
            SELECT VRIMPOSTOT, IDIMPORECUP, CDCCTBLPASS, CDCCTBLATIV,
                   IDTRATIMPO,  CDFISCTEMP
            FROM TRABIMPOSNFTOT INF, IMPOSTO IP, INCITEMP IT
            WHERE CDFILIMPTOT   = @P_FILIAL      AND
                  NRLANCIMPTOT  = @P_LANCTONF    AND
                  IP.CDIMPOSTO  = INF.CDIMPOSTOT AND
                  IT.CDIMPOTEMP = IP.CDIMPOSTO   AND
                  IT.NRINCITEMP = @V_INCITEMP    AND
                  IP.IDPRODNOTA = 'C';



            OPEN C_IMPOSCONTAB;
            FETCH NEXT FROM C_IMPOSCONTAB INTO @V_IMPOSCONT_VRIMPOSTOT, @V_IMPOSCONT_IDIMPORECUP,
                                               @V_IMPOSCONT_CDCCTBLPASS, @V_IMPOSCONT_CDCCTBLATIV,
                                               @V_IMPOSCONT_IDTRATIMPO, @V_IMPOSCONT_CDFISCTEMP;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF (@V_IMPOSCONT_IDIMPORECUP = 'S') BEGIN
                  IF (NOT(@V_IMPOSCONT_CDCCTBLATIV IS NULL)) AND
                     (@V_IMPOSCONT_CDFISCTEMP = '1') BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'V' BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'A' BEGIN
   ---------------------------------------------------------------------------------------------------------
                        IF NOT(@V_IMPOSCONT_CDCCTBLPASS IS NULL) BEGIN
   ---------------------------------------------------------------------------------------------------------
                           SET @V_TOTIMPOCONT = @V_TOTIMPOCONT + @V_IMPOSCONT_VRIMPOSTOT;
                        END;
                     END
                     ELSE IF @V_IMPOSCONT_IDTRATIMPO IN ('D','R') BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END;
               END
               ELSE BEGIN
                  IF NOT(@V_IMPOSCONT_CDCCTBLPASS IS NULL) BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'V' BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END
                  ELSE BEGIN
                     IF @V_IMPOSCONT_IDTRATIMPO = 'A' BEGIN
   ---------------------------------------------------------------------------------------------------------
                        IF NOT(@V_IMPOSCONT_CDCCTBLATIV IS NULL) BEGIN
   ---------------------------------------------------------------------------------------------------------
                           SET @V_TOTIMPOCONT = @V_TOTIMPOCONT + @V_IMPOSCONT_VRIMPOSTOT;
                        END;
                     END
                     ELSE IF @V_IMPOSCONT_IDTRATIMPO IN ('D','R')
                     BEGIN
                        SET @V_TOTIMPOCONT = @V_TOTIMPOCONT - @V_IMPOSCONT_VRIMPOSTOT;
                     END;
                  END;
               END;

               IF @V_IDNFIMPORTACAO = 'S' BEGIN
                  SET @V_TOTIMPOBRUT = @V_TOTIMPOBRUT + @V_IMPOSCONT_VRIMPOSTOT;
               END;

               FETCH NEXT FROM C_IMPOSCONTAB INTO @V_IMPOSCONT_VRIMPOSTOT, @V_IMPOSCONT_IDIMPORECUP,
                                                  @V_IMPOSCONT_CDCCTBLPASS, @V_IMPOSCONT_CDCCTBLATIV,
                                                  @V_IMPOSCONT_IDTRATIMPO, @V_IMPOSCONT_CDFISCTEMP;
            END; /*WHILE DO CURSOR C_IMPOSCONTAB*/

            CLOSE C_IMPOSCONTAB;
            DEALLOCATE C_IMPOSCONTAB;

            IF (@V_TOTIMPOBRUT <> 0) OR (@V_TOTIMPOCONT <> 0) BEGIN

               DECLARE C_ITPRODUTO CURSOR FOR
               SELECT NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
               FROM ITEMPRODUTO
               WHERE CDFILIAL   = @P_FILIAL AND
                     NRLANCTONF = @P_LANCTONF;

               OPEN C_ITPRODUTO;

               FETCH NEXT FROM C_ITPRODUTO INTO @V_ITPROD_NRSEQITPROD, @V_ITPROD_VRLIQUIDO;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  UPDATE ITEMPRODUTO
                  SET VRBRUTITEM = VRBRUTITEM + ((@V_TOTIMPOBRUT / @V_LIQUIDO) * @V_ITPROD_VRLIQUIDO),
                      VRCONTITEM = VRCONTITEM + ((@V_TOTIMPOCONT / @V_LIQUIDO) * @V_ITPROD_VRLIQUIDO)
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ITPROD_NRSEQITPROD;

                  FETCH NEXT FROM C_ITPRODUTO INTO @V_ITPROD_NRSEQITPROD, @V_ITPROD_VRLIQUIDO;
               END; /* WHILE CURSOR C_ITPRODUTO*/

               CLOSE C_ITPRODUTO;
               DEALLOCATE C_ITPRODUTO;

            END;

            DELETE FROM INCITEMP
            WHERE NRINCITEMP = @V_INCITEMP;
         END
         ELSE BEGIN
            DELETE FROM IMPOSTONF
            WHERE (CDFILIAL   = @P_FILIAL) AND
                  (NRLANCTONF = @P_LANCTONF);
         END;

   ---------------------------------------------------------------------------------------------------------

   --FIM DA TOTALIZAO DOS IMPOSTOS

   ---------------------------------------------------------------------------------------------------------

   -- NOTA FISCAL DE MOVIMENTAO - 07
      END
      ELSE IF @P_TIPOOPER IN ('07','10') OR (@V_IDOPERDEVONF = 'S') BEGIN
         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN

            DECLARE C_ITEMPROD CURSOR FOR
            SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD, I.CDPRODUTO,
                   CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                   VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                   IDCONFORITEM, CDFISOPEITEM, CDSUFXCFOPPR, CDSITUTRIBPR,
                   IDERROSITEM, IDAVISOSITEM, VRBRUTITEM, P.CDARVPROD,
                   I.NRLOTEESTQ, I.NRSUBLOTE, I.CDPRODUTO,
                   I.QTITEMPROD, I.CDFISCOPERSN
            FROM ITEMPRODUTO I, PRODUTO P
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF AND
                  I.CDPRODUTO = P.CDPRODUTO;

            OPEN C_ITEMPROD;
            FETCH NEXT FROM C_ITEMPROD INTO @V_ITEMPPROD_CDFILIAL, @V_ITEMPPROD_NRLANCTONF,
                                            @V_ITEMPPROD_NRSEQITPROD, @V_ITEMPPROD_CDPRODUTO,
                                            @V_ITEMPPROD_CDPRODEMIS, @V_ITEMPPROD_DSPRODEMIS,
                                            @V_ITEMPPROD_IDATUVRESTOQ, @V_ITEMPPROD_QTITEMPROD,
                                            @V_ITEMPPROD_VRUNITITEM, @V_ITEMPPROD_VRDESCITEM,
                                            @V_ITEMPPROD_VRTOTAITEM, @V_ITEMPPROD_VRCONTITEM,
                                            @V_ITEMPPROD_IDCONFORITEM, @V_ITEMPPROD_CDFISOPEITEM,
                                            @V_ITEMPPROD_CDSUFXCFOPPR, @V_ITEMPPROD_CDSITUTRIBPR,
                                            @V_ITEMPPROD_IDERROSITEM, @V_ITEMPPROD_IDAVISOSITEM,
                                            @V_ITEMPPROD_VRBRUTITEM,@V_ITEMPPROD_CDARVPROD,
                                            @V_ITEMPPROD_NRLOTEESTQ, @V_ITEMPPROD_NRSUBLOTE, @V_ITEMPPROD_CDPRODUTO,
                                            @V_ITEMPPROD_QTITEMPROD, @V_ITEMPPROD_CDFISCOPERSN;;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_LIQUIITEM = @V_ITEMPPROD_VRTOTAITEM - @V_ITEMPPROD_VRDESCITEM;

               EXEC CONSULTA_CST @P_ENTRSAID, @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA;

               SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
               FROM CSTTEMP
               WHERE (NRCSTTEMP = @V_CSTTEMP);

               IF @V_IDOPERDEVONF <> 'S' BEGIN
                  IF NOT (SUBSTRING(@V_ITEMPPROD_CDSITUTRIBPR,1,1) = SUBSTRING(@V_SITUTRIBPR,1,1)) AND
                     NOT (@V_ITEMPPROD_CDSITUTRIBPR IS NULL) BEGIN
                     SET @V_SITUTRIBPR = @V_ITEMPPROD_CDSITUTRIBPR;
                  END;
               END
               ELSE BEGIN
                  IF @V_SITUTRIBPR IS NULL BEGIN
                     SET @V_SITUTRIBPR = @V_ITEMPPROD_CDSITUTRIBPR;
                  END;
               END;

               /* VERIFICA IMPOSTOS POR REDUCAO REFERENTE A NOTA FISCAL DE ORIGEM */
               IF (@V_IDOPERDEVONF = 'S') BEGIN

                  SET @V_VRFATOCONV = 0;

                  DECLARE C_IMPOSORIG CURSOR FOR
                     SELECT VRPERREDBCIT, NRITPROIMPOS, CDIMPOSTO, CDFISCALIT,
                            VRALIQITEM, VRPARDEDIT, IDVALORINFIT, SUM(QTITEMPROD) AS QTITEMPROD,
                            CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                            CDFISCOPERIT, CDSUFXCFOPIT,
                            SUM(VRCONTITIMP) AS VRCONTITIMP,
                            SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT, IDMOTDESONERAIT
                       FROM ITEMPROIMPOS IT, ITEMPRODUTO I
                      WHERE IT.CDFILIAL  = @V_FILIORIG
                        AND IT.NRLANCTONF = @V_DEVOLORIG
                        AND I.CDFILIAL    = @V_FILIORIG
                        AND I.NRLANCTONF  = @V_DEVOLORIG
                        AND IT.NRSEQITPROD = I.NRSEQITPROD
                        AND I.CDPRODUTO = @V_ITEMPPROD_CDPRODUTO
                        AND ROUND(I.VRUNITITEM, @V_NRDECITOTANF) = ROUND(@V_ITEMPPROD_VRUNITITEM, @V_NRDECITOTANF)
                        AND (ISNULL(I.NRLOTEESTQ  , ' ') = (ISNULL(@V_ITEMPPROD_NRLOTEESTQ, ' ')))
                        AND (ISNULL(I.NRSUBLOTE , ' ')   = (ISNULL(@V_ITEMPPROD_NRSUBLOTE,  ' ')))
                      GROUP BY VRPERREDBCIT, NRITPROIMPOS, CDIMPOSTO, CDFISCALIT,
                               VRALIQITEM, VRPARDEDIT, IDVALORINFIT,
                               CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                               CDFISCOPERIT, CDSUFXCFOPIT, IDMOTDESONERAIT;

                  OPEN C_IMPOSORIG;
                  FETCH NEXT FROM C_IMPOSORIG INTO @V_IMPOSORIG_VRPERREDBCIT, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDIMPOSTO,
                                                   @V_IMPOSORIG_CDFISCALIT, @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPARDEDIT,
                                                   @V_IMPOSORIG_IDVALORINFIT, @V_IMPOSORIG_QTITEMPROD, @V_IMPOSORIG_CDSITUTRIBITNFE,
                                                   @V_IMPOSORIG_IDMODBCITNFE, @V_IMPOSORIG_IDMODBCSTITNFE,
                                                   @V_IMPOSORIG_CDFISCOPERIT, @V_IMPOSORIG_CDSUFXCFOPIT,
                                                   @V_IMPOSORIG_VRCONTITIMP, @V_IMPOSORIG_VRBASECALCIT,
                                                   @V_IMPOSORIG_VRIMPOSTOIT, @V_IMPOSORIG_IDMOTDESONERAIT;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SET @V_VRFATOCONV = ISNULL(@V_ITEMPPROD_QTITEMPROD, 0) / @V_IMPOSORIG_QTITEMPROD;

                     DELETE FROM TRABITPROIMPOS
                      WHERE CDFILIMPOIT = @P_FILIAL
                        AND NRLANCIMPOIT = @P_LANCTONF
                        AND NRSEQIMPOIT = @V_ITEMPPROD_NRSEQITPROD
                        AND CDIMPOSTOIT = @V_IMPOSORIG_CDIMPOSTO
                        AND NRSEQITPRO = @V_IMPOSORIG_NRITPROIMPOS;

                     DELETE FROM ITEMPROIMPOS
                      WHERE CDFILIAL = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD
                        AND CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO
                        AND NRITPROIMPOS = @V_IMPOSORIG_NRITPROIMPOS;

                     IF (@V_IMPOICMS IS NOT NULL) BEGIN

                        IF @V_IDORIGDESTNF = 'L' BEGIN

                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                             FROM PRODUTO
                            WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                           IF @V_CST1DIGT IS NULL BEGIN
                              SELECT @V_CST1DIGT = MAX(CDCSTDIG1SAI)
                                FROM INSCRESTAD
                               WHERE CDEMPRESA   = @P_EMPRESA AND
                                     CDINSCESTA  = @P_INSCESTA;
                           END;
                        END
                        ELSE IF @V_IDORIGDESTNF = 'C'
                        BEGIN
                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                             FROM PRODUTO
                            WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                           IF @V_CST1DIGT IS NULL BEGIN
                              SELECT @V_CST1DIGT  = MAX(CDCSTDIG1CLI)
                                FROM NOTAFISCAL N LEFT JOIN CLIENTE C
                                                 ON (N.CDCLIENTE = C.CDCLIENTE)
                               WHERE (CDFILIAL     = @P_FILIAL) AND
                                     (NRLANCTONF   = @P_LANCTONF);
                           END;
                        END
                        ELSE
                        BEGIN

                           SELECT @V_CST1DIGT = MAX(CDCSTDIG1PROD)
                             FROM PRODUTO
                            WHERE (CDARVPROD  = @V_ITEMPROD_CDARVPROD);

                           IF @V_CST1DIGT IS NULL BEGIN
                              SELECT @V_CST1DIGT = MAX(CDCSTDIG1ENT)
                                FROM NOTAFISCAL N, FORNECEDOR F
                               WHERE CDFILIAL     = @P_FILIAL
                                 AND NRLANCTONF   = @P_LANCTONF
                                 AND N.CDFORNECED = F.CDFORNECED;
                           END;
                        END;
                        IF (@V_CDSITTRIBTMP IS NOT NULL) BEGIN
                           UPDATE ITEMPRODUTO
                              SET CDSITUTRIBPR  = @V_CST1DIGT + @V_CDSITTRIBTMP
                            WHERE CDFILIAL      = @P_FILIAL AND
                                  NRLANCTONF    = @P_LANCTONF AND
                                  NRSEQITPROD   = @V_ITEMPPROD_NRSEQITPROD;

                           SET @V_SITUTRIBPR = @V_CST1DIGT + @V_CDSITTRIBTMP;
                        END;

                        SET @V_CDGRUPOFISCAUX = NULL;

                        SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                          FROM GRUPOFISCIMPFIL G,
                                (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                        ELSE CDFILIEMIT END AS CDFILIAL
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = @P_FILIAL
                                   AND NRLANCTONF = @P_LANCTONF) F
                         WHERE G.CDFILIAL = F.CDFILIAL
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO;

                        IF @V_IDORIGDESTNF = 'F' BEGIN
                        SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                          FROM GRFISIMPIEFORN G,
                               (SELECT CDFORNECED
                                  FROM NOTAFISCAL
                                 WHERE CDFILIAL = @P_FILIAL
                                   AND NRLANCTONF = @P_LANCTONF) N
                         WHERE G.CDFORNECED = N.CDFORNECED
                           AND G.CDEMPRESA = @P_EMPRESA
                           AND G.CDINSCESTA = @P_INSCESTA
                           AND NOT G.CDGRUPOFISC IS NULL
                           AND G.CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO;
                        END
                        ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                            SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                             FROM GRFISIMPIECLIE G,
                                  (SELECT CDCLIENTE
                                     FROM NOTAFISCAL
                                    WHERE CDFILIAL = @P_FILIAL
                                      AND NRLANCTONF = @P_LANCTONF) N
                            WHERE G.CDCLIENTE = N.CDCLIENTE
                              AND G.CDEMPRESA = @P_EMPRESA
                              AND G.CDINSCESTA = @P_INSCESTA
                              AND NOT G.CDGRUPOFISC IS NULL
                              AND G.CDIMPOSTO = @V_IMPOSORIG_CDIMPOSTO;
                        END;

                        IF (@V_CDGRUPOFISCAUX IS NOT NULL) BEGIN

                           EXEC CONSULTA_CFOP @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPROD_CDARVPROD,
                                     @P_INSCESTA,   @P_TIPOOPER, @V_PAISCFOP, @V_ESTACFOP,
                                     @V_PAISDEST,   @V_ESTADEST, @P_FILIAL,   @P_LANCTONF,
                                     @V_CDGRUPOFISCAUX,@P_INIVALID;

                           UPDATE NOTAFISCAL
                              SET DSCDFISOPENF = (SELECT MAX(DSCFOPTMP) FROM CFOPTEMP
                                                  WHERE NRCFOPTEMP = @V_CFOPTEMP)
                            WHERE CDFILIAL   = @P_FILIAL AND
                                  NRLANCTONF = @P_LANCTONF;

                           SELECT @V_FISOPEITEM = MAX(CDFISOPETMP),
                                  @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                                  @V_DSCDFISOPEIT = MAX(DSCFOPTMP)
                             FROM CFOPTEMP
                            WHERE NRCFOPTEMP = @V_CFOPTEMP;


                           UPDATE ITEMPRODUTO
                              SET CDFISOPEITEM = @V_FISOPEITEM,
                                  CDSUFXCFOPPR = @V_SUFXCFOPPR,
                                  DSCDFISOPEIT = @V_DSCDFISOPEIT

                            WHERE CDFILIAL    = @P_FILIAL   AND
                                  NRLANCTONF  = @P_LANCTONF AND
                                  NRSEQITPROD = @V_ITEMPROD_NRSEQITPROD;

                           DELETE FROM CFOPTEMP
                            WHERE NRCFOPTEMP = @V_CFOPTEMP;
                        END;

                     END;

                     INSERT INTO TRABITPROIMPOS(
                        CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                        CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                        VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                        CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_ITEMPPROD_NRSEQITPROD, @V_IMPOSORIG_CDIMPOSTO, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDFISCALIT,
                        @V_SITUTRIBPR, ISNULL(@V_FISOPEITEM, @V_IMPOSORIG_CDFISCOPERIT), ISNULL(@V_SUFXCFOPPR, @V_IMPOSORIG_CDSUFXCFOPIT), @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPERREDBCIT, (@V_IMPOSORIG_VRPARDEDIT * @V_VRFATOCONV),
                        ROUND((@V_IMPOSORIG_VRCONTITIMP * @V_VRFATOCONV),2), (@V_IMPOSORIG_VRBASECALCIT * @V_VRFATOCONV), (@V_IMPOSORIG_VRIMPOSTOIT * @V_VRFATOCONV), '00000', '00000', @V_IMPOSORIG_IDVALORINFIT,
                        @V_CDSITTRIBTMP, ISNULL(@V_IDMODBCNFE, @V_IMPOSORIG_IDMODBCITNFE), ISNULL(@V_IDMODBCSTNFE, @V_IMPOSORIG_IDMODBCSTITNFE),
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, ISNULL(@V_IDMOTIDESSTNFE, @V_IMPOSORIG_IDMOTDESONERAIT), @V_CDREGRAITALIQ);

                     INSERT INTO ITEMPROIMPOS(
                        CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
                        CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                        VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
                        IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                     VALUES(
                        @P_FILIAL, @P_LANCTONF, @V_ITEMPPROD_NRSEQITPROD, @V_IMPOSORIG_CDIMPOSTO, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDFISCALIT,
                        @V_SITUTRIBPR, ISNULL(@V_FISOPEITEM, @V_IMPOSORIG_CDFISCOPERIT), ISNULL(@V_SUFXCFOPPR, @V_IMPOSORIG_CDSUFXCFOPIT), @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPERREDBCIT, (@V_IMPOSORIG_VRPARDEDIT * @V_VRFATOCONV),
                        ROUND((@V_IMPOSORIG_VRCONTITIMP * @V_VRFATOCONV),2), (@V_IMPOSORIG_VRBASECALCIT * @V_VRFATOCONV), (@V_IMPOSORIG_VRIMPOSTOIT * @V_VRFATOCONV), '00000', '00000', @V_CDSITTRIBTMP,
                        ISNULL(@V_IDMODBCNFE, @V_IMPOSORIG_IDMODBCITNFE), ISNULL(@V_IDMODBCSTNFE, @V_IMPOSORIG_IDMODBCSTITNFE),
                        @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, ISNULL(@V_IDMOTIDESSTNFE, @V_IMPOSORIG_IDMOTDESONERAIT), @V_CDREGRAITALIQ);

                     FETCH NEXT FROM C_IMPOSORIG INTO @V_IMPOSORIG_VRPERREDBCIT, @V_IMPOSORIG_NRITPROIMPOS, @V_IMPOSORIG_CDIMPOSTO,
                                                      @V_IMPOSORIG_CDFISCALIT, @V_IMPOSORIG_VRALIQITEM, @V_IMPOSORIG_VRPARDEDIT,
                                                      @V_IMPOSORIG_IDVALORINFIT, @V_IMPOSORIG_QTITEMPROD, @V_IMPOSORIG_CDSITUTRIBITNFE,
                                                      @V_IMPOSORIG_IDMODBCITNFE, @V_IMPOSORIG_IDMODBCSTITNFE,
                                                      @V_IMPOSORIG_CDFISCOPERIT, @V_IMPOSORIG_CDSUFXCFOPIT,
                                                      @V_IMPOSORIG_VRCONTITIMP, @V_IMPOSORIG_VRBASECALCIT,
                                                      @V_IMPOSORIG_VRIMPOSTOIT, @V_IMPOSORIG_IDMOTDESONERAIT;
                  END;
                  CLOSE C_IMPOSORIG;
                  DEALLOCATE C_IMPOSORIG;
               END;

               IF (@V_IDOPERDEVONF = 'S') BEGIN
                  EXEC CONSULTA_INCIDENCIA @P_ENTRSAID, @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC, NULL, @V_IDINTEREST;

                  DECLARE C_INCIDITEM CURSOR FOR
                  SELECT CDIMPOTEMP, CDFISCTEMP
                  FROM INCITEMP
                  WHERE NRINCITEMP = @V_INCITEMP;

                  OPEN C_INCIDITEM;

                  FETCH NEXT FROM C_INCIDITEM INTO @V_INCIDITEM_CDIMPOTEMP, @V_INCIDITEM_CDFISCTEMP;

                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     /*VERIFICA CST POR IMPOSTO*/
                     SET @V_IMPOICMS = NULL;
                     SET @V_CDGRUPOFISCAUX = NULL;

                     SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                       FROM GRUPOFISCIMPFIL G,
                             (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                     ELSE CDFILIEMIT END AS CDFILIAL
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) F
                      WHERE G.CDFILIAL = F.CDFILIAL
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;

                     IF @V_IDORIGDESTNF = 'F' BEGIN
                     SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                       FROM GRFISIMPIEFORN G,
                            (SELECT CDFORNECED
                               FROM NOTAFISCAL
                              WHERE CDFILIAL = @P_FILIAL
                                AND NRLANCTONF = @P_LANCTONF) N
                      WHERE G.CDFORNECED = N.CDFORNECED
                        AND G.CDEMPRESA = @P_EMPRESA
                        AND G.CDINSCESTA = @P_INSCESTA
                        AND NOT G.CDGRUPOFISC IS NULL
                        AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;
                     END
                     ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                        SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                         FROM GRFISIMPIECLIE G,
                              (SELECT CDCLIENTE
                                 FROM NOTAFISCAL
                                WHERE CDFILIAL = @P_FILIAL
                                  AND NRLANCTONF = @P_LANCTONF) N
                        WHERE G.CDCLIENTE = N.CDCLIENTE
                          AND G.CDEMPRESA = @P_EMPRESA
                          AND G.CDINSCESTA = @P_INSCESTA
                          AND NOT G.CDGRUPOFISC IS NULL
                          AND G.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;
                     END;

                     IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                           EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_INCIDITEM_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                      @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                     END
                     ELSE BEGIN
                           EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDITEM_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                      @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                     END;


                     SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = @V_INCIDITEM_CDIMPOTEMP;

                     UPDATE ITEMPROIMPOS
                     SET   CDFISCALIT = @V_INCIDITEM_CDFISCTEMP,
                           CDSITUTRIBITNFE = @V_CDSITTRIBTMP,
                           IDMODBCITNFE = @V_IDMODBCNFE,
                           IDMODBCSTITNFE = @V_IDMODBCSTNFE,
                           CDTPCREDPICOITE = @V_CDTPCRPICOSTNFE,
                           CDNATUBCALPCIT  = @V_CDNATUBCPCSTNFE,
                           IDMOTDESONERAIT = @V_IDMOTIDESSTNFE,
                           CDREGRAIT       = @V_CDREGRAITALIQ
                     WHERE CDFILIAL   = @P_FILIAL   AND
                           NRLANCTONF = @P_LANCTONF AND
                           NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD  AND
                           CDIMPOSTO  = @V_INCIDITEM_CDIMPOTEMP;


                     UPDATE TRABITPROIMPOS
                     SET CDFISCIMPOIT   = @V_INCIDITEM_CDFISCTEMP,
                         CDSTRIBITNFE = @V_CDSITTRIBTMP,
                         IDMODBCITEMNFE = @V_IDMODBCNFE,
                         IDMODBCSTITENFE = @V_IDMODBCSTNFE,
                         CDTPCREDPICOITE = @V_CDTPCRPICOSTNFE,
                         CDNATUBCALPCIT  = @V_CDNATUBCPCSTNFE,
                         IDMOTDESOTRABIT = @V_IDMOTIDESSTNFE,
                         CDREGRATRABIT   = @V_CDREGRAITALIQ
                     WHERE CDFILIMPOIT  = @P_FILIAL   AND
                           NRLANCIMPOIT = @P_LANCTONF AND
                           NRSEQIMPOIT  = @V_ITEMPPROD_NRSEQITPROD AND
                           CDIMPOSTOIT  = @V_INCIDITEM_CDIMPOTEMP;
                     FETCH NEXT FROM C_INCIDITEM INTO @V_INCIDITEM_CDIMPOTEMP, @V_INCIDITEM_CDFISCTEMP;
                  END;

                  CLOSE C_INCIDITEM;
                  DEALLOCATE C_INCIDITEM;

                  UPDATE ITEMPROIMPOS
                  SET CDFISCALIT = '2'
                  WHERE CDFILIAL    = @P_FILIAL    AND
                        NRLANCTONF  = @P_LANCTONF  AND
                        VRPERREDBCIT > 0.00        AND
                        NRITPROIMPOS = '2';

                  UPDATE TRABITPROIMPOS
                  SET CDFISCIMPOIT = '2'
                  WHERE CDFILIMPOIT  = @P_FILIAL   AND
                        NRLANCIMPOIT = @P_LANCTONF AND
                        VRREDBCIMPOIT > 0.00       AND
                        NRSEQITPRO = '2';

                  DELETE FROM INCITEMP
                  WHERE NRINCITEMP = @V_INCITEMP;
               END;

               EXEC CONSULTA_CFOP @P_ENTRSAID, @P_EMPRESA, @V_ITEMPPROD_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_PAISCFOP,
                                  @V_ESTACFOP, @V_PAISDEST, @V_ESTADEST, @P_FILIAL, @P_LANCTONF, @V_CDGRUPOFISC,@P_INIVALID;

               /* Verifica primeiro digito do CFOP */
               SET @V_CFOP1DIGT = '';

               IF @V_PAISCFOP = @V_PAISDEST BEGIN
                  IF @V_ESTACFOP = @V_ESTADEST BEGIN
                     SET @V_CFOP1DIGT = '1';
                  END
                  ELSE BEGIN
                     SET @V_CFOP1DIGT = '2';
                  END;
               END
               ELSE BEGIN
                  SET @V_CFOP1DIGT = '3';
               END;

               SELECT @V_FISOPEITEM = MAX(CDFISOPETMP), @V_SUFXCFOPPR = MAX(CDSUFCFOPTMP),
                      @V_DSCDFISOPEIT = MAX(DSCFOPTMP)
               FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               IF NOT @V_FISOPEITEM IS NULL BEGIN
                  UPDATE NOTAFISCAL
                  SET CDFISOPENTF = @V_FISOPEITEM,
                      DSCDFISOPENF = @V_DSCDFISOPEIT
                  WHERE CDFILIAL   = @P_FILIAL   AND
                        NRLANCTONF = @P_LANCTONF;

               END;

   ---------------------------------------------------------------------------------------------------------
               SELECT @V_IDORDPRIMDFENT = MAX(IDORDPRIMDFENT)
                 FROM PARAMGERAL;


   ---------------------------------------------------------------------------------------------------------
               EXEC CONSULTA_CSOSN @P_ENTRSAID,   @P_EMPRESA,  @V_ITEMPPROD_CDARVPROD,
                                   @P_INSCESTA,   @P_TIPOOPER, @P_FILIAL,   @P_LANCTONF,
                                   @V_CDGRUPOFISC,@V_IDINTEREST, @P_CDFISCOPERSN = @V_CDFISCOPERSN OUTPUT;

               IF (NOT @V_CDFISCOPERSN IS NULL) AND (LEN(@V_CDFISCOPERSN) = 4) BEGIN
                  UPDATE ITEMPRODUTO
                     SET CDFISCOPERSN = @V_CDFISCOPERSN
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
               END
               ELSE BEGIN
                  UPDATE ITEMPRODUTO
                     SET CDFISCOPERSN = (SELECT MAX(I.CDFISCOPERSN)
                                           FROM ITEMPRODUTO I
                                          WHERE I.CDFILIAL   = @V_FILIORIG
                                            AND I.NRLANCTONF = @V_DEVOLORIG
                                            AND I.CDPRODUTO  = @V_ITEMPPROD_CDPRODUTO)
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
               END;

               IF NOT @V_FISOPEITEM IS NULL BEGIN
                  UPDATE ITEMPRODUTO
                  SET CDFISOPEITEM = @V_FISOPEITEM,
                      CDSUFXCFOPPR = @V_SUFXCFOPPR,
                      DSCDFISOPEIT = @V_DSCDFISOPEIT
                  WHERE CDFILIAL    = @P_FILIAL                 AND
                        NRLANCTONF  = @P_LANCTONF               AND
                        NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;

                  IF (@V_IDOPERDEVONF = 'S') BEGIN
                     UPDATE TRABITPROIMPOS
                     SET CDSTRIBIMPOIT = @V_SITUTRIBPR,
                         CDFOPERIMPOIT = @V_FISOPEITEM,
                         CDSCFOPIMPOIT = @V_SUFXCFOPPR
                     WHERE CDFILIMPOIT = @P_FILIAL                AND
                           NRLANCIMPOIT = @P_LANCTONF             AND
                           NRSEQIMPOIT = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END
               ELSE BEGIN
                  UPDATE ITEMPRODUTO
                  SET CDFISOPEITEM = @V_CFOP1DIGT + SUBSTRING(CDFISOPEITEM,2,10)
                  WHERE CDFILIAL    = @P_FILIAL                 AND
                        NRLANCTONF  = @P_LANCTONF               AND
                        NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;

                  IF (@V_IDOPERDEVONF = 'S') BEGIN
                     UPDATE TRABITPROIMPOS
                     SET CDFOPERIMPOIT = @V_CFOP1DIGT + SUBSTRING(CDFOPERIMPOIT,2,10)
                     WHERE CDFILIMPOIT = @P_FILIAL                AND
                           NRLANCIMPOIT = @P_LANCTONF             AND
                           NRSEQIMPOIT = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END;

               DELETE FROM CFOPTEMP
               WHERE NRCFOPTEMP = @V_CFOPTEMP;

               SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
               FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               IF @P_ENTRSAID = 'E' BEGIN
                  IF (SUBSTRING(@V_ITEMPPROD_CDSITUTRIBPR,1,1) = SUBSTRING(@V_SITUTRIBPR,1,1)) OR
                     (@V_ITEMPPROD_CDSITUTRIBPR IS NULL) BEGIN
                     UPDATE ITEMPRODUTO
                     SET CDSITUTRIBPR  = @V_SITUTRIBPR
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END
               ELSE IF @P_ENTRSAID = 'S' BEGIN
                  IF (SUBSTRING(@V_ITEMPPROD_CDSITUTRIBPR,1,1) = SUBSTRING(@V_SITUTRIBPR,1,1)) OR
                     (@V_ITEMPPROD_CDSITUTRIBPR IS NULL) BEGIN
                     UPDATE ITEMPRODUTO
                     SET CDSITUTRIBPR  = @V_SITUTRIBPR
                     WHERE CDFILIAL    = @P_FILIAL   AND
                           NRLANCTONF  = @P_LANCTONF AND
                           CDSITUTRIBPR IS NULL      AND
                           NRSEQITPROD = @V_ITEMPPROD_NRSEQITPROD;
                  END;
               END;

               DELETE FROM CSTTEMP
               WHERE NRCSTTEMP = @V_CSTTEMP;

               FETCH NEXT FROM C_ITEMPROD INTO @V_ITEMPPROD_CDFILIAL, @V_ITEMPPROD_NRLANCTONF,
                                               @V_ITEMPPROD_NRSEQITPROD, @V_ITEMPPROD_CDPRODUTO,
                                               @V_ITEMPPROD_CDPRODEMIS, @V_ITEMPPROD_DSPRODEMIS,
                                               @V_ITEMPPROD_IDATUVRESTOQ, @V_ITEMPPROD_QTITEMPROD,
                                               @V_ITEMPPROD_VRUNITITEM, @V_ITEMPPROD_VRDESCITEM,
                                               @V_ITEMPPROD_VRTOTAITEM, @V_ITEMPPROD_VRCONTITEM,
                                               @V_ITEMPPROD_IDCONFORITEM, @V_ITEMPPROD_CDFISOPEITEM,
                                               @V_ITEMPPROD_CDSUFXCFOPPR, @V_ITEMPPROD_CDSITUTRIBPR,
                                               @V_ITEMPPROD_IDERROSITEM, @V_ITEMPPROD_IDAVISOSITEM,
                                               @V_ITEMPPROD_VRBRUTITEM, @V_ITEMPPROD_CDARVPROD,
                                               @V_ITEMPPROD_NRLOTEESTQ, @V_ITEMPPROD_NRSUBLOTE, @V_ITEMPPROD_CDPRODUTO,
                                               @V_ITEMPPROD_QTITEMPROD, @V_ITEMPPROD_CDFISCOPERSN;;
            END;

            CLOSE C_ITEMPROD;
            DEALLOCATE C_ITEMPROD;

            IF(@V_IDOPERDEVONF <> 'S') BEGIN
               DECLARE C_ITEMENCARGO CURSOR FOR
               SELECT IE.CDENCARGO AS CDENCARGO, (VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0)) VRITEMENCA, IDENCARGO,
                    EN.CDCTBLENTREN, EN.CDCTBLSAIDEN
               FROM ENCARGO EN, ITEMENCARGO IE, (SELECT SUM(VRICMSSTITORIG) VRICMSSTITORIG
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL   = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF) I
              WHERE (IE.CDFILIAL   = @P_FILIAL)
                AND (IE.NRLANCTONF = @P_LANCTONF)
                AND (IE.VRITEMENCA-ISNULL(I.VRICMSSTITORIG,0) > 0)
                AND (EN.CDENCARGO  = IE.CDENCARGO);

               OPEN C_ITEMENCARGO;

               FETCH NEXT FROM  C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                                   @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                                   @V_ITEMENC_CDCTBLSAIDEN;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_TOTAPRODENCA = SUM(VRTOTAITEM - VRDESCITEM)
                  FROM ITEMPRODUTO IP
                  WHERE (IP.CDFILIAL   = @P_FILIAL)   AND
                        (IP.NRLANCTONF = @P_LANCTONF);

                  IF @V_TOTAPRODENCA <> 0 BEGIN

                     DECLARE C_ATUAVRCONT CURSOR FOR
                     SELECT IP.NRSEQITPROD, (VRTOTAITEM - VRDESCITEM) AS VRLIQUIDO
                     FROM ITEMPRODUTO IP
                     WHERE (IP.CDFILIAL    = @P_FILIAL) AND
                           (IP.NRLANCTONF  = @P_LANCTONF);

                     OPEN C_ATUAVRCONT;

                     FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;

                     WHILE (@@FETCH_STATUS = 0) BEGIN

                        IF (@V_ITEMENC_IDENCARGO = 'A') BEGIN
                           SET @V_VRBRUTO = (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                        END
                        ELSE IF (@V_ITEMENC_IDENCARGO = 'D') BEGIN
                           SET @V_VRBRUTO = - (@V_ITEMENC_VRITEMENCA/@V_TOTAPRODENCA);
                        END
                        ELSE BEGIN
                           SET @V_VRBRUTO = 0;
                        END;

                        IF (@V_ITEMENC_CDCTBLSAIDEN IS NULL) BEGIN
                           SET @V_VRCONTAB = @V_VRBRUTO;
                        END
                        ELSE BEGIN
                           SET @V_VRCONTAB = 0;
                        END;

                        UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = VRBRUTITEM + (@V_VRBRUTO  * (VRTOTAITEM - VRDESCITEM)),
                            VRCONTITEM = VRCONTITEM + (@V_VRCONTAB * (VRTOTAITEM - VRDESCITEM))
                        WHERE CDFILIAL    = @P_FILIAL   AND
                              NRLANCTONF  = @P_LANCTONF AND
                              NRSEQITPROD = @V_ATUAVR_NRSEQITPROD;

                        FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_NRSEQITPROD, @V_ATUAVR_VRLIQUIDO;

                     END;

                     CLOSE C_ATUAVRCONT;
                     DEALLOCATE C_ATUAVRCONT;
                  END;
                  FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENC_CDENCARGO, @V_ITEMENC_VRITEMENCA,
                                                     @V_ITEMENC_IDENCARGO, @V_ITEMENC_CDCTBLENTREN,
                                                     @V_ITEMENC_CDCTBLSAIDEN;
               END;

               CLOSE C_ITEMENCARGO;
               DEALLOCATE C_ITEMENCARGO;

            END;

            DECLARE C_QTITEM CURSOR FOR
            SELECT NRSEQITPROD
            FROM ITEMPRODUTO
            WHERE (CDFILIAL   = @P_FILIAL)   AND
                  (NRLANCTONF = @P_LANCTONF) AND
                  (QTITEMPROD = 0);

            OPEN C_QTITEM;
            FETCH NEXT FROM C_QTITEM INTO @V_QTITEM_NRSEQITPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               DELETE FROM TRABITPROIMPOS
               WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                     (NRLANCIMPOIT = @P_LANCTONF) AND
                     (NRSEQIMPOIT  = @V_QTITEM_NRSEQITPROD);

              FETCH NEXT FROM C_QTITEM INTO @V_QTITEM_NRSEQITPROD;
            END;
            CLOSE C_QTITEM;
            DEALLOCATE C_QTITEM;

            SELECT @V_IMPOSITEM = MAX(CDFILIMPOIT+NRLANCIMPOIT)
            FROM TRABITPROIMPOS
            WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                  (NRLANCIMPOIT = @P_LANCTONF);

            IF @V_IMPOSITEM IS NULL BEGIN
               DELETE FROM TRABIMPOSNFTOT
               WHERE (CDFILIMPTOT  = @P_FILIAL) AND
                     (NRLANCIMPTOT = @P_LANCTONF);
            END;

   ---------------------------------------------------------------------------------------------------------
            DELETE ITEMPRODUTO
            WHERE (CDFILIAL   = @P_FILIAL)   AND
                  (NRLANCTONF = @P_LANCTONF) AND
                  (QTITEMPROD = 0);
   ---------------------------------------------------------------------------------------------------------

            DECLARE C_IMPOSPROD CURSOR FOR
   ---------------------------------------------------------------------------------------------------------
            SELECT IT.CDIMPOSTOIT,
                   ISNULL(SUM(IT.VRIMPOSIT),0)  AS VRIMPOSTOIT,
                   ISNULL(SUM(IT.VRBCALCIMPOIT),0) AS VRBASECALCIT
            FROM TRABITPROIMPOS IT
            WHERE (IT.CDFILIMPOIT  = @P_FILIAL)   AND
                  (IT.NRLANCIMPOIT = @P_LANCTONF)
            GROUP BY IT.CDIMPOSTOIT;
   ---------------------------------------------------------------------------------------------------------
            OPEN C_IMPOSPROD;
            FETCH NEXT FROM C_IMPOSPROD INTO @V_IMPOSPROD_CDIMPOSTOIT, @V_IMPOSPROD_VRIMPOSTOIT, @V_IMPOSPROD_VRBASECALCIT;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               UPDATE TRABIMPOSNFTOT
               SET VRIMPOSTOT   = @V_IMPOSPROD_VRIMPOSTOIT,
                   VRBCALIMPTOT = @V_IMPOSPROD_VRBASECALCIT
               WHERE (CDFILIMPTOT  = @P_FILIAL)   AND
                     (NRLANCIMPTOT = @P_LANCTONF) AND
                     (CDIMPOSTOT   = @V_IMPOSPROD_CDIMPOSTOIT);
               FETCH NEXT FROM C_IMPOSPROD INTO @V_IMPOSPROD_CDIMPOSTOIT, @V_IMPOSPROD_VRIMPOSTOIT, @V_IMPOSPROD_VRBASECALCIT;
            END;
            CLOSE C_IMPOSPROD;
            DEALLOCATE C_IMPOSPROD;

   ---------------------------------------------------------------------------------------------------------
            IF @V_IDOPERDEVONF <> 'S' BEGIN
               DECLARE C_PREDBCALC CURSOR FOR
               SELECT NRSEQIMPOIT, CDIMPOSTOIT, CDSTRIBIMPOIT, CDFOPERIMPOIT,
                      CDSCFOPIMPOIT, VRCONTIMPOIT, VRREDBCIMPOIT, VRBCALCIMPOIT,
                      IDVALORINFO, P.CDARVPROD
               FROM TRABITPROIMPOS T, ITEMPRODUTO I, PRODUTO P
               WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
                     (NRLANCIMPOIT = @P_LANCTONF) AND
                     (T.CDFILIMPOIT = I.CDFILIAL) AND
                     (T.NRLANCIMPOIT = I.NRLANCTONF) AND
                     (T.NRSEQIMPOIT = I.NRSEQITPROD) AND
                     (I.CDPRODUTO = P.CDPRODUTO) AND
                     (VRREDBCIMPOIT > 0)
               OPEN C_PREDBCALC;
               FETCH NEXT FROM C_PREDBCALC INTO @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, @V_PREDBCALC_CDSTRIBIMPOIT,@V_PREDBCALC_CDFOPERIMPOIT,
                                                @V_PREDBCALC_CDSCFOPIMPOIT, @V_PREDBCALC_VRCONTIMPOIT, @V_PREDBCALC_VRREDBCIMPOIT,@V_PREDBCALC_VRBCALCIMPOIT,
                                                @V_PREDBCALC_IDVALORINFO, @V_PREDBCALC_CDARVPROD;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  DELETE ITEMPROIMPOS
                  WHERE CDFILIAL     = @P_FILIAL   AND
                        NRLANCTONF   = @P_LANCTONF AND
                        NRSEQITPROD  = @V_PREDBCALC_NRSEQIMPOIT AND
                        CDIMPOSTO    = @V_PREDBCALC_CDIMPOSTOIT AND
                        NRITPROIMPOS = '2';

                  /*VERIFICA CST POR IMPOSTO*/
                  SET @V_IMPOICMS = NULL;
                  SET @V_CDGRUPOFISCAUX = NULL;

                  SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
                    FROM GRUPOFISCIMPFIL G,
                          (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                                  ELSE CDFILIEMIT END AS CDFILIAL
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) F
                   WHERE G.CDFILIAL = F.CDFILIAL
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;

                  IF @V_IDORIGDESTNF = 'F' BEGIN
                  SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                    FROM GRFISIMPIEFORN G,
                         (SELECT CDFORNECED
                            FROM NOTAFISCAL
                           WHERE CDFILIAL = @P_FILIAL
                             AND NRLANCTONF = @P_LANCTONF) N
                   WHERE G.CDFORNECED = N.CDFORNECED
                     AND G.CDEMPRESA = @P_EMPRESA
                     AND G.CDINSCESTA = @P_INSCESTA
                     AND NOT G.CDGRUPOFISC IS NULL
                     AND G.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;
                  END
                  ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
                     SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                      FROM GRFISIMPIECLIE G,
                           (SELECT CDCLIENTE
                              FROM NOTAFISCAL
                             WHERE CDFILIAL = @P_FILIAL
                               AND NRLANCTONF = @P_LANCTONF) N
                     WHERE G.CDCLIENTE = N.CDCLIENTE
                       AND G.CDEMPRESA = @P_EMPRESA
                       AND G.CDINSCESTA = @P_INSCESTA
                       AND NOT G.CDGRUPOFISC IS NULL
                       AND G.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;
                  END;

                  IF @V_CDGRUPOFISCAUX IS NULL BEGIN
                     EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_PREDBCALC_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_PREDBCALC_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END
                  ELSE BEGIN
                     EXEC CONSULTA_CST_NFE 'E', @P_EMPRESA, @V_PREDBCALC_CDARVPROD, @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_PREDBCALC_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                                @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
                  END;

                  SELECT @V_IMPOICMS = MAX(CDIMPOSTO)
                    FROM IMPOSTONFE N, IMPOSTO I
                   WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                     AND N.CDIMPOSTONFE = '00'
                     AND I.CDIMPOSTO = @V_PREDBCALC_CDIMPOSTOIT;

                  INSERT INTO ITEMPROIMPOS(
                     CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                     CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, VRCONTITIMP,
                     VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                     CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT)
                  VALUES(
                     @P_FILIAL, @P_LANCTONF, @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, '2', '2',
                     @V_PREDBCALC_CDSTRIBIMPOIT, @V_PREDBCALC_CDFOPERIMPOIT, @V_PREDBCALC_CDSCFOPIMPOIT, 0,
                     0, 0, ROUND(@V_PREDBCALC_VRCONTIMPOIT - @V_PREDBCALC_VRBCALCIMPOIT,2), 0, 0, '00000', '00000',
                     @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);

                  DELETE TRABITPROIMPOS
                  WHERE CDFILIMPOIT  = @P_FILIAL   AND
                        NRLANCIMPOIT = @P_LANCTONF AND
                        NRSEQIMPOIT  = @V_PREDBCALC_NRSEQIMPOIT AND
                        CDIMPOSTOIT  = @V_PREDBCALC_CDIMPOSTOIT AND
                        NRSEQITPRO   = '2';

                  INSERT INTO TRABITPROIMPOS(
                     CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                     CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                     VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
                     CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
                  VALUES(
                     @P_FILIAL, @P_LANCTONF, @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, '2', '2',
                     @V_PREDBCALC_CDSTRIBIMPOIT, @V_PREDBCALC_CDFOPERIMPOIT, @V_PREDBCALC_CDSCFOPIMPOIT, 0,
                     0, 0, ROUND(@V_PREDBCALC_VRCONTIMPOIT - @V_PREDBCALC_VRBCALCIMPOIT,2), 0, 0, '00000', '00000',
                     @V_PREDBCALC_IDVALORINFO,  @V_CDSITTRIBTMP, @V_IDMODBCNFE, @V_IDMODBCSTNFE,
                     @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE, @V_CDREGRAITALIQ);

                     FETCH NEXT FROM C_PREDBCALC INTO @V_PREDBCALC_NRSEQIMPOIT, @V_PREDBCALC_CDIMPOSTOIT, @V_PREDBCALC_CDSTRIBIMPOIT,@V_PREDBCALC_CDFOPERIMPOIT,
                                                @V_PREDBCALC_CDSCFOPIMPOIT, @V_PREDBCALC_VRCONTIMPOIT, @V_PREDBCALC_VRREDBCIMPOIT,@V_PREDBCALC_VRBCALCIMPOIT,
                                                @V_PREDBCALC_IDVALORINFO, @V_PREDBCALC_CDARVPROD;
               END;
               CLOSE C_PREDBCALC;
               DEALLOCATE C_PREDBCALC;
            END;
   ---------------------------------------------------------------------------------------------------------

            DELETE FROM IMPOSTONF
            WHERE (CDFILIAL   = @P_FILIAL)   AND
                  (NRLANCTONF = @P_LANCTONF);

            DECLARE C_IMPOSUBTRIB CURSOR FOR
            SELECT NRSEQITPROD, CDIMPOSTO, IDTRIMPSTII
            FROM ITEMPROIMPOS I
            WHERE CDFILIAL     = @V_FILIORIG  AND
                  NRLANCTONF   = @V_DEVOLORIG AND
                  NRITPROIMPOS = '1'         AND
                  EXISTS (SELECT CDIMPOSTO
                          FROM IMPOSTO
                          WHERE CDIMPOSTRIB = I.CDIMPOSTO);

            OPEN C_IMPOSUBTRIB;
            FETCH NEXT FROM C_IMPOSUBTRIB INTO @V_NRSEQITPROD, @V_CDIMPOSTO, @V_IDTRIMPSTII;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               UPDATE TRABITPROIMPOS
               SET IDTRIMPSTTI = @V_IDTRIMPSTII
               WHERE CDFILIMPOIT  = @P_FILIAL      AND
                     NRLANCIMPOIT = @P_LANCTONF    AND
                     NRSEQIMPOIT  = @V_NRSEQITPROD AND
                     CDIMPOSTOIT  = @V_CDIMPOSTO   AND
                     NRSEQITPRO   = '1';

               FETCH NEXT FROM C_IMPOSUBTRIB INTO @V_NRSEQITPROD, @V_CDIMPOSTO, @V_IDTRIMPSTII;
            END;
            CLOSE C_IMPOSUBTRIB;
            DEALLOCATE C_IMPOSUBTRIB;

         END
         ELSE BEGIN
            SELECT @V_TOTAPROD = ISNULL(SUM(VRTOTAITEM - VRDESCITEM),0)
            FROM ITEMPRODUTO
            WHERE CDFILIAL   = @P_FILIAL   AND
                  NRLANCTONF = @P_LANCTONF;
         END;
      END
      ELSE BEGIN
         SELECT @V_TOTAPROD = ISNULL(SUM(VRTOTAITEM - VRDESCITEM),0)
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = @P_FILIAL   AND
               NRLANCTONF = @P_LANCTONF;
      END;

      IF @P_TIPOOPER = '11' AND @V_IDNFOUTRASNF = 'S' BEGIN
         SELECT @V_QTDEREGTRAB = COUNT(*)
         FROM TRABITPROIMPOS
         WHERE CDFILIMPOIT  = @P_FILIAL   AND
               NRLANCIMPOIT = @P_LANCTONF;

         IF @V_QTDEREGTRAB = 0 BEGIN
            INSERT INTO TRABITPROIMPOS(
               CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, VRCONTIMPOIT,
               VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO,
               CDSTRIBITNFE, IDMODBCITEMNFE, IDMODBCSTITENFE,
               CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESOTRABIT, CDREGRATRABIT)
               (SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT, CDSITUTRIBIT,
                       CDFISCOPERIT, CDSUFXCFOPIT, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, ROUND(VRCONTITIMP,2),
                       VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, ISNULL(IDVALORINFIT, 'N'),
                       CDSITUTRIBITNFE, IDMODBCITNFE, IDMODBCSTITNFE,
                       CDTPCREDPICOITE, CDNATUBCALPCIT, IDMOTDESONERAIT, CDREGRAIT
                FROM ITEMPROIMPOS
                WHERE CDFILIAL   = @P_FILIAL   AND
                      NRLANCTONF = @P_LANCTONF);


            DECLARE C_IMPOSNFTOT CURSOR FOR
            SELECT IP.CDIMPOSTO,
                   CDIMPOSTOIT,
                   ROUND(SUM(ISNULL(VRIMPOSIT,0)),@V_NRDECITOTANF) AS VRIMPOSTOIT,
                   ISNULL(SUM(VRBASECALCIT),0) AS VRBASECALCIT,
                   ISNULL(SUM(VRBCALCIMPOIT),0) AS VRBCALCIMPOIT,
                   MAX(ISNULL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR
            FROM ITEMPROIMPOS IP, TRABITPROIMPOS TI, IMPOSTO I
            WHERE (IP.CDFILIAL     = @P_FILIAL)      AND
                  (IP.NRLANCTONF   = @P_LANCTONF)    AND
                  (TI.CDFILIMPOIT  = @P_FILIAL)      AND
                  (TI.NRLANCIMPOIT = @P_LANCTONF)    AND
                  (IP.NRSEQITPROD  = TI.NRSEQIMPOIT) AND
                  (IP.NRITPROIMPOS = TI.NRSEQITPRO)  AND
                  (IP.CDIMPOSTO    = TI.CDIMPOSTOIT) AND
   ---------------------------------------------------------------------------------------------------------
                  (I.CDIMPOSTO     = IP.CDIMPOSTO)   AND
                  (IP.NRITPROIMPOS  = 1 )
   ---------------------------------------------------------------------------------------------------------
            GROUP BY IP.CDIMPOSTO, TI.CDIMPOSTOIT;

            OPEN C_IMPOSNFTOT;

            FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                              @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                              @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               INSERT INTO IMPOSNFTOT(CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF)
               VALUES (@P_FILIAL, @P_LANCTONF, @V_IMPOSNF_CDIMPOSTO, ISNULL(@V_IMPOSNF_VRIMPOSTOIT,0), ISNULL(@V_IMPOSNF_VRBASECALCIT,0));


               FETCH NEXT FROM C_IMPOSNFTOT INTO @V_IMPOSNF_CDIMPOSTO  , @V_IMPOSNF_CDIMPOSTOIT,
                                                 @V_IMPOSNF_VRIMPOSTOIT, @V_IMPOSNF_VRBASECALCIT,
                                                 @V_IMPOSNF_VRBCALCIMPOIT, @V_IMPOSNF_IDPREIMPENTR;
            END; /*WHILE DO CURSOR C_IMPOSNFTOT*/

            CLOSE C_IMPOSNFTOT;
            DEALLOCATE C_IMPOSNFTOT;

            DELETE TRABIMPOSNFTOT WHERE CDFILIMPTOT = @P_FILIAL AND NRLANCIMPTOT = @P_LANCTONF;

            INSERT INTO TRABIMPOSNFTOT(
               CDFILIMPTOT, NRLANCIMPTOT, CDIMPOSTOT, VRIMPOSTOT, VRBCALIMPTOT,
                       IDERROSTOT, IDAVISOSTOT)
               (SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, VRTOTIMPONF, VRTOTBCALCNF,
                       IDERROSIMPTT, IDAVISIMPTT
                        FROM IMPOSNFTOT
                        WHERE CDFILIAL   = @P_FILIAL AND
                              NRLANCTONF = @P_LANCTONF);
         END;
      END;

      /* Altera CFOP e CST para as tabelas NOTAFISCAL e ITEMPRODUTO para nf's de devoluo e complemento */
      IF (@V_IDOPERDEVONF = 'S') OR (@P_TIPOOPER = '03') BEGIN

         DECLARE C_ITPROD CURSOR FOR (SELECT NRSEQITPROD
                                        FROM ITEMPRODUTO
                                       WHERE CDFILIAL = @P_FILIAL
                                         AND NRLANCTONF = @P_LANCTONF);

         OPEN C_ITPROD;
         FETCH NEXT FROM C_ITPROD INTO @V_ITPRODU_NRSEQITPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_CDSITUTRIBIT = '';
            SET @V_CDFISCOPERIT = '';
            SET @V_CDSUFXCFOPIT = '';

            SELECT @V_CDSITUTRIBIT = MAX(CDSTRIBIMPOIT),
                   @V_CDFISCOPERIT = MAX(CDFOPERIMPOIT),
                   @V_CDSUFXCFOPIT = MAX(CDSCFOPIMPOIT)
              FROM TRABITPROIMPOS
             WHERE CDFILIMPOIT = @P_FILIAL
               AND NRLANCIMPOIT = @P_LANCTONF
               AND NRSEQIMPOIT = @V_ITPRODU_NRSEQITPROD;

         UPDATE ITEMPRODUTO
            SET CDSITUTRIBPR = @V_CDSITUTRIBIT,
                CDFISOPEITEM = @V_CDFISCOPERIT,
                CDSUFXCFOPPR = @V_CDSUFXCFOPIT
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND NRSEQITPROD = @V_ITPRODU_NRSEQITPROD;

            FETCH NEXT FROM C_ITPROD INTO @V_ITPRODU_NRSEQITPROD;
         END;
         CLOSE C_ITPROD;
         DEALLOCATE C_ITPROD;
      END;

      SET @V_DIFERENCA = 0;
    /* RATEIO DOS ENCARGOS PARA OS PRODUTOS DA NOTA. ESTE RATEIO  NECESSRIO PARA A NOTA FISCAL ELETRNICA */
      DECLARE C_ITEMENCARGO CURSOR FOR (SELECT ENCARGO.CDENCARGONFE, SUM(ITEMENCARGO.VRITEMENCA) AS VRITEMENCA
                                          FROM ITEMENCARGO, ENCARGO
                                         WHERE ITEMENCARGO.CDENCARGO = ENCARGO.CDENCARGO
                                           AND ENCARGO.CDENCARGONFE IN ('01', '02', '03', '04', '05')
                                           AND ISNULL(ITEMENCARGO.VRITEMENCA, 0) >= 0
                                           AND CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                         GROUP BY ENCARGO.CDENCARGONFE);
      OPEN C_ITEMENCARGO;
      FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENCARGO_CDENCARGONFE, @V_ITEMENCARGO_VRITEMENCA;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         /* ENCARGO FRETE */
         IF (@V_ITEMENCARGO_CDENCARGONFE = '01') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT NRSEQITPROD, VRTOTAITEM
                                                   FROM ITEMPRODUTO
                                                   WHERE CDFILIAL = @P_FILIAL
                                                     AND NRLANCTONF = @P_LANCTONF);
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_VRTOTAITEM = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRFRETEITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRFRETEITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VRFRETEITEM = SUM(VRFRETEITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VRFRETEITEM;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRFRETEITEM = VRFRETEITEM + @V_DIFERENCA
                   WHERE CDFILIAL = @P_FILIAL
                     AND NRLANCTONF = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRFRETEITEM = 0
                WHERE CDFILIAL  = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;

         /* ENCARGO SEGURO */
         IF (@V_ITEMENCARGO_CDENCARGONFE = '02') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT NRSEQITPROD, VRTOTAITEM
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF);

               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_VRTOTAITEM = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRSEGURITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRSEGURITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VRSEGURITEM = SUM(VRSEGURITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VRSEGURITEM;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRSEGURITEM = VRSEGURITEM + @V_DIFERENCA
                   WHERE CDFILIAL = @P_FILIAL
                     AND NRLANCTONF = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRSEGURITEM = 0
                WHERE CDFILIAL  = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;

         /* ENCARGO DESCONTO */
         IF (@V_ITEMENCARGO_CDENCARGONFE = '03') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT NRSEQITPROD, VRTOTAITEM
                                                   FROM ITEMPRODUTO
                                                  WHERE CDFILIAL = @P_FILIAL
                                                    AND NRLANCTONF = @P_LANCTONF);
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  SELECT @V_VRTOTAITEM = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRENCARGODESC = ROUND(VRDESCITEM + (@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100)), 2, 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRENCARGODESC = ROUND(VRDESCITEM + (@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100)), 2)
                      WHERE CDFILIAL  = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VRENCARGODESC = SUM(VRENCARGODESC)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SELECT @V_SUMVRDESCITEM = SUM(VRDESCITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL  = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = (@V_ITEMENCARGO_VRITEMENCA+@V_SUMVRDESCITEM) - @V_VRENCARGODESC;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRENCARGODESC = VRENCARGODESC + @V_DIFERENCA
                   WHERE CDFILIAL = @P_FILIAL
                     AND NRLANCTONF = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRENCARGODESC = VRDESCITEM + 0
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;

         /*ENCARGO OUTRAS DESPESAS*/
         IF (@V_ITEMENCARGO_CDENCARGONFE = '04') BEGIN
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR(SELECT NRSEQITPROD, VRTOTAITEM
                                                  FROM ITEMPRODUTO
                                                 WHERE CDFILIAL   = @P_FILIAL
                                                   AND NRLANCTONF = @P_LANCTONF)
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               WHILE(@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_VRTOTAITEM   = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM  = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL    = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF  = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VROUTRASDESPITEM = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD, @V_ITEMPRODUTO_VRTOTAITEM;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;
               /*AJUSTE DE VALORES*/
               SELECT @V_VROUTRASDESPITEM = SUM(VROUTRASDESPITEM)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;


               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VROUTRASDESPITEM;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VROUTRASDESPITEM = VROUTRASDESPITEM + @V_DIFERENCA
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                         FROM ITEMPRODUTO
                                         WHERE CDFILIAL   = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                              FROM ITEMPRODUTO
                                                             WHERE CDFILIAL   = @P_FILIAL
                                                               AND NRLANCTONF = @P_LANCTONF));

               END;
            END;
            ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VROUTRASDESPITEM = 0
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END
         END;

         /*ENCARGO DESPESAS ADUANEIRAS*/
         IF (@V_ITEMENCARGO_CDENCARGONFE = '05') BEGIN
            /*REFAZ O RATEIO DO ENCARGO VERIFICANDO A INCIDENCIA DO IMPOSTO DE IMPORTACAO*/
            UPDATE ITEMPRODUTO
               SET VRDESPADUANEIRA = 0
             WHERE CDFILIAL   = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;
            IF (@V_ITEMENCARGO_VRITEMENCA > 0) BEGIN
               DECLARE C_ITEMPRODUTO CURSOR FOR (SELECT DISTINCT(I.NRSEQITPROD)
                                       FROM ITEMPROIMPOS I, IMPOSTO II
                                      WHERE I.NRLANCTONF    = @P_LANCTONF
                                        AND I.CDFILIAL      = @P_FILIAL
                                        AND I.CDIMPOSTO     = II.CDIMPOSTO
                                        AND II.CDIMPOSTONFE = '20')
               OPEN C_ITEMPRODUTO;
               FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD;
               WHILE(@@FETCH_STATUS = 0) BEGIN
                  SELECT @V_VRTOTAITEM   = ITEMPRODUTO.VRTOTAITEM,
                         @V_SOMATOTAITEM = TOTAL.SOMATOTAITEM,
                         @V_PERCENTITEM  = CASE TOTAL.SOMATOTAITEM WHEN 0 THEN 0 ELSE ((100 * ITEMPRODUTO.VRTOTAITEM) / TOTAL.SOMATOTAITEM) END
                    FROM ITEMPRODUTO, (SELECT CDFILIAL, NRLANCTONF, SUM(VRTOTAITEM) SOMATOTAITEM
                                         FROM ITEMPRODUTO
                                        WHERE CDFILIAL   = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                        GROUP BY CDFILIAL, NRLANCTONF) TOTAL
                   WHERE ITEMPRODUTO.CDFILIAL    = TOTAL.CDFILIAL
                     AND ITEMPRODUTO.NRLANCTONF  = TOTAL.NRLANCTONF
                     AND ITEMPRODUTO.NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;

                  IF (@V_IDSISTEMA = 'VND') OR (@V_IDSISTEMA = 'PDV') BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRDESPADUANEIRA = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2, 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRDESPADUANEIRA = ROUND(@V_ITEMENCARGO_VRITEMENCA * (@V_PERCENTITEM / 100), 2)
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF
                        AND NRSEQITPROD = @V_ITEMPRODUTO_NRSEQITPROD;
                  END;
                  FETCH NEXT FROM C_ITEMPRODUTO INTO @V_ITEMPRODUTO_NRSEQITPROD;
               END;
               CLOSE C_ITEMPRODUTO;
               DEALLOCATE C_ITEMPRODUTO;

               /*AJUSTE DE VALORES*/
               SELECT @V_VRDESPADUANEIRA = SUM(VRDESPADUANEIRA)
                 FROM ITEMPRODUTO
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SET @V_DIFERENCA = @V_ITEMENCARGO_VRITEMENCA - @V_VRDESPADUANEIRA;

               IF @V_DIFERENCA <> 0 BEGIN
                  UPDATE ITEMPRODUTO
                     SET VRDESPADUANEIRA = VRDESPADUANEIRA + @V_DIFERENCA
                   WHERE CDFILIAL    = @P_FILIAL
                     AND NRLANCTONF  = @P_LANCTONF
                     AND NRSEQITPROD = (SELECT MAX(II.NRSEQITPROD)
                                          FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                         WHERE I.CDFILIAL     = @P_FILIAL
                                           AND I.NRLANCTONF   = @P_LANCTONF
                                           AND I.CDFILIAL     = II.CDFILIAL
                                           AND I.NRLANCTONF   = II.NRLANCTONF
                                           AND I.NRSEQITPROD  = II.NRSEQITPROD
                                           AND II.CDIMPOSTO   = S.CDIMPOSTO
                                           AND S.CDIMPOSTONFE = '20'
                                           AND VRTOTAITEM = (SELECT MAX(VRTOTAITEM)
                                                               FROM ITEMPRODUTO I, ITEMPROIMPOS II, IMPOSTO S
                                                              WHERE I.CDFILIAL     = @P_FILIAL
                                                                AND I.NRLANCTONF   = @P_LANCTONF
                                                                AND I.CDFILIAL     = II.CDFILIAL
                                                                AND I.NRLANCTONF   = II.NRLANCTONF
                                                                AND I.NRSEQITPROD  = II.NRSEQITPROD
                                                                AND II.CDIMPOSTO   = S.CDIMPOSTO
                                                                AND S.CDIMPOSTONFE = '20'));
               END;
            END
            ELSE BEGIN
               UPDATE ITEMPRODUTO
                  SET VRDESPADUANEIRA = 0
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;
            END;
         END;
         FETCH NEXT FROM C_ITEMENCARGO INTO @V_ITEMENCARGO_CDENCARGONFE, @V_ITEMENCARGO_VRITEMENCA;
      END;
      CLOSE C_ITEMENCARGO;
      DEALLOCATE C_ITEMENCARGO;

      SET @V_TOTALNOTA = 0;

      SELECT @V_SOMAENCA = SUM(VRITEMENCA)
      FROM ITEMENCARGO IE, ENCARGO EN
      WHERE IE.CDFILIAL   = @P_FILIAL    AND
            IE.NRLANCTONF = @P_LANCTONF  AND
            IE.CDENCARGO  = EN.CDENCARGO AND
            IDENCARGO = 'A';

      SELECT @V_MENOENCA = SUM(VRITEMENCA)
      FROM ITEMENCARGO IE, ENCARGO EN
      WHERE IE.CDFILIAL   = @P_FILIAL    AND
            IE.NRLANCTONF = @P_LANCTONF  AND
            IE.CDENCARGO  = EN.CDENCARGO AND
            IDENCARGO = 'D';


      IF (@V_IDNFIMPORTACAO = 'S') BEGIN
         SELECT @V_SOMAIMPO = SUM(VRIMPOSTOT)
           FROM TRABIMPOSNFTOT T, IMPOSTO I
          WHERE CDFILIMPTOT  = @P_FILIAL   AND
                NRLANCIMPTOT = @P_LANCTONF AND
                T.CDIMPOSTOT = I.CDIMPOSTO AND
                ISNULL(IDACRPRODENTRNF, 'N') = 'N' AND
                NOT EXISTS(SELECT CDIMPOSTO
                           FROM IMPOSTO
                           WHERE IMPOSTO.CDIMPOSTRIB = T.CDIMPOSTOT);

         IF NOT (@V_LIQUIDO IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_LIQUIDO;
         END;

         IF NOT (@V_SOMAIMPO IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA + ROUND(@V_SOMAIMPO, 2);
         END;

         IF NOT (@V_MENOIMPO IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA - ROUND(@V_MENOIMPO, 2);
         END;

         IF NOT (@V_SOMAENCA IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA + @V_SOMAENCA;
         END;

         IF NOT (@V_MENOENCA IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA - @V_MENOENCA;
         END;
      END;
      
      IF (@V_IDNFIMPORTACAO <> 'S') BEGIN
         SELECT @V_SOMAIMPO = SUM(VRIMPOSTOT)
           FROM TRABIMPOSNFTOT T, IMPOSTO I
          WHERE CDFILIMPTOT  = @P_FILIAL   AND
                NRLANCIMPTOT = @P_LANCTONF AND
                T.CDIMPOSTOT = I.CDIMPOSTO AND
                IDTRATIMPO   = 'A'         AND
                ISNULL(IDACRPRODENTRNF, 'N') = 'N' AND
                NOT EXISTS(SELECT CDIMPOSTO
                           FROM IMPOSTO
                           WHERE IMPOSTO.CDIMPOSTRIB = T.CDIMPOSTOT);

         SELECT @V_MENOIMPO = SUM(VRIMPOSTOT)
           FROM TRABIMPOSNFTOT T, IMPOSTO I
          WHERE CDFILIMPTOT  = @P_FILIAL   AND
                NRLANCIMPTOT = @P_LANCTONF AND
                T.CDIMPOSTOT = I.CDIMPOSTO AND
                IDTRATIMPO   = 'D';

         IF NOT (@V_LIQUIDO IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_LIQUIDO;
         END;

         IF NOT (@V_SOMAIMPO IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA + ROUND(@V_SOMAIMPO, 2);
         END;

         IF NOT (@V_MENOIMPO IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA - ROUND(@V_MENOIMPO, 2);
         END;

         IF NOT (@V_SOMAENCA IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA + @V_SOMAENCA;
         END;

         IF NOT (@V_MENOENCA IS NULL) BEGIN
            SET @V_TOTALNOTA = @V_TOTALNOTA - ROUND(@V_MENOENCA, 2);
         END;
      END;

      --VALOR SUBSTITUIO TRIBUTRIA COM IDENTIFICAO PARA ACRESCER AO TOTAL DA NF
      SELECT @V_SOMAIMPO = ISNULL(SUM(ROUND(T.VRIMPOSIT, @V_NRDECITOTANF)),0)
      FROM TRABITPROIMPOS T, IMPOSTO I
      WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
            T.NRLANCIMPOIT = @P_LANCTONF AND
            ISNULL(T.IDTRIMPSTTI, '0')  = '0'         AND
            T.CDIMPOSTOIT    = I.CDIMPOSTO AND
            ISNULL(I.IDACRPRODENTRNF, 'N') = 'N' AND
            EXISTS(SELECT CDIMPOSTO
                   FROM IMPOSTO
                   WHERE CDIMPOSTRIB = T.CDIMPOSTOIT);

      IF NOT (@V_SOMAIMPO IS NULL) BEGIN
         SET @V_TOTALNOTA = @V_TOTALNOTA + ROUND(@V_SOMAIMPO, 2);
      END;

      IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN
   ---------------------------------------------------------------------------------------------------------
         IF ((@V_TOTALNOTA <> 0) AND (ISNULL(@V_LIQUIDO,0) = 0)) BEGIN
            SELECT @V_VRPRODUTOS = ISNULL(MAX(VRPRODUTOS),0)
            FROM NOTAFISCAL
            WHERE CDFILIAL = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END
         ELSE BEGIN
            SET @V_VRPRODUTOS = ISNULL(@V_LIQUIDO, 0);

            UPDATE NOTAFISCAL
            SET VRPRODUTOS = ISNULL(@V_LIQUIDO, 0)
            WHERE CDFILIAL = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END;
   ---------------------------------------------------------------------------------------------------------
      END
      ELSE BEGIN
         UPDATE NOTAFISCAL
         SET VRPRODUTOS = ISNULL(@V_TOTAPROD, 0)
         WHERE CDFILIAL = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;
      END;

      UPDATE NOTAFISCAL
         SET VRNOTAFISC = ROUND(@V_TOTALNOTA, 2)
       WHERE CDFILIAL   = @P_FILIAL
         AND NRLANCTONF = @P_LANCTONF;

      EXEC CONSULTA_DESONERACAO @P_FILIAL, @P_LANCTONF, @P_VRDESONERA = @V_IMPOSDESONERA OUTPUT;

      IF @V_IDIMPDESONERA = 'N' BEGIN
         SET @P_VRNOTAFISC = ROUND(@V_TOTALNOTA, 2);
         SET @V_TOTALNOTA  = ROUND(@V_TOTALNOTA, 2);
      END
      ELSE BEGIN
         SET @P_VRNOTAFISC = ROUND(@V_TOTALNOTA - @V_IMPOSDESONERA, 2);
         SET @V_TOTALNOTA  = ROUND(@V_TOTALNOTA - @V_IMPOSDESONERA, 2);
      END;

   --CLCULO DO VALOR TOTAL DA NOTA FISCAL
   ---------------------------------------------------------------------------------------------------------
      IF @P_TIPOOPER = '08' BEGIN
         UPDATE NOTAFISCAL
         SET VRNOTAFISC = ISNULL(@V_TOTALNOTA,0),
             VRPRODUTOS = ISNULL(@V_LIQUIDO,0),
             IDERROS    = '000'
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;
      END;
   ---------------------------------------------------------------------------------------------------------

      IF (@V_IDOPERDEVONF <> 'S') OR ((@V_IDOPERDEVONF = 'S') AND (@V_DEVOLORIG IS NULL)) BEGIN
         DECLARE C_VRIMPOSTO CURSOR FOR
         SELECT II.CDIMPOSTOIT, SUM(II.VRIMPOSIT) AS VRIMPOSIT
         FROM TRABITPROIMPOS II, IMPOSTO I
         WHERE II.CDIMPOSTOIT  = I.CDIMPOSTO AND
               II.CDFILIMPOIT  = @P_FILIAL   AND
               II.NRLANCIMPOIT = @P_LANCTONF AND
               II.NRSEQITPRO   = '1'         AND
               I.IDTRATIMPO  IN ('A', 'D')
         GROUP BY II.CDIMPOSTOIT;

         OPEN C_VRIMPOSTO;
         FETCH NEXT FROM C_VRIMPOSTO INTO @V_VRIMPOSTO_CDIMPOSTOIT, @V_VRIMPOSTO_VRIMPOSIT;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_VRTOTIMPONF = SUM(VRIMPOSTOT)
            FROM TRABIMPOSNFTOT
            WHERE CDFILIMPTOT  = @P_FILIAL   AND
                  NRLANCIMPTOT = @P_LANCTONF AND
                  CDIMPOSTOT   = @V_VRIMPOSTO_CDIMPOSTOIT;

            SET @V_VRDIFERENCA = @V_VRTOTIMPONF - @V_VRIMPOSTO_VRIMPOSIT;

            SELECT @V_VRBRUTO = SUM(I.VRBRUTITEM)
            FROM ITEMPRODUTO I, TRABITPROIMPOS II
            WHERE I.CDFILIAL      = @P_FILIAL     AND
                  I.NRLANCTONF    = @P_LANCTONF   AND
                  II.CDFILIMPOIT  = @P_FILIAL     AND
                  II.NRLANCIMPOIT = @P_LANCTONF   AND
                  II.NRSEQIMPOIT  = I.NRSEQITPROD AND
                  II.NRSEQITPRO   = '1'           AND
                  II.CDIMPOSTOIT  = @V_VRIMPOSTO_CDIMPOSTOIT;


            DECLARE C_ATUALIZA CURSOR FOR
            SELECT NRSEQIMPOIT
            FROM TRABITPROIMPOS
            WHERE CDFILIMPOIT  = @P_FILIAL   AND
                  NRLANCIMPOIT = @P_LANCTONF AND
                  CDIMPOSTOIT  = @V_VRIMPOSTO_CDIMPOSTOIT AND
                  NRSEQITPRO = '1'
            ORDER BY NRSEQIMPOIT;

            OPEN C_ATUALIZA;
            FETCH NEXT FROM C_ATUALIZA INTO @V_ATUALIZA_NRSEQIMPOIT;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF @V_VRBRUTO > 0 BEGIN
                  UPDATE ITEMPRODUTO
      ---------------------------------------------------------------------------------------------------------
                  SET VRBRUTITEM = VRBRUTITEM + ((VRBRUTITEM/@V_VRBRUTO) * ISNULL(@V_VRDIFERENCA,0))
      ---------------------------------------------------------------------------------------------------------
                  WHERE CDFILIAL    = @P_FILIAL   AND
                        NRLANCTONF  = @P_LANCTONF AND
                        NRSEQITPROD = @V_ATUALIZA_NRSEQIMPOIT;
               END;
               FETCH NEXT FROM C_ATUALIZA INTO @V_ATUALIZA_NRSEQIMPOIT;
            END;
            CLOSE C_ATUALIZA;
            DEALLOCATE C_ATUALIZA;

            FETCH NEXT FROM C_VRIMPOSTO INTO @V_VRIMPOSTO_CDIMPOSTOIT, @V_VRIMPOSTO_VRIMPOSIT;
         END;
         CLOSE C_VRIMPOSTO;
         DEALLOCATE C_VRIMPOSTO;

         SELECT @V_VRBRUTO = SUM(VRBRUTITEM)
         FROM ITEMPRODUTO
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;

         SELECT @V_VRNOTAFISC = MAX(VRNOTAFISC)
         FROM NOTAFISCAL
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCTONF = @P_LANCTONF;

         SET @V_VRDIFERENCA = @V_VRNOTAFISC - @V_VRBRUTO;

         IF (@V_VRDIFERENCA <> 0) AND (ABS(@V_VRDIFERENCA) <= 0.05) BEGIN
            SELECT @V_NRSEQITPROD = MAX(NRSEQITPROD)
            FROM ITEMPRODUTO
            WHERE CDFILIAL   = @P_FILIAL   AND
                  NRLANCTONF = @P_LANCTONF AND
                  VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                FROM ITEMPRODUTO
                                WHERE CDFILIAL = @P_FILIAL AND
                                      NRLANCTONF = @P_LANCTONF);

            UPDATE ITEMPRODUTO
            SET VRBRUTITEM = VRBRUTITEM + @V_VRDIFERENCA
            WHERE CDFILIAL    = @P_FILIAL   AND
                  NRLANCTONF  = @P_LANCTONF AND
                  NRSEQITPROD = @V_NRSEQITPROD;
         END;

         -- RECALCULO DO VALOR CONTABIL DO ITEM

         IF (@P_TIPOOPER <> '03') BEGIN

            UPDATE ITEMPRODUTO
               SET VRBRUTITEM = ROUND(VRBRUTITEM, 2)
             WHERE CDFILIAL   = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;

            SET @V_VRTOTBRUT = 0;
            SET @V_VRTOTANF  = 0;
            SET @V_DIFBRUTNF = 0;

            SELECT @V_VRTOTBRUT = SUM(VRBRUTITEM)
              FROM ITEMPRODUTO
             WHERE CDFILIAL   = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF;

            IF @V_VRTOTBRUT IS NULL BEGIN
               SET @V_VRTOTBRUT = 0;
            END;


            IF @V_VRNOTAFISC = 0 BEGIN
               UPDATE NOTAFISCAL
                  SET VRNOTAFISC = ROUND(@V_TOTALNOTA, 2)
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               IF (@V_VRTOTBRUT <> ROUND(@V_TOTALNOTA, 2)) BEGIN
                  SET @V_DIFBRUTNF = ROUND(@V_TOTALNOTA, 2) - @V_VRTOTBRUT;

                  IF (ABS(@V_DIFBRUTNF) <= 0.2) BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = (VRBRUTITEM + (@V_DIFBRUTNF))
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                             FROM ITEMPRODUTO
                                            WHERE CDFILIAL   = @P_FILIAL
                                              AND NRLANCTONF = @P_LANCTONF
                                              AND VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                                                  FROM ITEMPRODUTO
                                                                 WHERE CDFILIAL   = @P_FILIAL
                                                                   AND NRLANCTONF = @P_LANCTONF));
                  END;
               END;
            END
            ELSE BEGIN
               UPDATE NOTAFISCAL
                  SET VRNOTAFISC = ROUND(VRNOTAFISC, 2)
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               SELECT @V_VRTOTANF = ROUND(VRNOTAFISC, 2)
                 FROM NOTAFISCAL
                WHERE CDFILIAL   = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               IF (@V_VRTOTBRUT <> @V_VRTOTANF) BEGIN
                  SET @V_DIFBRUTNF = @V_VRTOTANF - @V_VRTOTBRUT;

                  IF (ABS(@V_DIFBRUTNF) <= 0.2) BEGIN
                     UPDATE ITEMPRODUTO
                        SET VRBRUTITEM = (VRBRUTITEM + (@V_DIFBRUTNF))
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF
                        AND NRSEQITPROD = (SELECT MAX(NRSEQITPROD)
                                             FROM ITEMPRODUTO
                                            WHERE CDFILIAL   = @P_FILIAL
                                              AND NRLANCTONF = @P_LANCTONF
                                              AND VRBRUTITEM = (SELECT MAX(VRBRUTITEM)
                                                                  FROM ITEMPRODUTO
                                                                 WHERE CDFILIAL   = @P_FILIAL
                                                                   AND NRLANCTONF = @P_LANCTONF));
                  END;
               END;
            END;
         END;

         DECLARE C_ITEM CURSOR FOR SELECT ROUND(VRBRUTITEM, 2) AS VRBRUTITEM, NRSEQITPROD
                                   FROM ITEMPRODUTO I
                                   WHERE CDFILIAL    = @P_FILIAL   AND
                                         NRLANCTONF  = @P_LANCTONF;
         OPEN C_ITEM;
         FETCH NEXT FROM C_ITEM INTO @C_ITEM_VRBRUTITEM, @C_ITEM_NRSEQITPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT = ROUND(VRCONTIMPOIT,2)
            WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                  (NRLANCIMPOIT = @P_LANCTONF)   AND
                  (NRSEQIMPOIT  = @C_ITEM_NRSEQITPROD) AND
                  (NRSEQITPRO   = '2');

            SELECT @V_VRREDUCAO = MAX(ISNULL(VRCONTIMPOIT,0))
            FROM TRABITPROIMPOS
            WHERE (CDFILIMPOIT  = @P_FILIAL) AND
                  (NRLANCIMPOIT = @P_LANCTONF)   AND
                  (NRSEQIMPOIT  = @C_ITEM_NRSEQITPROD) AND
                  (NRSEQITPRO   = '2');

            IF @V_VRREDUCAO IS NULL BEGIN
               SET @V_VRREDUCAO = 0;
            END;

            UPDATE TRABITPROIMPOS
            SET VRCONTIMPOIT  = ISNULL(ROUND((@C_ITEM_VRBRUTITEM - @V_VRREDUCAO),2),0)
            WHERE CDFILIMPOIT  = @P_FILIAL              AND
                  NRLANCIMPOIT = @P_LANCTONF            AND
                  NRSEQITPRO   = '1'                    AND
                  NRSEQIMPOIT  = @C_ITEM_NRSEQITPROD;

            UPDATE ITEMPROIMPOS
            SET VRCONTITIMP = ROUND((@C_ITEM_VRBRUTITEM - @V_VRREDUCAO),2)
            WHERE (NRLANCTONF   = @P_LANCTONF) AND
                  (CDFILIAL     = @P_FILIAL)   AND
                  (NRITPROIMPOS = '1')         AND
                  (NRSEQITPROD  = @C_ITEM_NRSEQITPROD);

            FETCH NEXT FROM C_ITEM INTO @C_ITEM_VRBRUTITEM, @C_ITEM_NRSEQITPROD;

         END;
         CLOSE C_ITEM;
         DEALLOCATE C_ITEM;
      END;

      ---------------------------------------------------------------------------------------------------------
      EXEC ARREDONDA_BASECALC 'E', @P_FILIAL, @P_LANCTONF;
      ---------------------------------------------------------------------------------------------------------

      IF @V_SEQUIMPOSTNF IS NULL BEGIN
         SET @V_SEQUIMPOSTNF = '01';
      END;

      IF @V_SEQUIMPOSTNF = '01' BEGIN
         DELETE FROM IMPOSTONF
         WHERE (CDFILIAL   = @P_FILIAL) AND
               (NRLANCTONF = @P_LANCTONF);
      END;

   ---------------------------------------------------------------------------------------------------------
      DECLARE C_IMPOSTONF CURSOR FOR
      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    <> '03')         AND
            ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3')) AND
            VRCONTIMPOIT > 0
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    <> '03')         AND
            (NRSEQITPRO   <> '3')        AND
            ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0))) AND
            VRCONTIMPOIT > 0
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION ALL


      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    = '03')         AND
            ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3'))
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    = '03')         AND
            (NRSEQITPRO   <> '3')        AND
            ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0)))
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT

      UNION ALL


      SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N, TIPOOPERAC T
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)      AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)   AND
            (CDIMPOSTOIT  = I.CDIMPOSTO)       AND
            (N.CDTIPOOPER    = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP  = T.IDENTRSAIDOP) AND
            (T.IDNFAJUSTE    = 'S')            AND
            ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3'))
      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT
      UNION
      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT, I.IDTRATIMPO,
             SUM(VRIMPOSIT) AS VRIMPOSCONT, ISNULL(IDDIFALIQCUSPTI, 'N') IDDIFALIQCUSPTI,
             IDMOTDESOTRABIT
      FROM TRABITPROIMPOS IT, IMPOSTO I, NOTAFISCAL N, TIPOOPERAC T
      WHERE (CDFILIMPOIT  = @P_FILIAL)   AND
            (NRLANCIMPOIT = @P_LANCTONF) AND
            (IT.CDFILIMPOIT = N.CDFILIAL)    AND
            (IT.NRLANCIMPOIT = N.NRLANCTONF)  AND
            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
            (N.CDTIPOOPER    = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP  = T.IDENTRSAIDOP) AND
            (T.IDNFAJUSTE    = 'S')            AND
            (NRSEQITPRO   <> '3')        AND
            ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
             ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0)))
      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, I.IDTRATIMPO,
               ISNULL(IDDIFALIQCUSPTI, 'N'), IDMOTDESOTRABIT

      OPEN C_IMPOSTONF;
      FETCH NEXT FROM C_IMPOSTONF INTO @V_IMPOSTON_CDIMPOSTOIT, @V_IMPOSTON_VRALIQIMPOIT,
                                       @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRPDEDIMPOIT,
                                       @V_IMPOSTON_CDFISCIMPOIT, @V_IMPOSTON_CDSTRIBIMPOIT,
                                       @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
                                       @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_VRCONTIMPOIT,
                                       @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRIMPOSIT,
                                       @V_IMPOSTON_IDTRATIMPO, @V_IMPOSTON_VRIMPOSCONT,
                                       @V_IMPOSTON_IDDIFALIQCUSPTI, @V_IMPOSTON_IDMOTDESOTRABIT;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT  @V_IDFORMAPUR = MAX(IDFORMAPUR)
         FROM IMPOSTO
         WHERE CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;

         SET @V_VRIMPOSCONT = 0;
         IF @V_IMPOSTON_IDTRATIMPO = 'A' BEGIN
            SET @V_VRIMPOSCONT = @V_IMPOSTON_VRIMPOSCONT;
         END
         ELSE IF @V_IMPOSTON_IDTRATIMPO = 'D' BEGIN
            SET @V_VRIMPOSCONT = - @V_IMPOSTON_VRIMPOSCONT;
         END;
   ---------------------------------------------------------------------------------------------------------

         IF @V_IDFORMAPUR = 'P' BEGIN
            INSERT INTO IMPOSTONF(
               CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
               VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
               IDIMPOSTONF, IDDIFALIQCUSPRN, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
            VALUES(
               @P_FILIAL, @P_LANCTONF, @V_IMPOSTON_CDIMPOSTOIT, @V_SEQUIMPOSTNF, ROUND(@V_IMPOSTON_VRCONTIMPOIT,2),
               @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRALIQIMPOIT,
               @V_IMPOSTON_VRPDEDIMPOIT, @V_IMPOSTON_VRIMPOSIT, @V_IMPOSTON_CDFISCIMPOIT,
               @V_IMPOSTON_CDSTRIBIMPOIT, @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
               @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_IDDIFALIQCUSPTI, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IMPOSTON_IDMOTDESOTRABIT);

            SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
         END
         ELSE BEGIN
            SET @V_CDGRUPOFISCAUX = NULL;

            SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
              FROM GRUPOFISCIMPFIL G,
                    (SELECT CASE  'E' WHEN 'E' THEN CDFILIRECE
                            ELSE CDFILIEMIT END AS CDFILIAL
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = @P_FILIAL
                       AND NRLANCTONF = @P_LANCTONF) F
             WHERE G.CDFILIAL = F.CDFILIAL
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;

            IF @V_IDORIGDESTNF = 'F' BEGIN
            SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
              FROM GRFISIMPIEFORN G,
                   (SELECT CDFORNECED
                      FROM NOTAFISCAL
                     WHERE CDFILIAL = @P_FILIAL
                       AND NRLANCTONF = @P_LANCTONF) N
             WHERE G.CDFORNECED = N.CDFORNECED
               AND G.CDEMPRESA = @P_EMPRESA
               AND G.CDINSCESTA = @P_INSCESTA
               AND NOT G.CDGRUPOFISC IS NULL
               AND G.CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;
            END
            ELSE IF @V_IDORIGDESTNF = 'C' BEGIN
               SELECT @V_CDGRUPOFISCAUX = ISNULL(MAX(G.CDGRUPOFISC), @V_CDGRUPOFISCAUX)
                FROM GRFISIMPIECLIE G,
                     (SELECT CDCLIENTE
                        FROM NOTAFISCAL
                       WHERE CDFILIAL = @P_FILIAL
                         AND NRLANCTONF = @P_LANCTONF) N
               WHERE G.CDCLIENTE = N.CDCLIENTE
                 AND G.CDEMPRESA = @P_EMPRESA
                 AND G.CDINSCESTA = @P_INSCESTA
                 AND NOT G.CDGRUPOFISC IS NULL
                 AND G.CDIMPOSTO = @V_IMPOSTON_CDIMPOSTOIT;
            END;

            IF @V_CDGRUPOFISCAUX IS NULL BEGIN
               EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISC, @V_IMPOSTON_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                     @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
            END
            ELSE BEGIN
               EXEC CONSULTA_CST_NFE @P_ENTRSAID, @P_EMPRESA, '', @P_INSCESTA, @P_TIPOOPER, @V_CDGRUPOFISCAUX, @V_IMPOSTON_CDIMPOSTOIT, @V_IDINTEREST, @V_IDINTERNA, @P_FILIAL, @P_LANCTONF, '', @P_CDSITTRIBTMP = @V_CDSITTRIBTMP OUTPUT, @P_IDMODBCNFE = @V_IDMODBCNFE OUTPUT,
                                     @P_IDMODBCSTNFE = @V_IDMODBCSTNFE OUTPUT, @P_CDTPCRPICOSTNFE = @V_CDTPCRPICOSTNFE OUTPUT, @P_CDNATUBCPCSTNFE = @V_CDNATUBCPCSTNFE OUTPUT, @P_IDMOTIDESSTNFE = @V_IDMOTIDESSTNFE OUTPUT;
            END;

   ---------------------------------------------------------------------------------------------------------
            INSERT INTO IMPOSTONF(
               CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
               VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
               IDIMPOSTONF, IDDIFALIQCUSPRN, CDTPCREDPICONF, CDNATUBCALPCNF, IDMOTDESONERANF)
            VALUES(
               @P_FILIAL, @P_LANCTONF, @V_IMPOSTON_CDIMPOSTOIT, @V_SEQUIMPOSTNF, ROUND(@V_IMPOSTON_VRCONTIMPOIT,2),
               @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRALIQIMPOIT,
               @V_IMPOSTON_VRPDEDIMPOIT, @V_IMPOSTON_VRIMPOSIT, @V_IMPOSTON_CDFISCIMPOIT,
               @V_IMPOSTON_CDSTRIBIMPOIT, @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
               @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_IDDIFALIQCUSPTI, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IMPOSTON_IDMOTDESOTRABIT);
   ---------------------------------------------------------------------------------------------------------

            SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_SEQUIMPOSTNF) + 1)),2);
         END;

         FETCH NEXT FROM C_IMPOSTONF INTO @V_IMPOSTON_CDIMPOSTOIT, @V_IMPOSTON_VRALIQIMPOIT,
                                          @V_IMPOSTON_VRREDBCIMPOIT, @V_IMPOSTON_VRPDEDIMPOIT,
                                          @V_IMPOSTON_CDFISCIMPOIT, @V_IMPOSTON_CDSTRIBIMPOIT,
                                          @V_IMPOSTON_CDFOPERIMPOIT, @V_IMPOSTON_CDSCFOPIMPOIT,
                                          @V_IMPOSTON_NRSEQITPRO, @V_IMPOSTON_VRCONTIMPOIT,
                                          @V_IMPOSTON_VRBCALCIMPOIT, @V_IMPOSTON_VRIMPOSIT,
                                          @V_IMPOSTON_IDTRATIMPO, @V_IMPOSTON_VRIMPOSCONT,
                                          @V_IMPOSTON_IDDIFALIQCUSPTI, @V_IMPOSTON_IDMOTDESOTRABIT;
      END; /* WHILE DO CURSOR C_IMPOSTONF*/

      CLOSE C_IMPOSTONF;
      DEALLOCATE C_IMPOSTONF;

      ---------------------------------------------------------------------------------------------------------
         DECLARE C_IMPOSTORETI CURSOR FOR SELECT N.CDEMPRESA, CDIMPOSTO, N.IDTPIJURNF, N.NRINSJURNF, N.DTENTRSAID
                                          FROM IMPOSTO I, NOTAFISCAL N
                                          WHERE IDTRATIMPO    = 'R'        AND
                                                IDUTVRMENSBC  = 'S'        AND
                                                N.CDFILIAL    = @P_FILIAL   AND
                                                N.NRLANCTONF  = @P_LANCTONF;

         OPEN C_IMPOSTORETI;
         FETCH NEXT FROM C_IMPOSTORETI INTO @V_IMPOSTORETI_CDEMPRESA, @V_IMPOSTORETI_CDIMPOSTO ,@V_IMPOSTORETI_IDTPIJURNF , @V_IMPOSTORETI_NRINSJURNF, @V_IMPOSTORETI_DTENTRSAID;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            EXEC BASECALC_RETIDO 'S', @P_FILIAL, @P_LANCTONF, @V_IMPOSTORETI_IDTPIJURNF, @V_IMPOSTORETI_NRINSJURNF,
                                      @V_IMPOSTORETI_DTENTRSAID, @V_IMPOSTORETI_CDIMPOSTO, 'E', @V_IMPOSTORETI_CDEMPRESA,
                                      @P_INSCESTA, @V_PAISORIG, @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_CDGRUPOFISC, @V_CDGRPFISCSV, @P_TIPOOPER;

            FETCH NEXT FROM C_IMPOSTORETI INTO @V_IMPOSTORETI_CDEMPRESA, @V_IMPOSTORETI_CDIMPOSTO ,@V_IMPOSTORETI_IDTPIJURNF , @V_IMPOSTORETI_NRINSJURNF, @V_IMPOSTORETI_DTENTRSAID;
         END;

         CLOSE C_IMPOSTORETI;
         DEALLOCATE C_IMPOSTORETI;

      /* SE O IPI COMPOR A BASE DE CALCULO DO ICMS E O ICMS TIVER O CODIGO FISCAL IGUAL A 1 SERA ATUALIZADO COM O IDENTIFICADOR 4 */
         DECLARE C_IMPFISC CURSOR FOR
            SELECT CDFILIAL, NRLANCTONF, CDIMPOSTO, CDSITUTRIBNF, CDFISCOPERNF, CDFISCALNF
              FROM IMPOSTONF IP
             WHERE IP.CDFILIAL = @P_FILIAL
               AND IP.NRLANCTONF = @P_LANCTONF
               AND IP.IDIMPOSTONF = '1'
               AND IP.CDFISCALNF = '1'

         OPEN C_IMPFISC;
         FETCH NEXT FROM C_IMPFISC INTO @V_IMPFISC_CDFILIAL ,@V_IMPFISC_NRLANCTONF , @V_IMPFISC_CDIMPOSTO,
                                        @V_IMPFISC_CDSITUTRIBNF, @V_IMPFISC_CDFISCOPERNF, @V_IMPFISC_CDFISCALNF;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_CDIMPOBCALC = MAX(BC.CDIMPOBCALC)
              FROM BASECALCTPOPER BC
             WHERE BC.IDENTRSAIDOP = @P_ENTRSAID
               AND BC.CDTIPOOPER = @P_TIPOOPER
               AND BC.CDIMPOSTO = @V_IMPFISC_CDIMPOSTO
               AND BC.CDIMPOBCALC IS NOT NULL
               AND ((SUBSTRING(@V_IMPFISC_CDSITUTRIBNF,2,2)  = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
               AND ((SUBSTRING(@V_IMPFISC_CDFISCOPERNF,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
               AND (@V_IMPFISC_CDFISCALNF = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL);

            IF @V_CDIMPOBCALC IS NULL BEGIN
               SELECT @V_CDIMPOBCALC = MAX(BC.CDIMPOBCALC)
                 FROM BASECALC BC
                WHERE BC.CDIMPOSTO = @V_IMPFISC_CDIMPOSTO
                  AND BC.CDIMPOBCALC IS NOT NULL
                  AND ((SUBSTRING(@V_IMPFISC_CDSITUTRIBNF,2,2)  = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL))
                  AND ((SUBSTRING(@V_IMPFISC_CDFISCOPERNF,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL))
                  AND (@V_IMPFISC_CDFISCALNF = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)
                  AND BC.IDTIPOBCALC = 'I';

               IF NOT @V_CDIMPOBCALC IS NULL BEGIN
                  UPDATE IMPOSTONF
                  SET IDIMPOSTONF = '4'
                  WHERE CDFILIAL   = @V_IMPFISC_CDFILIAL   AND
                        NRLANCTONF = @V_IMPFISC_NRLANCTONF AND
                        CDIMPOSTO  = @V_CDIMPOBCALC        AND
                        IDIMPOSTONF = '1';
               END;
            END
            ELSE BEGIN
               UPDATE IMPOSTONF
               SET IDIMPOSTONF = '4'
               WHERE CDFILIAL   = @V_IMPFISC_CDFILIAL   AND
                     NRLANCTONF = @V_IMPFISC_NRLANCTONF AND
                     CDIMPOSTO  = @V_CDIMPOBCALC        AND
                     IDIMPOSTONF = '1';
            END;

            FETCH NEXT FROM C_IMPFISC INTO @V_IMPFISC_CDFILIAL ,@V_IMPFISC_NRLANCTONF , @V_IMPFISC_CDIMPOSTO,
                                           @V_IMPFISC_CDSITUTRIBNF, @V_IMPFISC_CDFISCOPERNF, @V_IMPFISC_CDFISCALNF;
         END;

         CLOSE C_IMPFISC;
         DEALLOCATE C_IMPFISC;

      ---------------------------------------------------------------------------------------------------------

      --INCLUSO DOS ENCARGOS DA NF EM CASO DE IMPORTAO
         IF (@V_INTEGRACAO IS NOT NULL) BEGIN
            INSERT INTO ITEMENCARGO
            (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
            (SELECT @P_FILIAL, @P_LANCTONF, CDENCARGO, 0 AS VRITEMENCA
             FROM ENCARGO
             WHERE NOT EXISTS
             (SELECT CDFILIAL, NRLANCTONF, CDENCARGO, 0 AS VRITEMENCA
              FROM ITEMENCARGO
              WHERE CDFILIAL   = @P_FILIAL AND
                    NRLANCTONF = @P_LANCTONF AND
                    (ITEMENCARGO.CDENCARGO = ENCARGO.CDENCARGO)));
          END;

      --ATUALIZAO DO CDIGO FISCAL DA OPERAO NA TABELA DE NOTA FISCAL


         IF (@V_INTEGRACAO IS NULL) OR (@P_ENTRSAID = 'E') BEGIN
            IF NOT(@P_TIPOOPER  = '09') BEGIN
               SELECT @V_CDCFOPINFUSU = MAX(CDCFOPINFUSU),
                      @V_DSCFOPINFUSU = MAX(DSCFOPINFUSU)
                 FROM NOTAFISCAL
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCTONF = @P_LANCTONF;

               IF (@V_CDCFOPINFUSU IS NULL) OR (@V_CDCFOPINFUSU = '***') BEGIN        
                  SELECT @V_COUNT = COUNT(DISTINCT CDFISOPEITEM),
                         @V_CDFISOPENTF = MAX(CDFISOPEITEM)
                    FROM ITEMPRODUTO
                   WHERE (CDFILIAL   = @P_FILIAL) 
                     AND (NRLANCTONF = @P_LANCTONF);        

                  IF (@V_COUNT > 1) BEGIN
                     UPDATE NOTAFISCAL
                        SET CDFISOPENTF = '***',
                            CDCFOPINFUSU = '***'
                      WHERE CDFILIAL   = @P_FILIAL 
                        AND NRLANCTONF = @P_LANCTONF;
                  END
                  ELSE IF (@V_COUNT = 1) BEGIN    
                     UPDATE NOTAFISCAL
                        SET CDFISOPENTF = @V_CDFISOPENTF,
                            CDCFOPINFUSU = @V_CDFISOPENTF
                      WHERE CDFILIAL    = @P_FILIAL
                        AND NRLANCTONF  = @P_LANCTONF;

                     UPDATE NOTAFISCAL
                        SET DSCDFISOPENF = @V_DSCDFISOPEIT
                      WHERE (CDFILIAL    = @P_FILIAL)
                        AND (NRLANCTONF  = @P_LANCTONF)
                        AND DSCDFISOPENF IS NULL;     
                  END;
               ELSE
                  SELECT @V_COUNT = COUNT(DISTINCT CDFISOPEITEM),
                         @V_CDFISOPENTF = MAX(CDFISOPEITEM)
                    FROM ITEMPRODUTO
                   WHERE (CDFILIAL   = @P_FILIAL)
                     AND (NRLANCTONF = @P_LANCTONF);

                  IF (@V_COUNT > 1) BEGIN
                     UPDATE NOTAFISCAL
                        SET CDFISOPENTF  = '***',
                            CDCFOPINFUSU = '***'
                      WHERE CDFILIAL   = @P_FILIAL
                        AND NRLANCTONF = @P_LANCTONF;
                  END
                  ELSE IF (@V_COUNT = 1) BEGIN
                        UPDATE NOTAFISCAL
                           SET CDFISOPENTF  = @V_CDFISOPENTF,
                               DSCDFISOPENF = @V_DSCDFISOPEIT
                         WHERE (CDFILIAL    = @P_FILIAL)
                           AND (NRLANCTONF  = @P_LANCTONF);
                  END;
               END;
            END;
         END;

      ---------------------------------------------------------------------------------------------------------
         IF (@V_INTEGRACAO IS NOT NULL) BEGIN
            IF (@P_ENTRSAID = 'S') BEGIN
               SELECT @V_VRCONTAREC = ISNULL(SUM(VRORIGREC),0)
               FROM CONTARECEBER
               WHERE CDFILIAL   = @P_FILIAL AND
                     NRLANCTONF = @P_LANCTONF;

               SELECT @V_IMPOSRETI = ISNULL(SUM(IT.VRIMPOSTOT),0)
               FROM TRABIMPOSNFTOT IT, IMPOSTO I
               WHERE I.CDIMPOSTO     = IT.CDIMPOSTOT AND
                     IT.CDFILIMPTOT  = @P_FILIAL      AND
                     IT.NRLANCIMPTOT = @P_LANCTONF    AND
                     I.IDDESCRFONTE  <> 'A'          AND
                     I.IDTRATIMPO    = 'R';

               IF (@V_VRCONTAREC = @V_VRNOTAFISC) AND (@V_IMPOSRETI > 0) BEGIN
                  EXEC APURAC_VENC @P_FILIAL, @P_FORNECED, @P_LANCTONF;
               END;
            END
            ELSE BEGIN
               IF (@V_IDDOCFINANC <> 'L') AND (@V_IDSTATUS NOT IN ('A', 'E')) AND
                  (SUBSTRING(@V_INTEGRACAO,1,1) IN ('F', 'M')) BEGIN
                  IF @V_IDORIGDESTNF = 'F' BEGIN
                     SELECT @V_IDTPFORPGTFO = MAX(IDTPFORPGTFO)
                     FROM FORNECEDOR
                     WHERE CDFORNECED = @P_FORNECED;

                     IF @V_IDTPFORPGTFO IS NOT NULL BEGIN
                        EXEC GERA_CONTAPAGAR @P_FILIAL, @P_FORNECED, @P_LANCTONF, 'F';
                     END;
                  END;
               END;
            END;

            SELECT @V_CDPRGENEREV = MAX(CDPRODUTO)
            FROM ITEMPRODUTO
            WHERE CDPRODUTO  = @V_CDPRGENEREV AND
                  CDFILIAL   = @P_FILIAL      AND
                  NRLANCTONF = @P_LANCTONF;

            IF @V_CDPRGENEREV IS NOT NULL BEGIN

               DELETE IMPOSINFUSU
               WHERE CDFILIAL   = @P_FILIAL AND
                     NRLANCTONF = @P_LANCTONF;

               INSERT INTO IMPOSINFUSU
                  (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO,
                   CDFISCINFUSU, VRALIQINFUSU, VRRDBCINFUSU, VRPDEDINFUSU)
               (SELECT CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT,
                       ISNULL(CDFISCIMPOIT,' '), ISNULL(VRALIQIMPOIT,0), VRREDBCIMPOIT,
                       VRPDEDIMPOIT
                FROM TRABITPROIMPOS
                WHERE CDFILIMPOIT  = @P_FILIAL AND
                      NRLANCIMPOIT = @P_LANCTONF AND
                      NRSEQITPRO   = '1');
            END;
         END;
      ---------------------------------------------------------------------------------------------------------

         /* ESTA ROTINA ABAIXO SERVE PARA ATUALIZAR O VALOR CONTBIL E BRUTO DOS PRODUTOS COM A DIFERENA
            DE CENTAVOS ENTRE O VALOR DOS IMPOSTOS POR TEM E A SUA RESPECTIVA TOTALIZAO. ESTA DIFERENA
             IGNORADA NO FECHAMENTO DA NF CASO O CLIENTE TRABALHE COM UM NMERO MENOR DE CASAS DECIMAIS E
            PROVOCA ERROS NA CONTABILIZAO*/

         IF @V_NRDECITOTANF <> 2 BEGIN
            DECLARE C_ATUAVRCONT CURSOR FOR
            SELECT T.CDIMPOSTOIT, SUM(T.VRIMPOSIT) AS VRIMPOSIT, T.CDFISCIMPOIT,
                   I.IDIMPORECUP, I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO
            FROM TRABITPROIMPOS T, IMPOSTO I
            WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                  T.NRLANCIMPOIT = @P_LANCTONF AND
                  T.NRSEQITPRO   = '1'         AND
                  T.CDIMPOSTOIT  = I.CDIMPOSTO AND
                  I.IDTIPCONTAB  = 'D'
            GROUP BY T.CDIMPOSTOIT, T.CDFISCIMPOIT, I.IDIMPORECUP,
                     I.CDCCTBLATIV, I.CDCCTBLPASS, I.IDTRATIMPO;

            OPEN C_ATUAVRCONT;
            FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_CDIMPOSTOIT, @V_ATUAVR_VRIMPOSIT,
                                              @V_ATUAVR_CDFISCIMPOIT, @V_ATUAVR_IDIMPORECUP,
                                              @V_ATUAVR_CDCCTBLATIV, @V_ATUAVR_CDCCTBLPASS,
                                              @V_ATUAVR_IDTRATIMPO;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               SELECT @V_VRDIFERENCA = SUM(VRIMPOSTOT) - @V_ATUAVR_VRIMPOSIT
               FROM TRABIMPOSNFTOT
               WHERE CDFILIMPTOT  = @P_FILIAL   AND
                     NRLANCIMPTOT = @P_LANCTONF AND
                     CDIMPOSTOT   = @V_ATUAVR_CDIMPOSTOIT;

               SELECT @V_VRBRUTO = SUM(VRBRUTITEM), @V_VRCONTAB = SUM(VRCONTITEM)
               FROM ITEMPRODUTO I, TRABITPROIMPOS T
               WHERE T.CDFILIMPOIT  = I.CDFILIAL    AND
                     T.NRLANCIMPOIT = I.NRLANCTONF  AND
                     T.NRSEQIMPOIT  = I.NRSEQITPROD AND
                     T.CDFILIMPOIT  = @P_FILIAL     AND
                     T.NRLANCIMPOIT = @P_LANCTONF   AND
                     T.NRSEQITPRO   = '1'           AND
                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT;

               IF @V_VRDIFERENCA <> 0 BEGIN
                  SET @V_IMPOCONTAB = 0;

                  IF (@V_ATUAVR_IDIMPORECUP = 'S') BEGIN
                     IF (@V_ATUAVR_CDFISCIMPOIT = '1') BEGIN
                        IF (@V_ATUAVR_CDCCTBLATIV IS NOT NULL) BEGIN
                           IF @V_ATUAVR_IDTRATIMPO = 'V' BEGIN
                              SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                           END;
                        END;
                     END
                     ELSE BEGIN
                        IF @V_ATUAVR_IDTRATIMPO = 'A' BEGIN
                           SET @V_IMPOCONTAB = @V_VRDIFERENCA;
                        END
                        ELSE IF @V_ATUAVR_IDTRATIMPO IN ('D','R') BEGIN
                           SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     IF NOT(@V_ATUAVR_CDCCTBLPASS IS NULL) BEGIN
                        IF @V_ATUAVR_IDTRATIMPO = 'V' BEGIN
                           SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                        END;
                     END
                     ELSE BEGIN
                        IF @V_ATUAVR_IDTRATIMPO = 'A' BEGIN
                           SET @V_IMPOCONTAB = @V_VRDIFERENCA;
                        END
                        ELSE IF @V_ATUAVR_IDTRATIMPO IN ('D','R') BEGIN
                           SET @V_IMPOCONTAB = - @V_VRDIFERENCA;
                        END;
                     END;
                  END;

                  IF @V_ATUAVR_IDTRATIMPO = 'A' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = VRCONTITEM + ((@V_IMPOCONTAB  / @V_VRCONTAB) * VRCONTITEM)
                     WHERE CDFILIAL+NRLANCTONF+NRSEQITPROD IN (SELECT CDFILIMPOIT+NRLANCIMPOIT+NRSEQIMPOIT
                                                               FROM TRABITPROIMPOS T
                                                               WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                                                                     T.NRLANCIMPOIT = @P_LANCTONF AND
                                                                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT);
                  END
                  ELSE IF @V_ATUAVR_IDTRATIMPO = 'D' BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = VRCONTITEM + ((@V_IMPOCONTAB  / @V_VRCONTAB) * VRCONTITEM)
                     WHERE CDFILIAL+NRLANCTONF+NRSEQITPROD IN (SELECT CDFILIMPOIT+NRLANCIMPOIT+NRSEQIMPOIT
                                                               FROM TRABITPROIMPOS T
                                                               WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                                                                     T.NRLANCIMPOIT = @P_LANCTONF AND
                                                                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT);
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                     SET VRCONTITEM = VRCONTITEM + ((@V_IMPOCONTAB  / @V_VRCONTAB) * VRCONTITEM)
                     WHERE CDFILIAL+NRLANCTONF+NRSEQITPROD IN (SELECT CDFILIMPOIT+NRLANCIMPOIT+NRSEQIMPOIT
                                                               FROM TRABITPROIMPOS T
                                                               WHERE T.CDFILIMPOIT  = @P_FILIAL   AND
                                                                     T.NRLANCIMPOIT = @P_LANCTONF AND
                                                                     T.CDIMPOSTOIT  = @V_ATUAVR_CDIMPOSTOIT);

                  END;
               END;
               FETCH NEXT FROM C_ATUAVRCONT INTO @V_ATUAVR_CDIMPOSTOIT, @V_ATUAVR_VRIMPOSIT,
                                                 @V_ATUAVR_CDFISCIMPOIT, @V_ATUAVR_IDIMPORECUP,
                                                 @V_ATUAVR_CDCCTBLATIV, @V_ATUAVR_CDCCTBLPASS,
                                                 @V_ATUAVR_IDTRATIMPO;
            END;
            CLOSE C_ATUAVRCONT;
            DEALLOCATE C_ATUAVRCONT;
         END;

      IF NOT(@P_LANCESTQ IS NULL) AND (@V_IDCTRLESTQ <> 'N') BEGIN
   ---------------------------------------------------------------------------------------------------------

        IF (@V_IDOPERDEVONF = 'S') BEGIN
            IF (@V_DEVOLORIG IS NOT NULL) BEGIN

               SET @V_DTSAIDNFORIG = NULL;

               SELECT @V_IDSISTEMA = MAX(IDSISTEMA),
                      @V_DTSAIDNFORIG = MAX(DTENTRSAID)
               FROM NOTAFISCAL N, ITEMNOTAFISC I
               WHERE I.CDFILIAL     = @P_FILIAL   AND
                     I.NRLANCTONF   = @P_LANCTONF AND
                     I.CDFILIALIT   = N.CDFILIAL AND
                     I.NRLANCTONFIT = N.NRLANCTONF;
            END
            ELSE BEGIN
               SET @V_IDSISTEMA = 'EXP';
               SET @V_DTSAIDNFORIG = @V_DTATUAL;
            END;

            IF (@V_IDSISTEMA = 'EXP') BEGIN
               SELECT @V_IDRETPROEXP = MAX(ISNULL(IDRETPROEXP,1))
               FROM PAREXPEDICAO;
            END;
         END;
   ---------------------------------------------------------------------------------------------------------
         /*O pau d aqui*/
         DELETE FROM ITLANCTOEST
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCESTQ = @P_LANCESTQ;

         IF (@V_IDSISTEMA <> 'VMN') BEGIN

            DELETE FROM LANCTOESTOQ
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCESTQ = @P_LANCESTQ;

            DELETE FROM LANCTOESTOQ
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END
         ELSE BEGIN
            UPDATE LANCTOESTOQ
            SET DTLANCESTQ   = @P_INIVALID
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCESTQ = @P_LANCESTQ;
         END;

         IF @P_ENTRSAID = 'S' BEGIN
            IF (@P_TIPOOPER = '06') BEGIN
               SET @V_TIPOMOVI = '5';
            END
            ELSE BEGIN
               SET @V_TIPOMOVI = '4';
            END;
         END
         ELSE BEGIN
            SET @V_TIPOMOVI = '2';
         END;

         SELECT @V_NMTIPOOPER = T.NMTIPOOPER, @V_NMFILIEMIT = F.NMFILIAL
         FROM
            NOTAFISCAL N LEFT JOIN FILIAL F ON
            (N.CDFILIEMIT = F.CDFILIAL),
            TIPOOPERAC T
         WHERE
            (N.CDFILIAL     = @P_FILIAL)      AND
            (N.NRLANCTONF   = @P_LANCTONF)    AND
            (N.CDTIPOOPER   = T.CDTIPOOPER)   AND
            (N.IDENTRSAIDOP = T.IDENTRSAIDOP)

         IF @V_IDORIGDESTNF = 'L' BEGIN
            SET @V_DESCLANC = 'NF: '+@P_LANCTONF+' - '+SUBSTRING(@V_NMTIPOOPER,1,25)+' - '+SUBSTRING(@V_NMFILIEMIT,1,15);
         END
         ELSE BEGIN
            SET @V_DESCLANC = 'LANC. ORIGEM: '+@V_NRINSJURNF+' N'+@V_NRNOTAFISC+' SERIE '+@V_SERIE;
         END;

   ---------------------------------------------------------------------------------------------------------
         SELECT @V_COUNT = COUNT(*)
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = @P_FILIAL AND
               NRLANCESTQ = @P_LANCESTQ;

         IF @V_COUNT = 0 BEGIN
            INSERT INTO LANCTOESTOQ(CDFILIAL,NRLANCESTQ,NRLANCTONF,DSLANCESTQ,IDTPLANCTO,DTLANCESTQ,CDOPERADOR,CDFILIMOVI)
                             VALUES(@P_FILIAL, @P_LANCESTQ, @P_LANCTONF, @V_DESCLANC, @P_ENTRSAID, @P_INIVALID,@P_CDOPERADOR, @V_CDFILIRECE);
         END;
   ---------------------------------------------------------------------------------------------------------

         IF (@V_IDSISTEMA = 'PDV') BEGIN
            SELECT @V_IDATUEST = ISNULL(MAX(IDATUEST),1)
            FROM PARAVEND
            WHERE CDFILIAL = @P_FILIAL;
         END;

         IF ((@V_IDSISTEMA = 'EXP') AND (@V_IDRETPROEXP = '2')) OR ((@V_IDSISTEMA = 'PDV') AND (@V_IDATUEST = '1')) BEGIN
            DECLARE C_ITLANCTOEST CURSOR FOR
            SELECT NRSEQITPROD, IP.CDPRODUTO,  VRUNITITEM,
                   VRTOTAITEM,  QTITEMPROD,    CDPRODESTO,
                   VRBRUTITEM,  VRDESCITEM,    VRCONTITEM,
                   ISNULL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE,
                   ISNULL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                   ISNULL(NRLOTEESTQ, ' ') NRLOTEESTQ,
                   ISNULL(NRSUBLOTE, ' ') NRSUBLOTE, CDFILIMOVI,
                   CDFISOPEITEM, ISNULL(IDORIGEMPROD, 'N') AS IDORIGEMPROD
            FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
            WHERE IP.CDFILIAL    = @P_FILIAL     AND
                  IP.NRLANCTONF  = @P_LANCTONF   AND
                  P.CDPRODUTO    = IP.CDPRODUTO  AND
                  PF.CDFILIAL    = @V_CDFILIRECE AND
                  PF.CDPRODUTO   = P.CDPRODESTO  AND
                  ISNULL(IDCNTRESTOQ, 'S') <> 'N';

            OPEN C_ITLANCTOEST;
            FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,   @V_ITLANC_CDPRODUTO,
                                               @V_ITLANC_VRUNITITEM,    @V_ITLANC_VRTOTAITEM,
                                               @V_ITLANC_QTITEMPROD,    @V_ITLANC_CDPRODESTO,
                                               @V_ITLANC_VRBRUTITEM,    @V_ITLANC_VRDESCITEM,
                                               @V_ITLANC_VRCONTITEM,    @V_ITLANC_CDALMOXARIFE,
                                               @V_ITLANC_CDLOCALESTOQ,  @V_ITLANC_NRLOTEESTQ,
                                               @V_ITLANC_NRSUBLOTE,     @V_ITLANC_CDFILIMOVI,
                                               @V_ITLANC_CDFISOPEITEM,  @V_ITLANC_IDORIGEMPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO LOTE
               (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
               (SELECT @V_ITLANC_CDFILIMOVI,  @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE,
                       @V_ITLANC_CDPRODESTO, 'L' , GETDATE()
                FROM PARAMGERAL
                WHERE
                NOT EXISTS
                (SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
                       @V_ITLANC_CDPRODESTO, 'L', GETDATE()
                 FROM LOTE
                 WHERE  @V_ITLANC_CDFILIMOVI  =  CDFILIAL     AND
                        @V_ITLANC_NRLOTEESTQ  =  NRLOTEESTQ   AND
                        @V_ITLANC_NRSUBLOTE   =  NRSUBLOTE    AND
                        @V_ITLANC_CDPRODESTO  =  CDPRODUTO));

               UPDATE ITEMPRODUTO
               SET CDPRODMOVI = @V_ITLANC_CDPRODESTO
               WHERE (CDFILIAL    = @P_FILIAL)    AND
                     (NRLANCTONF  = @P_LANCTONF ) AND
                     (NRSEQITPROD = @V_ITLANC_NRSEQITPROD);

               SELECT @V_EXISTE_ROT = COUNT(*)
               FROM ROTFABRICA
               WHERE CDPRODUTO = @V_ITLANC_CDPRODUTO;

               IF (@V_EXISTE_ROT) > 0 BEGIN

                  EXEC INSERE_SUBPRODMAN @P_FILIAL, @P_LANCESTQ, @P_TIPOOPER, @V_ITLANC_CDPRODUTO,
                                         @V_ITLANC_QTITEMPROD, @V_ITLANC_VRTOTAITEM, @V_ITLANC_VRDESCITEM,
                                         @V_ITLANC_VRBRUTITEM, @V_ITLANC_VRCONTITEM,
                                         @V_VRTOTALANCTO, @V_QTDELANCTO, @V_TIPOMOVI, @P_INIVALID,
                                         @V_ITLANC_CDPRODESTO, '','','F';

               END
               ELSE BEGIN
                  SELECT @V_FATOCONV = MAX(VRFATOCONV)
                  FROM PRODUTO P, ITEMPRODUTO IP
                  WHERE P.CDPRODUTO    = IP.CDPRODUTO AND
                        IP.CDFILIAL    = @P_FILIAL     AND
                        IP.NRLANCTONF  = @P_LANCTONF   AND
                        IP.NRSEQITPROD = @V_ITLANC_NRSEQITPROD;

                  IF (@V_FATOCONV IS NULL) OR (@V_FATOCONV = 0) BEGIN
                     SET @V_FATOCONV = 1;
                  END;

                  SET @V_QTDELANCTO   = @V_ITLANC_QTITEMPROD;
                  SET @V_VRTOTALANCTO = (@V_ITLANC_VRTOTAITEM - @V_ITLANC_VRDESCITEM);

                  IF NOT(@V_QTDELANCTO = 0) BEGIN
                     SET @V_VRUNITLANCTO = @V_VRTOTALANCTO/@V_QTDELANCTO;
                  END ELSE BEGIN
                     SET @V_VRUNITLANCTO = @V_VRTOTALANCTO;
                  END;

                  IF (@P_TIPOOPER = '06') BEGIN
                     SET @V_TOTABRUT   = 0;
                     SET @V_TOTACONTAB = 0;
                     SET @V_VRCUSTENTR = 0;
                  END
                  ELSE BEGIN
                     IF NOT(@V_QTDELANCTO = 0) BEGIN
                        SET @V_TOTABRUT   = (@V_ITLANC_VRBRUTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                        SET @V_TOTACONTAB = (@V_ITLANC_VRCONTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                     END ELSE BEGIN
                        SET @V_TOTABRUT   = @V_ITLANC_VRBRUTITEM/@V_FATOCONV;
                        SET @V_TOTACONTAB = @V_ITLANC_VRCONTITEM/@V_FATOCONV;
                     END;
                     SET @V_VRCUSTENTR = @V_ITLANC_VRCONTITEM;
                  END;

                  IF (@V_IDOPERDEVONF = 'S' AND @V_IDUTCUSORIGEST = 'S') BEGIN
                     SELECT @V_VRCUSTENTR = ROUND(TEKNISA.CUSTO_PRODUTO_LCEST (@V_CDFILIRECE, @V_ITLANC_CDPRODESTO, @V_CDTIPCUSTEST, @P_INIVALID,
                                                                               @V_DTATUAL, @V_ITLANC_CDALMOXARIFE, @V_ITLANC_CDLOCALESTOQ,
                                                                               @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE), 5)
                       FROM PARAMGERAL;

                     IF @V_VRCUSTENTR = 0 BEGIN
                        SET @V_TOTABRUT   = @V_ITLANC_VRUNITITEM;
                        SET @V_TOTACONTAB = @V_ITLANC_VRUNITITEM;
                     END
                     ELSE BEGIN
                        SET @V_TOTABRUT   = @V_VRCUSTENTR;
                        SET @V_TOTACONTAB = @V_VRCUSTENTR;
                     END;
                  END;

                  SELECT @V_NRSEQITPROD = ISNULL(MAX(NRSEQUITEM),0) + 1
                  FROM ITLANCTOEST
                  WHERE CDFILIAL   = @P_FILIAL AND
                        NRLANCESTQ = @P_LANCESTQ;

                  SELECT @V_VRPESOBRUTPR = ISNULL(MAX(A.VRPESOBRUTPR),0),
                         @V_VRPECUSTOLOG = ISNULL(MAX(VRPECUSTOLOG),0),
                         @V_VRVRCUSTOLOG = ISNULL(MAX(VRVRCUSTOLOG),0),
                         @V_VRPESEGURLOG = ISNULL(MAX(VRPESEGURLOG),0)
                  FROM PRODUTO P, CUSTOLOGIST C, PRODUTO A
                  WHERE
                     (CHARINDEX(P.CDARVPROD, A.CDARVPROD) = 1)     AND
                     A.CDPRODUTO    = @V_ITLANC_CDPRODUTO          AND
                     P.CDPRODUTO    = C.CDPRODUTO                  AND
                     C.CDFILIAL     = @V_CDFILIRECE                AND
                     C.CDFORNECED   = @P_FORNECED                  AND
                     C.DTINIVIGCLOG = (SELECT MAX(DTINIVIGCLOG)
                                       FROM CUSTOLOGIST A, PRODUTO B, PRODUTO Q
                                       WHERE
                                          A.CDFILIAL     = C.CDFILIAL    AND
                                          A.CDFORNECED   = C.CDFORNECED  AND
                                          (CHARINDEX(Q.CDARVPROD, B.CDARVPROD) = 1)    AND
                                          B.CDPRODUTO    = @V_ITLANC_CDPRODUTO         AND
                                          Q.CDPRODUTO    = A.CDPRODUTO                 AND
                                          A.DTINIVIGCLOG <= @P_INIVALID);

                  IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_ITLANC_QTITEMPROD * @V_VRPESOBRUTPR)* @V_VRVRCUSTOLOG;
                  END;

                  IF (@V_VRPECUSTOLOG > 0) BEGIN
                     SET @V_VRCUSTOLOG = (@V_ITLANC_VRTOTAITEM * @V_VRPECUSTOLOG)/100;
                  END;

                  IF (@V_VRPESEGURLOG > 0) BEGIN
                     SET @V_VRCUSTOSEG = (@V_ITLANC_VRTOTAITEM * @V_VRPESEGURLOG)/100;
                  END;

                  INSERT INTO ITLANCTOEST
                     (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                      IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT,VRLANCTOEST,
                      VRCUSTENTR,CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE,NRLANCORIGRP,
                      VRCUSTLOGLAN, VRSEGULOGLAN, IDORIGEMPROD)
                  VALUES
                     (@P_FILIAL, @P_LANCESTQ,
                      (RIGHT('0000',4 - DATALENGTH(CONVERT(VARCHAR,@V_NRSEQITPROD))) + CONVERT(VARCHAR,@V_NRSEQITPROD)),
                      @V_ITLANC_CDPRODUTO, @V_QTDELANCTO, @V_VRUNITLANCTO, @V_VRTOTALANCTO,
                      @V_TIPOMOVI, @P_INIVALID,'2', @V_ITLANC_CDPRODESTO,
                     (@V_QTDELANCTO * @V_FATOCONV), @V_TOTABRUT, @V_TOTACONTAB, @V_VRCUSTENTR,
                     @V_CDFILIRECE, @V_ITLANC_CDALMOXARIFE, @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                     @V_ITLANC_NRSUBLOTE, @V_IDDOCREPLIC, @V_VRCUSTOLOG, @V_VRCUSTOSEG, @V_ITLANC_IDORIGEMPROD);
               END;
               FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,  @V_ITLANC_CDPRODUTO,
                                                  @V_ITLANC_VRUNITITEM,   @V_ITLANC_VRTOTAITEM,
                                                  @V_ITLANC_QTITEMPROD,   @V_ITLANC_CDPRODESTO,
                                                  @V_ITLANC_VRBRUTITEM,   @V_ITLANC_VRDESCITEM,
                                                  @V_ITLANC_VRCONTITEM,   @V_ITLANC_CDALMOXARIFE,
                                                  @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                                                  @V_ITLANC_NRSUBLOTE,    @V_ITLANC_CDFILIMOVI,
                                                  @V_ITLANC_CDFISOPEITEM, @V_ITLANC_IDORIGEMPROD;
            END;
            CLOSE C_ITLANCTOEST;
            DEALLOCATE C_ITLANCTOEST;
         END ELSE BEGIN
            DECLARE C_ITLANCTOEST CURSOR FOR
            SELECT NRSEQITPROD, IP.CDPRODUTO,  VRUNITITEM,
                   VRTOTAITEM,  QTITEMPROD,    CDPRODESTO,
                   VRBRUTITEM,  VRDESCITEM,    VRCONTITEM,
                   ISNULL(IP.CDALMOXARIFE, ' ') CDALMOXARIFE,
                   ISNULL(IP.CDLOCALESTOQ, ' ') CDLOCALESTOQ,
                   ISNULL(NRLOTEESTQ, ' ') NRLOTEESTQ,
                   ISNULL(NRSUBLOTE, ' ') NRSUBLOTE, CDFILIMOVI,
                   CDFISOPEITEM, ISNULL(IDORIGEMPROD, 'N') AS IDORIGEMPROD
            FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
            WHERE IP.CDFILIAL    = @P_FILIAL     AND
                  IP.NRLANCTONF  = @P_LANCTONF   AND
                  P.CDPRODUTO    = IP.CDPRODUTO  AND
                  PF.CDFILIAL    = @V_CDFILIRECE AND
                  PF.CDPRODUTO   = P.CDPRODESTO  AND
                  ISNULL(IDCNTRESTOQ, 'S') <> 'N';

            OPEN C_ITLANCTOEST;
            FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,  @V_ITLANC_CDPRODUTO,
                                               @V_ITLANC_VRUNITITEM,   @V_ITLANC_VRTOTAITEM,
                                               @V_ITLANC_QTITEMPROD,   @V_ITLANC_CDPRODESTO,
                                               @V_ITLANC_VRBRUTITEM,   @V_ITLANC_VRDESCITEM,
                                               @V_ITLANC_VRCONTITEM,   @V_ITLANC_CDALMOXARIFE,
                                               @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                                               @V_ITLANC_NRSUBLOTE,    @V_ITLANC_CDFILIMOVI,
                                               @V_ITLANC_CDFISOPEITEM, @V_ITLANC_IDORIGEMPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO LOTE
               (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE)
               (SELECT @V_ITLANC_CDFILIMOVI,  @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE,
                       @V_ITLANC_CDPRODESTO, 'L' , GETDATE()
                FROM PARAMGERAL
                WHERE
                NOT EXISTS
                (SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
                       @V_ITLANC_CDPRODESTO, 'L', GETDATE()
                 FROM LOTE
                 WHERE  @V_ITLANC_CDFILIMOVI  =  CDFILIAL     AND
                        @V_ITLANC_NRLOTEESTQ  =  NRLOTEESTQ   AND
                        @V_ITLANC_NRSUBLOTE   =  NRSUBLOTE    AND
                        @V_ITLANC_CDPRODESTO  =  CDPRODUTO));

               UPDATE ITEMPRODUTO
               SET CDPRODMOVI = @V_ITLANC_CDPRODESTO
               WHERE (CDFILIAL    = @P_FILIAL)    AND
                     (NRLANCTONF  = @P_LANCTONF ) AND
                     (NRSEQITPROD = @V_ITLANC_NRSEQITPROD);

               SELECT @V_FATOCONV = MAX(VRFATOCONV)
               FROM PRODUTO P, ITEMPRODUTO IP
               WHERE P.CDPRODUTO    = IP.CDPRODUTO AND
                     IP.CDFILIAL    = @P_FILIAL     AND
                     IP.NRLANCTONF  = @P_LANCTONF   AND
                     IP.NRSEQITPROD = @V_ITLANC_NRSEQITPROD;

               IF (@V_FATOCONV IS NULL) OR (@V_FATOCONV = 0) BEGIN
                  SET @V_FATOCONV = 1;
               END;

               SET @V_QTDELANCTO   = @V_ITLANC_QTITEMPROD;
               SET @V_VRTOTALANCTO = (@V_ITLANC_VRTOTAITEM - @V_ITLANC_VRDESCITEM);

               IF NOT(@V_QTDELANCTO = 0) BEGIN
                  SET @V_VRUNITLANCTO = @V_VRTOTALANCTO/@V_QTDELANCTO;
               END
               ELSE BEGIN
                  SET @V_VRUNITLANCTO = @V_VRTOTALANCTO;
               END;

               IF (@P_TIPOOPER = '06') BEGIN
                  SET @V_TOTABRUT   = 0;
                  SET @V_TOTACONTAB = 0;
                  SET @V_VRCUSTPROD = 0;
               END
               ELSE BEGIN
                  IF NOT(@V_QTDELANCTO = 0) BEGIN
                     SET @V_TOTABRUT   = (@V_ITLANC_VRBRUTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                     SET @V_TOTACONTAB = (@V_ITLANC_VRCONTITEM/@V_QTDELANCTO)/@V_FATOCONV;
                  END
                  ELSE BEGIN
                     SET @V_TOTABRUT   = @V_ITLANC_VRBRUTITEM;
                     SET @V_TOTACONTAB = @V_ITLANC_VRCONTITEM;
                  END;
                  SET @V_VRCUSTENTR = @V_ITLANC_VRCONTITEM;
               END;

               IF (@V_IDOPERDEVONF = 'S' AND @V_IDUTCUSORIGEST = 'S') BEGIN
                  SELECT @V_VRCUSTENTR = ROUND(TEKNISA.CUSTO_PRODUTO_LCEST (@V_CDFILIRECE, @V_ITLANC_CDPRODESTO, @V_CDTIPCUSTEST, @V_DTSAIDNFORIG,
                                                                            @V_DTATUAL, @V_ITLANC_CDALMOXARIFE, @V_ITLANC_CDLOCALESTOQ,
                                                                            @V_ITLANC_NRLOTEESTQ, @V_ITLANC_NRSUBLOTE), 5)
                    FROM PARAMGERAL;

                  IF @V_VRCUSTENTR = 0 BEGIN
                     SET @V_TOTABRUT   = @V_ITLANC_VRUNITITEM;
                     SET @V_TOTACONTAB = @V_ITLANC_VRUNITITEM;
                  END
                  ELSE BEGIN
                     SET @V_TOTABRUT   = @V_VRCUSTENTR;
                     SET @V_TOTACONTAB = @V_VRCUSTENTR;
                  END;
               END;

               SELECT @V_VRPESOBRUTPR = ISNULL(MAX(A.VRPESOBRUTPR),0),
                      @V_VRPECUSTOLOG = ISNULL(MAX(VRPECUSTOLOG),0),
                      @V_VRVRCUSTOLOG = ISNULL(MAX(VRVRCUSTOLOG),0),
                      @V_VRPESEGURLOG = ISNULL(MAX(VRPESEGURLOG),0)
               FROM PRODUTO P, CUSTOLOGIST C, PRODUTO A
               WHERE
                  (CHARINDEX(P.CDARVPROD, A.CDARVPROD) = 1)     AND
                  A.CDPRODUTO    = @V_ITLANC_CDPRODUTO          AND
                  P.CDPRODUTO    = C.CDPRODUTO                  AND
                  C.CDFILIAL     = @V_CDFILIRECE                AND
                  C.CDFORNECED   = @P_FORNECED                  AND
                  C.DTINIVIGCLOG = (SELECT MAX(DTINIVIGCLOG)
                                    FROM CUSTOLOGIST A, PRODUTO B, PRODUTO Q
                                    WHERE
                                       A.CDFILIAL     = C.CDFILIAL    AND
                                       A.CDFORNECED   = C.CDFORNECED  AND
                                       (CHARINDEX(Q.CDARVPROD, B.CDARVPROD) = 1)    AND
                                       B.CDPRODUTO    = @V_ITLANC_CDPRODUTO         AND
                                       Q.CDPRODUTO    = A.CDPRODUTO                 AND
                                       A.DTINIVIGCLOG <= @P_INIVALID);

               IF (@V_VRVRCUSTOLOG > 0) AND (@V_VRPESOBRUTPR > 0) BEGIN
                  SET @V_VRCUSTOLOG = (@V_ITLANC_QTITEMPROD * @V_VRPESOBRUTPR)* @V_VRVRCUSTOLOG;
               END;

               IF (@V_VRPECUSTOLOG > 0) BEGIN
                  SET @V_VRCUSTOLOG = (@V_ITLANC_VRTOTAITEM * @V_VRPECUSTOLOG)/100;
               END;

               IF (@V_VRPESEGURLOG > 0) BEGIN
                  SET @V_VRCUSTOSEG = (@V_ITLANC_VRTOTAITEM * @V_VRPESEGURLOG)/100;
               END;
               INSERT INTO ITLANCTOEST
                  (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                   IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT,VRLANCTOEST,
                   VRCUSTENTR,CDFILIMOVI,CDALMOXARIFE,CDLOCALESTOQ,NRLOTEESTQ,NRSUBLOTE, NRLANCORIGRP,
                   VRCUSTLOGLAN, VRSEGULOGLAN, IDORIGEMPROD)
               VALUES
                  (@P_FILIAL,@P_LANCESTQ,@V_ITLANC_NRSEQITPROD,@V_ITLANC_CDPRODUTO,
                   @V_QTDELANCTO,@V_VRUNITLANCTO,@V_VRTOTALANCTO,@V_TIPOMOVI,@P_INIVALID,'2',
                   @V_ITLANC_CDPRODESTO,(@V_QTDELANCTO * @V_FATOCONV),@V_TOTABRUT,
                   @V_TOTACONTAB,@V_VRCUSTPROD,@V_CDFILIRECE,
                   @V_ITLANC_CDALMOXARIFE,@V_ITLANC_CDLOCALESTOQ,@V_ITLANC_NRLOTEESTQ,
                   @V_ITLANC_NRSUBLOTE,@V_IDDOCREPLIC, @V_VRCUSTOLOG, @V_VRCUSTOSEG, @V_ITLANC_IDORIGEMPROD);


               FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQITPROD,  @V_ITLANC_CDPRODUTO,
                                                  @V_ITLANC_VRUNITITEM,   @V_ITLANC_VRTOTAITEM,
                                                  @V_ITLANC_QTITEMPROD,   @V_ITLANC_CDPRODESTO,
                                                  @V_ITLANC_VRBRUTITEM,   @V_ITLANC_VRDESCITEM,
                                                  @V_ITLANC_VRCONTITEM,   @V_ITLANC_CDALMOXARIFE,
                                                  @V_ITLANC_CDLOCALESTOQ, @V_ITLANC_NRLOTEESTQ,
                                                  @V_ITLANC_NRSUBLOTE,    @V_ITLANC_CDFILIMOVI,
                                                  @V_ITLANC_CDFISOPEITEM, @V_ITLANC_IDORIGEMPROD;
            END;
            CLOSE C_ITLANCTOEST;
            DEALLOCATE C_ITLANCTOEST;
         END;
      END;

   ---------------------------------------------------------------------------------------------------------
      IF @P_TIPOOPER = '03' BEGIN
         SET @V_VRCOMPLEMEN = 0;

         DECLARE C_ENCARGO CURSOR FOR
         SELECT EN.IDENCARGO, SUM(VRITEMENCA) AS VRITEMENCA
         FROM ITEMENCARGO IE, ENCARGO EN
         WHERE (IE.CDFILIAL   = @P_FILIAL)    AND
               (IE.NRLANCTONF = @P_LANCTONF)  AND
               (IE.VRITEMENCA > 0)            AND
               (EN.CDCTBLENTREN IS NULL)      AND
               (EN.CDENCARGO  = IE.CDENCARGO)
         GROUP BY IDENCARGO

         OPEN C_ENCARGO;
         FETCH NEXT FROM C_ENCARGO INTO @V_ENCARGO_IDENCARGO,  @V_ENCARGO_VRITEMENCA;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF @V_ENCARGO_IDENCARGO = 'A' BEGIN
               SET @V_VRCOMPLEMEN = @V_VRCOMPLEMEN + @V_ENCARGO_VRITEMENCA;
            END
            ELSE IF @V_ENCARGO_IDENCARGO = 'D' BEGIN
               SET @V_VRCOMPLEMEN = @V_VRCOMPLEMEN - @V_ENCARGO_VRITEMENCA;
            END;
            FETCH NEXT FROM C_ENCARGO INTO @V_ENCARGO_IDENCARGO,  @V_ENCARGO_VRITEMENCA;
         END;
         CLOSE C_ENCARGO;
         DEALLOCATE C_ENCARGO;

         IF (@V_VRCOMPLEMEN > 0) AND (@V_LIQUIDO = 0) BEGIN
            SET @V_VRNOTAF = @V_VRCOMPLEMEN - @V_VRPRODUTOS;
            EXEC ATUALIZA_CUSTO_COMPLEMENTO @P_FILIAL, @P_LANCTONF, @V_VRNOTAF;
         END;

         IF @V_VRNOTAFISC = 0 BEGIN
            UPDATE NOTAFISCAL
               SET VRNOTAFISC = ROUND(@V_TOTALNOTA, 2)
             WHERE CDFILIAL   = @P_FILIAL    AND
                   NRLANCTONF = @P_LANCTONF;
         END
         ELSE BEGIN
            UPDATE NOTAFISCAL
               SET VRNOTAFISC = ROUND(VRNOTAFISC, 2)
             WHERE CDFILIAL   = @P_FILIAL    AND
                   NRLANCTONF = @P_LANCTONF;
         END;

         IF @V_VRPRODUTOS = 0 BEGIN
            UPDATE NOTAFISCAL
            SET VRPRODUTOS = @V_VRCOMPLEMEN
            WHERE CDFILIAL   = @P_FILIAL AND
                  NRLANCTONF = @P_LANCTONF;
         END;
      END;
   ---------------------------------------------------------------------------------------------------------

      -- Recalcula diferencial de aliquota considerando valor contabil quando no possuir reduo de base de clculo
      DECLARE C_TRABITPROIMPOS CURSOR FOR (SELECT NRSEQITPROD, CDIMPOSTO
                                             FROM ITEMPROIMPOS
                                            WHERE CDFILIAL = @P_FILIAL
                                              AND NRLANCTONF = @P_LANCTONF
                                              AND NRITPROIMPOS = '3');

      OPEN C_TRABITPROIMPOS;
      FETCH NEXT FROM C_TRABITPROIMPOS INTO @V_TRABITPROIMPOS_NRSEQITPROD, @V_TRABITPROIMPOS_CDIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_CDFILIREDU = NULL;

         SELECT @V_CDFILIREDU = MAX(CDFILIAL)
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND NRSEQITPROD = @V_TRABITPROIMPOS_NRSEQITPROD
            AND CDIMPOSTO = @V_TRABITPROIMPOS_CDIMPOSTO
            AND NRITPROIMPOS = '2';

         IF @V_CDFILIREDU IS NULL BEGIN

            SET @V_VRCONTITIMP = 0;

            SELECT @V_VRCONTITIMP = MAX(VRCONTITIMP)
              FROM ITEMPROIMPOS
             WHERE CDFILIAL = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF
               AND NRSEQITPROD = @V_TRABITPROIMPOS_NRSEQITPROD
               AND CDIMPOSTO = @V_TRABITPROIMPOS_CDIMPOSTO
               AND NRITPROIMPOS = '1';

            UPDATE TRABITPROIMPOS
               SET VRCONTIMPOIT = @V_VRCONTITIMP,
                   VRBCALCIMPOIT = @V_VRCONTITIMP,
                   VRIMPOSIT = ((@V_VRCONTITIMP * VRALIQIMPOIT) / 100)
             WHERE CDFILIMPOIT = @P_FILIAL
               AND NRLANCIMPOIT = @P_LANCTONF
               AND NRSEQIMPOIT = @V_TRABITPROIMPOS_NRSEQITPROD
               AND CDIMPOSTOIT = @V_TRABITPROIMPOS_CDIMPOSTO
               AND NRSEQITPRO   = '3';

            UPDATE ITEMPROIMPOS
               SET VRCONTITIMP = @V_VRCONTITIMP,
                   VRBASECALCIT = @V_VRCONTITIMP,
                   VRIMPOSTOIT = ((@V_VRCONTITIMP * VRALIQITEM) / 100)
             WHERE CDFILIAL = @P_FILIAL
               AND NRLANCTONF = @P_LANCTONF
               AND NRSEQITPROD = @V_TRABITPROIMPOS_NRSEQITPROD
               AND CDIMPOSTO = @V_TRABITPROIMPOS_CDIMPOSTO
               AND NRITPROIMPOS = '3';
         END;

         FETCH NEXT FROM C_TRABITPROIMPOS INTO @V_TRABITPROIMPOS_NRSEQITPROD, @V_TRABITPROIMPOS_CDIMPOSTO;
      END;
      CLOSE C_TRABITPROIMPOS;
      DEALLOCATE C_TRABITPROIMPOS;

      DECLARE C_TRABIMPOSNF CURSOR FOR SELECT CDIMPOSTO,
                                              SUM(VRCONTITIMP) AS VRCONTITIMP,
                                              SUM(VRBASECALCIT) AS VRBASECALCIT,
                                              SUM(VRIMPOSTOIT) AS VRIMPOSTOIT
                                         FROM ITEMPROIMPOS
                                        WHERE CDFILIAL = @P_FILIAL
                                          AND NRLANCTONF = @P_LANCTONF
                                          AND NRITPROIMPOS = '3'
                                        GROUP BY CDIMPOSTO;

      OPEN C_TRABIMPOSNF;
      FETCH NEXT FROM C_TRABIMPOSNF INTO @V_TRABIMPOSNF_CDIMPOSTO, @V_TRABIMPOSNF_VRCONTITIMP, @V_TRABIMPOSNF_VRBASECALCIT, @V_TRABIMPOSNF_VRIMPOSTOIT;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         UPDATE IMPOSTONF
            SET VRCONTABILNF = @V_TRABIMPOSNF_VRCONTITIMP,
                VRBASECALCNF = @V_TRABIMPOSNF_VRBASECALCIT,
                VRIMPOSTONF  = @V_TRABIMPOSNF_VRIMPOSTOIT
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND CDIMPOSTO = @V_TRABIMPOSNF_CDIMPOSTO
            AND IDIMPOSTONF = '3';

         FETCH NEXT FROM C_TRABIMPOSNF INTO @V_TRABIMPOSNF_CDIMPOSTO, @V_TRABIMPOSNF_VRCONTITIMP, @V_TRABIMPOSNF_VRBASECALCIT, @V_TRABIMPOSNF_VRIMPOSTOIT;
      END;
      CLOSE C_TRABIMPOSNF;
      DEALLOCATE C_TRABIMPOSNF;

      DECLARE C_TRABITPROIMP CURSOR FOR SELECT CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                               CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT,
                                               SUM(VRCONTITIMP) AS VRCONTITIMP,
                                               SUM(VRBASECALCIT) AS VRBASECALCIT,
                                               SUM(VRIMPOSTOIT) AS VRIMPOSTOIT
                                          FROM ITEMPROIMPOS
                                         WHERE CDFILIAL = @P_FILIAL
                                           AND NRLANCTONF = @P_LANCTONF
                                           AND NRITPROIMPOS = '3'
                                         GROUP BY CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
                                                  CDFISCALIT, CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT;

      OPEN C_TRABITPROIMP;
      FETCH NEXT FROM C_TRABITPROIMP INTO @V_TRABITPRO_CDIMPOSTO, @V_TRABITPRO_VRALIQITEM, @V_TRABITPRO_VRPERREDBCIT, @V_TRABITPRO_VRPARDEDIT,
                                          @V_TRABITPRO_CDFISCALIT, @V_TRABITPRO_CDSITUTRIBIT, @V_TRABITPRO_CDFISCOPERIT, @V_TRABITPRO_CDSUFXCFOPIT,
                                          @V_TRABITPRO_VRCONTITIMP, @V_TRABITPRO_VRBASECALCIT, @V_TRABITPRO_VRIMPOSTOIT

      WHILE (@@FETCH_STATUS = 0) BEGIN
         UPDATE IMPOSTONF
            SET VRCONTABILNF = @V_TRABITPRO_VRCONTITIMP,
                VRBASECALCNF = @V_TRABITPRO_VRBASECALCIT,
                VRIMPOSTONF  = @V_TRABITPRO_VRIMPOSTOIT
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND CDIMPOSTO = @V_TRABITPRO_CDIMPOSTO
            AND IDIMPOSTONF = '3'
            AND VRALIQNF = @V_TRABITPRO_VRALIQITEM
            AND VRPERREDBCNF = @V_TRABITPRO_VRPERREDBCIT
            AND VRPARDEDNF = @V_TRABITPRO_VRPARDEDIT
            AND CDFISCALNF = @V_TRABITPRO_CDFISCALIT
            AND CDSITUTRIBNF = @V_TRABITPRO_CDSITUTRIBIT
            AND CDFISCOPERNF = @V_TRABITPRO_CDFISCOPERIT
            AND ISNULL(CDSUFXCFOPNF, 'N') = ISNULL(@V_TRABITPRO_CDSUFXCFOPIT, 'N');

         FETCH NEXT FROM C_TRABITPROIMP INTO @V_TRABITPRO_CDIMPOSTO, @V_TRABITPRO_VRALIQITEM, @V_TRABITPRO_VRPERREDBCIT, @V_TRABITPRO_VRPARDEDIT,
                                             @V_TRABITPRO_CDFISCALIT, @V_TRABITPRO_CDSITUTRIBIT, @V_TRABITPRO_CDFISCOPERIT, @V_TRABITPRO_CDSUFXCFOPIT,
                                             @V_TRABITPRO_VRCONTITIMP, @V_TRABITPRO_VRBASECALCIT, @V_TRABITPRO_VRIMPOSTOIT
      END;
      CLOSE C_TRABITPROIMP;
      DEALLOCATE C_TRABITPROIMP;

      -- Atualiza custo do produto em estoque caso o diferencial compoem o custo do produto
      DECLARE C_ITLANCTOESTO CURSOR FOR
         SELECT NRSEQITPROD, VRBRUTITEM, P.VRFATOCONV, QTITEMPROD, VRCONTITEM
         FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
         WHERE IP.CDFILIAL    = @P_FILIAL     AND
               IP.NRLANCTONF  = @P_LANCTONF   AND
               P.CDPRODUTO    = IP.CDPRODUTO  AND
               PF.CDFILIAL    = @V_CDFILIRECE AND
               PF.CDPRODUTO   = P.CDPRODESTO;

      OPEN C_ITLANCTOESTO;
      FETCH NEXT FROM C_ITLANCTOESTO INTO @V_ITLANCT_NRSEQITPROD, @V_ITLANCT_VRBRUTITEM,
                                          @V_ITLANCT_VRFATOCONV, @V_ITLANCT_QTITEMPROD,
                                          @V_ITLANCT_VRCONTITEM;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_VRIMPDIFALIQ = 0;

         SELECT @V_VRIMPDIFALIQ = ISNULL(SUM(VRIMPOSTOIT), 0)
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND NRSEQITPROD = @V_ITLANCT_NRSEQITPROD
            AND IDDIFALIQCUSPRI = 'S';

         IF @V_VRIMPDIFALIQ > 0 BEGIN
            UPDATE ITEMPRODUTO
               SET VRCONTITEM   = (VRCONTITEM + @V_VRIMPDIFALIQ)
             WHERE (CDFILIAL    = @P_FILIAL)    AND
                   (NRLANCTONF  = @P_LANCTONF)  AND
                   (NRSEQITPROD = @V_ITLANCT_NRSEQITPROD);

            IF (@P_TIPOOPER = '06') BEGIN
               UPDATE ITLANCTOEST
                  SET VRLANCTOBRUT = (@V_VRIMPDIFALIQ / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRLANCTOEST  = (@V_VRIMPDIFALIQ / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRCUSTENTR = (VRCUSTENTR + @V_VRIMPDIFALIQ)
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCESTQ = @P_LANCESTQ
                  AND NRSEQUITEM = @V_ITLANCT_NRSEQITPROD;
            END
            ELSE BEGIN
               UPDATE ITLANCTOEST
                  SET VRLANCTOBRUT = ((@V_ITLANCT_VRBRUTITEM + @V_VRIMPDIFALIQ) / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRLANCTOEST = ((@V_ITLANCT_VRCONTITEM + @V_VRIMPDIFALIQ) / @V_ITLANCT_QTITEMPROD) / @V_ITLANCT_VRFATOCONV,
                      VRCUSTENTR = (VRCUSTENTR + @V_VRIMPDIFALIQ)
                WHERE CDFILIAL = @P_FILIAL
                  AND NRLANCESTQ = @P_LANCESTQ
                  AND NRSEQUITEM = @V_ITLANCT_NRSEQITPROD;
            END;
         END;

         FETCH NEXT FROM C_ITLANCTOESTO INTO @V_ITLANCT_NRSEQITPROD, @V_ITLANCT_VRBRUTITEM,
                                             @V_ITLANCT_VRFATOCONV, @V_ITLANCT_QTITEMPROD,
                                             @V_ITLANCT_VRCONTITEM;
      END;
      CLOSE C_ITLANCTOESTO;
      DEALLOCATE C_ITLANCTOESTO;

      DELETE FROM REGRANOTA
      WHERE CDFILIAL = @P_FILIAL
        AND NRLANCTONF = @P_LANCTONF;

      DECLARE C_IMPOSNOTA CURSOR FOR
         SELECT DISTINCT CDREGRAIT
           FROM ITEMPROIMPOS
          WHERE CDFILIAL = @P_FILIAL
            AND NRLANCTONF = @P_LANCTONF
            AND CDREGRAIT IS NOT NULL
         ORDER BY CDREGRAIT;
      OPEN C_IMPOSNOTA;
      FETCH NEXT FROM C_IMPOSNOTA INTO @V_IMPOSNOTA_CDREGRAIT;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         DECLARE C_REGRAMSG CURSOR FOR
            SELECT CDREGRAFISC, DSMENSREGRAFISC
              FROM TEKNISA.MSG_REGRAFISCAL(@V_IMPOSNOTA_CDREGRAIT, @P_EMPRESA, 'E', @P_TIPOOPER, @P_INSCESTA) M
             WHERE NOT EXISTS(SELECT DSDADOADIC
                                FROM DADOSADIC
                               WHERE (CDFILIAL   = @P_FILIAL)
                                 AND (NRLANCTONF = @P_LANCTONF)
                                 AND (DSDADOADIC = M.DSMENSREGRAFISC)) ;
         OPEN C_REGRAMSG;
         FETCH NEXT FROM C_REGRAMSG INTO @V_REGRAMSG_CDREGRAFISC, @V_REGRAMSG_DSMENSREGRAFISC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            INSERT INTO DADOSADIC(CDFILIAL,  NRLANCTONF,  NRDADOADIC,  DSDADOADIC)
                           VALUES(@P_FILIAL, @P_LANCTONF, @V_DADOADIC, @V_REGRAMSG_DSMENSREGRAFISC);

            SET @V_DADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_DADOADIC) + 1)),3);

            FETCH NEXT FROM C_REGRAMSG INTO @V_REGRAMSG_CDREGRAFISC, @V_REGRAMSG_DSMENSREGRAFISC;
         END;
         CLOSE C_REGRAMSG;
         DEALLOCATE C_REGRAMSG;

         INSERT INTO REGRANOTA(CDFILIAL, NRLANCTONF, CDREGRAFISC)
                        VALUES(@P_FILIAL, @P_LANCTONF, @V_IMPOSNOTA_CDREGRAIT);

         FETCH NEXT FROM C_IMPOSNOTA INTO @V_IMPOSNOTA_CDREGRAIT;
      END;
      CLOSE C_IMPOSNOTA;
      DEALLOCATE C_IMPOSNOTA;
      IF (ISNULL(@P_AUDIT, 'N') <> 'S') BEGIN
         EXEC CONFERE_ERROS_NF @P_FILIAL, @P_LANCTONF, @V_TOTALNOTA;
      END;

      IF @P_TIPOOPER = '01' BEGIN
         EXEC CONHECIMENTO_TRANSPORTE @P_FILIAL, @P_LANCTONF, @P_LANCESTQ;
      END;
   END;

   ---------------------------------------------------------------------------------------------------------
   /* Rotina para gerao de sada no estoque (filial agente de terceirizao) */
   SET @V_CDFORNAGETERC = NULL;

   SELECT @V_CDFORNAGETERC = MAX(CDFORNAGETERC)
     FROM ITEMNOTAFISC I, NOTAFISCAL N, FILIAL F
    WHERE I.CDFILIALIT   = @P_FILIAL
      AND I.NRLANCTONFIT = @P_LANCTONF
      AND N.CDFILIAL     = I.CDFILIAL
      AND N.NRLANCTONF   = I.NRLANCTONF
      AND F.CDFILIAL     = N.CDFILIEMIT;

   IF (@V_CDFORNAGETERC IS NULL) AND (@V_IDORIGDESTNF = 'F') BEGIN

      SET @V_CDFILIAGENT = NULL;

      SELECT @V_CDFILIAGENT = CDFILIAL
        FROM FILIAL
       WHERE CDFORNAGETERC = @P_FORNECED;

      IF NOT @V_CDFILIAGENT IS NULL BEGIN

         SET @V_CDEMPRESAAG  = NULL;
         SET @V_CDINSCESTAAG = NULL;
         SET @V_CDINSCMUNIAG = NULL;

         SELECT @V_CDEMPRESAAG = CDEMPRESA,
                @V_CDINSCESTAAG = CDINSCESTA,
                @V_CDINSCMUNIAG = CDINSCMUNI
           FROM FILIAL
             WHERE CDFILIAL  = @V_CDFILIAGENT;

         IF (@V_IDCTRLESTQ = 'S') BEGIN
            DECLARE C_ITLANCTO CURSOR FOR SELECT IP.NRSEQITPROD, IP.VRBRUTITEM, IP.QTITEMPROD, IP.CDPRODUTO,
                                                 IP.VRCONTITEM, IP.VRUNITITEM, IP.VRTOTAITEM, P.CDARVPROD,
                                                 P.NMPRODUTO, IP.VRDESCITEM, P.CDPRODESTO, ISNULL(P.VRFATOCONV, 1) AS VRFATOCONV,
                                                 ISNULL(IDORIGEMPROD, 'N') AS IDORIGEMPROD
                                            FROM ITEMPRODUTO IP, PRODUTO P, PRODFILI PF
                                           WHERE IP.CDFILIAL    = @P_FILIAL
                                             AND IP.NRLANCTONF  = @P_LANCTONF
                                             AND P.CDPRODUTO    = IP.CDPRODUTO
                                             AND PF.CDFILIAL    = @V_CDFILIRECE
                                             AND PF.CDPRODUTO   = P.CDPRODESTO
                                             AND ISNULL(PF.IDCNTRESTOQ, 'S') <> 'N'
            OPEN C_ITLANCTO;
            FETCH NEXT FROM C_ITLANCTO INTO @V_ITLC_NRSEQITPROD, @V_ITLC_VRBRUTITEM, @V_ITLC_QTITEMPROD, @V_ITLC_CDPRODUTO,
                                            @V_ITLC_VRCONTITEM, @V_ITLC_VRUNITITEM, @V_ITLC_VRTOTAITEM, @V_ITLC_CDARVPROD,
                                            @V_ITLC_NMPRODUTO, @V_ITLC_VRDESCITEM, @V_ITLC_CDPRODESTO, @V_ITLC_VRFATOCONV,
                                            @V_ITLC_IDORIGEMPROD;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_CDALMOXARIFEAG = ' ';
               SET @V_CDLOCALESTOQAG = ' ';
               SET @V_IDUTILLOTEAG   = 'N';

               SELECT @V_CDALMOXARIFEAG = ISNULL(ISNULL(P.CDALMOXARIFE, F.CDALMOXARIFE), ' '),
                      @V_CDLOCALESTOQAG = ISNULL(ISNULL(P.CDLOCALESTOQ, F.CDLOCALESTOQ), ' '),
                      @V_IDUTILLOTEAG = ISNULL(F.IDUTILLOTE, 'N')
                 FROM PARAMFILIAL F, PRODFILI P
                WHERE F.CDFILIAL  = @V_CDFILIAGENT
                  AND P.CDFILIAL  = @V_CDFILIAGENT
                  AND P.CDPRODUTO = @V_ITLC_CDPRODESTO;

               IF @V_IDUTILLOTEAG = 'S' BEGIN
                  IF (@V_NRLOTEESTQAG IS NULL) OR (@V_NRLOTEESTQAG = ' ') BEGIN
                     EXEC PRXLOTEPRODEST @V_CDFILIAGENT, @P_INIVALID, @V_ITLC_CDPRODESTO, @V_NRLOTEESTQAG;
                     SET @V_NRSUBLOTEAG = ' ';
                  END;
               END
               ELSE BEGIN
                  SET @V_NRLOTEESTQAG = ' ';
                  SET @V_NRSUBLOTEAG  = ' ';
               END;

               IF @V_BOLANESTSAIDAG = 1 BEGIN
                  /* Gerando o registro na tabela LANCTOESTOQ para a entrada na filial relacionada ao agente de terceirizao */
                  SET @V_NOVO_CODIGO = 'LANCNF/FILIAL' + @V_CDFILIAGENT;
                  EXEC NOVO_CODIGO_SC @V_NOVO_CODIGO, @P_SEQUENCIAL = @V_NRLANCTONFAG OUTPUT, @P_QTDE = 1;
                  SET @V_NRLANCTONFAG = SUBSTRING(@V_NRLANCTONFAG, 11, 10);

                  SET @V_NOVO_CODIGO_NT = 'LANCTOEST' + @V_CDFILIAGENT;
                  EXEC NOVO_CODIGO_SC @V_NOVO_CODIGO_NT, @P_SEQUENCIAL = @V_NRLANESTENTRAG OUTPUT, @P_QTDE = 1;
                  SET @V_NRLANESTENTRAG = SUBSTRING(@V_NRLANESTENTRAG, 11, 10);

                  SET @V_TPOPERREMESSA = NULL;

                  SELECT @V_TPOPERREMESSA = CDTPOOPREMESSA
                    FROM PARAMGERAL
                   WHERE CDPARGERAL = '0001';


                  IF (@V_TPOPERREMESSA IS NULL) BEGIN
                     RAISERROR('Tipo de operao para gerao de lanamento de estoque deve ser informado - (Parmetros para Documentos Fiscais de Sada - Operador Logstico)', 16,1);
                  END;

                  INSERT INTO NOTAFISCAL
                     (CDFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRLANCTONF, NRINSJURNF,
                      IDTPIJURNF, DTEMISSAO, NRNOTAFISC, CDSERIE, IDBLOQUEADO, IDDOCFISCAL,
                      IDDOCFINANC, VRPRODUTOS, VRNOTAFISC, IDENTRSAIDOP, CDTIPOOPER, CDCLIENTE,
                      DTENTRSAID, CDFILIEMIT, IDORIGDESTNF, CDFORNECED, CDFILIRECE, NRAPURACFAT)

                  VALUES
                     (@V_CDFILIAGENT, @V_CDEMPRESAAG, @V_CDINSCESTAAG, @V_CDINSCMUNIAG, @V_NRLANCTONFAG, @V_NRINSJURNF,
                      @V_IDTPIJURNF, @P_INIVALID, NULL, NULL, 'N', 'N',
                      'S', @V_VRPRODUTOS, @V_VRNOTAFISC, 'S', @V_TPOPERREMESSA, @P_FORNECED,
                      @P_INIVALID, @V_CDFILIAGENT, 'C', NULL, NULL, NULL);

                  INSERT INTO ITEMNOTAFISC
                     (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
                  VALUES
                     (@V_CDFILIAGENT, @V_NRLANCTONFAG, '001', @P_FILIAL, @P_LANCTONF);

                  INSERT INTO LANCTOESTOQ
                     (CDFILIAL, CDFILIMOVI, NRLANCESTQ, IDTPLANCTO,
                      DTLANCESTQ, DSLANCESTQ,
                      NRLANCTONF, CDOPERADOR, CDALMOXARIFE, CDLOCALESTOQ)
                  VALUES
                     (@V_CDFILIAGENT, @V_CDFILIAGENT, @V_NRLANESTENTRAG, '4',
                      @P_INIVALID, 'NF Retorno Armazenagem - lan. ' + @V_CDFILIRECE + ' ' + @P_LANCTONF,
                      @V_NRLANCTONFAG, @P_CDOPERADOR, NULL, NULL);

                  SET @V_BOLANESTSAIDAG = 0;
               END;

               INSERT INTO ITEMPRODUTO
                  (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO,
                   CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                   VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                   VRBRUTITEM, IDCONFORITEM, CDFILIMOVI,
                   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODMOVI)
               VALUES
                  (@V_CDFILIAGENT, @V_NRLANCTONFAG, @V_ITLC_NRSEQITPROD, @V_ITLC_CDPRODUTO,
                   @V_ITLC_CDARVPROD, @V_ITLC_NMPRODUTO, 'S', @V_ITLC_QTITEMPROD,
                   @V_ITLC_VRUNITITEM, @V_ITLC_VRDESCITEM, @V_ITLC_VRTOTAITEM, @V_ITLC_VRCONTITEM,
                   @V_ITLC_VRBRUTITEM, 'S', @V_CDFILIAGENT,
                   @V_CDALMOXARIFEAG, @V_CDLOCALESTOQAG, @V_NRLOTEESTQAG, @V_NRSUBLOTEAG,
                   @V_ITLC_CDPRODESTO);

               INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
                   CDPRODMOVI, VRUNILANCTO, VRTOTLANCTO, QTTOTLANCTO,
                   QTLANCTOEST, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,
                   VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, CDALMOXARIFE,
                   CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDORIGEMPROD)
               VALUES
                  (@V_CDFILIAGENT, @V_NRLANESTENTRAG, @V_ITLC_NRSEQITPROD, @V_ITLC_CDPRODUTO,
                   @V_ITLC_CDPRODESTO, @V_ITLC_VRUNITITEM, @V_ITLC_VRTOTAITEM, @V_ITLC_QTITEMPROD,
                   @V_ITLC_QTITEMPROD * @V_ITLC_VRFATOCONV, '4', @P_INIVALID, '9',
                   @V_ITLC_VRBRUTITEM, @V_ITLC_VRTOTAITEM, @V_CDFILIAGENT, @V_CDALMOXARIFEAG,
                   @V_CDLOCALESTOQAG, @V_NRLOTEESTQAG, @V_NRSUBLOTEAG, @V_ITLC_IDORIGEMPROD);

               FETCH NEXT FROM C_ITLANCTO INTO @V_ITLC_NRSEQITPROD, @V_ITLC_VRBRUTITEM, @V_ITLC_QTITEMPROD, @V_ITLC_CDPRODUTO,
                                               @V_ITLC_VRCONTITEM, @V_ITLC_VRUNITITEM, @V_ITLC_VRTOTAITEM, @V_ITLC_CDARVPROD,
                                               @V_ITLC_NMPRODUTO, @V_ITLC_VRDESCITEM, @V_ITLC_CDPRODESTO, @V_ITLC_VRFATOCONV,
                                               @V_ITLC_IDORIGEMPROD;
            END;

            CLOSE C_ITLANCTO;
            DEALLOCATE C_ITLANCTO;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTO_ENTRADA','6.25.xxx';
GO
